﻿/*************************************

USE : To decalre the contant values 
Ex: Set date format for jquery datepicker etc...

CREATED: 17 JUL 2013

CREATED BY: SPR\718

LAST MODIFIED : 10 APR 2014

*************************************/

"use strict";        // ECMA 5 onwards.. recommended as it avoid silly mistakes..

var _app = new function () {

    // -- PRIVATE VARIABLES..
    var _self = this;

    // -- PUBLIC VARIABLES..
    this.dateTimeFormat = "mm/dd/yy";
    this.momentFormat = "MM/DD/YYYY"; //For moment js
    this.dateyear = "mm-yy";
    this.currentDateTime = "";
    this.currentUserId = 0;
    this.currentUserImage = "";
    this.timeZone = "Asia/Kolkata";
    this.momentWithTime = "MM/DD/YYYY hh:mm:ss A"; //For moment JS
    this.momemntWithShortTime = "MM/DD/YYYY hh:mm A";
    this.momentTimeFormat = "hh:mm:ss A";
    this.timePickerFormat = "hh:mm TT";
    this.parentLockStatus = false;
    //using in jtablesettings.js
    this.jtableSettings = [];
    this.multiColumnMinFields = 7;
    this.jtPageSizeOptions = [5, 10, 20, 50, 100, 250, 500];
    this.importRecordRequestFrequency = 0;
    this.jtPagingModule = "";
    this.importParellelAjaxRequest = 0;
    this.intlCurrency = { style: 'currency', currency: 'USD', currencyDisplay: "symbol" };
    this.localRegion = 'en-US'

    this.grid = undefined;

    //For Employee master
    this.Active = 23;

    //For FormBFormD settings
    this.FormBLookUpID = 204;
    this.FormDLookUpID = 205;

    //For PayrollCycle
    this.Weekly = 370;
    this.Monthly = 373;
    this.Yearly = 375;
    this.Custom = 376;

    //For payroll Item
    this.Fixed = 412;
    this.Variable = 413;
    this.Formula = 617;
    this.Function = 618;
    this.Transaction = 690;

    this.PayType = 609;

    this.paramFertilizerScheduleId = 0;
    this.paramFertPermition = "";
    this.FertlizerFinished = 34032;

    //For Employee Transfer
    this.Pending = "Pending Business Rule";
    this.Approved = "Approval Business Rule";
    this.Rejected = "Reject Business Rule";
    this.PendingId = 37;
    this.ApproveId = 38;

    //For IOMode - Manual Punch
    this.IOModeManual = 6001;
    this.IOModeDevice = 6002;
    this.IOModeApplication = 6003;

    //For PunchMode - Employee Setting
    this.NoPunch = 6004;
    this.SinglePunch = 6005;
    this.DualPunch = 6006;

    //For PayCalendar
    this.Open = 600;
    this.Processing = 625;
    this.Processed = 626;
    this.Finalized = 627;
    this.Voided = 629;

    //Final settlement Payment
    this.Both = 771;
    this.Cash = 772;
    this.Cheque = 773;

    //Final settlement Payment Nominee
    this.Nominee = 221;
    this.Self = 222;
    this.LegalHeir = 223;

    //Finala Settlement - Employee Classification
    this.STF = 1;
    this.WRK = 2;

    //SCHEMA EDITOR
    this.objSchemaEditor = null;
    this.objSchemaEditorArr = [];

    //For BonusProvision Eligibility Rule
    this.CeilingTypeId = 80;

    //For Leave Application
    this.LeaveType = 614;

    //Place Holder
    this.PlaceHolder = "";

    //For ActiveStatus
    this.ActiveYes = 1;
    this.ActiveNo = 0;


    //For Maximum record count
    this.MaxRecordCount = 0;


    /*
    * Application Notification using PNotify library
    *************************************************************************/
    this.notify = function (options) {
        if (PNotify && options) {
            new PNotify(options);
        }
    }

    //Add keys from web.config here
    this.config = new function () {
        this.paperStyleEnabled = true;
    }

    //################### Admin lookups ###########################

    //For Weekly Festival Advance
    this._wkly = new function () {
        this.Wkly = 549;
        this.Festival = 550;
        this.Both = 551;
    }

    this.TileMenu = new function () {
        this.JsonData = "/";
    }
    this.ApplicationURL = new function () {
        this.BaseURL = getBaseUrlValue("BaseURL=");
    }

    //For currency formats
    this.Currency = new function () {
        this.INR = '₹';
        this.USD = '$';
        this.EURO = '£';
    }

    this.ActiveView = new function () {
        this.pivot = 'Pivot';
        this.grid = 'Grid';
        this.graph = 'Graph';
        this.map = 'Map';
        this.timeseries = 'Timeseries';
    }

    this.ConvertCurrencyToInteger = function (p_Value) {
        return parseFloat(p_Value.replace(/[^\d.-]/g, '')); //RETURN FORMAT - 1230.05
    }

    this.DmsfUpload = new function () {
        this.Dmsfurl = "";
    }

    //For Worksheet
    this.Worksheet = new function () {
        this.WrkDefinitionDetail = 32016;
        //lookup type
        this.MaterialType = 3400;
        this.Value_Type = 3405;
        this.IsCustom = 3406;
        this.VALUE_TYPE_ID = 3407;
        this.CostType = 3408;
        this.Vehicle = 34021;
        this.Equipments = 34020;
        this.Buildings = 34019;
        this.Others = 34022;
        //lookup
        this.Numeric = 1000;
        this.Text = 1001;
        this.System_Defined = 1002;
        this.User_Defined = 1003;
        this.Material = 1004;
        this.Normal = 1005;
        this.Hidden = 1006;
        this.Calculated = 1007;
        this.Mandays = 1008;
        this.Labour_Cost = 1009;
        this.Material_Cost = 1010;
        this.Other_Cost = 1012
    }

    //For Service Request
    this.ServiceRequest = new function () {
        this.Internal = 54029;
        this.OutSourced = 54030
    }

    //for EmployeeDossier
    this.EmployeeActionDetail = new function () {
        this.PerformanceReview = 821;
        this.Certification = 820;
        this.DisciplinaryAction = 819;
        this.FeedBack = 818;
        this.MaxRate = 5;
        this.MaximumWeightage = 100
    }

    //FOR TRANSLATOR PLUGIN
    this.Translator = new function () {
        this.ModuleGroup = "Administration";
        this.Languages = {
            "en": "English",
            "hi": "Hindi",
            "ta": "Tamil",
            "kn": "Kannada",
            "es": "Spanish",
            "id": "Indonesian"
        };
    }

    this._budgetProcessTab = new function () {
        this.General = 34059;
        this.Fertilizing = 34060;
        this.Programmes = 34061;
        this.Activity = 34062;
    }

    //sales start
    this.Indent = new function () {
        this.SalesType = 32093;
        this.RawMaterial = 32203;
        this.Consignment = "Consignment Sale";
    }

    this.SalesAdvance = new function () {
        this.PaymentMode = 32135;
        this.Status = 29;
    }

    this.AdvanceReceipts = new function () {
        this.PaymentMode = 32135;
        this.Status = 29;
    }

    //for Addtional charges
    this.ValueType = new function () {
        this.Amount = 420;
        this.Percentage = 419;
    }

    this.ParentSaleType = new function () {
        this.AuctionSale = 32170;
        this.DirectSale = 32171;
        this.ExportSale = 32173;
        this.ConsignmentSale = 32172;
    }
    this.SalesModuleId = new function () {
        this.Sales = 17;
        this.Auction = 38;
        this.Export = 39;
    }

    this.mainSaleTypes = new function () {
        this.ConsignmentSale = 32202;
        this.DirectSale = 32206;
    }

    this.subSaleTypes = new function () {

        this.IndirectExportSale = 32207;
        this.InterStateSale = 32208;
        this.LocalSale = 32209;
        this.NotApplicable = 32222;
    }

    this.referenceTypes = new function () {
        this.IndentWise = 66062;
        this.BidWise = 66063;
        this.OfferWise = 66061;
    }

    //################### BISuite lookups ###########################

    /// <summary>
    /// Connection Types - BI
    /// </summary>
    this.connectionType = new function () {
        this.External = 0;
        this.Internal = 1;
    }

    /// <summary>
    /// Catelog Types - BI
    /// </summary> Snapshot, Query, Dashlet
    this.catalogType = new function () {
        this.Dataset = 82025;
        this.External = 82026;
        this.Filter = 82027;
        this.Snapshot = 82028;
        this.Dashlet = 82029,
        this.FilterDashlet = 82035;
    }

    /// <summary>
    /// Access rights - BI
    /// </summary>
    this.accessType = new function () {
        this.Public = 82001;
        this.Shared = 82002;
        this.Restricted = 82003;
        this.Confidential = 82004;
        this.Private = 82005;
    }


    /// <summary>
    /// Access rights - BI
    /// </summary>
    this.roleType = new function () {
        this.Manager = 1;
        this.Owner = 2;
        this.Member = 3;
        this.Guest = 4;
    }

    /// <summary>
    /// Data delimliters - BI
    /// </summary>
    this.dataDelimiter = new function () {
        this.Comma = 82013;
        this.SemiColon = 82014;
        this.Hyphen = 82015;
        this.Tab = 82016;
    }

    /// <summary>
    /// External data source - BI
    /// </summary>
    this.dataSource = new function () {
        this.SQL = 82006;
        this.Oracle = 82007;
        this.SharePoint = 82008;
        this.WebAPI = 82009;
        this.Jasper = 82010;
        this.Excel = 82011;
        this.TextFile = 82012;
        this.MySql = 82017;
    }

    /// <summary>
    /// External data source - BI
    /// </summary>
    this.mis = new function () {
        this.geoFields = ["geojson", "geom", "the_geom", "geometry", "spatial", "geo", "longitude", "latitude", "long", "lat", "longlat", "longitudelatitude"];
    }

    //################### function ###########################


    this.checkJtableBulkImportThreshold = function (p_FieldLength) {
        var l_threshold = 500;
        switch (p_FieldLength) {
            case p_FieldLength >= 30:
                l_threshold = 500;
                break;
            case p_FieldLength >= 25:
                l_threshold = 750;
                break;
            case p_FieldLength >= 20:
                l_threshold = 900;
                break;
            case p_FieldLength >= 15:
                l_threshold = 1000;
                break;
            case p_FieldLength >= 10:
                l_threshold = 1200;
                break;
            case p_FieldLength >= 5:
                l_threshold = 2000;
                break;
            default:
                l_threshold = 1000;
                break;
        }
        return l_threshold;
    };

    this.LanguagePackPath = new function () {
        var name = "JsonLanguagePath=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1);
            if (c.indexOf(name) != -1) {
                this.JsonLanguagePath = decodeURIComponent(c.substring(name.length, c.length));
            }
        }
    }


    this.GetAppCurrentDate = function () {
        if (_app.dateTimeFormat == "dd/mm/yy" || _app.dateTimeFormat == "mm/dd/yy" || _app.dateTimeFormat.indexOf("-") != -1) {
            return _app.currentDateTime.replace(/\//g, "-");
        } else {
            return _app.currentDateTime;
        }
        return _app.Date.Date;
    };

    this.GetSystemDateTime = function (callBackMethod) {
        $.ajax({
            url: _app.ApplicationURL.BaseURL + 'PanBIActions/GetDateTime',
            type: 'post',
            success: function (result) {
                if (result) {
                    result.ShortDateTime = moment.tz(result.Now, (_app.timeZone || "Asia/Kolkata")).format(_app.momemntWithShortTime);
                    result.Now = moment.tz(result.Now, (_app.timeZone || "Asia/Kolkata")).format(_app.momentWithTime);
                    result.UtcNow = moment.tz(result.UtcNow, (_app.timeZone || "Asia/Kolkata")).format(_app.momentWithTime);
                    result.Today = moment.tz(result.Today, (_app.timeZone || "Asia/Kolkata")).format(_app.momentFormat);
                    result.Date = moment.tz(result.Date, (_app.timeZone || "Asia/Kolkata")).format(_app.momentFormat);
                    result.ShortDate = moment.tz(result.ShortDate, (_app.timeZone || "Asia/Kolkata")).format(_app.momentFormat);
                }
                _app.Date = result;
                if (callBackMethod) {
                    callBackMethod(_app.Date)
                }
            },
            error: function () {
                if (callBackMethod) {
                    callBackMethod(false)
                }
            }
        });
    };

    //Contains server datetime details
    this.Date = null;

    this.GetMoment = function (includeTime) {
        return includeTime ? _app.Date.Now : _app.Date.Today;
    };

    this.DateDifference = function (p_DateFrom, p_DateTo) {
        p_DateFrom = $.datepicker.parseDate(this.dateTimeFormat, p_DateFrom);
        p_DateFrom = moment(p_DateFrom);
        p_DateTo = $.datepicker.parseDate(this.dateTimeFormat, p_DateTo);
        p_DateTo = moment(p_DateTo);
        return p_DateFrom.diff(p_DateTo);
    }

    // this function will return Application Settings for the given key, [module], [criteria]
    this.GetAppSettings = function (p_JSONData, p_callbackFunction) {
        // set the default value..
        var l_JSONData = $.extend({
            "settingKey": "",
            "moduleId": 1,
            "criteria": ""
        }, p_JSONData);
        $.ajax({
            url: _app.ApplicationURL.BaseURL + '/Administration/Setting/GetApplicationSetting/',
            type: 'POST',
            asysnc: false,
            data: JSON.stringify(l_JSONData),
            contentType: 'application/json ;',
            dataType: 'json',
            success: function onSuccess(data) {
                // do the basic error validation
                if (data.Result == "Error") {
                    ShowValidationMessages(g_LangTranslator.Translate(data.Message),
						g_LangTranslator.Translate("Error"));
                }
                else {	// if all ok, call the CallBack ()..
                    p_callbackFunction(data)
                }
            },
            error: function () {
                ShowValidationMessages(g_LangTranslator.Translate("Ajax error occured."), g_LangTranslator.Translate("Error"));
            }

        });
    }

    //sales end
    // utility functions..
    this.util = new function () {
        //function for converting uppercase
        this.toTitleCase = function (str) {
            return str.replace(/\w\S*/g, function (txt) { return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase(); });
        };
    }

    // client browser related attributes..
    this.browser = new function () {
        // get client OS
        this.getOS = function () {
            var navUA = navigator.userAgent.toLowerCase();
            var navAppVer = navigator.appVersion;

            if (/windows nt 5.0/.test(navUA)) {
                return "Windows 2000";
            }
            else if (/windows nt 5.1/.test(navUA)) {
                return "Windows XP";
            }
            else if (/windows nt 6.0/.test(navUA)) {
                return "Windows Vista";
            }
            else if (/windows nt 6.1/.test(navUA)) {
                return "Windows 7";
            }
            else if (/windows/.test(navUA)) {
                return "Windows";
            }
            else if (navAppVer.indexOf("X11") != -1) {
                return "Unix";
            }
            else if (navAppVer.indexOf("Mac") != -1) {
                return "Macintosh";
            }
            else if (navAppVer.indexOf("Linux") != -1) {
                return "Linux";
            }
            else {
                return "Unknown";
            }
        }
    }
    //Used to get values from the query string
    this.GetValuesFromQueryString = function (p_QueryString) {
        var l_PageURL = window.location.search.substring(1);
        if (l_PageURL) {
            var l_URLVariables = l_PageURL.split('&');
            for (var i = 0; i < l_URLVariables.length; i++) {
                var l_ParameterName = l_URLVariables[i].split('=');
                if (l_ParameterName[0] == p_QueryString) {
                    return l_ParameterName[1];
                }
            }
        }
    }

    this.MillisecondsToHHMMSS = function (p_millisecond) {
        var milliseconds = parseInt((p_millisecond % 1000) / 100)
        , seconds = parseInt((p_millisecond / 1000) % 60)
        , minutes = parseInt((p_millisecond / (1000 * 60)) % 60)
        , hours = parseInt((p_millisecond / (1000 * 60 * 60)) % 24);

        hours = (hours < 10) ? "0" + hours : hours;
        minutes = (minutes < 10) ? "0" + minutes : minutes;
        seconds = (seconds < 10) ? "0" + seconds : seconds;

        return hours + ":" + minutes + ":" + seconds;
    }

    function getBaseUrlValue(cookieName) {
        var name = cookieName;
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') c = c.substring(1);
            if (c.indexOf(name) != -1) {
                var UrlValue = decodeURIComponent(c.substring(name.length, c.length));
                return UrlValue;
            }
        }

    }

    this.EncodeHTML = function (p_JString) {
        return $('<div/>').text(p_JString).html();
    }

    this.DecodeHTML = function (p_JString) {
        return $('<div/>').html(p_JString).text();
    }

    //PanBI Side Panel functions
    this.SidePanel = new function () {
        this.SidePanelHeight = 400;
        this.SidePanelWidth = '20%'; //nithin
        this.DataContainerWidth = '80%';
        this.SidePanelElement = "";
        this.SlideElement = "";
        this.isActivated = false;
        this.ActivateSidePanel = function (p_containers) {
            _app.SidePanel.SidePanelHeight = $(".dataContent").css('height');
            _app.SidePanel.SidePanelHeight = _app.SidePanel.SidePanelHeight ? parseInt(_app.SidePanel.SidePanelHeight) - 10 + "px" : "400px";
            //$("#divSideBySideView").show().css({
            //'width': _app.SidePanel.SidePanelWidth,
            // 'max-height': _app.SidePanel.SidePanelHeight,
            //'height': _app.SidePanel.SidePanelHeight,
            // 'margin-top': '0px', //nithin
            // 'margin-left': '0px', //nithin
            // 'overflow': 'visible'

            //});
            $(".PanBI-main-data-container").css({
                //'width': _app.SidePanel.DataContainerWidth,
                //'padding-right': '.8%' // nithin
            });
            $(".MenuName").removeClass('absoluteMenu');
            _app.SidePanel.BindSlider();
            if (p_containers) {
                _app.SidePanel.BindContainers(p_containers);
            }
            _app.SidePanel.isActivated = true;
        },


		this.ArrangeWizardStyle = function () {
		    if (_app.SidePanel.SidePanelElement) {
		        $(_app.SidePanel.SidePanelElement).data('wizard').ArrangeScroll();
		    }
		},

        this.hide = function (grid) {
            if (_app.SidePanel.SlideElement != "") {
                _app.SidePanel.SlideElement.attr('active', 'true');
                if (grid) this.grid = grid;
                _app.SidePanel.SlideElement.click();
            }
        },

        this.show = function (grid) {
            if (_app.SidePanel.SlideElement != "") {
                _app.SidePanel.SlideElement.attr('active', 'false');
                if (grid) this.grid = grid;
                _app.SidePanel.SlideElement.click();
            }
        },

        this.BindSlider = function () {
            var self = this;
            var l_mtop = parseInt(_app.SidePanel.SidePanelHeight) / 2 + "px";
            if ($('.ast-side-view-slider-icon-right').length == 0 && $('.ast-side-view-slider').length == 0) {
                var l_SliderIcon = $('<div class="ast-side-view-slider-icon-right"></div>').css('margin-top', l_mtop);

                _app.SidePanel.SlideElement = $('<div class="ast-side-view-slider" active="true"></div>').attr('title', 'Hide Panel').css({ 'height': _app.SidePanel.SidePanelHeight })
			.click(function () {
			    var l_isActive = $(this).attr('active');
			    if (l_isActive == "true") {
			        $(this).attr({ 'active': 'false', 'title': 'Show Panel' }).nextAll().hide();
			        /*$("#divSideBySideView").animate({
			        'width': '0px'
			        }, 500, function () {
			        $('.jtable-sildepanel-connection-noty-div').hide();
			        $("#divSideBySideView").addClass('closed-state');
			        $('.PanBI-main-data-container').addClass('open');
			        });

			        $(".PanBI-main-data-container").animate({
			        'width': '100%'
			        }, 500);*/
			        $('.jtable-sildepanel-connection-noty-div').hide();
			        $("#divSideBySideView").removeClass('open-state').addClass('closed-state');
			        $('.PanBI-main-data-container').removeClass('closed').addClass('open');
			        //$('#divAdvancedSearch').css('width', '90%');
			        //Code edited by Nithin for New Sliding images
			        //$('.ast-side-view-slider-icon').css('background-position', '-101px -18px');
			        //$('.ast-side-view-slider-icon-right').removeClass().addClass('ast-side-view-slider-icon-left');
			        _app.SidePanel.ArrangeWizardStyle();

			        setTimeout(function () {
			            if (self.grid) self.grid.resizeCanvas(); //For resize grid width while expanding sidebar
			        }, 600);
			    } else {
			        $('.headColor').removeClass('noClick', 'slow');
			        $('.headImg').removeClass('noClickImg');
			        $('.filter-master-control-container').removeClass('noClickSearch', 'slow');
			        $('.catalog-header.headColor').removeClass('inactive-header');
			        // $('#divAdvancedSearch').css('width', '112%');
			        $(this).attr({ 'active': 'true', 'title': 'Hide Panel' });
			        $(this).children('[tab-active=true]').show();
			        $("#divSideBySideView").removeClass('closed-state').addClass('open-state');
			        $('.PanBI-main-data-container').removeClass('open').addClass('closed');


			        if ($('.bi-previewer-saveas-container').length == 0) {
			            if ($('.jtable-sildepanel-connection-noty-div')) {
			                $('.jtable-sildepanel-connection-noty-div').show().css({ 'left': $('.jtable-row-selected').width() + 2 });
			                $('#jtableSideViewAnalyticsVisulizerTab, .collaborate').show('slow', function () {
			                    if (self.grid) self.grid.resizeCanvas(); //For resize grid width while expanding sidebar
			                });
			            }
			        }
			        else {
			            if ($('.jtable-sildepanel-connection-noty-div')) {
			                $('.jtable-sildepanel-connection-noty-div').show().css({ 'left': $('.jtable-row-selected').width() + 2 });
			                $('#jtableSideViewAnalyticsVisulizerTab').show('slow', function () {
			                    if (self.grid) self.grid.resizeCanvas(); //For resize grid width while expanding sidebar
			                });
			                if ($('.headColor').hasClass('noClick')) {
			                    $('.filter-master-control-container').removeClass('noClickSearch', 'slow');
			                }
			            }
			        }

			        /*
			        $("#divSideBySideView").animate({
			        //'width': _app.SidePanel.SidePanelWidth
			        }, 500, function () {








			            
			        });

			        //Code edited by Nithin for New Sliding images			        
			        $('.ast-side-view-slider-icon-left').removeClass().addClass('ast-side-view-slider-icon-right');*/
			        _app.SidePanel.ArrangeWizardStyle();
			    }

			    if ($('#jtableSideViewCommentShareTab').attr('tab-active') === 'true') {
			        $('#divSideViewTitle').hide();
			    }
			})
			.append(l_SliderIcon).appendTo("#divSideBySideView");
            }
        }

        this.BindContainers = function (p_containers) {
            if (p_containers.indexOf('title') != -1 && $('#divSideViewTitle').length == 0) {
                _app.SidePanel.BindTitleContainer();
            }

            if (p_containers.indexOf('add') != -1 && $('#jtableSideViewAddTab').length == 0) {
                _app.SidePanel.BindAddFormContainer();
            }

            if (p_containers.indexOf('edit') != -1 && $('#jtableSideViewEditTab').length == 0) {
                _app.SidePanel.BindEditFormContainer();
            }

            if (p_containers.indexOf('filter') != -1 && $('#jtableSideViewFilterTab').length == 0) {
                _app.SidePanel.BindFilterContainer();
            }

            if (p_containers.indexOf('comment') != -1 && p_containers.indexOf('share') != -1 && $('#jtableSideViewCommentShareTab').length == 0) {
                _app.SidePanel.BindCommentShareContainer();
            } else {
                if (p_containers.indexOf('comment') != -1 && $('#jtableSideViewCommentTab').length == 0) {
                    _app.SidePanel.BindCommentContainer();
                }

                if (p_containers.indexOf('share') != -1 && $('#jtableSideViewShareTab').length == 0) {
                    _app.SidePanel.BindShareContainer();
                }
            }
        }

        this.BindTitleContainer = function () {
            $('<div id="divSideViewTitle"></div>').appendTo("#divSideBySideView");
        }

        this.BindAddFormContainer = function () {
            $('<div id="jtableSideViewAddTab"></div>').appendTo("#divSideBySideView");
        }

        this.BindEditFormContainer = function () {
            $('<div id="jtableSideViewEditTab"></div>').appendTo("#divSideBySideView");
        }

        this.BindCommentContainer = function () {
            $('<div id="jtableSideViewCommentTab"></div>').appendTo("#divSideBySideView");
        }

        this.BindShareContainer = function () {
            $('<div id="jtableSideViewShareTab"></div>').appendTo("#divSideBySideView");
        }

        this.BindFilterContainer = function () {
            $('<div id="jtableSideViewFilterTab" tab-active="true"></div>').appendTo("#divSideBySideView");
        }

        this.BindCommentShareContainer = function () {
            try {

                $('<div id="jtableSideViewAnalyticsVisulizerTab" style="display:none"></div>')
                .appendTo("#divSideBySideView");

                var _$commentLi = $('<li style="background-color: #e1dcd9!important;border: none; "><a href="#jtableSideViewCommentTab" class="filter-CommentTab_comment"><div>Comment</div></a></li>'),
                    _$shareLi = $('<li style="background-color: #e1dcd9!important;border: none;"><a href="#jtableSideViewShareTab" class="filter-CommentTab_Share"><div>Share</div></a></li>'),
                    _$tabUl = $('<ul />').append(_$commentLi, _$shareLi);
                $('<div id="jtableSideViewCommentShareTab" class="toggled"></div>').append(_$tabUl, $('<div id="jtableSideViewCommentTab"></div>'), $('<div id="jtableSideViewShareTab"></div>'))
                .appendTo("#divSideBySideView");

            }
            catch (e) {
                throw e;
                return true;
            }
        }

        this.DisplayPanel = function (p_Case) {
            switch (p_Case) {
                case 1:
                    $('#jtableSideViewFilterTab').attr('tab-active', 'true');
                    $('#jtableSideViewAddTab,#jtableSideViewEditTab,#jtableSideViewCommentTab,#jtableSideViewShareTab,#jtableSideViewCommentShareTab').attr('tab-active', 'false').hide();
                    break;
                case 2:
                    $('#jtableSideViewAddTab').attr('tab-active', 'true').show();
                    $('#jtableSideViewFilterTab,#jtableSideViewEditTab,#jtableSideViewCommentTab,#jtableSideViewShareTab,#jtableSideViewCommentShareTab').attr('tab-active', 'false').hide();
                    break;
                case 3:
                    $('#jtableSideViewEditTab').attr('tab-active', 'true').show();
                    $('#jtableSideViewFilterTab,#jtableSideViewAddTab,#jtableSideViewCommentTab,#jtableSideViewShareTab,#jtableSideViewCommentShareTab').attr('tab-active', 'false').hide();
                    break;
                case 4:
                    $('#jtableSideViewFilterTab,#jtableSideViewAddTab,#jtableSideViewEditTab,#jtableSideViewCommentTab,#jtableSideViewShareTab,#jtableSideViewCommentShareTab').attr('tab-active', 'false').hide();
                    break;
                case 5:
                    $('#jtableSideViewCommentTab').attr('tab-active', 'true').show();
                    $('#jtableSideViewFilterTab,#jtableSideViewAddTab,#jtableSideViewEditTab,#jtableSideViewShareTab,#jtableSideViewCommentShareTab').attr('tab-active', 'false').hide();
                    break;
                case 6:
                    $('#jtableSideViewShareTab').attr('tab-active', 'true').show();
                    $('#jtableSideViewFilterTab,#jtableSideViewAddTab,#jtableSideViewEditTab,#jtableSideViewCommentTab,#jtableSideViewCommentShareTab').attr('tab-active', 'false').hide();
                    break;
                case 7:
                    $('#jtableSideViewCommentShareTab').attr('tab-active', 'true').show().tabs();
                    $('#jtableSideViewFilterTab,#jtableSideViewAddTab,#jtableSideViewEditTab,#jtableSideViewShareTab').attr('tab-active', 'false').hide();
                    break;
                default:
                    $('#jtableSideViewFilterTab').attr('tab-active', 'true').show();
                    $('#jtableSideViewAddTab,#jtableSideViewEditTab,#jtableSideViewCommentTab,#jtableSideViewShareTab,#jtableSideViewCommentShareTab').attr('tab-active', 'false').hide();
                    break;
            }

            if (_app.SidePanel.SlideElement.attr('active') != "true") {
                _app.SidePanel.SlideElement.click();
            } else {
                $("#divSideBySideView").children('[tab-active=true]').show();
            }

            //HIDE FOR PAN BI
            //  $('#divSideViewTitle').hide();           
        }

        this.ChangeTitle = function (p_title) {
            //$('#divSideViewTitle').hide();
            if (p_title) {
                $('#divSideViewTitle').text(p_title);
            } else {
                $('#divSideViewTitle').hide();
            }
        }
    }
    /*********************************************Fixed Header***********************************************************/


    //Function to call fixed header plugin
    this.getscrollHeader = function (getParentDivName, divHeight) {
        var getHeight = divHeight;
        if (!$(getParentDivName + ' table:visible').hasClass(".fht-thead")) {
            $(getParentDivName + ' .jtable:visible').fixedHeaderTable({
                height: getHeight
            });
        }
        //To hide horizontal scroll bar after jtable loading 
        $(document).ajaxComplete(function () {
            if ($('.dataContent .panerp-main-data-container').length > 0) {
                if ($('.dataContent .panerp-main-data-container').hasScrollBar())
                    $('.fht-tbody').css('overflow-x', 'hidden');
                else
                    $('.fht-tbody').css('overflow-x', 'hidden');
            }
        });

        //To get the length of the main jtable container and apply fixed header plugin.
        var getValue = $(getParentDivName + ' .jtable-tab-view-main-container:visible').length;
        if (getValue > 0) {
            $(getParentDivName + ' .jtable:visible').fixedHeaderTable('destroy');
            $(getParentDivName + ' .jtable:visible:first').remove();
            $(getParentDivName + ' .jtable:visible').fixedHeaderTable({
                height: getHeight
            });
        }
        var defaultMaxheight = '200px';
        if ($('.jtable-main-container:first').parent().jtable('option', 'childTables') === false) {
            defaultMaxheight = $('.contentWrapper').height() - 150;
        }
        $(getParentDivName + ' .fht-thead table thead .jtable-column-header-container').css("padding-top", "5px");
        $(getParentDivName + ' .fht-thead table thead .jtable-column-header-container').css("padding-bottom", "5px");
        $(getParentDivName + ' .fht-tbody tbody td').css("padding-top", "5px")
        $(getParentDivName + ' .fht-thead .jtable thead tr th').css("font-size", "11px")
        $(getParentDivName + ' .fht-tbody table tbody tr td').css("font-size", "11px");
        $(getParentDivName + ' .fht-table-wrapper').css({ "height": "auto", "max-height": defaultMaxheight + 20 });
        $(getParentDivName + ' .fht-table').css("border-collapse", "initial");
        $(getParentDivName + ' .fht-tbody').css({ "height": "auto", "overflow-x": "hidden", "max-height": defaultMaxheight - 70 });
        $(getParentDivName + ' .fht-tbody tr td:not(:has(button,input))').css({ 'padding-left': '3px', 'padding-right': '3px' })

        //To show and hide horizontal scroll bar on mouse hover
        $('.fht-tbody').mouseenter(function () {
            var width = $(this).children("table").first().width();
            /*Jtable horizontal scroll issue by checking table width is greater than 1000 - Nikhil*/
            if (width >= 1000) {
                $(this).css('overflow', 'auto');
            }
            else {
                $(this).css('overflow-x', 'hidden !important');
            }
        });
      
        $('.fht-tbody').mouseleave(function () {
            $(this).css('overflow-x', 'hidden')
        });

        if ($(' .fht-tbody').length > 0) {
            var getScrollStatus = $(getParentDivName + ' .fht-tbody').hasScrollBar();
            if (getScrollStatus) {
                $(getParentDivName + ' .fht-tbody').css("overflow-x", "hidden");
            } else {
                $(getParentDivName + ' .fht-tbody').css("overflow-x", "scroll");
            }
        }

        var getTabDivLength = $(getParentDivName + ' .jtable-tab-view-main-container').length;
        if (getTabDivLength > 0) {
            $(getParentDivName + ' .fht-tbody').css("overflow-x", "visible");
        }

        if ($(' .panerp-main-data-container').length > 0) {
            if ($('.panerp-main-data-container').hasScrollBar()) {
                var getDivs = $('.jtable-main-container:visible').parent();
                $(getDivs).each(function () {
                    var getCurrentDivName = $(this).attr("id");
                    $("#" + getCurrentDivName + ' .fht-tbody').css("overflow-x", "visible");
                })
            }
        }
    }
    //To get height of div
    this.getHeightOfDiv = function () {
        var getHeight;
        getHeight = ($('.dataContent').height() * 30) / 100;
        return getHeight;
    }
    //To get height of div in case only master table
    this.getFullHeight = function () {

        var getHeight;
        getHeight = ($('.dataContent').height() * 80) / 100;
        return getHeight;
    }
    //To recreate fixed header
    this.reCreateFixdHeader = function (getDivName) {
        if ($(getDivName + ' .fht-thead').length > 0) {
            if (($(getDivName + " tbody:visible tr").attr("class") != "jtable-no-data-row")) {
                $(getDivName + ' .jtable:visible').fixedHeaderTable('destroy');
                $(getDivName + ' .jtable:visible:first').remove();
                var getHeight = _app.getHeightOfDiv();
                _app.getscrollHeader(getDivName, getHeight);
            }

        }
    }

    //To call fixed header in case of window resize
    //    $(window).resize(function () {
    //        $('.jtable-page-size-dropdown').trigger('change');

    //    });

    //Initial Fixed Header
    this.getInitialFxdHeader = function (getDiv_Name) {
        if ($(getDiv_Name + " .fht-thead:visible").length > 0) {
            $(getDiv_Name + ' .jtable:visible').fixedHeaderTable('destroy');
            $(getDiv_Name + " .jtable:visible:first").remove();
        }
        if ($(getDiv_Name + " tbody:visible tr").length > 0) {
            var getHeightOfDiv;
            if (($(getDiv_Name + " tbody:visible tr").attr("class") != "jtable-no-data-row")) {
                if ($('tbody tr td:first-child').children('input').length > 0) {
                    getHeightOfDiv = _app.getHeightOfDiv();
                }
                else {
                    getHeightOfDiv = _app.getFullHeight();
                }
                var getHeight = _app.getHeightOfDiv();
                _app.getscrollHeader(getDiv_Name, getHeightOfDiv);

            }
        }
    }
    //To destroy header of the table
    this.destroyHeader = function (getDiv_Name) {
        $(getDiv_Name + ' .jtable:visible').fixedHeaderTable('destroy');
        $(getDiv_Name + " .jtable:visible:first").remove();
    }
    //in case of there is no data
    this.getFxdForTabClick = function (getDiv_Name) {
        if ($(getDiv_Name + " tbody:visible tr").length > 0) {
            if (($(getDiv_Name + " tbody:visible tr").attr("class") != "jtable-no-data-row")) {
                var getHeight = _app.getHeightOfDiv();
                _app.getscrollHeader(getDiv_Name, getHeight);
            }
        }
    }


    this.ajaxcall = function (options) {
        var defaultOptions = {
            url: undefined,
            type: 'GET',
            dataType: 'json',
            data: undefined,
            async: true,
            success: undefined,
            error: function (p_request, p_status, p_error) {
                if (window.console && window.console.log) console.log((p_error.message ? p_error.message : p_error));
            }
        };

        var ajaxOptions = $.extend(true, {}, defaultOptions, options);
        $.ajax(ajaxOptions);
    }

    this.jsonSort = function (array, prop, asc) {
        array = array.sort(function (a, b) {
            if (asc) return (a[prop] > b[prop]) ? 1 : ((a[prop] < b[prop]) ? -1 : 0);
            else return (b[prop] > a[prop]) ? 1 : ((b[prop] < a[prop]) ? -1 : 0);
        });
        return array;
    }
}
