

/*+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

JQuery  widget for Dashboard creation
Created By      : Nithin V and Resmy for Assyst International Pvt. Ltd.
Reviewed By     : Rony and Prasanth
Created Date    : 28-July-2014
Version         : 1.0.1
Project         : PanAgro
USAGE:  

Option:
        
Public Functions:
    
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+*/
(function ($) {
    //Create widget for Dashboard object
    $.widget('Assyst.Dashboard', {
        //Default values for options
        options: {
            mainContainerHeight: 0,
            menuId: undefined,
            //graphtypes used
            graphTypes: [{ "name": "Multi Bar", "value": "multiBar" }, { "name": "Multi Bar Horizontal", "value": "multiBarHorizontal" }, { "name": "Line", "value": "line" }, { "name": "Scatter", "value": "scatter" }, { "name": "Scatter Plus Line", "value": "scatterPlusLine" }, { "name": "Stacked Area", "value": "stackedArea" }, { "name": "Pie", "value": "pie" }, { "name": "Donut", "value": "donut"}],
            //timeseries view contains only two kind of charts
            timeseriesTypes: [{ "name": "Line", "value": "line" }, { "name": "Stacked Area", "value": "stackedArea"}],
            //the dashboard contains 4 layout structures
            columnLayout: [{ "columnClass": "singleColumn", "value": 1, "text": "Single Column" }, { "columnClass": "twoColumn", "value": 2, "text": "Two Column" }, { "columnClass": "threeColumn", "value": 3, "text": "Three Column" }, { "columnClass": "fourColumn", "value": 4, "text": "Four Column"}],
            //6 color themes
            themeLayout: [{ "columnClass": "themeOne", "value": 0 }, { "columnClass": "themeTwo", "value": 1 }, { "columnClass": "themeThree", "value": 2 }, { "columnClass": "themeFour", "value": 3 }, { "columnClass": "themeFive", "value": 4 }, { "columnClass": "themeSix", "value": 5 }, { "columnClass": "themeSeven", "value": 6}],
            //name of the dashboard
            name: undefined,
            //if the dashboard is shared the user id of the dsshlet may be different
            dashletUserId: undefined,
            //minimum height of a dashlet
            minHeight: 140,
            //permissions
            userRights: "",
            //date filters for data
            defaultFromDate: moment("20130701", "YYYYMMDD"),
            defaultToDate: moment("20130731", "YYYYMMDD"),
            //if toolbar is false, it doesn't draw the toolbar
            toolBar: true,
            //it allows right click
            contextMenu: true,
            //logged user
            userid: undefined,
            //colors of the widgrt chart
            widgetColors: ["#4FA0CC", "#f9a754", "#3EAD8E", "#8F6FA3", "#AF9133", "#000000"],
            //colors for the dashboard themes
            themes: ["#E9ECF3", "#DBE3F5", "#F7E9DC", "#E0EDDB", "#EAE3F5", "#EDEACE", "#FFFFFF"], // default 3 themes
            //set the page element as 5 for dashboard list
            showPerPage: 5,
            //set the current page as 0
            currentPage: 0,
            //setting selected dashboard color
            selectedColor: undefined,
            //it gives user to copy the api url
            getAPI: false,
            //permissions while sharing
            permissions: {
                "manager": 1,
                "guest": 4
            },
            //Dashboard filters
            filters: undefined/*{
                //"filter": [{ "id": "filt_66654", "fieldName": "Year_1663", "displayName": "Year", "operator": "In", "value1": "2016", "value2": "", "displayValue1": "", "displayValue2": "", "type": "numeric", "checked": true, "multiValue": true, "aliasName": "Year_1663", "title": "Year", "isDisable": false}],
                //"aggregate": []
            }*/,
            //dashboard colors used
            dashboardColors: ["#1395C6", "#E2AC24", "#6FAA87", "#6394B5", "#A85E7D", "#C5845C", "#D37A98", "#A27BB6"], //default 8 dashboard colors...
            //created api url
            apiURL: '/api/DashboardViewerAPI'
        },
        activeDashlet: undefined,
        dashletList: [],
        dashletViews: [],
        dashboard: {
            backgroundColor: "",
            templateType: "",
            shared: true,
            dashlets: {
                items: [],
                //Template of a dashlet item
                itemTemplate: {
                    id: 0,
                    catalogId: 0,
                    dashletId: 0,
                    rowNo: 0,
                    columnNo: 0,
                    colspan: 1,
                    rowspan: 1,
                    height: 0,
                    width: 0,
                    left: 0,
                    top: 0,
                    dashlet: "",
                    bgColor: "",
                    title: "",
                    type: "",
                    param: {},
                    showLegend: undefined,
                    clipHeadline: false,
                    widget: {
                        headline1: "",
                        head1Color: "",
                        headline2: "",
                        head2Color: "",
                        enableWidget: false,
                        percentage: 0,
                        percentageColor: "",
                        hoverOnDashelt: false,
                        chartType: ""
                    }
                },
                // Get unique identity number dynamicaly
                uniqueIdentity: function (startwith) {
                    startwith = startwith || "dashlet_";
                    return startwith + Math.floor(Math.random() * 99999);
                },
                // Sort daslet items based on row and column number in ASC format
                sort: function () {
                    _.each(this.items, function (val) {
                        val.rowNo = parseInt(val.rowNo);
                        val.columnNo = parseInt(val.columnNo);
                    });
                    this.items.sort(function (a, b) {
                        // note the minus before -cmp, for descending order
                        return cmp([cmp(a.rowNo, b.rowNo), cmp(a.columnNo, b.columnNo)], [cmp(b.rowNo, a.rowNo), cmp(b.columnNo, a.columnNo)]);
                    });

                    function cmp(x, y) {
                        return x > y ? 1 : x < y ? -1 : 0;
                    };
                },
                // Get the collection sorted dashlet item
                get: function () {
                    this.sort();
                    return this.items;
                },
                // Set the new dashlet collection
                set: function (data) {
                    this.items = data;
                },
                // Clear the dashlet collection
                clear: function () {
                    this.items = [];
                },
                // Get an item based on its id
                select: function (id) {
                    this.sort();
                    var item = _.findWhere(this.items, {
                        id: id
                    });
                    return (item) ? item : undefined;
                },
                // Add new item to dashlet collection
                addItem: function (options) {
                    // Make the clone of item for avoid object reference coupling
                    var newItem = $.extend(true, {}, this.itemTemplate, options, {
                        id: this.uniqueIdentity()
                    });
                    this.items.push(newItem);
                },

                // adding content to the dashlet
                updateItem: function (options) {
                    var item = this.select(options.id);
                    $.extend(true, item, options);
                    return item;
                },
                // Aligning the position
                // Calculate the top and left  position of each dashlet item 
                // This function will raise before the dashlet draw at dasboard
                setAlign: function (_self) {
                    var top = 15;
                    var left = 1;
                    var prevItem = undefined;
                    var jsonData = this.get();

                    // code for iterate the items for find the position 
                    _.each(jsonData, function (val) {
                        // when the previous item is blank (ie first row) or row Number change, the top variable is updated
                        // The top will be same for all columns which have the same row index
                        if (!prevItem || val.rowNo != prevItem.rowNo) {
                            top = getTop(val, jsonData);
                            prevItem = undefined;
                        }
                        left = getLeft(prevItem, val, jsonData);
                        val.left = left;
                        val.top = top;
                        prevItem = val;
                    });
                    return jsonData;

                    // find top position of an item
                    function getTop(item, items) {
                        var tHeight = 15;
                        // for the first row by default the top will be 10 px
                        if (item.rowNo == 0) return tHeight;

                        // LOGIC: First find the nearest item just above the current one
                        // calculate the top of current item by adding the bottom (nearest.top + nearest.height) of nearest with margin
                        var itemsAbove = $.grep(items, function (el, i) {
                            return (el.rowNo < item.rowNo && el.columnNo == item.columnNo);
                        });
                        var nearest = _.max(itemsAbove, function (data) {
                            return data.rowNo;
                        });

                        if (!isNaN(nearest.height))
                            nearest.height = nearest.height < _self.options.minHeight ? _self.options.minHeight : nearest.height;
                        else nearest.height = _self.options.minHeight;

                        tHeight = nearest.top + nearest.height + 15;
                        return tHeight;
                    }

                    // find the left position of an item
                    function getLeft(prevItem, item, items) {
                        // for the first column by default the left will be 10 px
                        if (item.columnNo == 0) return 1;

                        // LOGIC: if the current column continuous with previous one, then the left will be right(left + prevItem.width) of previous + margin.
                        if (prevItem && ((prevItem.columnNo + prevItem.colspan) == item.columnNo)) return left + prevItem.width + 1;
                        // Otherwise find one of the cells which are above the current one and take the left position                       
                        var topCells = $.grep(items, function (el, i) {
                            return (el.rowNo < item.rowNo && el.columnNo == item.columnNo);
                        });
                        if (topCells) return topCells[0].left;
                        return 0.5;
                    }
                },

                // inserting a new row functionality.
                // inserting a new row functionality.
                insertRow: function (_self, id, position) {
                    var item = this.select(id);
                    // Find the row index, where we need to insert the row
                    var rowSpanItems = $.grep(this.items, function (val, i) {
                        val.rowNo > val.rowNo + 1;
                    });
                    var rowSpan;
                    if (rowSpanItems.length == 0) rowSpan = item.rowNo + item.rowspan;
                    else rowSpan = item.rowNo + 1;
                    var newRowNo = position == "After" ? rowSpan : item.rowNo;
                    // Move one row down, all the rows which are greater than the index
                    var itemsBelow = $.grep(this.items, function (el, i) {
                        return (el.rowNo >= newRowNo);
                    });
                    _.each(itemsBelow, function (val) {
                        val.rowNo = val.rowNo + 1;
                    });
                    // Push new columns(2/3 based on layout) to dashlet collection
                    var layout = _self.dashboard.templateType;
                    var added;
                    if (layout == 1) added = 98;
                    else if (layout == 2) added = 48.5;
                    else if (layout == 3) added = 32;
                    else added = 23.7;

                    for (var indx = 0; indx < layout; indx++) {
                        this.addItem({
                            columnNo: indx,
                            rowNo: newRowNo,
                            width: added, // passing the width of existing div
                            height: _self.options.minHeight
                        });
                    }
                },

                // Delete the selected row
                deleteRow: function (id, _self) {
                    var item = this.select(id);
                    var rowNo = item.rowNo;
                    // LOGIC: Update dashlet with new collection, which will not include the selected row
                    // move all rows one index up
                    var template = _self.dashboard.templateType;
                    if (this.items.length < template) {
                        for (var i = 0; i < this.items.length; i++) {
                            var dashlet = _self.dashboard.dashlets.updateItem({
                                id: id,
                                dashlet: "",
                                title: "",
                                type: "",
                                param: undefined
                            });
                        }
                    } else this.items = $.grep(this.items, function (el, i) {
                        return (el.rowNo != rowNo);
                    });
                    var itemsBelow = $.grep(this.items, function (el, i) {
                        return (el.rowNo > rowNo);
                    });
                    _.each(itemsBelow, function (val) {
                        val.rowNo = val.rowNo - 1;
                    });
                },

                // Merge this with top element
                mergeTop: function (id, _self) {
                    var item = this.select(id);
                    // LOGIC: Take the nearest top cell(take all column which are comes top of selected one, and take the nearest top cell by selecting the rowNo is max).
                    // Update the hight( item.height + nearest.height + _self.options.mainmargin * 2) and rowpan (item.rowspan + nearest.rowspan) of selected cell.
                    // Remove the nearest cell
                    var itemsTop = $.grep(this.items, function (el, i) {
                        return (el.rowNo < item.rowNo && el.columnNo == item.columnNo);
                    });
                    var nearest = _.max(itemsTop, function (data) {
                        return data.rowNo;
                    });
                    item.height = (item.height < _self.options.minHeight) ? _self.options.minHeight : item.height;
                    nearest.height = (nearest.height < _self.options.minHeight) ? _self.options.minHeight : nearest.height;
                    if (nearest) {
                        item.height += (nearest.height + 15);
                        item.rowspan += nearest.rowspan;
                        item.rowNo = nearest.rowNo;
                        var index = _.indexOf(this.items, nearest);
                        if (index > -1) this.items.splice(index, 1);
                    }
                },

                //Merge this with bottom element
                mergeBottom: function (id, _self) {
                    var item = this.select(id);
                    // LOGIC: Take the nearest bottom cell(take all column which are comes bottom of selected one, and take the nearest bottom cell by selecting the rowNo is min).
                    // Update the hight( item.height + nearest.height + _self.options.mainmargin * 2) and rowpan (item.rowspan + nearest.rowspan) of selected cell.
                    // Remove the nearest cell
                    var itemsBelow = $.grep(this.items, function (el, i) {
                        return (el.rowNo > item.rowNo && el.columnNo == item.columnNo);
                    });
                    var nearest = _.min(itemsBelow, function (data) {
                        return data.rowNo;
                    });
                    item.height = (item.height < _self.options.minHeight) ? _self.options.minHeight : item.height;
                    nearest.height = (nearest.height < _self.options.minHeight) ? _self.options.minHeight : nearest.height;
                    if (nearest) {
                        item.height += (nearest.height + 15);
                        item.rowspan += nearest.rowspan;
                        var index = _.indexOf(this.items, nearest);
                        if (index > -1) this.items.splice(index, 1);
                    }
                },

                //Merging this with left element
                mergeLeft: function (id, _self) {
                    var item = this.select(id);
                    // LOGIC: Take the nearest left cell(take all column which are comes left of selected one, and take the nearest left cell by selecting the columnNo is max).
                    // Update the width( item.width + nearest.width + _self.options.mainmargin * 2) and colspan (item.colspan + nearest.colspan) of selected cell.
                    // Remove the nearest cell
                    var itemsLeft = $.grep(this.items, function (el, i) {
                        return (el.rowNo == item.rowNo && el.columnNo < item.columnNo);
                    });
                    var nearest = _.max(itemsLeft, function (data) {
                        return data.columnNo;
                    });
                    if (nearest) {
                        item.width += (nearest.width + 1);
                        item.colspan += nearest.colspan;
                        item.columnNo = nearest.columnNo;
                        var index = _.indexOf(this.items, nearest);
                        if (index > -1) this.items.splice(index, 1);
                    }
                },

                //Merging this with right element
                mergeRight: function (id, _self) {
                    var item = this.select(id);
                    // LOGIC: Take the nearest right cell(take all column which are comes right of selected one, and take the nearest right cell by selecting the columnNo is min).
                    // Update the width( item.width + nearest.width + _self.options.mainmargin * 2) and colspan (item.colspan + nearest.colspan) of selected cell.
                    // Remove the nearest cell
                    var itemsRight = $.grep(this.items, function (el, i) {
                        return (el.rowNo == item.rowNo && el.columnNo > item.columnNo);
                    });
                    var nearest = _.min(itemsRight, function (data) {
                        return data.columnNo;
                    });
                    if (nearest) {
                        item.width += (nearest.width + 1);
                        item.colspan += nearest.colspan;
                        var index = _.indexOf(this.items, nearest);
                        if (index > -1) this.items.splice(index, 1);
                    }
                },

                //splitting merged json[column] 
                splitColumn: function (id, _self) {
                    var item = this.select(id);
                    // Split the cell with respective of its column sapan
                    if (item.colspan > 1) {
                        var colspan = item.colspan;
                        if (colspan == 3 || colspan == 4) var width = ((item.width) / colspan) - 0.7;
                        else var width = ((item.width) / colspan) - 0.5;
                        item.width = width; // - colspan;
                        item.colspan = 1;
                        for (var i = 0; i < colspan - 1; i++) {
                            this.addItem({
                                rowNo: item.rowNo,
                                rowspan: item.rowspan,
                                columnNo: item.columnNo + 1 + i,
                                height: item.height,
                                width: width //- colspan
                            });
                        }
                    }
                },

                //splitting merged json[row] 
                splitRow: function (id, _self) {
                    var item = this.select(id);
                    // Split the cell with respective of its row sapan
                    if (item.rowspan > 1) {
                        var itemHeight = item.height;
                        var itemRowspan = item.rowspan;
                        var itemRow = item.rowNo;
                        var itemColumn = item.columnNo;
                        var itemColspan = item.colspan;

                        var newHeight, newRow, newColumn;
                        var siblings = $.grep(this.items, function (val, i) {
                            return val.rowNo == itemRow;
                        });

                        if (siblings.length <= 1) {
                            newHeight = itemHeight / itemRowspan < _self.options.minHeight ? _self.options.minHeight : itemHeight / itemRowspan - (15 / itemRowspan);
                            item.height = itemHeight / itemRowspan < _self.options.minHeight ? _self.options.minHeight : itemHeight / itemRowspan - (15 / itemRowspan);
                            item.rowspan = 1;
                            for (var i = 1; i < itemRowspan; i++) {
                                this.addItem({
                                    colspan: itemColspan,
                                    rowNo: itemRow + i,
                                    columnNo: itemColumn,
                                    height: newHeight,
                                    width: item.width
                                });
                            }
                        }
                        else {
                            var spHieght, npHeight;
                            var nextItems = $.grep(this.items, function (val, i) {
                                return val.columnNo > itemColumn && val.rowspan == 1 && val.rowNo == itemRow;
                            });

                            if (nextItems.length == 0) {
                                nextItems = $.grep(this.items, function (val, i) {
                                    return val.columnNo < itemColumn && val.rowspan == 1 && val.rowNo == itemRow;
                                });

                                if (nextItems.length == 0) {
                                    nextItems = $.grep(this.items, function (val, i) {
                                        return val.columnNo > itemColumn && val.rowNo == itemRow;
                                    });

                                    if (nextItems.length == 0) {
                                        nextItems = $.grep(this.items, function (val, i) {
                                            return val.columnNo < itemColumn && val.rowNo == itemRow;
                                        });
                                        spHieght = ((nextItems[0].height / itemRowspan) - (itemRowspan * 7.5));
                                    }

                                    else spHieght = ((nextItems[0].height / itemRowspan) - (itemRowspan * 7.5));

                                }
                                else spHieght = nextItems[0].height;
                            }
                            else spHieght = nextItems[0].height;
                            item.height = spHieght;

                            item.rowspan = 1;
                            for (var i = 1; i < itemRowspan; i++) {
                                npHeight = $.grep(this.items, function (val, j) {
                                    return val.rowNo == itemRow + i && val.rowspan == 1;
                                });
                                if (npHeight.length == 0) {
                                    npHeight = $.grep(this.items, function (val, j) {
                                        return val.rowNo == itemRow + i;
                                    });
                                    if (npHeight.length == 0) {
                                        npHeight = $.grep(this.items, function (val, j) {
                                            return val.rowNo == itemRow + 1 && val.columnNo == itemColumn;
                                        });
                                        if (npHeight.length == 0) {
                                            newHeight = ((itemHeight / itemRowspan) - (itemRowspan * 4));
                                        }
                                        else newHeight = npHeight[0].height;
                                    }
                                    else newHeight = (npHeight[0].height / itemRowspan) - (7.5);
                                }
                                else newHeight = npHeight.length == 0 ? itemHeight / itemRowspan : npHeight[0].height;

                                this.addItem({
                                    colspan: itemColspan,
                                    rowNo: itemRow + i,
                                    columnNo: itemColumn,
                                    height: newHeight,
                                    width: item.width
                                });
                            }
                        }
                    }
                },

                //swap dashlet
                swap: function (dropId, dragId) {
                    var dropItem = this.select(dropId);
                    var dragItem = this.select(dragId);
                    var tempItem = $.extend(true, {}, dropItem);
                    // Inter change the two items properties
                    if (dropItem.catalogId == "0") {
                        $.extend(true, dropItem, {
                            dashlet: dragItem.dashlet,
                            widget: dragItem.widget,
                            clipHeadline: dragItem.clipHeadline,
                            bgColor: dragItem.bgColor,
                            title: dragItem.title,
                            type: dragItem.type,
                            dataset: dragItem.dataset,
                            misSchema: dragItem.misSchema,
                            param: dragItem.param,
                            catalogId: dragItem.catalogId,
                            dashletId: dragItem.dashletId
                        });
                        $.extend(true, dragItem, {
                            dashlet: tempItem.dashlet,
                            widget: tempItem.widget,
                            clipHeadline: tempItem.clipHeadline,
                            bgColor: tempItem.bgColor,
                            title: "",
                            type: "",
                            param: {
                                $id: null,
                                graphType: null,
                                misID: null,
                                name: null
                            },
                            dataset: undefined,
                            misSchema: undefined,
                            catalogId: 0,
                            id: dragId,
                            dashletId: 0
                        });
                    }
                    else {
                        $.extend(true, dropItem, {
                            dashlet: dragItem.dashlet,
                            widget: dragItem.widget,
                            clipHeadline: dragItem.clipHeadline,
                            bgColor: dragItem.bgColor,
                            title: dragItem.title,
                            type: dragItem.type,
                            param: dragItem.param,
                            dataset: dragItem.dataset,
                            misSchema: dragItem.misSchema,
                            catalogId: dragItem.catalogId,
                            dashletId: dragItem.dashletId
                        });
                        $.extend(true, dragItem, {
                            dashlet: tempItem.dashlet,
                            widget: tempItem.widget,
                            clipHeadline: tempItem.clipHeadline,
                            bgColor: tempItem.bgColor,
                            title: tempItem.title,
                            type: tempItem.type,
                            param: tempItem.param,
                            dataset: tempItem.dataset,
                            misSchema: tempItem.misSchema,
                            catalogId: tempItem.catalogId,
                            dashletId: tempItem.dashletId
                        });
                    }
                },

                // Methode for right and bottam resize
                resize: function (data) {
                    var item = this.select(data.id);
                    var dHeight = data.height - item.height;
                    var dWidth = data.width - item.width;
                    // Resize downwards
                    if (data.handles == "s") {
                        // LOGIC: select all cells of current row, resize the height of all cells with respective resize
                        // For implementing logic, looping the index zero to max (layout 3 or 2)
                        // In each iteration, update the cells which have the columnNo same as cIdx from the selected collection                        
                        var columns = _.where(this.items, {
                            rowNo: item.rowNo
                        });
                        for (cIdx = 0; cIdx < data.layout; ) {
                            var coln = _.findWhere(columns, {
                                columnNo: cIdx
                            });
                            if (coln) {
                                coln.height = coln.height + dHeight;
                                cIdx += coln.colspan;
                            }
                            // When the absence of continues cell, take the nearest top cell which has the columnNo same as cIdx
                            else {
                                var itemsTop = $.grep(this.items, function (el, i) {
                                    return (el.rowNo < item.rowNo && el.columnNo == cIdx);
                                });
                                var nearColn = _.max(itemsTop, function (data) {
                                    return data.rowNo;
                                });
                                if (nearColn) {
                                    nearColn.height = nearColn.height + dHeight;
                                    cIdx += nearColn.colspan;
                                }
                            }
                        }
                    }
                    // Resize right side
                    else if (data.handles == "e") {
                        // LOGIC: select all cells which have the columnNo same as current columnNo, resize the width of all cells with respective resize
                        // For implementing logic, looping the index zero to max of row index
                        // In each iteration, update the cells which have the rowNo same as rIdx from the selected collection 
                        var rows = _.where(this.items, {
                            columnNo: item.columnNo
                        });
                        var maxRowNo = (_.max(this.items, function (data) {
                            return data.rowNo;
                        })).rowNo;
                        for (rIdx = 0; rIdx <= maxRowNo; ) {
                            var coln = _.findWhere(rows, {
                                rowNo: rIdx
                            });
                            if (coln) {
                                coln.width = coln.width + dWidth;
                                rIdx += coln.rowspan;
                            }
                            // When the absence of continues cell, take the nearest left cell which has the rowNo same as rIdx
                            else {
                                var itemsLeft = $.grep(this.items, function (el, i) {
                                    return (el.columnNo < item.columnNo && el.rowNo == rIdx);
                                });
                                var nearColn = _.max(itemsLeft, function (data) {
                                    return data.rowNo;
                                });
                                if (nearColn) {
                                    nearColn.width = nearColn.width + dWidth;
                                    rIdx += nearColn.rowspan;
                                }
                            }
                        }
                    }
                }
            },
            // Get the dashboard object
            get: function () {
                return {
                    backgroundColor: this.backgroundColor,
                    templateType: this.templateType,
                    dashlets: this.dashlets.get(),
                    shared: this.shared
                };
            },
            // Set the dashboard object
            set: function (data) {
                this.backgroundColor = data.backgroundColor;
                this.templateType = data.templateType;
                this.dashlets.items = data.dashlets;
                this.shared = data.shared;
            },
            // Set the dashlet for save
            setGeneric: function (_self) {
                // setting width and height in %
                var jsonData = this.dashlets.get();
                var that = this;
                _.each(jsonData, function (val) {
                    val.width = val.width + "%";
                    if (val.height < _self.options.minHeight) {
                        val.height = _self.options.minHeight;
                    }
                    val.height = (val.height * 100) / _self.options.mainContainerHeight + "%";
                    val.colspan = parseInt(val.colspan) || 1;
                });
            },
            // Set the dashlet for draw
            setSpecific: function (_self) {
                // removing % and px for operations
                var jsonData = this.dashlets.get();
                var that = this;
                _.each(jsonData, function (val) {
                    if (val.width.indexOf("%") > -1) {
                        val.width = parseFloat(val.width.trim("%"));
                        val.height = parseFloat(val.height.trim("%")) * _self.options.mainContainerHeight / 100;
                    } else {
                        val.width = parseFloat(width.trim("px"));
                        val.height = parseFloat(height.trim("px"));
                    }
                    val.colspan = parseInt(val.colspan) || 1;
                    val.rowspan = parseInt(val.rowspan) || 1;
                });

                var minHeight = _.min(jsonData, function (data) {
                    return data.height;
                });
                var minWidth = _.min(jsonData, function (data) {
                    return data.width;
                });

                if (minHeight.height < _self.options.minHeight) {
                    minHeight.height = _self.options.minHeight;
                }
                this.dashlets.itemTemplate.height = minHeight.height || 250;
                this.dashlets.itemTemplate.width = minWidth.width || 400;
            },

            // On layout change event
            changeLayout: function (type, _self) {
                var jsonData = this.dashlets.get(); // getting jsondata
                var counter = 0; //setting a counter
                var rowNo = 0;
                var columnNo = 0;
                var added;
                if (type == 1) added = 98;
                else if (type == 2) added = 48.5;
                else if (type == 3) added = 32;
                else added = 23.7;
                var width = added;
                var height = parseFloat($(window).height() * 29.99 / 100);
                this.templateType = type;

                _.each(jsonData, function (item) {
                    counter++;
                    item.rowNo = rowNo;
                    item.columnNo = columnNo++;
                    item.width = width;
                    item.height = height;
                    item.colspan = 1;
                    item.rowspan = 1;
                    if (counter == type) {
                        counter = 0;
                        columnNo = 0;
                        rowNo++;
                    }
                });
                addCell();

                _self._drawDashlets();

                // adding blank dashlet
                function addCell() {
                    var maxRow = (_.max(jsonData, function (data) {
                        return data.rowNo;
                    })).rowNo;
                    while (jsonData.length % type != 0) {
                        var options = {
                            columnNo: columnNo++,
                            width: width,
                            rowNo: maxRow,
                            height: height
                        };
                        _self.dashboard.dashlets.addItem(options);
                    }
                }
            },

            changeTheme: function (item, _self) {
                var items = _self.dashboard.get();
                items.backgroundColor = _self.options.themes[item];
                _self.dashboard.set(items);
                $(_self.element).find('#dashboardContainer').css("background", _self.options.themes[item]);
                $(_self.element).find("div#layoutContainer,div#wrappercontainer,#dashboardContainer").css("background", _self.options.themes[item]);
                $(".dataContent").css("background-color", _self.options.themes[item]);
            },

            // Check the context menu enable status
            contextMenuStatus: function (id, type) {
                var disabled = true;
                var item = this.dashlets.select(id);
                //Split Rows and Columns
                if (type == "splitColumn") {
                    // 1, the column span should be greater than one  
                    disabled = (item.colspan <= 1);
                } else if (type == "splitRow") {
                    // 1, the row span should be greater than one
                    disabled = (item.rowspan <= 1);
                } else {
                    var currentRow = _.where(this.dashlets.items, {
                        rowNo: item.rowNo
                    });
                    var currentColumn = _.where(this.dashlets.items, {
                        columnNo: item.columnNo
                    });
                    var layout = this.templateType;
                    var maxRowNo = (_.max(this.dashlets.items, function (data) {
                        return data.rowNo;
                    })).rowNo;

                    var sumColspan = 0;
                    _.each(currentRow, function (item) {
                        sumColspan += item.colspan;
                    });

                    switch (type) {
                        case type = "deleteRow":
                            // 1, current row should have all cells
                            // 2, none of them merged vertically with previous row-cell 
                            // 3, if it is only existing in the dashboard
                            if (sumColspan == layout) {
                                var maxRowspan = _.max(currentRow, function (data) {
                                    return data.rowspan;
                                });
                                if (maxRowspan.rowspan == 1) disabled = false;

                                var anyRows = _.max(this.dashlets.items, function (data) {
                                    return data.rowNo;
                                });
                                if (anyRows.rowNo == 0) disabled = true;
                            }
                            break;
                        case type = "insertBefore":
                            // 1, current row should have all cells
                            if (sumColspan == layout) {
                                disabled = false;
                            }
                            break;
                        case type = "insertAfter":
                            // 1, In case of the last row, always eligible
                            // 2, Other wise the next row should have all cells
                            // 3, none of them merged vertically with previous row-cell
                            if (item.rowNo < maxRowNo) {
                                var rowBelow = _.where(this.dashlets.items, {
                                    rowNo: (item.rowNo + 1)
                                });
                                var rbelowwColspan = 0;
                                _.each(rowBelow, function (val) {
                                    rbelowwColspan += val.colspan;
                                });
                                if (rbelowwColspan == layout) {
                                    disabled = false;
                                }
                            } else {
                                disabled = false;
                            }
                            break;
                        case type = "mergeLeft":
                            // 1, columnNo(columnNo + colspan) should be greater than 0
                            // 2, the nearest left cell should has the same row sapn with selected one 
                            if (item.columnNo > 0) {
                                var itemsLeft = $.grep(currentRow, function (el, i) {
                                    return (el.columnNo < item.columnNo);
                                });
                                var nearLeft = _.max(itemsLeft, function (data) {
                                    return data.columnNo;
                                });
                                if (item.rowspan == nearLeft.rowspan && item.columnNo == (nearLeft.columnNo + nearLeft.colspan)) disabled = false;
                            }
                            break;
                        case type = "mergeRight":
                            // 1, columnNo(columnNo + colspan) should be lesser than max cell count 
                            // 2, the nearest right cell should has the same row sapn with selected one
                            if ((item.columnNo + item.colspan) <= layout) {
                                var itemsRight = $.grep(currentRow, function (el, i) {
                                    return (el.columnNo > item.columnNo);
                                });
                                if (itemsRight && itemsRight.length > 0) {
                                    var nearRight = _.min(itemsRight, function (data) {
                                        return data.columnNo;
                                    });
                                    if (item.rowspan == nearRight.rowspan && (item.columnNo + item.colspan) == nearRight.columnNo) disabled = false;
                                }
                            }
                            break;
                        case type = "mergeTop":
                            // 1, rowNo should be greater than 0
                            // 2, the nearest top cell should has the same column sapn with selected one and most near
                            if (item.rowNo > 0) {
                                var itemsTops = $.grep(currentColumn, function (el, i) {
                                    return (el.rowNo < item.rowNo);
                                });
                                var nearTop = _.max(itemsTops, function (data) {
                                    return data.rowNo;
                                });
                                if (item.colspan == nearTop.colspan && item.rowNo == (nearTop.rowNo + nearTop.rowspan)) disabled = false;
                            }
                            break;
                        case type = "mergeBottom":
                            // 1, rowNo should be greater than max row count
                            // 2, the nearest bottom cell should has the same column sapn with selected one and most near
                            if ((item.rowNo + item.rowspan) <= maxRowNo) {
                                var itemsBottom = $.grep(currentColumn, function (el, i) {
                                    return (el.rowNo > item.rowNo);
                                });
                                if (itemsBottom && itemsBottom.length > 0) {
                                    var nearBottom = _.min(itemsBottom, function (data) {
                                        return data.rowNo;
                                    });
                                    if (item.colspan == nearBottom.colspan && (item.rowNo + item.rowspan) == nearBottom.rowNo) disabled = false;
                                }
                            }
                            break;
                    }
                }
                return disabled;
            }
        },

        // Initialising the dashlets
        _init: function () {
            //console.log("function name End Time " + new Date().toLocaleString(), arguments.callee.trace()); //function end
        },

        // creating the templates
        _create: function () {
            var self = this;
            //console.log("function name Start Time " + new Date().toLocaleString(), arguments.callee.trace()); //function start
            try {
                self.render();
                self._personalize();
            }
            catch (ex) {
                console.log(ex);
            }
        },

        //Taking json
        _jsonData: function () {
            var self = this;
            var dashUserId = 0;
            if (self.options.dashletUserId != undefined) {
                dashUserId = self.options.dashletUserId;
            }
            else {
                dashUserId = self.options.userid;
            }
            var getParamValues = {
                mId: self.options.menuId,
                name: self.options.name,
                userId: self.options.userid,
                dashletUserId: dashUserId
            };
            self._ajaxcall({
                url: self.options.apiURL + '/Get',
                type: 'GET',
                async: false,
                data: {
                    param: JSON.stringify(getParamValues)
                },
                success: function (data) {
                    _.each(data.dashletViews, function (val, i) { /*setting the layout value for current dashboard in entire json*/
                        if (val.name == data.currentView) {
                            val.layout = data.dashLayout;
                        }
                    });
			self.sameItem = [];
                    self.jsonArrayFull = data;
                    self.dashletViews = (data.dashletViews && data.dashletViews.length > 0) ? data.dashletViews : [];
                    self.options.name = data.currentView;
                    self.dashboard.set(data.dashLayout);
                    //if doShare is false current user cannot share the dashboard
                    if (self.dashboard.shared == true) {
                        var currentDashboard = _.findWhere(self.dashletViews, { name: self.options.name });
                        var isGot = false;
                        _.each(currentDashboard.share.specificUsers, function (value, idx) {
                            //checking for manager                        
                            if (!isGot) {
                                if (value.permission == self.options.permissions.manager) {
                                    _.each(value.userslist, function (val, i) {
                                        if (parseInt(val) >= _app.userGroupsCount) {
                                            self._ajaxcall({
                                                url: self.options.apiURL + '/GetUserGroups',
                                                type: 'GET',
                                                async: true,
                                                data: {
                                                    userGroupsId: JSON.stringify(val)
                                                },
                                                success: function (data) {
                                                    if ($.inArray(self.options.userid, data.Data.Records) > -1) {
                                                        self.dashboard["doShare"] = isGot = true;
                                                        return false;
                                                    }
                                                }
                                            });
                                        }
                                        else if (val == self.options.userid) {
                                            self.dashboard["doShare"] = isGot = true;
                                            return false;
                                        }
                                    });
                                }
                                else {
                                    self.dashboard["doShare"] = false;
                                }
                            }
                            else {
                                return false;
                            }
                        });
                    }
                    else {
                        self.dashboard["doShare"] = true;
                    }

                    var defaultViewSettings = null;
                    _.each(data.dashletViews, function (value) {
                        if (value.name == data.currentView) {
                            defaultViewSettings = value;
                        }
                    });
                    var myPos = [($(window).width() / 1.4), 80];                    
                }
            });
        },

        //Template for dashboard and dropdow filling
        _dashboardTemplate: function () {
            var template = '<div class="dashboardIcons">' +
                '{{#getAPI}}<div class="apiDiv">' +
                    '<div id="apiurl" class="apiurl" title="Get API URI"></div>' +
                    '<div class="apiContent">' +
                        '<div class="URIarrow-up"></div>' +
                        '<span class="urlLabel">Access Dataset via API</span>' +
                        '<span class="closeURI">X</span>' +
                        '<span class="urlText">API provides programmatic access to the dataset.</span>' +
                        '<span class="spnEndPoint">API Endpoint</span>' +
                        '<span class="spanURIInput"><input type="text" class="txtURI"/></span>' +
                        '<span class="spanURIEmail"><input type="checkbox" class="chkEmail"/>Send via Email' +
                        '<input type="text" class="txtEmail" placeHolder="Email Address" style="margin-left: 10px;"/></span>' +
                        '<div style="width: 100%;float: left;"><div class="btnEmail">Email</div>' +
                        '<div class="btnURI">Copy URL</div></div>' +
                    '</div>' +
                '</div>{{/getAPI}}' +
                '{{#dashLayout}}<div id="dashboardShare" class="{{#shared}}dashboardShareInActive{{/shared}} {{^shared}}dashboardShareActive{{/shared}}" title="Share">' +
                '</div>{{/dashLayout}}' +
                '<div class="iconsDiv"><div class="dashIcons"><div id="ddlLayoutType" class="notDisabled"><div class="arrow-up"></div>' +
                    '<span class="iconText">Change Layout</span> <span class="spriteIcon changeLayout">' +
                    '</span><span class="iconArrow"></span>' +
                    '<div class="layoutOption childMenu">' +
                        '{{#columnLayout}}<div id="{{columnClass}}" class="{{columnClass}} toolMenu" data-value="{{value}}">' +
                            '<span class="spriteIcon"></span><span class="iconText">{{text}}</span>' +
                        '</div>{{/columnLayout}}' +
                    '</div>' +
            '</div>' +
            '<span class="spriteIcon pipe notDisabled"></span>' +
            '<div id="changeTheme" class="changeTheme notDisabled">' +
                '<div class="arrow-up">' +
                '</div>' +
                '<span class="iconText">Change Theme</span> <span class="spriteIcon changeTheme">' +
                '</span><span class="iconArrow"></span>' +
                '<div class="themes childMenu">' +
                    '{{#themeLayout}}<div id="{{columnClass}}" class="{{columnClass}} toolMenu" data-value="{{value}}">' +
                        '<span class="spriteIcon"></span><span class="iconText"></span>' +
                    '</div>{{/themeLayout}}' +
                '</div>' +
            '</div>' +
            '<span class="spriteIcon pipe notDisabled"></span>' +
            '<div id="aCancelBtn" class="cancelButton notDisabled">' +
                '<span class="iconText">Reset</span> <span class="spriteIcon reset"></span>' +
            '</div>' +
            '<span class="spriteIcon pipe notDisabled"></span>' +
            '{{#dashLayout}}<div id="aSavebtn" class="saveButton {{#shared}}disableClass{{/shared}}">' +
                '<span class="iconText">Save</span> <span class="spriteIcon save"></span>' +
            '</div>{{/dashLayout}}' +
            '<span class="spriteIcon pipe notDisabled"></span>' +
            '<div id="refresh" class="refresh notDisabled">' +
                '<span class="iconText">Refresh</span> <span class="spriteIcon refresh"></span>' +
            '</div>' +
            '<span class="spriteIcon pipe notDisabled"></span>' +
        '</div>' +
        '<div id="expand_icon" class="expand_iconPlus" title="Expand">' +
        '</div>' +
    '</div>' +
    '<div id="dashletMenu" title="Dashboard View"></div>' +
'</div>' +
'<div id="dashboardContainer">{{#dashLayout}}<div id="wrappercontainer" style="background:{{backgroundColor}};">{{/dashLayout}}' +
                '<div id="hdnDialogDiv" style="display:none">' +
                    '<div id="dialog-confir" style="width:450px" title=""> </div>' +
                '</div> ' +
                '<div class="dashletMenuList" style="display: none;">' +
                '<div class="dashboardCollection">' +
                '<div class="contentdashletMenuList"></div>' +
                '<div class="dashletMenuListcolumnDivAdd">' +
                    '<div class="dashletMenuListImage"></div>Add Dashboard' +
                    '<div class="saveBox" title="Add Dashboard">' +
                        '<div class="saveBoxTri"></div>' +
                        '<div class="txtTitleBox"><input type="text" placeholder="Name" id="txtDash"/></div>' +
                        '<div class="saveColorBox">' +
                         '</div>' +
                        '</div>' +
                '</div>' +
                '</div>' +
                '<div class="headView"><a class="previous_link link" href="#"></a><span class="pageCountGroup"></span><a class="next_link link" href="#"></a></div>' +
                '</div>' +
                '{{#dashLayout}}<div id="layoutContainer" style="background:{{backgroundColor}}"></div>{{/dashLayout}}' +
                '</div></div>'
            return template;
        },

        _addDashletTemplate: function () {
            var template = '<div class="dialog-confirm">' +
                    '<div class="addContentTitle">' +
                        '<span class="txtDashlet">Filter/Dashlet</span>' +
                    '</div>' +
                    '<div class="icnDiv"><div class="addDashletIcon addDashletActive"></div><div class="clipHeadIcon" {{#clipHeadline}}style="display:block"{{/clipHeadline}}></div></div>' +
                    '<div class="addDashletBody">' +
                        '<div class="catalogDiv">' +
                            '<div class="fieldContainer" id="divDaslets">' +
                                '<div class="selectCatalog">Select Catalog</div>' +
                            '</div>' +
                        '</div>' +
                        '<div class="dashletDiv">' +
                            '<div class="fieldContainer" id="divDasletsName">' +
                                '<span class="txtDashlet" id="txtselectedtitle">{{name}}</span>' +
                            '</div>' +
                        '</div>' +
                        '<div class="titleDiv">' +
                            '<div class="labelContainer">Title : </div>' +
                            '<div class="fieldContainer"><input id="txtcontenttitle" type="text" name="dashlettitle" value="{{title}}"/></div>' +
                        '</div>' +
                        '<div class="clipHeadline">' +
                            '<span class="clipDiv"><input type="checkbox" id="chkClipHeadline" {{#enableWidget}}checked{{/enableWidget}}/><span class="clipLogo"></span>Clip Headline</span>' +
                        '</div>' +
                    '</div>' +
                    '{{#widget}}' +
                    '<div class="clipHeadBody">' +
                        '<span class="clipIcon"></span>' +
                        '<div class="headLine1">' +
                            '<span class="headlineText">Headline 1</span>' +
                            '<input type="text" class="txtHeadline1" value="{{headline1}}" style="color:{{head1Color}}" maxlength="40"/>' +
                            '<span class="imgColorIcon"><input type="hidden" id="hdnHead1" value="{{head1Color}}"/>' +
                            '</span>' +
                        '</div>' +
                        '<div class="headLine2">' +
                            '<span class="headlineText">Headline 2</span>' +
                            '<input type="text" class="txtHeadline2 mention"  value="{{headline2}}" maxlength="40" style="color:{{head2Color}}"/>' +
                             '<div class="millionize" title="In Million">M</div>' +
                            '<div class="billionize" title="In Billion">B</div>' +
                            '<span class="imgColorIcon">' +
                                '<input type="hidden" id="hdnHead2" value="{{head2Color}}"/>' +
                            '</span>' +
                        '</div>' +
            /*        '<div class="headLine2">' +
            '<textarea class="txtHeadline1 mention" value="{{headline}}" style="color:{{head1Color}}" maxlength="40"></textarea>' +
            '<span class="imgColorIcon"><input type="hidden" id="hdnHead1" value="{{head1Color}}"/></span>' +
            '</div>' +
            '<div class="headLine2">' +
            '<span class="headlineText">Headline 2</span>' +
            '<input type="text" class="txtHeadline2"  value="{{headline2}}" maxlength="65" style="color:{{head2Color}}"/>' +
            '<span class="imgColorIcon">' +
            '<input type="hidden" id="hdnHead2" value="{{head2Color}}"/>' +
            '</span>' +
            '</div>' +
            '<div class="enableWidget">' +
            '<div class="chkEnabledDiv"><input type="checkbox" class="chkEnableWidget" {{#enableWidget}}checked{{/enableWidget}}/>Enable Widget</div>' +
            '<div class="txtEnabledDiv" {{#enableWidget}}style="display:block"{{/enableWidget}}><input type="text" class="txtEnableWidget" placeHolder="Enter Percentage" value ="{{percentage}}" style="color:{{percentageColor}}"/>' +
            '<span class="imgColorIcon"><input type="hidden" id="hdnPercent" value="{{percentageColor}}"/></span>' +
            '</div>' +
            '</div>' +*/
                        '<div class="hoverOnDashlet"><input type="checkbox" class="chkHoverDashlet" {{#hoverOnDashelt}}checked{{/hoverOnDashelt}}/>Hover on Dashlet</div>' +
                    '</div>' +
                    '{{/widget}}' +
                    '<div class="buttonSet">' +
                        '<div class="btnCancel">Cancel</div>' +
                        '<div class="btnOk">Ok</div>' +
                    '</div>' +
                '</div>';
            return template;
        },

        _widgetTemplate: function () {
            return '{{#clipHeadline}}' +
                '{{#widget}}' +
                    '<div class="frontFace">' +
                        '{{^hoverOnDashelt}}<span class="closeDashletWidget" title="Remove"></span>{{/hoverOnDashelt}}' +
                        '<div class="widgetText"><div style="color:{{head1Color}}" class="headlineText1"></div>' +
                        '<div style="color:{{head2Color}}" class="headlineText2"></div></div>' +
                        '{{#enableWidget}}<div class="widgetChartContent" data-widget="guage" data-color="{{percentageColor}}" style="color:{{percentageColor}}; fill:{{percentageColor}};"></div>{{/enableWidget}}' +
                    '</div>' +
                    '{{#hoverOnDashelt}}' +
                        '<div class="backFace">' +
                        '<div class="header_div" data-bgcolor="{{bgColor}}" style="background-color:{{bgColor}}"><span title ="{{title}}" class="titleDashlet">{{title}}</span><span class="graphTypeDashlet" title="Change Type"><span class="spnType"><span></span></span></span><div class="btndshGrid1"></div><div class="selectedDashlet"><div class="addContentDiv"><span id="addContent" class="addContent spriteIcon toolMenu" title="Add Dashlet"></span><span class="dashletText"></span></div><div class="addRowDiv"><span class="rowSpan spriteIcon toolMenu" title="Row Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="rowOption">' +
                            '<div class="insertBef"><span id="insertBefore" class="insertBefore spriteIcon toolMenu condMenu" title="Insert Before"></span><span class="dashletText">Insert Before</span></div>' +
                            '<div class="insertAft"><span id="insertAfter" class="insertAfter spriteIcon toolMenu condMenu" title="Insert After"></span><span class="dashletText">Insert After</span></div>' +
                            '<div class="insertRw"><span id="deleteRow" class="deleteRow spriteIcon toolMenu condMenu" title="Delete Row"></span><span class="dashletText">DeleteRow</span></div>' +
                            '</div></div><div class="addCellDiv"><span class="cellSpan spriteIcon toolMenu" title="Cell Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="cellOption">' +
                            '<div class="mergeLef"><span id="mergeLeft" class="mergeLeft spriteIcon toolMenu condMenu" title="Merge Left"></span><span class="dashletText">Merge Left</span></div>' +
                            '<div class="mergeRig"><span id="mergeRight" class="mergeRight spriteIcon toolMenu condMenu" title="Merge Right"></span><span class="dashletText">Merge Right</span></div>' +
                            '<div class="mergeTp"><span id="mergeTop" class="mergeTop spriteIcon toolMenu condMenu" title="Merge Top"></span><span class="dashletText">Merge Top</span></div>' +
                            '<div class="mergeBo"><span id="mergeBottom" class="mergeBottom spriteIcon toolMenu condMenu" title="Merge Bottom"></span><span class="dashletText">Merge Bottom</span></div>' +
                            '<div class="splitRw"><span id="splitRow" class="splitRow spriteIcon toolMenu condMenu" title="Split Row"></span><span class="dashletText">Split Row</span></div>' +
                            '<div class="splitCn"><span id="splitColumn" class="splitColumn spriteIcon toolMenu condMenu" title="Split Column"></span><span class="dashletText">Split Column</span></div>' +
                            '</div></div></div><div class="defaultDashletIcons"><span class="closeDashlet" title="Remove"></span><span class="fullsizeSameWindow" title="Open in same window"></span><span class="swapDashlet" title="Move"></span><span class="fullsizeDashlet" title="Open in new window"></span><span class="refreshDashlet" title="Refresh"></span><span class="dashletFilters" title="Show Filters"></span></div></div>' +
                        '<div class="content_div"></div>' +
                        '<div class="contentDrid_div"></div>' +
                        '</div>' +
                    '{{/hoverOnDashelt}}' +
                 '{{/widget}}' +
                '{{/clipHeadline}}' +

                '{{^clipHeadline}}' +
                    '<div class="frontFace">' +
                    '<div class="header_div" data-bgcolor="{{bgColor}}" style="background-color:{{bgColor}}"><span title ="{{title}}" class="titleDashlet">{{title}}</span><span class="graphTypeDashlet" title="Change Type"><span class="spnType"></span><span class="spnArrow"></span></span><div class="btndshGrid1"></div><div class="selectedDashlet"><div class="addContentDiv"><span id="addContent" class="addContent spriteIcon toolMenu" title="Add Dashlet"></span><span class="dashletText"></span></div><div class="addRowDiv"><span class="rowSpan spriteIcon toolMenu" title="Row Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="rowOption">' +
                        '<div class="insertBef"><span id="insertBefore" class="insertBefore spriteIcon toolMenu condMenu" title="Insert Before"></span><span class="dashletText">Insert Before</span></div>' +
                        '<div class="insertAft"><span id="insertAfter" class="insertAfter spriteIcon toolMenu condMenu" title="Insert After"></span><span class="dashletText">Insert After</span></div>' +
                        '<div class="insertRw"><span id="deleteRow" class="deleteRow spriteIcon toolMenu condMenu" title="Delete Row"></span><span class="dashletText">DeleteRow</span></div>' +
                        '</div></div><div class="addCellDiv"><span class="cellSpan spriteIcon toolMenu" title="Cell Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="cellOption">' +
                        '<div class="mergeLef"><span id="mergeLeft" class="mergeLeft spriteIcon toolMenu condMenu" title="Merge Left"></span><span class="dashletText">Merge Left</span></div>' +
                        '<div class="mergeRig"><span id="mergeRight" class="mergeRight spriteIcon toolMenu condMenu" title="Merge Right"></span><span class="dashletText">Merge Right</span></div>' +
                        '<div class="mergeTp"><span id="mergeTop" class="mergeTop spriteIcon toolMenu condMenu" title="Merge Top"></span><span class="dashletText">Merge Top</span></div>' +
                        '<div class="mergeBo"><span id="mergeBottom" class="mergeBottom spriteIcon toolMenu condMenu" title="Merge Bottom"></span><span class="dashletText">Merge Bottom</span></div>' +
                        '<div class="splitRw"><span id="splitRow" class="splitRow spriteIcon toolMenu condMenu" title="Split Row"></span><span class="dashletText">Split Row</span></div>' +
                        '<div class="splitCn"><span id="splitColumn" class="splitColumn spriteIcon toolMenu condMenu" title="Split Column"></span><span class="dashletText">Split Column</span></div>' +
                        '</div></div></div><div class="defaultDashletIcons"><span class="closeDashlet" title="Remove"></span><span class="fullsizeSameWindow" title="Open in same window"></span><span class="swapDashlet" title="Move"></span><span class="fullsizeDashlet" title="Open in new window"></span><span class="refreshDashlet" title="Refresh"></span><span class="dashletFilters" title="Show Filters"></span></div></div>' +
                    '<div class="content_div"></div>' +
                    '<div class="contentDrid_div"></div>' +
                    '</div>' +
                '{{/clipHeadline}}'
        },

        _graphTypeTemplate: function () {
            return '<div class="chart-types-container">' +
                        '<div class="graphSet">' +
                            '{{#charts}}<div class="graphIcons sGraphtype">' +
                                '<div title="{{name}}" name="{{name}}" class="tiledGraph {{value}}" value="{{value}}"></div>' +
                                '<span class="sliced">{{name}}</span>' +
                            '</div>{{/charts}}' +
                        '</div>' +
                    '</div>';
        },

        showFilterTemplate: function () {
            return '<div class="filterContent">{{#showFilter}}<div><span style="font-weight:bold;">{{displayName}}</span><span>({{operator}})</span><span>{{value1}}</span><span>{{#value2}} and {{/value2}}{{value2}}</span></div>{{/showFilter}}</div>';
        },

        renderDashbaord: function () {
            var self = this;
            var data = {
                toolBar: self.options.toolBar,
                dashletViews: self.dashletViews,
                getAPI: self.options.getAPI,
                dashLayout: self.dashboard.get()
            };
            $.extend(true, data, {
                columnLayout: self.options.columnLayout,
                themeLayout: self.options.themeLayout
            });
            var out = Mustache.render(self._dashboardTemplate(), data);
            self.element.html(out);
        },

        // rendering dashboard template
        render: function () {
            var self = this;
            self._jsonData();
            self.renderDashbaord();
            self._setOptions();
            self.dashboard.setSpecific(self);
            self._drawDashlets();	     
            if (self.dashletViews.length == 0) {
                self.element.find('#dashboardShare').removeClass('dashboardShareActive').addClass('dashboardShareInActive');
            }
            else {
                self.element.find('#dashboardShare').removeClass('dashboardShareInActive').addClass('dashboardShareActive');
            }
        },

        // rendering dashboard template
        reRender: function () {
            var self = this;
            self._jsonData();
            self.dashboard.setSpecific(self);		
            self._fillDropdownView();
            self._drawDashlets();
            if (self.dashletViews.length == 0) {
                self.element.find('#dashboardShare').removeClass('dashboardShareActive').addClass('dashboardShareInActive');
            }
            else {
                self.element.find('#dashboardShare').removeClass('dashboardShareInActive').addClass('dashboardShareActive');
            }
        },

        _fillDropdownView: function () {
            var self = this;
            self.options.currentPage = 0;

            _.each(self.dashletViews, function (item, i) {
                if (item.background == null) {
                    item.background = self.options.dashboardColors[i % (self.options.dashboardColors.length)];
                }
            });

            var template = '{{#.}}<div class="dashletMenuListcolumnDiv" style="border: 1px solid {{background}}; color: {{background}}" dt-dashUserId="{{dashletUserId}}" title="{{name}}">' +
                               '<div class="optDiv"></div>{{#defaultView}}<div class="tickDefault" title="Default dashboard" ></div>{{/defaultView}}{{#shared}}<div class="shareIdentify" title="Shared by {{Username}}"></div>{{/shared}}' + /*--Added html tag for to identify the default dashboard and shared dashboard --by Athul */
                               '<div class="menuContainer">' +
                                   '<div class="createCopytxt {{#shared}}disableClass{{/shared}}"><span class="createCopy"></span>Create Copy</div>' +
                                   '<div class="renameDashboardtxt {{#shared}}disableClass{{/shared}}"><span class="renameDashboard"></span>Rename</div>' +
                                   '<div class="deleteDashboardtxt {{#shared}}disableClass{{/shared}}"><span class="deleteDashboard"></span>Delete</div>' +
                                   '<div class="defaultDashboardtxt"><span class="defaultDashboard"></span>Set as Default</div>' +
                               '</div>' +
                               '<div class="clkdashletMenuListImage" data = "{{name}}"></div>' +
                               '<div class="dashboardName" data="{{name}}">{{name}}</div>' +
                               '<div class="editBox" title="Edit Dashboard">' +
                               '<div class="saveBoxTri"></div>' +
                               '<div class="txtTitleBox"><input type="text" placeholder="Name" id="txtUpdate"/></div>' +
                               '<div class="colorBox">' +
                               '<input type="hidden" id="txtColor"/>' +
                               '</div>' +
                               '</div>' +
                           '</div>{{/.}}';
            var out = Mustache.render(template, self.dashletViews);
            self.element.find('.contentdashletMenuList').empty().html(out);
            _.each(self.element.find('.dashletMenuListcolumnDiv'), function (item) {
                $(item).find('.clkdashletMenuListImage').text($(item).find('.dashboardName').text().substring(0, 1).toUpperCase());
            });

            var number_of_items = self.element.find('.contentdashletMenuList').children().size();
            var maxPage = parseInt(number_of_items / self.options.showPerPage);
            self.element.find('.pageCount').remove();

            for (var t = 0; t < maxPage + 1; t++) {
                self.element.find('.headView span.pageCountGroup').append('<span class="pageCount" page="' + (t) + '">' + (t + 1) + '</span>');
                if (t == 0) self.element.find('.pageCount').addClass('pagingNum');
                if (number_of_items == self.options.showPerPage) break;
            }

            self.element.find('.previous_link').hide();
            if (number_of_items > self.options.showPerPage) self.element.find('.next_link').show();
            else self.element.find('.next_link').hide();
            self.element.find('#page_navigation .page_link:first').addClass('active_page');
            self.element.find('.contentdashletMenuList').children().css('display', 'none');
            self.element.find('.contentdashletMenuList').children().slice(0, self.options.showPerPage).css('display', 'block');
            _.each(self.element.find('.dashletMenuListcolumnDiv'), function (item) {
                if ($(item).children('.clkdashletMenuListImage').attr('data') == self.options.name) $('.dashboardOverlay').remove();
            });

            if (self.element.find('.pageCount').length > 0) {
                var flag = self.element.find('.pageCount.pagingNum').attr('page');
                if (self.element.find('.pageCount.pagingNum').attr('page') == 0) {
                    _.each(self.element.find('.pageCount'), function (val) {
                        if (parseInt(($(val).attr('page'))) == parseInt(flag + 2)) {
                            $(val).hide();
                            flag++;
                        }
                    });
                }
            }
        },

        _setOptions: function () {
            var self = this;
            var layoutwidth = self.element.find("div#layoutContainer").width() - 40;
            var windowWidth = $(window).width();
            var windowHeight = $(window).height();
            self.options.mainContainerHeight = windowHeight;
            var date = new Date();
            self.options.defaultToDate = moment(date),
                date.setMonth(date.getMonth() - 2);
            self.options.defaultFromDate = moment(date);
        },

        _colorPickerTemplate: function () {
            return '<div class="colorPickerDiv">' +
                '{{#.}}<div class="widgetColor" data-color="{{.}}" style="background-color:{{.}}"></div>{{/.}}' +
            '</div>';
        },

        // rendering dashlets
        _drawDashlets: function () {
			/////////For PanKM Maps
            /*var self = this;
            var template = '{{#.}}<div class="dashletContainer"><div class="col left cell box menu-1 unloaded" id="{{id}}" type="{{type}}" data-column="{{columnNo}}" data-rowno="{{rowNo}}" data-colspan="{{colspan}}" data-rowspan="{{rowspan}}" data-contenttitle="{{title}}" data-content="{{dashlet}}" style="width:{{width}}%; height:{{height}}px; left:{{left}}%; top:{{top}}px;">' +
                '<div class="content"></div></div></div>{{/.}}';
            var json = self.dashboard.dashlets.setAlign(self);
            var out = Mustache.render(template, json);

            self.element.find('div#layoutContainer').html(out);
            if ($('#dashboardContainer').parents('.dataContent').length > 0)
                self.element.find('div#dashboardContainer').height($('#dashboardContainer').parents('.dataContent').height() - 45);
            self.element.find('.dashletName').siblings().hide();
            if ($("#h3menu").find('span').hasClass('dashletName')) $('.dashletName').remove();
            if (self.options.name != "")
                $("#h3menu").append("<span class='dashletName'>" + self.options.name + "</span>");

            self.element.find('#wrappercontainer,#layoutContainer,#dashboardContainer').css('background-color', self.dashboard.backgroundColor);
            $('.dataContent').css('background-color', self.dashboard.backgroundColor);
            self._resizable();*/
        },

        _createWidgetChart: function (id, type) {
            var self = this;
            var dashlet = self.dashboard.dashlets.select(id);
            $('#' + id).find('.frontFace .headlineText1,.frontFace .headlineText2').removeClass('textCenter').css('margin', 'auto');
            $('#' + id).find('.frontFace').find('.widgetChartContent').attr('data-widget', '').empty();
            var percentage = parseInt(dashlet.widget.percentage);
            $('#' + id).find('.frontFace').find('.headlineText1').text(""); //dashlet.widget.headline1
            $('#' + id).find('.frontFace').find('.headlineText2').text(""); //dashlet.widget.headline2
            switch (type) {
                case "progressBar":
                    $('#' + id).find('.frontFace').find('.widgetChartContent').attr('data-widget', 'progressBar').append('<div class="widget"><div class="status"><div class="status-title"></div><div class="status-number"></div></div><div class="progress"><span class="progress-bar progress-bar-success green-sharp"><span class="sr-only"></span></span></div></div>');
                    $('#' + id).find('.frontFace').find('.widgetChartContent').find('.widget .progress-bar').animate({
                        width: percentage + '%'
                    }, 500).css('display', 'list-item');
                    $('#' + id).find('.widget').find('.status-number').html(percentage + '%');
                    $('#' + id).find('.progress-bar').css('background-color', $('#' + id).find('.frontFace').find('.widgetChartContent').attr('data-color'));
                    $('#' + id).find('.status-number').css('color', $('#' + id).find('.frontFace').find('.widgetChartContent').attr('data-color'));
                    if (screen.width > 991) {
                        if (self.dashboard.get().templateType == "1") {
                            $('#' + id).find('.frontFace .headlineText1,.frontFace .headlineText2').addClass('textCenter');
                            $('#' + id).find('.widget').width('15%');
                            $('#' + id).find('.widget').css('margin-left', (($('#' + id).width() - 200) / 2)).css('float', 'none');
                        }
                        else {
                            _.each(self.dashboard.dashlets.get(), function (val) {
                                if (val.rowspan > 1) {
                                    $('#' + val.id).find('.frontFace .headlineText1,.frontFace .headlineText2').addClass('textCenter');
                                    $('#' + val.id).find('.frontFace .headlineText1').css('margin-top', ((val.height - 210) / 2));
                                }
                            });
                        }
                    }
                    break;
                case "radial":
                    $('#' + id).find('.frontFace').find('.widgetChartContent').attr('data-widget', 'radial').append('<div class="divRadial"></div>');
                    var div1 = d3.select('#' + id + ' .divRadial');
                    var rp1 = radialProgress('#' + id + ' .divRadial').label(' ').diameter(100).value(percentage).render();
                    if (screen.width > 991) {
                        if (self.dashboard.get().templateType == 1) {
                            $('#' + id).find('.frontFace .headlineText1,.frontFace .headlineText2').addClass('textCenter');
                            $('#' + id).find('.divRadial').css('margin-left', (($('#' + id).width() - 90) / 2)).css('float', 'none');
                        }
                        else {
                            _.each(self.dashboard.dashlets.get(), function (val) {
                                if (parseInt(val.rowspan) > 1) {
                                    $('#' + val.id).find('.frontFace .headlineText1,.frontFace .headlineText2').addClass('textCenter');
                                    $('#' + val.id).find('.divRadial').css('margin-left', (($('#' + val.id).width() - 80) / 2)).css('float', 'none');
                                    $('#' + val.id).find('.frontFace .headlineText1').css('margin-top', ((val.height - 210) / 2));
                                    if (screen.width > 991) { $('#' + val.id).find('.frontFace .widgetChartContent').css('margin-top', ((val.height - 210) / 2)); }
                                }
                            });
                        }
                    }
                    break;
                case "guage":
                    $('#' + id).find('.frontFace').find('.widgetChartContent').attr('data-widget', 'guage').append('<div class="chart-gauge"></div>');
                    createGuage(percentage, id);
                    if (screen.width > 991) {
                        if (self.dashboard.get().templateType == "1") {
                            $('#' + id).find('.frontFace .headlineText1,.frontFace .headlineText2').addClass('textCenter');
                            $('#' + id).find('.chart-gauge').css('margin-left', (($('#' + id).width() - 185) / 2)).css('float', 'none');
                        }
                        else {
                            _.each(self.dashboard.dashlets.get(), function (val) {
                                if (val.rowspan > 1) {
                                    $('#' + val.id).find('.frontFace .headlineText1,.frontFace .headlineText2').addClass('textCenter');
                                    $('#' + val.id).find('.chart-gauge').css('margin-left', (($('#' + val.id).width() - 185) / 2)).css('float', 'none');
                                    $('#' + val.id).find('.frontFace .headlineText1').css('margin-top', ((val.height - 210) / 2));
                                    if (screen.width > 991) { $('#' + val.id).find('.frontFace .widgetChartContent').css('margin-top', ((val.height - 210) / 2)); }
                                }
                            });
                        }
                    }
                    break;
                default:
                    $('#' + id).find('.frontFace .headlineText1,.frontFace .headlineText2').addClass('textCenter');
                    $('#' + id).find('.frontFace .headlineText1').css('margin-top', ($('#' + id).height() / 2 - $('#' + id).find('.frontFace .headlineText1').height()));
                    break;
            }
        },

        _colorBoxTemplate: function () {
            var self = this;
            var template = '{{#.}}<span class="colors" color="{{.}}" style="background:{{.}}"></span>{{/.}}';
            return template;
        },

        _loadEmptyDashlets: function (element) {
            $('<div class="emptyDashlet"><img src="/Scripts/ContextMenu/Images/contextmenu/noData0.png"/></div></div>').insertAfter($(element).find('.contentDrid_div'));
        },

        drawWidget: function (element, dashlet) {
            var self = this;
            if (dashlet.clipHeadline) {
                var widgetType = '<div class="selectType">' +
                                            '<div class="widgetTypes">' +
                                                '<div class="typeText widgetCharts text_class" data-value="text" title="Text"></div>' +
                                                '<div class="typeRadial widgetCharts radial_class" data-value="radial" title="Radial"></div>' +
                                                '<div class="typeGuage widgetCharts guage_class" data-value="guage" title="Guage"></div>' +
                                                '<div class="typeProgress widgetCharts progressBar_class" data-value="progressBar" title="Progress Bar"></div>' +
                                            '</div>' +
                                    '</div>' +
                                    '<div class="grphTypeMobile clickMobileType"></div>';
                $(widgetType).insertBefore('#' + dashlet.id);
                $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').css('margin-left', $('#' + dashlet.id).position().left + $('#' + dashlet.id).width() - self.element.find('.selectType').width());
                if (screen.width > 991) $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').css('margin-top', dashlet.top - 13);
                else $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').css('margin-top', '2px');
            }
            var out = Mustache.render(self._widgetTemplate(), dashlet);
            element.empty().html(out);
        },

        _drawDashlet: function (dashlet, container, graphTypeChanged) {
            var self = this;
            var element = container.find('.content');
            if (dashlet != undefined) {
                self.drawWidget(element, dashlet); // drawing widget for each dashlet.

                element.find('.content_div').each(function () {
                    var content = $(this);
                    var parent = content.parents('.col');
                    content.height(parent.height() - $('.header_div', parent).height());
                    parent.find('.contentDrid_div').height(parent.height() - $('.header_div', parent).height());
                });

                if ($.trim(dashlet.dashlet).length > 0) {
                    element.find("div.header_div span.titleDashlet").html(dashlet.title);
                    var uniqueId = self._getUniqueIdentity("reportTabs_");
                    var l_tabReport = self._getUniqueIdentity("tabReport_");
                    var divcontent = '<div id="reportTabs_' + uniqueId + '" class="reportTabs">' +
                    '<div class="mis-container" id=' + l_tabReport + '>' +
                    '<div id=' + self._getUniqueIdentity("recline_") + ' class="recline_Tab"><div id=' + self._getUniqueIdentity("viewer_") + ' class="viewerTab"></div></div' +
                    '</div>' +
                    '</div>'
                    element.find("div.content_div").append(divcontent);
                    element.attr("type", dashlet.type);
                    $('.emptyDashlet', element).hide();
                    element.find(".swapDashlet, .fullsizeDashlet,.fullsizeSameWindow, .refreshDashlet,.closeDashlet,.dashletFilters", ".header_div").show();
                    self.callSchema(dashlet, element, graphTypeChanged);
                }
                else {
                    self._emptyDashlet(element);
                    self._loadEmptyDashlets(element);
                    container.find('.unloadedDiv').remove();
                }

                if (dashlet.clipHeadline) {
                    self._createWidgetChart(dashlet.id, dashlet.widget.chartType);
                    $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').find('.' + dashlet.widget.chartType + '_class').addClass('activeCharts');
                }
                else $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').remove();

                if (dashlet.clipHeadline && screen.width < 991) $('#' + dashlet.id).find('.frontFace').css('margin-top', '40px');

                if (dashlet.widget.hoverOnDashelt) $('#' + dashlet.id).parents('.dashletContainer').find('.clickMobileType').show();
                else $('#' + dashlet.id).parents('.dashletContainer').find('.clickMobileType').hide();
            }

            switch (parseInt(self.dashboard.get().templateType)) {
                case 4:
                    self.element.find('.fourColumn').addClass('disableClass');
                    self.element.find('.threeColumn').removeClass('disableClass');
                    self.element.find('.twoColumn').removeClass('disableClass');
                    self.element.find('.singleColumn').removeClass('disableClass');
                    break;
                case 3:
                    self.element.find('.fourColumn').removeClass('disableClass');
                    self.element.find('.threeColumn').addClass('disableClass');
                    self.element.find('.twoColumn').removeClass('disableClass');
                    self.element.find('.singleColumn').removeClass('disableClass');
                    break;
                case 2:
                    self.element.find('.twoColumn').addClass('disableClass');
                    self.element.find('.threeColumn').removeClass('disableClass');
                    self.element.find('.fourColumn').removeClass('disableClass');
                    self.element.find('.singleColumn').removeClass('disableClass');
                    break;
                default:
                    self.element.find('.singleColumn').addClass('disableClass');
                    self.element.find('.fourColumn').removeClass('disableClass');
                    self.element.find('.threeColumn').removeClass('disableClass');
                    self.element.find('.twoColumn').removeClass('disableClass');
                    break;
            }
            if (screen.width > 991) {
                self._setSwappable();
            }

            //hidind/showing share icon based on schema
            if (self.dashboard["doShare"] == false) {
                self.element.find('.dashboardIcons #dashboardShare').removeClass('dashboardShareActive').addClass('dashboardShareInActive');
                self.element.find('#aSavebtn').addClass('disableClass');
            }
            else {
                self.element.find('.dashboardIcons #dashboardShare').removeClass('dashboardShareInActive').addClass('dashboardShareActive');
                self.element.find('#aSavebtn').removeClass('disableClass');
            }
        },

        widgetData: function (element, dashlet, headline1, headline2, widgetField, misSchema, coredata) {
             var self = this;
            element.parents('.col').find('.unloadedDiv').remove();
            dashlet.widget.headline2 = headline2.toString();
            dashlet.widget.headline1 = headline1;
            dashlet.widget.widgetField = widgetField;
            var item = _.findWhere(misSchema.fields, { id: dashlet.widget["widgetField"] });
            if (item) {
		var cal;
                if (dashlet.widget.headline2.indexOf('$') != -1 && dashlet.widget.headline2.indexOf('undefined') == -1 && dashlet.widget.headline2.split(/\s+/)[1] != "") {
                    if (dashlet.widget.headline2.split(/\s+/)[1] == 'Million') {
                        cal = 1000000;
                    } else { cal = 1000000000 }
                    dashlet.widget.headline2 = self.getAligned(cal, dashlet.widget.headline2.split(/\s+/)[1], self._calcPercentage(item, coredata).toString());
                }
                else {
                    dashlet.widget.headline2 = self._calcPercentage(item, coredata);
                }		
                $('#' + dashlet.id).find('.headlineText1').html(dashlet.widget.headline1);
                $('#' + dashlet.id).find('.headlineText2').html(dashlet.widget.headline2);
            }
        },

        callSchema: function (dashlet, element, graphTypeChanged) {
            var self = this;
            var schemaURLs = self.options.apiURL + "/GetSchema";
            var catalog, dashlets;
            var param = self._getQueryString(schemaURLs, true, dashlet);
            self._ajaxcall({
                url: schemaURLs,
                type: 'GET',
                async: true,
                data: param,
                success: function (data) {
                    data = data.Records;
                    if (data) {
                        catalog = {
                            CatalogTypeId: data.CatalogTypeId,
                            CatalogId: data.CatalogId,
                            savedFilters: $.parseJSON(data.LegendQuery),
                            dashletList: [],
                            asOfDate: data.asOfDate
                        };
                        var schema = JSON.parse(data.Schema);
                        var visual = schema.layoutSchema;
                        dashlet.type = visual.type;
                        var p_jsondata = $.parseJSON(data.misSchema);
                        if (typeof p_jsondata.misSchema != "undefined") {
                            var misSchema = p_jsondata.misSchema;
                            misSchema.views = visual;
                            if (misSchema.views.type == "graph" && graphTypeChanged == undefined) {
                                dashlet.param.graphType = misSchema.views.view.graph.state.graphType;
                            }
                            if (graphTypeChanged) {
                                misSchema.views.view.graph.state.graphType = dashlet.param.graphType;
                            }
                             if ($.inArray(dashlet.dashletId.toString(), self.sameItem) == -1) {
				     var paramData = new Object();
                                paramData.mId = self.options.menuId;
                                paramData.userid = self.options.userid;
                                paramData["getData"] = JSON.stringify(self._getQueryString(self.options.apiURL + '/GetData', true, dashlet));
                                self._ajaxcall({
                                    url: self.options.apiURL + '/POST',
                                    type: 'POST',
                                    async: false,
                                    data: paramData,
                                    success: function (data) {
                                        data = JSON.parse(data.Data);
                                        var coredata = data;
                                        if (typeof coredata === 'undefined') return;
                                        if (!coredata) return;
                                        if (typeof coredata.Records == 'string') {
                                            coredata.Records = JSON.parse(coredata.Records);
                                        }
                                        misSchema["data"] = coredata.Records;
                                        misSchema["totalRecords"] = coredata.TotalRecordCount;
                                        TotalRecordCount = coredata.TotalRecordCount;
                                        var withComputedFields = [], computedFields = schema.computedFields;
                                        withComputedFields = p_jsondata.misSchema.fields;
                                        _.each(computedFields, function (val, i) {
                                            withComputedFields.push(val);
                                        });
                                        var records = _appFun.getAlaSQL(p_jsondata.misSchema.fields, coredata.Records);
                                         if (JSON.parse(paramData["getData"]).query && JSON.parse(JSON.parse(paramData["getData"]).query).filter.length > 0) {
                                            records = applyFilterQuery(records, JSON.parse(JSON.parse(paramData["getData"]).query));
                                        }
                                        var dataset = new recline.Model.Dataset({
                                            records: records || [],
                                            fields: p_jsondata.misSchema.fields,
                                            catalog: catalog,
                                            formulaGrid: false,
                                            pagingState: misSchema.views.view.state.pagingState,
                                            queryInit: p_jsondata.misSchema.views.view.state.queryState,
                                            totalRecords: coredata.TotalRecordCount
                                        });

                                        dashlet["dataset"] = dataset;
                                        dashlet["misSchema"] = misSchema;
                                		var sameItem = _.where(self.dashboard.dashlets.get(), { dashletId: dashlet.dashletId });
                                		_.each(sameItem, function (val, i) {
                                       		 	val["dataset"] = dataset;
                                        			val["misSchema"] = misSchema;
                                		});                                
                                        self.callDashlet(dashlet, element);
					      self.sameItem.push(dashlet.dashletId);						
                                    }
                                });				     
                            }      
				else 
				{
				     var sameItem = _.where(self.dashboard.dashlets.get(), { dashletId: dashlet.dashletId.toString() });
                                var dtSet = $.grep(sameItem, function (val, i) {
                                    return val.dataset;
                                });
                                dashlet.dashletId = dashlet.dashletId.toString();
                                dashlet["dataset"] = dtSet[0].dataset;
                                dashlet["misSchema"] = dtSet[0].misSchema;
                                //if (graphTypeChanged) {
                                    dashlet.misSchema.views.view.graph.state.graphType = dashlet.param.graphType;
                                //}
                                self.callDashlet(dashlet, element);   
				}             
                        }
                        else {
                            self._emptyDashlet(element), self._loadEmptyDashlets(element);
                            element.parents('.col').find('.unloadedDiv').remove();
                        }

                        if (dashlet.type == "graph" || dashlet.type == "timeseries") {
                            element.find('.graphTypeDashlet').show();
                            element.find('.graphTypeDashlet').append(Mustache.render(self._graphTypeTemplate(), {
                                charts: dashlet.type == "timeseries" ? self.options.timeseriesTypes : self.options.graphTypes
                            }));
                            if (screen.width > 991) {
                                if (dashlet.type == "timeseries") {
                                    $('#' + dashlet.id).find('.chart-types-container').css('left', ($('#' + dashlet.id).find('.graphTypeDashlet').position().left - 8) + 'px');
                                } else {
                                    $('#' + dashlet.id).find('.chart-types-container').css('left', '0px');
                                }
                            }
                            $('#' + dashlet.id).find('.' + dashlet.param.graphType).addClass('active');
                        } else {
                            element.find('.graphTypeDashlet').hide();
                        }
                    } else {
                        self._emptyDashlet(element),
                        self._loadEmptyDashlets(element),
                        element.parents('.col').find('.unloadedDiv').remove();
                    }                    
                }
            });
        },

        callDashlet: function (dashlet, element) {
            var self = this;
            var l_subviewer = element.find(".viewerTab");
            var headline2 = dashlet.widget.headline2;
            dashlet.widget.headline2 = '';
            var headline1 = dashlet.widget.headline1;
            dashlet.widget.headline1 = '';
            var widgetField = dashlet.widget.widgetField;
            dashlet.widget.widgetField = '';
            if ((dashlet.clipHeadline && dashlet.widget.hoverOnDashelt) || dashlet.clipHeadline == false) {
                switch (dashlet.type) {
                    case "grid":
                        savedFilters = _appFun._create_GridExplorer(dashlet.dataset, l_subviewer, dashlet.misSchema);
                        break;
                    case "graph":
                        savedFilters = _appFun._create_GraphExplorer(dashlet.dataset, l_subviewer, dashlet.misSchema, dashlet.showLegend);
                        break;
                    case "pivot":
                        savedFilters = _appFun._create_PivotExplorer(dashlet.dataset, l_subviewer, dashlet.misSchema);
                        break;
                    case "map":
                        savedFilters = _appFun._create_MapExplorer(dashlet.dataset, l_subviewer, dashlet.misSchema);
                        break;
                    default:
                        savedFilters = "";
                        break;
                }
                if (dashlet.clipHeadline && dashlet.widget.hoverOnDashelt) {
                    self.widgetData(element, dashlet, headline1, headline2, widgetField, dashlet.misSchema, dashlet.misSchema['data']);
                }
                self.savedFilters(savedFilters);
            }
            else {
                self.widgetData(element, dashlet, headline1, headline2, widgetField, dashlet.misSchema, dashlet.misSchema['data']);
            }
        },

        /*  Method for create a unique id
        */
        _getUniqueIdentity: function (stratwith) {
            return String(stratwith) + Math.floor(Math.random() * 99999);
        },

        _jsonpcall: function (url, type, postData, async, success) {
            $.jsonp({
                url: url,
                callbackParameter: "callback",
                data: postData,
                cache: false,
                success: function (data) {
                    if (data && typeof data == "string") data = JSON.parse(data);
                    success(data)
                },
                error: function (xOptions, textStatus) {
                    if (window.console && window.console.log) console.log(textStatus)
                }
            });
        },

        // loading the content of dashlet
        _loadDashlets: function (dashlet, graphTypeChanged) {
            var self = this;
            self.element.find('#dashboardContainer').css("background", self.dashboard.get().backgroundColor);
            self.element.find("div#layoutContainer,div#wrappercontainer,#dashboardContainer").css("background", self.dashboard.get().backgroundColor);
            var element = $('#' + dashlet.id);
            self._drawDashlet(dashlet, element, graphTypeChanged);
            self.element.find(".notDisabled").removeClass('disableClass');
        },

        _emptyDashlet: function (div) {
            $("span.titleDashlet", div).empty();
            $('.emptyDashlet', div).show();
            $("div.content_div", div).empty();
            div.find(".swapDashlet, .fullsizeDashlet,.fullsizeSameWindow, .refreshDashlet,.closeDashlet,.graphTypeDashlet,.dashletFilters", ".header_div").hide();
        },

        viewOnSameWindow: function (id) {
            var self = this;
            var dashlet = self.dashboard.dashlets.select(id);
            if (dashlet.dashlet != "") {
                var baseUrl = self._getBaseURL() + dashlet.dashlet + "?misID=" + dashlet.dashletId + "&fromCatalogViewer=" + dashlet.catalogId;
                var queryStrings = self._getQueryString(dashlet.dashlet, false, dashlet);

                queryStrings["isDashlet"] = 2;
                queryStrings["dashbord"] = self.options.name;

                var form = $("<form id='formPopout' method='POST' action='" + baseUrl + "' target='_top' />");
                _.each(queryStrings, function (value, key) {
                    var input = $("<input type='hidden' name='" + key + "' />").val(value);
                    form.append(input);
                });
                form.appendTo('body').submit();
            }
            else {
                if (self.element.find('.dialog-confirm').length == 0) {
                    self._errorBox({
                        message: "Dashlet is empty. Please load Dashlet.",
                        class: "message info-dialog custom-style no-titlebar",
                        errorType: true
                    });
                }
            }
        },

        // personlising the dashboard
        _personalize: function () {
            var self = this;
            if (self.options.toolBar) self._initToollbar();
            if (self.options.contextMenu) self._initContextMenu();
            if (self.options.userRights == "") {
                self.element.find('.dashletMenuListcolumnDivAdd,.saveButton,.optDiv').addClass('savebutton_hide');
            }

            $(document).on('click', '.fullsizeSameWindow', function (event) {
                event.preventDefault();
                event.stopPropagation();
                var id = $(this).parents('div.col').attr("id"); // setting the dashlet id                
                if (id != "") {
                    self.viewOnSameWindow(id);
                }
            });

            $(document).on('change', '.chkEmail', function (event) {
                if ($(this).is(':checked')) {
                    self.element.find('.txtEmail,.btnEmail').show();
                }
                else {
                    self.element.find('.txtEmail,.btnEmail').hide();
                }
            });

            $(document).on('click', '.btnEmail', function (event) {
                _app.notify({
                    title: 'Under Customization !!!',
                    type: 'success',
                    text: 'URl has been sent to <b>' + self.element.find('.txtEmail').val() + '</b>',
                    delay: 3000
                });
                self.element.find('.apiContent').hide();
            });

            $(document).on('click', '.apiurl', function (event) {
                self.element.find('.apiContent').show();
                self.element.find('.txtURI').val(window.location.host + self.options.apiURL + '/GetSchemaData?name=' + self.jsonArrayFull.currentView + '&userId=' + self.options.userid);
            });

            $(document).on('click', '.closeURI', function (event) {
                self.element.find('.apiContent').hide();
            });

            $(document).on('click', '.btnURI', function (event) {
                var elem = document.getElementsByClassName("txtURI")[0];
                // create hidden text element, if it doesn't already exist
                var targetId = "_hiddenCopyText_";
                var isInput = elem.tagName === "INPUT" || elem.tagName === "TEXTAREA";
                var origSelectionStart, origSelectionEnd;
                if (isInput) {
                    // can just use the original source element for the selection and copy
                    target = elem;
                    origSelectionStart = elem.selectionStart;
                    origSelectionEnd = elem.selectionEnd;
                } else {
                    // must use a temporary form element for the selection and copy
                    target = document.getElementById(targetId);
                    if (!target) {
                        var target = document.createElement("textarea");
                        target.style.position = "absolute";
                        target.style.left = "-9999px";
                        target.style.top = "0";
                        target.id = targetId;
                        document.body.appendChild(target);
                    }
                    target.textContent = elem.textContent;
                }
                // select the content
                var currentFocus = document.activeElement;
                target.focus();
                target.setSelectionRange(0, target.value.length);

                // copy the selection
                var succeed;
                try {
                    succeed = document.execCommand("copy");
                } catch (e) {
                    succeed = false;
                }
                // restore original focus
                if (currentFocus && typeof currentFocus.focus === "function") {
                    currentFocus.focus();
                }

                if (isInput) {
                    // restore prior selection
                    elem.setSelectionRange(origSelectionStart, origSelectionEnd);
                } else {
                    // clear temporary content
                    target.textContent = "";
                }
                self.element.find('.apiContent').hide();
                return succeed;
            });

            // When the user clicks anywhere outside of the modal, close it
            $(document).on('click', function (event) {
                if (!$(event.target).is(".apiDiv, .apiDiv *")) {
                    self.element.find('.apiContent').hide();
                }
            });

            $(document).on('click', '.selectCatalog', function (event) {
                var that = this;
 		  $(this).parents().find('.addDashletBody').find('#chkClipHeadline').attr('checked', false);
                $('.popupDiv').remove();
                $(this).append('<div class="popupDiv"><div class="popupSearch"><input type="text" placeHolder="Search.."/></div></div>');
                var id = $(this).parents('.col').attr("id");
                var dashlet = self.dashboard.dashlets.select(id);
                var widget = $(this).find('.popupDiv').dialog({
                    width: 600,
                    height: 500,
                    title: "Select Filter/Dashlet",
                    modal: true,
                    buttons: {
                        "Ok": function () {
                            $(this).dialog("destroy");
                            $(that).parents('.dialog-confirm').find('#txtcontenttitle').val(dashlet.selectedCatalog.Caption);
                            $(that).parents('.dialog-confirm').find('.txtDashlet').text(dashlet.selectedCatalog.Caption)
                        },
                        Cancel: function () {
                            $(this).dialog("destroy");
                        }
                    },
                    close: function () {
                        $(this).dialog('destroy');
                    }
                });

                if (self.dashletList.length == 0) {
                    if (self.options.dashletUserId != undefined) {
                        dashUserId = self.options.dashletUserId;
                    } else {
                        dashUserId = self.options.userid;
                    }
                    var getParamValues = {
                        mId: self.options.menuId,
                        name: self.options.name,
                        userId: self.options.userid,
                        dashletUserId: dashUserId
                    };
                    self._ajaxcall({
                        url: self.options.apiURL + '/GetDashletList',
                        type: 'GET',
                        async: true,
                        data: {
                            param: JSON.stringify(getParamValues)
                        },
                        success: function (data) {
                            self.dashletList = data;
                            if (self.dashletList.length == 0) {
                                self._listView(self.dashletList, dashlet, "error");
                            } else self._listView(self.dashletList, dashlet, "success");
                        }
                    });
                }
                self._listView(self.dashletList, dashlet, "success");
                $(widget).parents('.ui-dialog').addClass('popupDivMain').find('.ui-dialog-titlebar').addClass('popupTitle');
            });

            $(document).on('keyup', '.popupSearch input', function (event) {
                var text = $(this).val();
                var catalogs = $.extend(true, [], self.dashletList);
                var searchlist = [];
                var flag;
                if (text != "") {
                    _.each(catalogs, function (val, i) {
                        flag = false;
                        matchtext(val, text);
                        if (flag == true) {
                            searchlist.push(val);
                        }
                    });
                    self._listView(searchlist, undefined, "success");
                }
                else self._listView(catalogs, undefined, "success");


                function matchtext(val, text) {
                    if (val.Caption.toLowerCase().search(text.toLowerCase()) != -1) {
                        flag = true;
                    }
                    if (val.Children.length > 0) {
                        _.each(val.Children, function (col) {
                            matchtext(col, text);
                        });

                    }
                }
            });

            $(document).on('click', '.fullsizeDashlet', function (event) {
                event.preventDefault();
                event.stopPropagation();
                var id = $(this).parents('div.col').attr("id"); // setting the dashlet id
                if (id != "") {
                    var dashlet = self.dashboard.dashlets.select(id);
                    if (dashlet.dashlet != "") {
                        var baseUrl = self._getBaseURL() + dashlet.dashlet + "?misID=" + dashlet.dashletId + "&fromCatalogViewer=" + dashlet.catalogId;
                        var queryStrings = self._getQueryString(dashlet.dashlet, false, dashlet);

                        queryStrings["isDashlet"] = 2;
                        queryStrings["dashbord"] = self.options.name;
                        var form = $("<form id='formPopout' method='POST' action='" + baseUrl + "' target='_blank' />");
                        _.each(queryStrings, function (value, key) {
                            var input = $("<input type='hidden' name='" + key + "' />").val(value);
                            form.append(input);
                        });
                        form.appendTo('body').submit();
                    }
                    else {
                        self._errorBox({
                            message: "Dashlet is empty. Please load Dashlet.",
                            class: "message info-dialog custom-style no-titlebar",
                            errorType: true
                        });
                    }
                }
            });

            $(document).on('click', '.graphTypeDashlet .spnArrow', function (event) {
                var id = $(this).parents('div.col').attr("id");
                var dashlet = self.dashboard.dashlets.select(id);
                var position = $(this).parents('div.col').offset();
                if ($(this).parents('.graphTypeDashlet').find('.chart-types-container').is(':visible')) {
                    $(this).parents('.graphTypeDashlet').find('.chart-types-container').hide();
                }
                else {
                    $(this).parents('.graphTypeDashlet').find('.chart-types-container').show();
                    var heightDiv = dashlet.height < self.options.minHeight ? self.options.minHeight : dashlet.height;
                    if ($(this).parents('.graphTypeDashlet').find('.chart-types-container').height() > heightDiv) {
                        $(this).parents('.graphTypeDashlet').find('.chart-types-container').addClass('graphPos');
                        $(this).parents('.graphTypeDashlet').find('.chart-types-container').css('left', position.left);
                        $(this).parents('.graphTypeDashlet').find('.chart-types-container').css('width', $(this).parents('div.col').width());
                    }
                }
                event.preventDefault();
                event.stopPropagation();
            });

            $(document).on('click', '.graphTypeDashlet .spnType', function (event) {
                $(this).parents('.col').find('.frontFace .content_div').show();
                $(this).parents('.col').find('.frontFace .contentDrid_div').hide();
                event.preventDefault();
                event.stopPropagation();
            });

            $("body:not(div.graphTypeDashlet)").click(function () {
                self.element.find('.graphTypeDashlet').find('.chart-types-container').hide();
            });

            $(self.element).on('mouseleave', '.col', function () {
                if (screen.width > 991) {
                    if ($(this).find('.backFace').length != 0) {
                        if (screen.width < 991) { $(this).find('.backFace').addClass('mobile'); }
                        $(this).find('.backFace').clearQueue().stop(true, true).animate({ 'top': '100%' }, 300, function () {
                            $(this).removeClass('overflow-show');
                        });
                        $(this).removeClass('overflow-show');
                        $(this).parents('.dashletContainer').find('.selectType').show();
                    }
                }
            });

            $(self.element).on('mouseenter', '.col', function () {
                if (screen.width > 991) {
                    if ($(this).find('.backFace').length != 0) {
                        $(this).find('.backFace').clearQueue().stop(true, true).animate({ 'top': '0px' }, 300, function () {
                            $(this).parent().addClass('overflow-show'); //.css('overflow', 'visible');
                        });
                        $(this).parents('.dashletContainer').find('.selectType').hide();
                    }
                }
            });

            $(document).on('click', '.sGraphtype', function () {
                var id = $(this).parents('.dashletContainer').find('div.col').attr('id');
                var dashlet = self.dashboard.dashlets.select(id);
                dashlet.param["graphType"] = $(this).find('div.tiledGraph').attr('value');
                self._loadDashlets(dashlet, "graphTypeChanged");
                if (screen.width < 991) {
                    $(this).parents('.backFace').addClass('desktop');
                }
            });

            $(document).on('click', '.widgetCharts', function (e) {
                self.element.find('.widgetCharts').removeClass('activeCharts');
                $(this).addClass('activeCharts');
                var id = self.element.find(this).parents('.dashletContainer').find('div.col').attr('id');
                var type = self.element.find(this).attr('data-value');
                var val = self.dashboard.dashlets.select(id);
                var widget = $.extend({}, val.widget, {
                    "chartType": type
                });
                var dashlet = self.dashboard.dashlets.updateItem({
                    id: id,
                    widget: widget
                });

                self._createWidgetChart(id, type);
            });

            $(document).on('click', '.closeDashletWidget', function () {
                var div = $(this).parents('.col');
                $("#dialog-confir").html("Are you sure you want to remove?");
                $("#dialog-confir").dialog({
                    resizable: false,
                    modal: true,
                    height: "200",
                    width: "auto",
                    draggable: false,
                    close: function () { $(this).dialog('destroy'); },
                    dialogClass: "message info-dialog custom-style no-titlebar",
                    buttons: {
                        Yes: function () {
                            self._removeContentWidget(div);
                            $(this).dialog('destroy');
                        },
                        No: function () {
                            $(this).dialog('destroy');
                        }
                    }
                });
            });

            $(document).on('click', '.addDashletIcon', function (e) {
                if (self.element.find('.clipHeadIcon').hasClass('clipHeadActive') > 0) {
                    if ($(this).hasClass('addDashletActive')) {
                        $(this).removeClass('addDashletActive');
                    }
                    else {
                        $(this).addClass('addDashletActive');
                    }
                    $(this).parents('.dialog-confirm').find('.addDashletBody').slideToggle();
                    $(this).parents('.dialog-confirm').find('.clipHeadBody').hide();
                    $(this).parents('.dialog-confirm').find('.clipHeadIcon').removeClass('clipHeadActive');
                }
            });

            $(document).on('click', '.btnOk', function (e) {
                var id = $(this).parents('.col').attr("id");
                var dashlet = self.dashboard.dashlets.select(id);
                if (dashlet.selectedCatalog) {
                    var title = self.element.find('input#txtcontenttitle').val();
                    var $dashGroup, menuId, viewPath, $dashItem, dashletId, name;
                    viewPath = "BI/MISViewer/Index";
                    $dashItem = dashlet.selectedCatalog; 
                    dashletId = $dashItem.CatalogId == undefined ? parseInt(dashlet.dashletId) : $dashItem.CatalogId;
                    menuId = $dashItem.ParentCatalogId == undefined ? parseInt(dashlet.catalogId) : $dashItem.ParentCatalogId;
                    name = $dashItem.Caption == undefined ? dashlet.param.name : $dashItem.Caption;
                    function find(source, id) {
                        for (key in source) {
                            var item = source[key];
                            if (item.CatalogId == id)
                                return item;

                            if (item.Children) {
                                var subresult = find(item.Children, id);
                                if (subresult)
                                    return subresult;
                            }
                        }
                        return null;
                    }

                    if (self.dashletList.length != 0) {
                        var type = "grid";
                        var items = find(self.dashletList, menuId);
                        var dashlet = $.extend(true, {}, items);
                        var graphType;
                        if (dashlet.param == undefined) {
                            menuId = dashletId;
                            items = find(self.dashletList, menuId);
                            dashlet = $.extend(true, {}, items);
                            graphType = dashlet.Type;
                        }
                        else {
                            delete dashlet.param.$id;
                            var grphTypeItem = $.grep(dashlet.Children, function (el, i) {
                                return el.CatalogId == dashletId;
                            });
                            if (grphTypeItem[0].Type == "timeseries" || grphTypeItem[0].Type == "graph")
                                graphType = grphTypeItem[0].param.graphType;
                        }

                        $.extend(dashlet.param, {
                            "name": name,
                            "misID": dashletId,
                            "graphType": graphType
                        });
                    }

                    var clipHeadline = self.element.find(this).parents('.dialog-confirm').find('#chkClipHeadline').is(':checked');
                    var headline1 = self.element.find(this).parents('.dialog-confirm').find('.txtHeadline1').val();
                    var headline1Color = self.element.find(this).parents('.dialog-confirm').find('#hdnHead1').val();
                    var headline2 = $(this).parents('.dialog-confirm').find('.txtHeadline2').val();
                    var headline2Color = $(this).parents('.dialog-confirm').find('#hdnHead2').val();
                    var hoverOnWidget = $(this).parents('.dialog-confirm').find('.chkHoverDashlet').is(':checked');
                    var widget = $.extend(true, {}, dashlet.widget, {
                        "headline1": headline1,
                        "headline2": headline2,
                        "enableWidget": clipHeadline,
                        "hoverOnDashelt": hoverOnWidget,
                        "head1Color": headline1Color,
                        "head2Color": headline2Color,
                        "chartType": self.element.find(this).parents('.dashletContainer').find('.widgetTypes .activeCharts').attr('data-value') == undefined ? "guage" : self.element.find(this).parents('.dashletContainer').find('.widgetTypes .activeCharts').attr('data-value')
                    });
                    if (viewPath != null) {
                        var dashLet = self.dashboard.dashlets.updateItem({
                            id: id,
                            catalogId: menuId,
                            dashletId: dashletId.toString(),
                            dashlet: viewPath,
                            title: title,
                            type: type,
                            param: dashlet.param,
                            clipHeadline: clipHeadline,
                            widget: widget
                        });
                        self._loadDashlets(dashLet);
                    }
                    $(this).parents('.dialog-confirm').remove();
                }
                else {
                    _app.notify({
                        title: 'Error',
                        type: 'error',
                        text: 'Please select a cataog item.',
                        delay: 3000
                    });
                }
            });

            $(document).on('click', '.btnCancel', function (e) {
                var id = $(this).parents('.col').attr("id");
                if (self.dashboard.dashlets.select(id)) {
                    /*Removes selected Dashlets on cancel click*/
                    if (self.dashboard.dashlets.select(id).selectedCatalog){
                        self.dashboard.dashlets.select(id).selectedCatalog = undefined;
			   self._removeContentWidget(div);	
			}
                }
                $(this).parents('.dialog-confirm').remove();
            });

            $(document).on('click', '.selectType', function (e) {
                var clickedDiv = $(this);
                if (screen.width >= 991) {
                    clickedDiv.find('.widgetTypes').slideToggle('slow', function () {
                        clickedDiv.toggleClass('crossSymbol');
                    });
                }
                else {
                    if (!clickedDiv.parents('.dashletContainer').find('.clickMobileType').hasClass('grphTypeMobile'))
                        clickedDiv.parents('.dashletContainer').find('.clickMobileType').addClass('grphTypeMobile')
                    clickedDiv.parents('.dashletContainer').find('.backFace').addClass('mobile').removeClass('desktop');
                    clickedDiv.find('.widgetTypes').slideToggle('slow', function () {
                        clickedDiv.toggleClass('crossSymbol');
                    });
                }
            });

            $(document).on('keyup', '.txtEnableWidget', function (e) {
                //do not allow more than two charactes
                if ($(this).val().length > 2 && $(this).val() != 100) {
                    $(this).val($(this).val().substring(0, 2));
                    return false;
                }
                e.preventDefault();
            });

            $(document).on('keypress', '.txtEnableWidget', function (e) {
                var regex = new RegExp("^[0-9]+$");
                var Evt = e || window.event;
                var key = Evt.keyCode || Evt.which;
                // Don't validate the input if below arrow, delete and backspace keys were pressed 
                if (key == 37 || key == 38 || key == 39 || key == 40 || key == 8 || key == 46) { // Left / Up / Right / Down Arrow, Backspace, Delete keys
                    return true;
                }
                var str = String.fromCharCode(!e.charCode ? e.which : e.charCode);
                if (regex.test(str) || str == "-") {
                    return true;
                }
                e.preventDefault();
                return false;
            });

            $(document).on('change', '#chkClipHeadline', function (e) {
                  var id = $(this).parents('.col').attr("id");
                var dashlet = self.dashboard.dashlets.select(id);
                if (dashlet.selectedCatalog) {
 		  	var selectedCatlog = dashlet.selectedCatalog.CatalogId;
                	var selectedCaption = dashlet.selectedCatalog.Caption
                	var that = this.parentElement.parentElement.parentElement.nextSibling.nextSibling.children[1];
                    var title = self.element.find('input#txtcontenttitle').val();
                    var $dashGroup, menuId, viewPath, $dashItem, dashletId, name;
                    viewPath = "BI/MISViewer/Index";
                    $dashItem = dashlet.selectedCatalog;
                    dashletId = $dashItem.CatalogId == undefined ? parseInt(dashlet.dashletId) : $dashItem.CatalogId;
                    menuId = $dashItem.ParentCatalogId == undefined ? parseInt(dashlet.catalogId) : $dashItem.ParentCatalogId;
                    name = $dashItem.Caption == undefined ? dashlet.param.name : $dashItem.Caption;
                    function find(source, id) {
                        for (key in source) {
                            var item = source[key];
                            if (item.CatalogId == id)
                                return item;

                            if (item.Children) {
                                var subresult = find(item.Children, id);
                                if (subresult)
                                    return subresult;
                            }
                        }
                        return null;
                    }
                    if (self.dashletList.length != 0) {
                        var type = "grid";
                        var items = find(self.dashletList, menuId);
                        var dashlet = $.extend(true, {}, items);
                        var graphType;
                        if (dashlet.param == undefined) {
                            menuId = dashletId;
                            items = find(self.dashletList, menuId);
                            dashlet = $.extend(true, {}, items);
                            graphType = dashlet.Type;
                        }
                        else {
                            delete dashlet.param.$id;
                            var grphTypeItem = $.grep(dashlet.Children, function (el, i) {
                                return el.CatalogId == dashletId;
                            });
                            if (grphTypeItem[0].Type == "timeseries" || grphTypeItem[0].Type == "graph")
                                graphType = grphTypeItem[0].param.graphType;
                        }

                        $.extend(dashlet.param, {
                            "name": name,
                            "misID": dashletId,
                            "graphType": graphType
                        });
                    }
                    var hoverOnWidget = $(that).parents('.dialog-confirm').find('.chkHoverDashlet').is(':checked');
                    var widget = $.extend(true, {}, dashlet.widget, {
                        "headline1": "",
                        "headline2": "",
                        "enableWidget": true,
                        "hoverOnDashelt": hoverOnWidget,
                        "head1Color": "",
                        "head2Color": "",
                        "chartType": self.element.find(that).parents('.dashletContainer').find('.widgetTypes .activeCharts').attr('data-value') == undefined ? "guage" : self.element.find(this).parents('.dashletContainer').find('.widgetTypes .activeCharts').attr('data-value')
                    });
                    if (viewPath != null) {
                        var dashLet = self.dashboard.dashlets.updateItem({
                            id: id,
                            catalogId: menuId,
                            dashletId: dashletId,
                            dashlet: viewPath,
                            title: title,
                            type: type,
                            param: dashlet.param,
                            clipHeadline: true,
                            widget: widget
                        });
                    }
                    if ($(this).is(':checked')) {
                        if ($(this).parents('.clipHeadline').prev().find('#txtcontenttitle').val() !== '') {
                            $(this).parents('.addDashletBody').hide();
                            $(this).parents('.dialog-confirm').find('.clipHeadIcon').addClass('clipHeadActive');
                            $(this).parents('.dialog-confirm').find('.addDashletIcon').removeClass('addDashletActive');
                            $(this).parents('.dialog-confirm').find('.clipHeadBody,.clipHeadIcon').show();
                            self.element.find('.addContentTitle').text(self.element.find('#txtcontenttitle').val());
                            var param = { misID: selectedCatlog, name: selectedCaption };
                            self._ajaxcall({
                                type: 'GET',
                                async: true,
                                data: param,
                                url: self.options.apiURL + '/GetSchema',
                                success: function (data) {
                                    data = data.Records;
                                    var fields = JSON.parse(data.misSchema).misSchema.fields;
                                    $('.txtHeadline2').mentionsInput({
                                        elastic: false,
                                        triggerChar: ['@'],
                                        startKeyEvent: false,
                                        overlay: false,
                                        onSelect: function (data, key) {
                                            if (key == '@') {
                                                dashLet.widget["widgetField"] = data.id;
                                                var value = self._calcPercentage(data, self.getRecords(dashLet));
							dashLet.widget["widgetFieldvalue"] = value;
                                                return value;
                                            }
                                        },
                                        onDataRequest: function (mode, key, query, callback) {
                                            if (key == '@') {
                                                var fields = JSON.parse(data.misSchema).misSchema.fields;
                                                var numer = _.filter(fields, function (item) {
                                                    if (item.type == "numeric") {
                                                        return item.label;
                                                    }
                                                });
                                                callback.call(this, numer);
                                            }
                                        }
                                    });
                                }
                            });
                        }
                        else {
                            $(this).prop('checked', false);
                            self._errorBox({
                                message: "Title is empty.",
                                class: "message error-dialog custom-style no-titlebar",
                                errorType: true
                            });
                        }
                    }
                    else {
                        $(this).parents('.dialog-confirm').find('.clipHeadBody').hide();
                        $(this).parents('.dialog-confirm').find('.clipHeadIcon').hide();
                        $(this).parents('.dialog-confirm').find('.addDashletIcon').addClass('addDashletActive');
                        $(this).prop('checked', false);
                    }
                }
                else {
                    _app.notify({
                        title: 'Error',
                        type: 'error',
                        text: 'Please select a cataog item.',
                        delay: 3000
                    });
                }
                e.preventDefault();
                e.stopPropagation();
            });

            $(document).on('click', '.headLine1 .imgColorIcon', function (e) {
                var id = self.element.find(this).parents('.col').attr('id');
                self.element.find(this).append(Mustache.render(self._colorPickerTemplate(), self.options.widgetColors));
                e.preventDefault();
            });

            $(document).on('click', '.headLine2 .imgColorIcon', function (e) {
                var id = self.element.find(this).parents('.col').attr('id');
                self.element.find(this).append(Mustache.render(self._colorPickerTemplate(), self.options.widgetColors));
                e.preventDefault();
            });

            $(document).on('click', '.txtEnabledDiv .imgColorIcon', function (e) {
                var id = self.element.find(this).parents('.col').attr('id');
                self.element.find(this).append(Mustache.render(self._colorPickerTemplate(), self.options.widgetColors));
                e.preventDefault();
            });

            $(document).on('mouseleave', '.headLine1', function (e) {
                self.element.find('.headLine1').find('.colorPickerDiv').remove();
            });

            $(document).on('mouseleave', '.headLine2', function (e) {
                self.element.find('.headLine2').find('.colorPickerDiv').remove();
            });

            $(document).on('mouseleave', '.txtEnabledDiv', function (e) {
                self.element.find('.txtEnabledDiv').find('.colorPickerDiv').remove();
            });

            $(document).on('click', '.widgetColor', function (e) {
                var color = $(this).attr('data-color');
                $(this).parents('.imgColorIcon').find('input').val(color);
                $(this).parents('.imgColorIcon').prev().css('color', color);
            });

            $(document).on('click', '.chkEnableWidget', function (e) {
                if ($(this).is(':checked')) {
                    $(this).parents('.enableWidget').find('.txtEnabledDiv').show();
                }
                else {
                    $(this).parents('.enableWidget').find('.txtEnabledDiv').hide();
                }
            });

            $(document).on('click', '.clipHeadIcon', function (e) {
                if (!$(this).hasClass('clipHeadActive')) {
                    $(this).addClass('clipHeadActive');
                    $(this).parents('.dialog-confirm').find('.addDashletActive').removeClass('addDashletActive');
                    $(this).parents('.dialog-confirm').find('.addDashletBody').hide();
                    $(this).parents('.dialog-confirm').find('.clipHeadBody').slideToggle().css('overflow', 'visible');
                }
            });

            $(document).on('inview', 'div.unloaded', function (event, isVisible) {
                var div = $(this);
                var id = div.attr("id"); // setting the dashlet id
                div.prepend('<div class="unloadedDiv"/>');
                if (id != "") {
                    var val = self.dashboard.dashlets.select(id);
                    self._drawDashlet(val, div);
                }
                div.removeClass('unloaded');
            });

            // selected div
            $(document).on('click', 'div.header_div', function (e) {
                e.preventDefault();
                e.stopPropagation();
                if (screen.width > 991 && self.options.guestUser == false) {
                    if (self.dashletViews.length > 0) {
                        if (self.element.find('div.col').find('.context-menu-one')) {
                            if ($(e.target).parents('.dialog-confirm').length == 0) {
                                $(this).addClass('overflow-show');
                                self.element.find('div.col').removeClass('context-menu-one').css("opacity", "1");
                                $(this).find('.selectedDashlet').show();
                                $(this).find('.defaultDashletIcons').hide();
                            }
                        }
                        $(this).parents('.col').addClass("context-menu-one");
                        self.element.find("div.col:not(.context-menu-one)").css("opacity", "0.5");
                        self.activeDashlet = $(this).parents('.col').attr("id");
                        self.element.find('.condMenu').each(function () {
                            var key = $(this).attr("id");
                            var value = self.dashboard.contextMenuStatus(self.activeDashlet, key);
                            if (value) {
                                $(this).parent().addClass('disableClass');
                            } else {
                                $(this).parent().removeClass('disableClass');
                            }
                        });
                    }
                    else {
                        self.element.find('#dashletMenu').trigger('click');
                        self._errorBox({
                            message: "Please create a dashboard.",
                            class: "message warning-dialog custom-style no-titlebar",
                            errorType: true
                        });
                    }
                }
            });

            // selection disabled on outside click of div
            $("body:not(div.col)").click(function () {
                self.element.find('div.col').removeClass('overflow-show');
                self.element.find('div.col').removeClass('context-menu-one').css("opacity", "1");
                self.element.find('.selectedDashlet').hide();
                self.element.find('.rowOption,.cellOption').hide();
                self.element.find('.defaultDashletIcons').show();
                self.activeDashlet = null;
                self.element.find(".notDisabled").removeClass('disableClass');
            });

            $(document).on('click', '.content_div', function (e) {
                var count = $(this).children().length;
                if (count == 0) {
                    self._addContent($(this).parents('div.col'));
                }
            });

            $(document).on('click', '.emptyDashlet', function (e) {
                var count = $(this).parents('div.col').find('.content_div').children()
                if (count.length == 0) {
                    self._addContent($(this).parents('div.col'));
                }
            });

            $("body:not(div#ddlLayoutType,div#ddlLayoutType *)").click(function () {
                $(this).find('.layoutOption,.arrow-up').hide();
            });

            $("body:not(div#changeTheme,div#changeTheme *)").click(function () {
                $(this).find('.themes,.arrow-up').hide();
            });

            // Resetting the changes
            $(document).on("click", "#aCancelBtn", function () {
                self.reRender();
                self.element.find('.childMenu,.arrow-up').hide();
            });

            //Showing toolbar
            $(document).on("click", "div.toolBoxIcn, div.col", function () {
                if (self.element.find('#toolbar').hasClass('toolbarDeactive')) {
                    self.showToolbar();
                } else if ($(this).hasClass("toolBoxIcn")) {
                    self.hideToolbar();
                }
            });

            $('body:not(.menuContainer)').click(function () {
                self.element.find('.menuContainer').hide();
            });

            $(document).on('mouseenter', '.dashletMenuListcolumnDiv', function () {
                if (self.options.userRights != "")
                    $(this).children('.optDiv').show();
            });

            $(document).on('mouseleave', '.dashletMenuListcolumnDiv', function () {
                $(this).children('.optDiv').hide();
            });

            //saving dashboard
            $('#aSavebtn').on('click', function () {
                self.dashboard.setGeneric(self);
                self.element.find('.childMenu,.arrow-up').hide();
                var dashboard = self.dashboard.get();
                var jsonArray = [];
                var title = self.options.name;
                var defaultView = self.element.find('#chkDefaultView').is(":checked");
                if (IsNull(title)) {
                    self._errorBox({
                        message: "Please create dashboard.",
                        class: "message warning-dialog custom-style no-titlebar",
                        errorType: true
                    });
                    return false;
                }
                //taking the current dashboard using title
                var currentDashboard = _.findWhere(self.dashletViews, { name: title });
                $.each(dashboard.dashlets, function (i, val) {
                    if (val.type = 'graph') {
                        val.showLegend = $("#" + val.id).find('.dashContent').hasClass('showDashLegend')
                    }
                });

                jsonArray.push({
                    "templateType": dashboard.templateType,
                    "backgroundColor": dashboard.backgroundColor,
                    "dashlets": dashboard.dashlets
                });

                $.each(dashboard.dashlets, function (i, val) {
                    val.misSchema = undefined;
                    val.dataset = undefined;
                });

                var param = new Object();
                param.name = title;
                param.mId = self.options.menuId;
                param.defaultView = defaultView;
                param.content = JSON.stringify(jsonArray);
                param.userid = self.options.userid;
                //checking for the share is null or empty
                param.share = (currentDashboard.share != "" && currentDashboard.share != null) ? JSON.stringify(currentDashboard.share) : null;
                self._ajaxcall({
                    url: self.options.apiURL + '/Post',
                    data: param,
                    type: 'POST',
                    success: function (data) {
                        if (data.result) {
                            self._errorBox({
                                message: "Dashboard saved successfully.",
                                class: "message info-dialog custom-style no-titlebar",
                                height: "100",
                                width: "400",
                                errorType: true
                            });
                            self.hideToolbar();
                            self.options.name = title;
                            self.dashletViews = data.dashletViews;
                            self._jsonData();
                            self.dashboard.setSpecific(self);
                        }
                    }
                });
            });

            //creating copy of dashboard
            $(document).on("click", '.createCopytxt', function () {
                var layout = parseInt(self.dashboard.get().templateType);
                var title = "Copy of " + $(this).parent().siblings('.clkdashletMenuListImage').attr('data');
                var defaultView = self.element.find('#chkDefaultView').is(":checked");
                self.dashboard.setGeneric(self);
                var copyDashboard = _.findWhere(self.dashletViews, { name: $(this).parent().siblings('.clkdashletMenuListImage').attr('data') });
                var dashboard = self.dashboard.get();
                var jsonArray = [];
                jsonArray.push({
                    "templateType": copyDashboard.defaultView == true ? dashboard.templateType : copyDashboard.layout.templateType,
                    "backgroundColor": copyDashboard.defaultView == true ? dashboard.backgroundColor : copyDashboard.layout.backgroundColor,
                    "dashlets": copyDashboard.defaultView == true ? dashboard.dashlets : copyDashboard.layout.dashlets
                });
                var param = new Object();
                param.name = title;
                param.mId = self.options.menuId;
                param.defaultView = defaultView;
                param.content = JSON.stringify(jsonArray);
                param.userid = self.options.userid;
                param.background = null;
                $("#dialog-confir").html("Are you sure you want to create copy of this Dashboard?");
                $("#dialog-confir").dialog({
                    resizable: false,
                    modal: true,
                    height: "200",
                    width: "auto",
                    draggable: false,
                    dialogClass: "message warning-dialog custom-style no-titlebar",
                    close: function () { $(this).dialog('destroy'); },
                    buttons: {
                        Yes: function () {
                            self._ajaxcall({
                                url: self.options.apiURL + '/Post',
                                data: param,
                                type: 'POST',
                                success: function (data) {
                                    _app.notify({ /* success notification after creating copy of dashboard*/
                                        title: 'Success',
                                        type: 'success',
                                        text: 'The copy of the Dashboard created successfully.',
                                        delay: 3000
                                    });
                                    if (data.result) {
                                        self.dashletViews = data.dashletViews;
                                        self.hideToolbar();
                                        self._jsonData();
                                        self.dashboard.setSpecific(self);
                                        self._fillDropdownView();
                                    }
                                }
                            });
                            $(this).dialog('destroy');
                        },
                        No: function () {
                            $(this).dialog('destroy');
                        }
                    }
                });
                self.element.find('.dashletMenuList').hide();
            });

            //deleting saved dashboard
            $(document).on("click", '.deleteDashboardtxt', function () {
                var content = new Object();
                content.mId = self.options.menuId;
                var currentName = $(this).parent().siblings('.clkdashletMenuListImage').attr('data');
                content.name = $(this).parent().siblings('.clkdashletMenuListImage').attr('data');
                content.userid = self.options.userid;
                $("#dialog-confir").html("Are you sure you want to delete this Dashboard?");
                jQuery.support.cors = true;
                $("#dialog-confir").dialog({
                    resizable: false,
                    modal: true,
                    height: "200",
                    width: "auto",
                    draggable: false,
                    dialogClass: "message warning-dialog custom-style no-titlebar",
                    close: function () { $(this).dialog('destroy'); },
                    buttons: {
                        Yes: function () {
                            self._ajaxcall({
                                url: self.options.apiURL + '/Delete',
                                type: 'DELETE',
                                dataType: 'json',
                                data: content,
                                success: function (data) {
                                    _app.notify({    /*success notification after deleting dashboard*/
                                        title: 'Success',
                                        type: 'success',
                                        text: 'Dashboard deleted successfully.',
                                        delay: 3000
                                    });
                                    self.dashletViews = data.dashletViews;
                                    self.hideToolbar();
                                    if (data.result) {
                                        if (self.options.name == currentName) {
                                            self.reRender();
                                        } else {
                                            self._jsonData();
                                            self.dashboard.setSpecific(self);
                                            self._fillDropdownView();
                                        }
                                    }
                                }
                            });
                            $(this).dialog('destroy');
                        },
                        No: function () {
                            $(this).dialog('destroy');
                        }
                    }
                });
                self.element.find('.dashletMenuList').hide();
            });

            $(document).on("click", '.defaultDashboardtxt', function () {
                var text = $(this).parent().siblings('.dashboardName').attr('data');
                var dashboard = self.dashboard.get();
                var param = new Object();
                param.name = text;
                param.mId = self.options.menuId;
                param.defaultView = true;
                param.userid = self.options.userid;
                self._ajaxcall({
                    url: self.options.apiURL + '/Put',
                    data: param,
                    type: 'PUT',
                    success: function (data) {
                        if (data.result) {
                            self.dashletViews = data.dashletViews;
                            self.hideToolbar();
                            self.options.name = text;
                            _app.notify({   /* Success notification after setting default dashboard*/
                                title: 'Success',
                                type: 'success',
                                text: 'The Dashboard ' + text + ' has been set successfully as default.',
                                delay: 3000
                            });
                        }
                    }
                });
                self.element.find('.dashletMenuList').hide();
            });

            $(document).on('mouseleave', '.dashletMenuListcolumnDiv', function (e) {
                self.element.find('.dashboardTooltip').remove();
            });

            $(document).on('click', '#dashletMenu', function (e) {
                self._fillDropdownView();
                self.element.find('.dashletMenuList').show();
            });

            $(document).on('click', '.dashboardShareActive', function () {
                $('div#share').shareFunctions('open');
            });

            $(document).on('click', '.mergeLef', function (e) {
                var id = $(this).parents('div.col').attr('id');
                var row = parseInt($(this).parents('.col').attr('data-rowno'));
                var column = parseInt($(this).parents('.col').attr('data-column'));
                var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                    return val.columnNo < column && val.rowNo == row;
                });
                var lengthItem = items.length - 1;
                if (items[lengthItem] != undefined && items[lengthItem].dashlet != "") {
                    $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                    $("#dialog-confir").data('object', self).dialog({
                        resizable: false,
                        modal: true,
                        height: "220",
                        width: "380",
                        draggable: false,
                        close: function () { $(this).dialog('destroy'); },
                        dialogClass: "message warning-dialog custom-style no-titlebar",
                        buttons: {
                            Yes: function () {
                                self.dashboard.dashlets.mergeLeft(id, self);
                                self._drawDashlets();
                                $(this).dialog('destroy');
                            },
                            No: function () {
                                $(this).dialog('destroy');
                            }
                        }
                    });
                }
                else {
                    self.dashboard.dashlets.mergeLeft(id, self);
                    self._drawDashlets();
                }
            });

            $(document).on('click', '.mergeRig', function (e) {
                var id = $(this).parents('div.col').attr('id');
                var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                    return val.columnNo > self.dashboard.dashlets.select(id).columnNo && val.rowNo == self.dashboard.dashlets.select(id).rowNo;
                });
                if (items.length == 0 || items[0].dashlet != "") {
                    $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                    $("#dialog-confir").dialog({
                        resizable: false,
                        modal: true,
                        height: "220",
                        width: "380",
                        draggable: false,
                        close: function () { $(this).dialog('destroy'); },
                        dialogClass: "message warning-dialog custom-style no-titlebar",
                        buttons: {
                            Yes: function () {
                                self.dashboard.dashlets.mergeRight(id, self);
                                self._drawDashlets();
                                $(this).dialog('destroy');
                            },
                            No: function () {
                                $(this).dialog('destroy');
                            }
                        }
                    });
                }
                else {
                    self.dashboard.dashlets.mergeRight(id, self);
                    self._drawDashlets();
                }
            });

            $(document).on('click', '.mergeTp', function (e) {
                var id = $(this).parents('div.col').attr('id');
                var row = parseInt($(this).parents('.col').attr('data-rowno'));
                var column = parseInt($(this).parents('.col').attr('data-column'));
                var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                    return val.rowNo < row && val.columnNo == column;
                });
                var lengthItem = items.length - 1;
                if (items[lengthItem] != undefined && items[lengthItem].dashlet != "") {
                    $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                    $("#dialog-confir").dialog({
                        resizable: false,
                        modal: true,
                        height: "220",
                        width: "380",
                        draggable: false,
                        close: function () { $(this).dialog('destroy'); },
                        dialogClass: "message warning-dialog custom-style no-titlebar",
                        buttons: {
                            Yes: function () {
                                self.dashboard.dashlets.mergeTop(id, self);
                                self._drawDashlets();
                                $(this).dialog('destroy');
                            },
                            No: function () {
                                $(this).dialog('destroy');
                            }
                        }
                    });
                }
                else {
                    self.dashboard.dashlets.mergeTop(id, self);
                    self._drawDashlets();
                }
            });

            $(document).on('click', '.mergeBo', function (e) {
                var id = $(this).parents('div.col').attr('id');
                var row = parseInt($(this).parents('.col').attr('data-rowno'));
                var column = parseInt($(this).parents('.col').attr('data-column'));
                var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                    return val.rowNo > row && val.columnNo == column;
                });
                var lengthItem = items.length - 1;
                if (items[lengthItem] != undefined && items[lengthItem].dashlet != "") {
                    $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                    $("#dialog-confir").dialog({
                        resizable: false,
                        modal: true,
                        height: "220",
                        width: "380",
                        draggable: false,
                        close: function () { $(this).dialog('destroy'); },
                        dialogClass: "message warning-dialog custom-style no-titlebar",
                        buttons: {
                            Yes: function () {
                                self.dashboard.dashlets.mergeBottom(id, self);
                                self._drawDashlets();
                                $(this).dialog('destroy');
                            },
                            No: function () {
                                $(this).dialog('destroy');
                            }
                        }
                    });
                }
                else {
                    self.dashboard.dashlets.mergeBottom(id, self);
                    self._drawDashlets();
                }
            });

            $(document).on('click', '.splitRw', function (e) {
                var id = $(this).parents('div.col').attr('id');
                self.dashboard.dashlets.splitRow(id, self);
                self._drawDashlets();
            });

            $(document).on('click', '.splitCn', function (e) {
                var id = $(this).parents('div.col').attr('id');
                self.dashboard.dashlets.splitColumn(id, self);
                self._drawDashlets();
            });

            $('body:not(.dashletMenuList)').click(function (e) {
                if (!self.element.find('.dashletMenuList').is(e.target) && self.element.find('.dashletMenuList').has(e.target).length === 0)
                    self.element.find('.dashletMenuList').hide();
            });

            $(document).on('click', '.dashletMenuListcolumnDivAdd', function (e) {
                $(this).find('.saveColorBox').children().remove();
                $(this).find('.saveColorBox').append(Mustache.render(self._colorBoxTemplate(), self.options.dashboardColors));
                var pos = $(this).offset();
                var width = $(this).find('.saveBox').width();
                if ((pos.left + width) > $(window).width()) {
                    $(this).find('.saveBox').css('right', '0');
                    $(this).find('.saveBoxTri').css('left', '100px');
                    $(this).find('.saveBox').css('left', '-70px');
                }
                $(this).children('.saveBox').show();
                $(this).children('.saveBox').find('#txtDash').focus();
                e.preventDefault();
            });

            //rename the dashboard.
            $(document).on('click', '.renameDashboardtxt', function () {
                $(this).parents('.dashletMenuListcolumnDiv').find('.editBox').find('.colorBox').children().remove();
                self.element.find('.colorBox').append(Mustache.render(self._colorBoxTemplate(), self.options.dashboardColors));
                var pos = $(this).parents('.dashletMenuListcolumnDiv').find('.dashboardName').offset();
                var width = $(this).parents('.dashletMenuListcolumnDiv').find('.editBox').width();
                if ((pos.left + width) > $(window).width()) {
                    $(this).parents('.dashletMenuListcolumnDiv').find('.editBox').css('right', '0');
                    $(this).parents('.dashletMenuListcolumnDiv').find('.editBox').find('.saveBoxTri').css('left', '100px');
                    $(this).parents('.dashletMenuListcolumnDiv').find('.editBox').css('left', '-70px');
                }
                var value = $(this).parents('.dashletMenuListcolumnDiv').find('.dashboardName').attr('data');
                $(this).parents('.dashletMenuListcolumnDiv').find('.editBox').show();
                $(this).parents('.dashletMenuListcolumnDiv').find('.editBox').find('#txtUpdate').val(value).focus();
            });

            $(document).on('click', '.colors', function (e) {
                self.element.find('.colors').css('opacity', 1);
                $(this).css('opacity', 0.2);
                self.element.find('#txtDash,#txtUpdate').focus();
                e.preventDefault();
                return false;
            });

            $(document).on("keypress", ".saveBox", function (e) {
                if (e.which == 13) {
                    var layout = parseInt(self.dashboard.get().templateType);
                    var lowestWidthEle = _.min(self.dashboard.dashlets.get(), function (data) {
                        return data.width;
                    });
                    if (lowestWidthEle.colspan > 1) {
                        if (layout == 1) lowestWidthEle.width = 98;
                        else if (layout == 2) lowestWidthEle.width = 48.5;
                        else if (layout == 3) lowestWidthEle.width = 32;
                        else lowestWidthEle.width = 23.7;
                    }
                    var title = self.element.find("#txtDash").val();
                    var conf;
                    if (title != "") {
                        var defaultView = self.element.find('#chkDefaultView').is(":checked");
                        self.dashboard.dashlets.clear();

                        for (var indx = 0; indx < layout; indx++) {
                            self.dashboard.dashlets.addItem({
                                columnNo: indx,
                                rowNo: 0,
                                width: lowestWidthEle.width // passing the width of existing div
                            });
                        }

                        self.dashboard.setGeneric(self);
                        var dashboard = self.dashboard.get();
                        var jsonArray = [];

                        jsonArray.push({
                            "templateType": dashboard.templateType,
                            "backgroundColor": dashboard.backgroundColor,
                            "dashlets": dashboard.dashlets
                        });

                        var color = (self.options.selectedColor == undefined) ? null : self.options.selectedColor;
                        var item = $.grep(self.dashletViews, function (val, i) {
                            return val.name == title;
                        });
                        if (item.length > 0) {
                            //conf = confirm("Are you sure you want to overwrite?");
                            $("#dialog-confir").html("Are you sure you want to overwrite?");
                            $("#dialog-confir").dialog({
                                resizable: false,
                                modal: true,
                                height: "200",
                                width: "auto",
                                draggable: false,
                                close: function () { $(this).dialog('destroy'); },
                                dialogClass: "message info-dialog custom-style no-titlebar",
                                buttons: {
                                    Yes: function () {
                                        var param = new Object();
                                        param.name = title;
                                        param.mId = self.options.menuId;
                                        param.defaultView = defaultView;
                                        param.content = JSON.stringify(jsonArray);
                                        param.userid = self.options.userid;
                                        param.background = color;
                                        self._ajaxcall({
                                            url: self.options.apiURL + '/Post',
                                            data: param,
                                            type: 'POST',
                                            success: function (data) {
                                                if (data.result) {
                                                    self.element.find('.saveBox').hide();
                                                    self.hideToolbar();
                                                    self.options.name = title;
                                                    self.options.selectedColor = undefined;
                                                    self.dashletViews = data.dashletViews;
                                                    self.element.find('#txtDash').val('');
                                                    self.reRender();
                                                }
                                            }
                                        });
                                        $(this).dialog('destroy');
                                    },
                                    No: function () {
                                        self.element.find("#txtDash").val('');
                                        $(this).dialog('destroy');
                                    }
                                }
                            });

                        }
                        else {
                            var param = new Object();
                            param.name = title;
                            param.mId = self.options.menuId;
                            param.defaultView = defaultView;
                            param.content = JSON.stringify(jsonArray);
                            param.userid = self.options.userid;
                            param.background = color;
                            self._ajaxcall({
                                url: self.options.apiURL + '/Post',
                                data: param,
                                type: 'POST',
                                success: function (data) {
                                    if (data.result) {
                                        self.element.find('.saveBox').hide();
                                        self.hideToolbar();
                                        self.options.name = title;
                                        self.options.selectedColor = undefined;
                                        self.dashletViews = data.dashletViews;
                                        self.element.find('#txtDash').val('');
                                        self.reRender();
                                    }
                                }
                            });
                        }
                    } else {
                        self._errorBox({
                            message: "Name is empty.",
                            class: "message error-dialog custom-style no-titlebar",
                            errorType: true
                        });
                    }
                    self.element.find('.dashletMenuList').hide();
                }
            });

            $(document).on("keypress", ".editBox", function (e) {
                //$(this).parent().hide();
                if (e.which == 13) {
                    self.element.find('.dashboardName').show();
                    var textToDisplay = $(this).find('.txtTitleBox').children('#txtUpdate').val();
                    var oldText = self.element.find('.editBox:visible').siblings('.dashboardName').attr('data');
                    var item = $.grep(self.dashletViews, function (val, i) {
                        return val.name == textToDisplay;
                    });
                    if (item.length == 0 || (item.length == 1 && textToDisplay == oldText)) {
                        self.dashboard.setGeneric(self);
                        var dashboard = self.dashboard.get();
                        $(this).parent().siblings('.dashboardName').text(textToDisplay);
                        $(this).parent().siblings('.dashboardName').children().remove();
                        var param = new Object();
                        param.name = oldText;
                        param.mId = self.options.menuId;
                        param.newName = textToDisplay;
                        param.userid = self.options.userid;
                        //Here we can pass the default view to DashboardViewerAPIController put method.
                        param.defaultView = _.findWhere(self.dashletViews, { name: oldText }).defaultView;
                        param.background = (self.options.selectedColor == undefined) ? null : self.options.selectedColor;
                        $("#dialog-confir").html("Are you sure you want to rename this Dashboard?");
                        $("#dialog-confir").dialog({
                            resizable: false,
                            modal: true,
                            height: "200",
                            width: "auto",
                            draggable: false,
                            dialogClass: "message warning-dialog custom-style no-titlebar",
                            close: function () { $(this).dialog('destroy'); },
                            buttons: {
                                Yes: function () {
                                    self._ajaxcall({
                                        url: self.options.apiURL + '/Put',
                                        data: param,
                                        type: 'PUT',
                                        success: function (data) {
                                            _app.notify({  /*success notification after renaming dashboard*/
                                                title: 'Success',
                                                type: 'success',
                                                text: 'Dashboard renamed successfully.',
                                                delay: 3000
                                            });
                                            if (data.result) {
                                                self.dashletViews = data.dashletViews;
                                                self.hideToolbar();
                                                self.options.name = textToDisplay;
                                                if ($("#h3menu .dashletName").text() == oldText) {
                                                    self.element.find('.dashletName').siblings().hide();
                                                    if ($("#h3menu").find('span').hasClass('dashletName')) $('.dashletName').remove();
                                                    if (self.options.name != "") {
                                                        $("#h3menu").append("<span class='dashletName'>" + self.options.name + "</span>");
                                                    }
                                                }
                                                self._jsonData();
                                                self.dashboard.setSpecific(self);
                                                self._fillDropdownView();
                                            }
                                        }
                                    });
                                    $(this).dialog('destroy');
                                },
                                No: function () {
                                    $(this).dialog('destroy');
                                }
                            }
                        });
                    }
                    else {
                        self._errorBox({
                            message: "Dashboard name already exists. Please enter a unique name.",
                            class: "message error-dialog custom-style no-titlebar",
                            errorType: true
                        });
                    }
                    self.element.find('.dashletMenuList').hide();
                }
            });

            $('.scrollDown').css('top', $(window).height() - 120);

            $(document).on('click', '.scrollDown', function () {
                var sortJson = self.dashboard.dashlets.get();
                var maxRow = _.max(sortJson, function (data) {
                    return data.rowNo;
                });
                var scrollHeight = 0;
                for (var i = 0; i < maxRow.rowNo; i++) {
                    var items = $.grep(sortJson, function (el, index) {
                        return (el.rowNo == i && el.columnNo == 0);
                    });
                    scrollHeight += items[0].height;
                }
                $(self.element).animate({
                    scrollTop: ($(self.element).scrollTop() + scrollHeight / maxRow.rowNo)
                }, 500);
            });

            $(document).on("click", ".previous_link", function () {
                new_page = parseInt(self.options.currentPage) - 1;
                if (self.element.find('.active_page').prev('.page_link').length == 0) {
                    if (new_page >= 0) self.go_to_page(new_page);
                }
                self.element.find('.pageCount').removeClass('pagingNum');
                _.each(self.element.find('.pageCount'), function (value, key) {
                    if ($(value).text() == (new_page + 1)) $(this).addClass('pagingNum');
                });
            });

            $(document).on("click", ".next_link", function () {
                var number_of_items = self.element.find('.contentdashletMenuList').children().size();
                var maxPage = parseInt(number_of_items / self.options.showPerPage);
                new_page = parseInt(self.options.currentPage) + 1;
                if (self.element.find('.active_page').next('.page_link').length == 0) {
                    if (new_page <= maxPage) self.go_to_page(new_page);
                }
                self.element.find('.pageCount').removeClass('pagingNum');
                _.each(self.element.find('.pageCount'), function (value, key) {
                    if ($(value).text() == (new_page + 1)) $(this).addClass('pagingNum');
                });
            });

            $(document).on("change", "select.ddlContentName", function () {
                $('#txtcontenttitle').val($('.ddlContentName option:selected').text()); //Assigning the selected values to the title field
            });


            $(document).on("change", "select.add-content", function () {
                var dashletBody = $(this).parents('.addDashletBody');
                var dashletDropdown = dashletBody.find('#ddlcontentName');
                dashletDropdown.empty();

                //$('#txtcontenttitle').val($(this).find("option:selected").attr("title"));

                var menuId = $(this).find("option:selected").val();
                var items = $.grep(self.dashletList, function (el, i) {
                    return el.menuId == menuId;
                });

                if (items.length > 0 && items[0].name) {
                    var itemsName = items[0].name;
                    itemsName = _.groupBy(itemsName, function (obj) {
                        return obj.Type;
                    });
                    _.each(itemsName, function (val, i) {
                        if (i == "graph") i = "Chart";
                        var optionGrp = $('<optgroup class="grpGroup" label="' + i + '"></optgroup>');
                        dashletDropdown.append(optionGrp);
                        _.each(val, function (value, j) {
                            optionGrp.append('<option type = ' + value.Type + ' value=  ' + value.CatalogId + '>' + value.Name + '</option>');
                        });
                    });
                }
                //dashletBody.find('#txtcontenttitle').val(dashletDropdown.children(':selected').text());
                $('#txtcontenttitle').val($('.ddlContentName option:selected').text()); //Assigning the selected values to the title field
            });

            $(document).on('click', '.refresh', function (e) {
                e.preventDefault();
                e.stopPropagation();
                self._drawDashlets();
                self.element.find('.childMenu,.arrow-up').hide();
            });

            $(document).on('click', '#ddlLayoutType', function (e) {
                self.element.find('.childMenu,.arrow-up').hide();
                $(this).find('.layoutOption.childMenu,.arrow-up').show();
                e.stopPropagation();
            });

            $(document).on('click', '#changeTheme', function (e) {
                self.element.find('.childMenu,.arrow-up').hide();
                $(this).find('.themes.childMenu,.arrow-up').show();
                e.stopPropagation();
            });

            $(document).on('click', '.refreshDashlet', function (e) {
                self._refresh($(this).parents('div.col'));
                e.preventDefault();
                e.stopPropagation();
            });

            $(document).on('click', '.dashletFilters', function (e) {
                e.preventDefault();
                e.stopPropagation();
                if ($(this).parents('.col').find('.content_div .filterContent').length > 0)
                    $(this).parents('.col').find('.content_div .filterContent').hide();
                $(this).parents('.col').find('.content_div .filterContent').show();
            });

            $('body:not(.filterContent)').click(function (e) {
                self.element.find('.filterContent').hide();
            });

            $(document).on('click', '.closeDashlet', function () {
                var div = $(this).parents('.col');
                $("#dialog-confir").html("Are you sure you want to remove?");
                $("#dialog-confir").dialog({
                    resizable: false,
                    modal: true,
                    height: "200",
                    width: "auto",
                    draggable: false,
                    close: function () { $(this).dialog('destroy'); },
                    dialogClass: "message info-dialog custom-style no-titlebar",
                    buttons: {
                        Yes: function () {
                            self._removeContent(div);
                            self._removeContentWidget(div);
                            //self._drawDashlets();
                            $(this).dialog('destroy');
                        },
                        No: function () {
                            $(this).dialog('destroy');
                        }
                    }
                });
            });

            $(document).on('click', '.insertBef', function () {
                self.dashboard.dashlets.insertRow(self, $(this).parents('div.col').attr('id'), "Before");
                self._drawDashlets();
            });

            $(document).on('click', '.insertAft', function () {
                self.dashboard.dashlets.insertRow(self, $(this).parents('div.col').attr('id'), "After");
                self._drawDashlets();
            });

            $(document).on('click', '.saveColorBox span,.colorBox span', function () {
                self.options.selectedColor = undefined;
                self.options.selectedColor = $(this).attr('color');
            });

            $(document).on('click', function (event) {
                if (!$(event.target).is(".saveBox, .saveBox *, .ui-dialog, .ui-dialog *, .ui-button, .ui-button-text")) {
                    self.element.find('.saveBox').hide();
                    var layout = parseInt(self.dashboard.get().templateType);
                    //finding the lowest width of dashlet
                    var lowestWidthEle = _.min(self.dashboard.dashlets.get(), function (data) {
                        return data.width;
                    });
                    //checking for the dashboard name
                    var title = self.element.find("#txtDash").val();
                    if (title != "") {
                        if (lowestWidthEle.colspan > 1) {
                            if (layout == 1) lowestWidthEle.width = 98;
                            else if (layout == 2) lowestWidthEle.width = 48.5;
                            else if (layout == 3) lowestWidthEle.width = 32;
                            else lowestWidthEle.width = 23.7;
                        }
                        var conf;
                        var defaultView = self.element.find('#chkDefaultView').is(":checked");
                        self.dashboard.dashlets.clear();

                        for (var indx = 0; indx < layout; indx++) {
                            self.dashboard.dashlets.addItem({
                                columnNo: indx,
                                rowNo: 0,
                                width: lowestWidthEle.width, // passing the width of existing div
                                height: 195
                            });
                        }

                        self.dashboard.setGeneric(self);
                        var dashboard = self.dashboard.get();
                        var jsonArray = [];

                        jsonArray.push({
                            "templateType": dashboard.templateType,
                            "backgroundColor": dashboard.backgroundColor,
                            "dashlets": dashboard.dashlets
                        });

                        var color = (self.options.selectedColor == undefined) ? null : self.options.selectedColor;
                        var item = $.grep(self.dashletViews, function (val, i) {
                            return val.name == title;
                        });
                        if (item.length > 0) {
                            $("#dialog-confir").html("Are you sure you want to overwrite?");
                            $("#dialog-confir").dialog({
                                resizable: false,
                                modal: true,
                                height: "200",
                                width: "auto",
                                draggable: false,
                                close: function () { $(this).dialog('destroy'); },
                                dialogClass: "message info-dialog custom-style no-titlebar",
                                buttons: {
                                    Yes: function () {
                                        var param = new Object();
                                        param.name = title;
                                        param.mId = self.options.menuId;
                                        param.defaultView = defaultView;
                                        param.content = JSON.stringify(jsonArray);
                                        param.userid = self.options.userid;
                                        param.background = color;
                                        self._ajaxcall({
                                            url: self.options.apiURL + '/Post',
                                            data: param,
                                            type: 'POST',
                                            success: function (data) {
                                                if (data.result) {
                                                    self.element.find('.saveBox').hide();
                                                    self.hideToolbar();
                                                    self.options.name = title;
                                                    self.options.selectedColor = undefined;
                                                    self.dashletViews = data.dashletViews;
                                                    self.dashletViews.shared = false;
                                                    self.element.find('#txtDash').val('');
                                                    self.reRender();
                                                }
                                            }
                                        });
                                        $(this).dialog('destroy');
                                    },
                                    No: function () {
                                        self.element.find("#txtDash").val('');
                                        $(this).dialog('destroy');
                                    }
                                }
                            });
                        }
                        else {
                            var param = new Object();
                            param.name = title;
                            param.mId = self.options.menuId;
                            param.defaultView = defaultView;
                            param.content = JSON.stringify(jsonArray);
                            param.userid = self.options.userid;
                            param.background = color;
                            self._ajaxcall({
                                url: self.options.apiURL + '/Post',
                                data: param,
                                type: 'POST',
                                success: function (data) {
                                    if (data.result) {
                                        self.element.find('.saveBox').hide();
                                        self.hideToolbar();
                                        self.options.name = title;
                                        self.options.selectedColor = undefined;
                                        self.dashletViews = data.dashletViews;
                                        self.element.find('#txtDash').val('');
                                        self.element.find('.dashletMenuList').hide();
                                        self.reRender();
                                    }
                                }
                            });
                        }
                    }
                }
                if ($(event.target).is(".dashletMenuListcolumnDivAdd,.dashletMenuListImage")) {
                    self.element.find(".saveBox").show();
                }
            });

            //Changing the layout
            $(document).on('click', '.layoutOption .toolMenu', function (e) {
                self.dashboard.changeLayout(parseInt($(this).attr('data-value')), self);
                self.element.find('.layoutOption').hide();
                $(this).parents('.layoutOption').siblings('.arrow-up').hide();
                //self._removeItem(parseInt($(this).attr('data-value')));
                e.stopPropagation();
            });

            //Chnaging the theme
            $(document).on('click', '.themes .toolMenu', function (e) {
                self.dashboard.changeTheme(parseInt($(this).attr('data-value')), self);
                self.element.find('.themes').hide();
                $(this).parents('.themes').siblings('.arrow-up').hide();
                e.stopPropagation();
            });

            $(document).on('click', '#expand_icon', function (e) {
                var that = this;
                if ($(that).hasClass('expand_iconPlus')) {
                    $(that).animate({ backgroundColor: '#DFA126' }, 500, function () {
                        self.element.find('.dashIcons').animate({
                            'width': "472px" //moves right
                        }, 700, function () { self.element.find('.iconsDiv').css('overflow', 'visible'); }).show().css('overflow', 'visible');
                        self.element.find('.dashIcons').show();
                        $(that).removeClass('expand_iconPlus').addClass('expand_iconMinus').attr('title', 'Collapse');
                        self.element.find('.iconsDiv').css('border', '1px solid #BDBDBD');
                        self.element.find('.iconsDiv').css('background-color', 'rgb(238, 238, 238)');
                    });

                }
                else {
                    self.element.find('#expand_icon').animate({ backgroundColor: 'transparent' }, 500, function () {
                        $(that).addClass('expand_iconPlus').removeClass('expand_iconMinus').attr('title', 'Expand');
                        self.element.find('.iconsDiv').css('overflow', 'hidden');
                        self.element.find('.dashIcons').animate({
                            'width': "0px" //moves left
                        }, 700, function () {
                            self.element.find('.dashIcons').hide();
                            self.element.find('.iconsDiv').css('background-color', 'transparent');
                            self.element.find('.iconsDiv').css('border', '0px solid #BDBDBD');
                        });
                    });

                }
            });

            $(document).on('click', '.dashletMenuListcolumnDiv', function (e) {
                if (e.target == this) {
                    self.options.name = $(this).find('.dashboardName').attr('data');
                    self.options.dashletUserId = $(this).attr('dt-dashuserid');
                    self.element.find('.dashletMenuList').hide();
                    self.reRender();
                }
                else if ($(e.target).attr('class') == $(this).find('div.optDiv').attr('class')) {
                    $(this).find('.menuContainer').slideToggle();
                }

                //hidind/showing share icon based on schema
                if (self.dashboard["doShare"] == false) {
                    self.element.find('.dashboardIcons #dashboardShare').removeClass('dashboardShareActive').addClass('dashboardShareInActive');
                    self.element.find('#aSavebtn').addClass('disableClass');
                }
                else {
                    self.element.find('.dashboardIcons #dashboardShare').removeClass('dashboardShareInActive').addClass('dashboardShareActive');
                    self.element.find('#aSavebtn').removeClass('disableClass');
                }
            });

            $(document).on('click', '.clkdashletMenuListImage', function (e) {
                self.options.name = $(this).attr('data');
                self.element.find('.dashletMenuList').hide();
                self.reRender();
            });

            $(document).on('click', '.addContentDiv', function (e) {
                self._addContent($(this).parents('div.col'));
            });

            $(document).on('click', '.addRowDiv', function (e) {
                self.element.find('.cellOption').hide();
                self.element.find('.rowOption').show();
            });

            $(document).on('click', '.addCellDiv', function (e) {
                self.element.find('.rowOption').hide();
                self.element.find('.cellOption').show();
            });

            $(document).on('click', '.insertRw', function (e) {
                var id = $(this).parents('div.col').attr('id');
                $("#dialog-confir").html("Are you sure you want to delete?");
                $("#dialog-confir").dialog({
                    resizable: false,
                    modal: true,
                    title: "Delete Row",
                    height: "200",
                    width: "auto",
                    close: function () { $(this).dialog('destroy'); },
                    dialogClass: "message info-dialog custom-style no-titlebar",
                    buttons: {
                        Yes: function () {
                            self.dashboard.dashlets.deleteRow(id, self);
                            self._drawDashlets();
                            $(this).dialog('destroy');
                        },
                        No: function () {
                            $(this).dialog('destroy');
                        }
                    }
                });
            });

            $(document).on('click', '.dashboardName', function (e) {
                self.options.name = $(this).siblings('.clkdashletMenuListImage').attr('data');
                self.options.dashletUserId = $(this).parent().attr('dt-dashuserid');
                self.element.find('.dashletMenuList').hide();
                self.reRender();
            });

            $(document).click(function (event) {
                if (!$(event.target).is(".editBox, .editBox *,.renameDashboardtxt")) {
                    self.element.find('.dashboardName').show();
                    var textToDisplay = self.element.find('.editBox:visible').find('#txtUpdate').val();
                    var oldText = self.element.find('.editBox:visible').siblings('.dashboardName').attr('data');
                    if (textToDisplay != "" && textToDisplay != undefined) {
                        self.dashboard.setGeneric(self);
                        var dashboard = self.dashboard.get();
                        $(this).parent().siblings('.dashboardName').text(textToDisplay);
                        $(this).parent().siblings('.dashboardName').children().remove();
                        var item = $.grep(self.dashletViews, function (val, i) {
                            return val.name == textToDisplay;
                        });
                        if (item.length == 0 || (item.length == 1 && textToDisplay == oldText)) {
                            var param = new Object();
                            param.name = oldText;
                            param.mId = self.options.menuId;
                            param.newName = textToDisplay;
                            param.userid = self.options.userid;
                            param.background = (self.options.selectedColor == undefined) ? null : self.options.selectedColor;
                            $("#dialog-confir").html("Are you sure you want to rename this Dashboard?");
                            $("#dialog-confir").dialog({
                                resizable: false,
                                modal: true,
                                height: "200",
                                width: "auto",
                                draggable: false,
                                dialogClass: "message warning-dialog custom-style no-titlebar",
                                close: function () { $(this).dialog('destroy'); },
                                buttons: {
                                    Yes: function () {
                                        self._ajaxcall({
                                            url: self.options.apiURL + '/Put',
                                            data: param,
                                            type: 'PUT',
                                            success: function (data) {
                                                _app.notify({  /*Success notification after renaming dashboard*/
                                                    title: 'Success',
                                                    type: 'success',
                                                    text: 'Dashboard renamed successfully.',
                                                    delay: 3000
                                                });
                                                if (data.result) {
                                                    self.dashletViews = data.dashletViews;
                                                    self.hideToolbar();
                                                    self.options.name = textToDisplay;
                                                    if ($("#h3menu .dashletName").text() == oldText) {
                                                        self.element.find('.dashletName').siblings().hide();
                                                        if ($("#h3menu").find('span').hasClass('dashletName')) $('.dashletName').remove();
                                                        if (self.options.name != "") {
                                                            $("#h3menu").append("<span class='dashletName'>" + self.options.name + "</span>");
                                                        }
                                                    }
                                                    self._jsonData();
                                                    self.dashboard.setSpecific(self);
                                                    self._fillDropdownView();
                                                }
                                            }
                                        });
                                        $(this).dialog('destroy');
                                    },
                                    No: function () {
                                        $(this).dialog('destroy');
                                    }
                                }
                            });
                        }
                        else {
                            self._errorBox({
                                message: "Dashboard name already exists. Please enter a unique name.",
                                class: "message error-dialog custom-style no-titlebar",
                                errorType: true
                            });
                        }
                        self.element.find('.dashletMenuList').hide();
                    }
                    else {
                        self.element.find(".editBox").hide();
                    }
                }
            });

            $(document).on('click', '.clickMobileType', function (e) {
                $(this).toggleClass('grphTypeMobile').parents('.dashletContainer').find('.backFace').addClass('desktop').removeClass('mobile');
            });


            $(document).on('click', '.millionize', function (e) {
                var id=$(this).parents('.col').attr("id");
                self.getAligned(1000000, 'Million', undefined, id);
            });

            $(document).on('click', '.billionize', function (e) {
                var id=$(this).parents('.col').attr("id");
                self.getAligned(1000000000, 'Billion', undefined, id);
            });

        },

        getAligned: function (value, unit, text, id) {
            var self = this;
            var dashlet = self.dashboard.dashlets.select(id);
            if (text == undefined) {
                var text = "";
                var activeEl = document.getElementsByClassName('txtHeadline2')[0];
                text = dashlet.widget.widgetFieldvalue;
                if ($.isNumeric(text)) {
                    str = (parseFloat(text) / value).toFixed(1);
                    activeEl.value = '$' + str + " " + unit;
                }
            }
            else {
                return '$' + (parseFloat(text) / value).toFixed(1) + " " + unit;
            }
        },
        hideToolbar: function () {
            var self = this;
            if (!self.element.find('#toolbar').hasClass('toolbarDeactive')) {
                self.element.find("div#toolbar").removeClass('active').animate({
                    height: "0px"
                }, 500, function () {
                    self.element.find('.toolBoxIcn').removeClass('closetoolBoxIcn');
                });
                self.element.find('div#layoutContainer').animate({
                    "margin-top": "0px"
                }, 500);
                //self.element.find('div#wrappercontainer').height(self.element.find('div#layoutContainer').height() + 2);
            }
        },

        showToolbar: function () {
            var self = this;
            if (self.element.find('#toolbar').hasClass('toolbarDeactive')) {
                self.element.find("div#toolbar").animate({
                    height: "33px"
                }, 500, function () {
                    self.element.find("div#toolbar").addClass('active');
                    self.element.find('.toolBoxIcn').addClass('closetoolBoxIcn');
                });
                self.element.find('#toolbar').removeClass("toolbarDeactive");
                self.element.find('div#layoutContainer').animate({
                    "margin-top": "33px"
                }, 500, function () {
                });
            }
        },

        //function for getting saved criteria in dashboard
        savedFilters: function (savedFilters) {
            var self = this;
            if (savedFilters.model.get('catalog') && savedFilters.model.get('catalog').asOfDate) {
                var item = $.grep(savedFilters.model.get('catalog').savedFilters.filter, function (val, i) {
                    return val.fieldName == "AsOfDate";
                });
                if (item.length == 0) {
                    (savedFilters.model.get('catalog').savedFilters.filter).push({
                        "id": "asOfDate",
                        "fieldName": "AsOfDate",
                        "displayName": "As Of Date",
                        "operator": "Today",
                        "value1": "",
                        "value2": "",
                        "type": "custom",
                        "checked": true,
                        "multiValue": false,
                        "aliasName": "AsOfDate",
                        "title": "As Of Date"
                    });
                }
            }
            var out = Mustache.render(self.showFilterTemplate(), { showFilter: savedFilters.model.get('catalog').savedFilters.filter });
            savedFilters.$el.parents('.col').find('.content_div').append(out);
            if (savedFilters.model.get('catalog').savedFilters.filter.length == 0) {
                savedFilters.$el.parents('.col').find('.dashletFilters').hide();
            }
        },

        _removeItem: function (type) {
            var jsonData = this.dashboard.dashlets.get();
            var maxRow = _.max(jsonData, function (data) {
                return data.rowNo;
            });
            var firstRow = $.grep(jsonData, function (val, idx) {
                return val.rowNo == 0;
            });
            if (maxRow.rowNo != 0) {
                for (var i = 1; i <= maxRow.rowNo; i++) {
                    var rowItems = $.grep(jsonData, function (val, idx) {
                        return val.rowNo == i;
                    });
                    var blankItem = $.grep(rowItems, function (val, i) {
                        return (val.dashlet != "");
                    });
                    firstRow = $.merge($.merge([], firstRow), blankItem);
                }
            }
        },

        go_to_page: function (page_num) {
            var self = this;
            start_from = page_num * self.options.showPerPage;
            end_on = start_from + self.options.showPerPage;
            var number_of_items = self.element.find('.contentdashletMenuList').children().size();
            var maxPage = parseInt(number_of_items / self.options.showPerPage);
            self.element.find('.contentdashletMenuList').children().css('display', 'none').slice(start_from, end_on).css('display', 'block');
            self.element.find('.page_link[longdesc=' + page_num + ']').addClass('active_page').siblings('.active_page').removeClass('active_page');
            self.options.currentPage = page_num;
            if (page_num == 0) self.element.find('.previous_link').hide();
            else self.element.find('.previous_link').show();
            if (page_num < maxPage) self.element.find('.next_link').show();
            else self.element.find('.next_link').hide();
            if (self.element.find('.pageCount').length > 0) {
                var flag = self.element.find('.pageCount.pagingNum').attr('page');
                if (page_num == 0) {
                    _.each(self.element.find('.pageCount'), function (val, i) {
                        if (parseInt(($(val).attr('page'))) == parseInt(flag + 2)) {
                            $(val).hide();
                            flag++;
                        }
                    });
                }
                else {
                    self.element.find('.pageCount').show();
                    _.each(self.element.find('.pageCount'), function (val, i) {
                        if ((page_num != parseInt($(val).attr('page'))) && (page_num != parseInt($(val).attr('page')) + 1) && (page_num != parseInt($(val).attr('page')) - 1)) {
                            $(val).hide();
                        }
                    });
                }
            }
        },

        //resizing dashlets
        _resizable: function () {
            var self = this;
            var width;
            self.element.find("div.col").resizable({
                handles: 's',
                start: function (event, ui) {
                    minWidth: $(ui.element).width;
                },
                resize: function (event, ui) {
                },
                stop: function (event, ui) {
                    var div = $(ui.element);
                    var id = $(ui.element[0]).attr('id');
                    var flag = true;

                    var itemRow = self.dashboard.dashlets.select(id).rowNo;
                    var itemHeight = self.dashboard.dashlets.select(id).height;
                    var diffHeight = itemHeight - div.height();

                    var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                        return val.rowNo == itemRow;
                    });

                    var leastValue = $.grep(items, function (val, i) {
                        return (val.height - diffHeight) < self.options.minHeight;
                    });

                    if (leastValue.length > 0) {
                        flag = false;
                    }

                    if (flag) {
                        var data = {
                            id: $(div).attr("id"),
                            layout: self.dashboard.get().templateType,
                            height: $(ui.element).height(),
                            width: $(ui.element).width(),
                            handles: $(ui.element).data('ui-resizable').axis // $(this).data('resizable').axis
                        };

                        self.dashboard.dashlets.resize(data);
                        $(ui.element).resizable("option", "disabled", false);
                        self._drawDashlets();
                    }
                    else {
                        $(ui.element).resizable("option", "disabled", false);
                        self._drawDashlets();
                    }
                }
            });
        },

        // for swapping dashlets
        _setSwappable: function () {
            var self = this;
            self.element.find("div.col").
            draggable({
                revert: true,
                start: function (event, ui) { ui.helper.addClass('beingDragged'); },
                stop: function (event, ui) { ui.helper.removeClass('beingDragged'); },
                cursor: "move",
                containment: self.element,
                scroll: false,
                handle: ".swapDashlet",
                helper: "clone",
                revert: "invalid",
                drag: function () {
                    if ($(this).find('.dialog-confirm').length == 0) {
                        if ($(this).find('.swapDashlet').length == 0) return false;
                        else return true;
                    }
                    else return false;
                }
            }).
            droppable({
                accept: "div.col",
                tolerance: "pointer",
                drop: function (event, ui) {
                    var dropDiv = $($(this).get(0));
                    var dragDiv = $($(ui.draggable).get(0));
                    //if (dropDiv.find('.backFace').length == 0 && dragDiv.find('.backFace').length == 0) {
                    var dropId = $(dropDiv).attr("id");
                    var dragId = $(dragDiv).attr("id");
                    var dragdivHeight = $(dragDiv).find('.content_div').height();
                    $(dragDiv).removeClass('overflow-show').find('.content_div').height($(dropDiv).find('.content_div').height());
                    $(dropDiv).removeClass('overflow-show').find('.content_div').height(dragdivHeight);

                    var dragdivHtml = $(dropDiv).clone().remove('.ui-resizable-handle').html();
                    var dropdivHtml = $(dragDiv).clone().remove('.ui-resizable-handle').html();
                    $(dropDiv).empty();
                    $(dragDiv).empty();
                    var hasWidgetCheck = $(dragDiv).hasClass('widgetLayout');
                    if (!$(dropDiv).hasClass('widgetLayout')) {
                        $(dragDiv).removeClass('widgetLayout');
                    }
                    else {
                        $(dragDiv).addClass('widgetLayout');
                    }
                    if (hasWidgetCheck) {
                        $(dropDiv).addClass('widgetLayout');
                    }
                    else {
                        $(dropDiv).removeClass('widgetLayout');
                    }
                    $(dropDiv).prepend(dropdivHtml);
                    $(dragDiv).prepend(dragdivHtml);

                    self.dashboard.dashlets.swap(dropId, dragId);
                    $('#' + dropId).parents('.dashletContainer').find('.selectType').remove();
                    $('#' + dragId).parents('.dashletContainer').find('.selectType').remove();
                    self._loadDashlets(self.dashboard.dashlets.select(dragId));
                    self._loadDashlets(self.dashboard.dashlets.select(dropId));
                    if ($('#' + dragId).find('.widgetChartContent').length !== 0)
                        self._createWidgetChart(dragId, $('#' + dragId).find('.widgetChartContent').attr('data-widget'));
                    if ($('#' + dropId).find('.widgetChartContent').length !== 0)
                        self._createWidgetChart(dropId, $('#' + dropId).find('.widgetChartContent').attr('data-widget'));
                    $('#' + dropId).find('.backFace').removeAttr('style');
                    $('#' + dragId).find('.backFace').removeAttr('style');
                }
            });
        },

        // for Toolbar
        _initToollbar: function () {
            var self = this;
            $('#type').button({
                text: false,
                icons: {
                    primary: "spriteIcon",
                    secondary: "ui-icon-triangle-1-s"
                }
            }).click(function () {
                var pos = $(this).position();
                var height = $(this).outerHeight();
                var menu = self.element.find("#typeop").css({
                    position: "absolute",
                    top: (pos.top) + height + "px",
                    left: (pos.left) + "px"
                }).show();
                $(document).one("click", function () {
                    menu.hide();
                });
                menu.show();
                return false;
            });

            self.element.find("#toolbar .condMenu, #toolbar .toolMenu").click(function () {
                if ($(this).hasClass("disableClass")) return false;
                var div = $("div#" + self.activeDashlet);
                var key = $(this).attr("id");
                self._menuHandler(key, div);
            });
        },

        //Context menu enabling
        _initContextMenu: function () {
            var self = this;
            $.contextMenu({
                selector: '.context-menu-one',
                callback: function (key, options) {
                    var div = options.$trigger;
                    self._menuHandler(key, div);
                },
                items: {
                    "addContent": {
                        name: "Add Dashlet",
                        icon: "addcontent"
                    },
                    "addrow": {
                        name: "Add Row",
                        items: {
                            "insertBefore": {
                                name: "Insert Before",
                                icon: "addrowbefore",
                                disabled: getMenuStatus
                            },
                            "insertAfter": {
                                name: "Insert After",
                                icon: "addrowafter",
                                disabled: getMenuStatus
                            }
                        },
                        icon: "addrow"
                    },
                    "deleteRow": {
                        name: "Delete Row",
                        icon: "deleterow",
                        disabled: getMenuStatus
                    },
                    "mergecell": {
                        name: "Merge Cells",
                        items: {
                            "mergeTop": {
                                name: "Merge Top",
                                icon: "mergetop",
                                disabled: getMenuStatus
                            },
                            "mergeBottom": {
                                name: "Merge Bottom",
                                icon: "mergebottom",
                                disabled: getMenuStatus
                            },
                            "mergeLeft": {
                                name: "Merge Left",
                                icon: "mergeleft",
                                disabled: getMenuStatus
                            },
                            "mergeRight": {
                                name: "Merge Right",
                                icon: "mergeright",
                                disabled: getMenuStatus
                            }
                        },
                        icon: "mergecell"
                    },
                    "splitcell": {
                        name: "Split Cells",
                        items: {
                            "splitColumn": {
                                name: "Split Column",
                                icon: "splitColumn",
                                disabled: getMenuStatus
                            },
                            "splitRow": {
                                name: "Split Row",
                                icon: "splitRow",
                                disabled: getMenuStatus
                            }
                        },
                        icon: "splitCells"
                    },
                    "refresh": {
                        name: "Refresh",
                        icon: "refresh"
                    }
                }
            });

            function getMenuStatus(key, options) {
                var div = options.$trigger;
                var id = $(div).attr("id");
                return self.dashboard.contextMenuStatus(id, key);
            }
        },

        _menuHandler: function (key, div) {
            var drawDashlets = true;
            var self = this;
            var id = typeof div != "undefined" ? $(div).attr("id") : "";
            switch (key) {
                case 'addContent':
                    self._addContent(div);
                    drawDashlets = false;
                    break;
                case 'deleteRow':
                    $("#dialog-confir").html("Are you sure you want to delete?");
                    $("#dialog-confir").dialog({
                        resizable: false,
                        modal: true,
                        title: "Delete Row",
                        height: "200",
                        width: "auto",
                        close: function () { $(this).dialog('destroy'); },
                        dialogClass: "message info-dialog custom-style no-titlebar",
                        buttons: {
                            Yes: function () {
                                self.dashboard.dashlets.deleteRow(id, self);
                                self._drawDashlets();
                                $(this).dialog('destroy');
                            },
                            No: function () {
                                $(this).dialog('destroy');
                            }
                        }
                    });
                    drawDashlets = false;
                    break;
                case 'refresh':
                    self._refresh(div);
                    drawDashlets = false;
                    break;
                case 'insertAfter':
                    self.dashboard.dashlets.insertRow(self, id, "After");
                    break;
                case 'insertBefore':
                    self.dashboard.dashlets.insertRow(self, id, "Before");
                    break;
                case 'mergeTop':
                    var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                        return val.rowNo == self.dashboard.dashlets.select(id).rowNo - 1 && val.columnNo == self.dashboard.dashlets.select(id).columnNo;
                    });
                    if (items.length == 0 || items[0].dashlet != "") {
                        $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                        $("#dialog-confir").dialog({
                            resizable: false,
                            modal: true,
                            title: "Delete Row",
                            height: "220",
                            width: "380",
                            close: function () { $(this).dialog('destroy'); },
                            dialogClass: "message warning-dialog custom-style no-titlebar",
                            buttons: {
                                Yes: function () {
                                    self.dashboard.dashlets.mergeTop(id, self);
                                    self._drawDashlets();
                                    $(this).dialog('destroy');
                                },
                                No: function () {
                                    $(this).dialog('destroy');
                                }
                            }
                        });
                    }
                    else {
                        self.dashboard.dashlets.mergeTop(id, self);
                        self._drawDashlets();
                    }
                    break;
                case 'mergeBottom':
                    var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                        return val.rowNo == self.dashboard.dashlets.select(id).rowNo + 1 && val.columnNo == self.dashboard.dashlets.select(id).columnNo;
                    });
                    if (items.length == 0 || items[0].dashlet != "") {
                        $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                        $("#dialog-confir").dialog({
                            resizable: false,
                            modal: true,
                            title: "Delete Row",
                            height: "220",
                            dialogClass: "message warning-dialog custom-style no-titlebar",
                            width: "380",
                            close: function () { $(this).dialog('destroy'); },
                            buttons: {
                                Yes: function () {
                                    self.dashboard.dashlets.mergeBottom(id, self);
                                    self._drawDashlets();
                                    $(this).dialog('destroy');
                                },
                                No: function () {
                                    $(this).dialog('destroy');
                                }
                            }
                        });
                    }
                    else {
                        self.dashboard.dashlets.mergeBottom(id, self);
                        self._drawDashlets();
                    }
                    break;
                case 'mergeLeft':
                    var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                        return val.columnNo == self.dashboard.dashlets.select(id).columnNo - 1 && val.rowNo == self.dashboard.dashlets.select(id).rowNo;
                    });
                    if (items.length == 0 || items[0].dashlet != "") {
                        $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                        $("#dialog-confir").dialog({
                            resizable: false,
                            modal: true,
                            title: "Delete Row",
                            height: "220",
                            width: "380",
                            close: function () { $(this).dialog('destroy'); },
                            dialogClass: "message warning-dialog custom-style no-titlebar",
                            buttons: {
                                Yes: function () {
                                    self.dashboard.dashlets.mergeLeft(id, self);
                                    self._drawDashlets();
                                    $(this).dialog('destroy');
                                },
                                No: function () {
                                    $(this).dialog('destroy');
                                }
                            }
                        });
                    }
                    else {
                        self.dashboard.dashlets.mergeLeft(id, self);
                        self._drawDashlets();
                    }
                    break;
                case 'mergeRight':
                    var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                        return val.columnNo > self.dashboard.dashlets.select(id).columnNo && val.rowNo == self.dashboard.dashlets.select(id).rowNo;
                    });
                    if (items.length == 0 || items[0].dashlet != "") {
                        $("#dialog-confir").html("The selection contains multiple data values. Merging into one cell will keep the selected data only. Do you wish to continue?");
                        $("#dialog-confir").dialog({
                            resizable: false,
                            modal: true,
                            title: "Delete Row",
                            height: "220",
                            width: "380",
                            close: function () { $(this).dialog('destroy'); },
                            dialogClass: "message warning-dialog custom-style no-titlebar",
                            buttons: {
                                Yes: function () {
                                    self.dashboard.dashlets.mergeRight(id, self);
                                    self._drawDashlets();
                                    $(this).dialog('destroy');
                                },
                                No: function () {
                                    $(this).dialog('destroy');
                                }
                            }
                        });
                    }
                    else {
                        self.dashboard.dashlets.mergeRight(id, self);
                        self._drawDashlets();
                    }
                    break;
                case 'splitColumn':
                    self.dashboard.dashlets.splitColumn(id, self);
                    break;
                case 'splitRow':
                    self.dashboard.dashlets.splitRow(id, self);
                    break;
                case 'multiBar':
                case 'multiBarHorizontal':
                case 'line':
                case 'cumulativeLine':
                case 'pie':
                case 'scatter':
                case 'discreteBar':
                case 'linePlusBar':
                case 'lineWithFocus':
                case 'scatterPlusLine':
                case 'stackedArea':
                case 'donut':
                    var dashlet = self.dashboard.dashlets.select(id);
                    dashlet.param["graphType"] = key;
                    self._loadDashlets(dashlet);
                    drawDashlets = false;
                    break;
            }
            if (drawDashlets) self._drawDashlets();
        },

        getRecords: function (dashlet) {
            var self = this;
            var schemaURLs = self.options.apiURL + "/GetSchema";
            var records;
            var data = self._getQueryString(schemaURLs, true, dashlet);
            if (data.name == undefined) {
                data.name = dashlet.selectedCatalog.Caption;
                data.misID = dashlet.selectedCatalog.CatalogId;
            }
            self._ajaxcall({
                url: self.options.apiURL + '/GetData',
                type: 'GET',
                async: false,
                data: data,
                success: function (data) {
                    records = JSON.parse(data.Data);
                }
            });
            return JSON.parse(records.Records);
        },

        _calcPercentage: function (dashlet, data) {
            var self = this, total = 0;
            _.each(data, function (val, i) {
                if (val[dashlet.id] && val[dashlet.id] != "" && val[dashlet.id] != null)
                    total += parseFloat(val[dashlet.id]);
            });
            return total;
        },
        // Adding content
        _addContent: function (div) {
            var self = this;
            var id = $(div).attr("id");

            var catalog = self.dashboard.dashlets.select(id);
            if (catalog.widget == null) catalog.widget = undefined;
            var dashlet = $.extend(true, {
                title: undefined,
                catalogId: 0,
                dashletId: 0,
                clipHeadline: false,
                showLegend: false,
                widget: {
                    headline1: "",
                    head1Color: "",
                    headline2: "",
                    head2Color: "",
                    enableWidget: false,
                    percentage: 0,
                    percentageColor: "",
                    hoverOnDashelt: false,
                    chartType: ""
                }
            }, catalog);

            var data = {
                toolBar: self.options.toolBar,
                title: dashlet.title,
                dashletViews: self.dashletViews,
                dashLayout: self.dashboard.get(),
                clipHeadline: dashlet.clipHeadline,
                name: dashlet.param.name,
                widget: dashlet.widget
            };

            var out = Mustache.render(self._addDashletTemplate(), data);
            div.append(out);
            //Grouping the dashlet based on type
            var itemsName = _.groupBy(data.dashletList, function (obj) {
                return obj.Type;
            });

            if (self.dashboard.templateType == 2 || self.dashboard.templateType == 1 || catalog.colspan > 1) {
                self.element.find('.addDashletBody,.clipHeadBody').width('340px');
                self.element.find('.buttonSet').width('381px');
            }
            else self.element.find("div.dialog-confirm").height($(div).height() + 4);

            //Added by sreejith.v.n for default title on 24-6-2016
            $("select#ddlcontentName option").each(function () {
                if ($(this).attr("value") == $(this).parents(".addDashletBody").find("#ddlcontentName").val()) {
                    $(this).parents(".addDashletBody").find("#txtcontenttitle").val($(this).text());
                }
            });
                 
        },

        _listView: function (catalogs, dashlet, message) {
            var self = this;
            var template = '<div class="listViewDiv"></div>';
            $('.listViewDiv').remove();
            $('.popupDiv').append(Mustache.render(template));
            if (message == "success") {
                catalogs = self.normalize(catalogs);
                var formatter = function (row, cell, value, columnDef, dataContext) {
                    var iconClass = '';
                    var iconTitle = '';
                    switch (dataContext["Type"].toLowerCase()) {
                        case 'grid':
                            iconClass = 'icon-grid';
                            iconTitle = 'Grid';
                            break;
                        case 'pivot':
                            iconClass = 'icon-pivot';
                            iconTitle = 'Pivot';
                            break;
                        case 'graph':
                            iconClass = 'icon-chart';
                            iconTitle = 'Chart';
                            break;
                        case 'snapshot':
                            iconClass = 'icon-snapshot';
                            iconTitle = 'Snapshot';
                            break;
                    }

                    if (columnDef.root) {
                        value = value.toString().replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
                        var spacer = "<span style='float:left;display:inline-block;height:1px;width:" + (15 * dataContext._indent) + "px'></span>";
                        if (dataContext._hasChild) {
                            if (dataContext._collapsed) {
                                value = spacer + " <div class='toggle expand'>&nbsp;&nbsp;</div><div class=" + iconClass + " title=" + iconTitle + " ></div><span title='" + value + "'>" + value + "</span>";
                            }
                            else {
                                value = spacer + " <div class='toggle collapse'></div><div class=" + iconClass + " title=" + iconTitle + " ></div><span title='" + value + "'>" + value + "</span>";
                            }
                        }
                        else {
                            value = spacer + " <div class='toggle tggempty'></div><div class=" + iconClass + " title=" + iconTitle + " ></div><span title='" + value + "'>" + value + "</span>";
                        }
                    }
                    else {
                        value = "<span title='" + value + "'>" + value + "</span>";
                    }
                    return value;
                }

                var fields = [{
                    cssClass: "align-left",
                    decimalPoint: 0,
                    field: "Caption",
                    headerCssClass: "align-left",
                    id: "Caption",
                    minWidth: 16,
                    name: "Catalogs",
                    root: true,
                    formatter: formatter,
                    sortable: true,
                    toolTip: "Catalogs",
                    type: "string"
                }];

                function myFilter(item, args) {
                    if (item._parent != 0) {
                        var parent = _.findWhere(args.records, { _id: item._parent });
                        while (parent) {
                            if (parent._collapsed) { return false; }
                            parent = _.findWhere(args.records, { _id: parent._parent });
                        }
                    }
                    return true;
                }

                self.dataView = new Slick.Data.DataView({ inlineFilters: true });
                self.dataView.beginUpdate();
                self.dataView.setItems(catalogs, "CatalogId");
                _.each(self.dataView.getItems(), function (val, i) {
                    val._collapsed = false;
                });
                self.dataView.setFilterArgs({ records: catalogs, searchText: undefined });
                self.dataView.setFilter(myFilter);
                self.dataView.endUpdate();

                self.grid = new Slick.Grid($('.listViewDiv'), self.dataView, fields, { enableAddRow: false, forceFitColumns: true });

                if (dashlet) {
                    var rowNo = self.dataView.getIdxById(dashlet.dashletId);
                    $(self.grid.getCellNode(rowNo, 0)).parents('.slick-row').addClass("slick-grid-selected");
                }

                self.grid.onClick.subscribe(function (e, args) {
                    if ($(e.target).hasClass("toggle")) {
                        var item = self.dataView.getItem(args.row);
                        if (item) {
                            if (!item._collapsed) {
                                item._collapsed = true;
                            } else {
                                item._collapsed = false;
                            }
                            self.dataView.updateItem(item["CatalogId"], item);
                        }
                        e.stopImmediatePropagation();
                    }
                });
                self.grid.setSelectionModel(new Slick.RowSelectionModel({ selectActiveRow: true }));
                self.grid.onClick.subscribe(function (e, args) {
                    var item = self.grid.getDataItem(args.row);
                    if (item && item.ParentCatalogId != 0 && (item.CatalogTypeId == _app.catalogType.Filter || item.CatalogTypeId == _app.catalogType.FilterDashlet || item.CatalogTypeId == _app.catalogType.Dashlet)) {
                        $('.slick-row').removeClass('slick-grid-selected');
                        $(e.target).parents('.slick-row').addClass('slick-grid-selected');
                        dashlet.selectedCatalog = self.grid.getDataItem(args.row);
                    }
                });

                self.grid.onSort.subscribe(function (e, args) {
                    var cols = args.sortCols;
                    args.grid.getData().sort(function (dataRow1, dataRow2) {
                        for (var i = 0, l = cols.length; i < l; i++) {
                            var field = cols[i].sortCol.field;
                            var sign = cols[i].sortAsc ? 1 : -1;
                            var value1 = dataRow1[field], value2 = dataRow2[field];
                            var result = (value1 == value2 ? 0 : (value1 > value2 ? 1 : -1)) * sign;
                            if (result != 0) {
                                return result;
                            }
                        }
                        return 0;
                    });
                    self.grid.invalidate();
                    self.grid.render();
                });

                self.dataView.onRowsChanged.subscribe(function (e, args) {
                    self.grid.invalidateRows(args.rows);
                    self.grid.render();
                });
            }
            else if (message == "error") {
                $('.errorMsgDashlet').remove();
                $('.popupDiv').append("<span class='errorMsgDashlet'>No Records Found</span>");
            }
        },

        normalize: function (p_data, p_indent) {
            var self = this;
            var v_records = [];
            p_indent = p_indent || 0;
            _.each(p_data, function (value, idx) {
                var metta = {
                    _indent: p_indent,
                    _hasChild: (value.Children && value.Children.length > 0),
                    _id: value['CatalogId'],
                    _collapsed: true,
                    _parent: value["ParentCatalogId"],
                    Children: undefined
                };
                v_records.push($.extend(true, {}, value, metta));
                if (metta._hasChild) {
                    var children = self.normalize(value.Children, p_indent + 1)
                    $.merge(v_records, children);
                }
            });
            return v_records;
        },

        _removeContent: function (div) {
            var self = this;
            var id = $(div).attr('id');
            //get paramid of removing dashletid
            var paramId = _.findWhere(self.dashboard.dashlets.items, {
                id: id
            }).param.$id;

            var dashlet = self.dashboard.dashlets.updateItem({
                id: id,
                dashlet: "",
                title: "",
                catalogId: 0,
                dashletId: 0,
                type: "",
                clipHeadline: false,
                param: {
                    $id: paramId,
                    graphType: "",
                    misID: "",
                    name: ""
                }
            });
            //clearing misschema,dataset,selected catalog
            dashlet.selectedCatalog = undefined;
            dashlet["misSchema"] = undefined;
            dashlet["dataset"] = undefined;
            $(div.parentElement).parent('.col').attr('data-content', '');
            self._loadDashlets(dashlet);
        },

        _removeContentWidget: function (div) {
            var self = this;
            var id = div.attr('id');
            //get paramid of removing dashletid
            var paramId = _.findWhere(self.dashboard.dashlets.items, {
                id: id
            }).param.$id;
            var dashlet = self.dashboard.dashlets.updateItem({
                id: id,
                catalogId: 0,
                dashletId: 0,
                dashlet: "",
                title: "",
                type: "",
                clipHeadline: false,
                widget: {
                    headline1: "",
                    head1Color: "",
                    headline2: "",
                    head2Color: "",
                    enableWidget: false,
                    percentage: 0,
                    percentageColor: "",
                    hoverOnDashelt: false,
                    chartType: ""
                },
                param: {
                    $id: paramId,
                    graphType: "",
                    misID: "",
                    name: ""
                }
            });
            //clearing misschema,dataset,selected catalog
            dashlet.selectedCatalog = undefined;
            dashlet["misSchema"] = undefined;
            dashlet["dataset"] = undefined;
            self._loadDashlets(dashlet);
        },

        _refresh: function (div) {
            var self = this;
            var id = $(div).attr("id");
            var dashlet = self.dashboard.dashlets.select(id);
            self._loadDashlets(dashlet);
        },

        _getQueryString: function (url, isDashlet, dashlet) {
            var self = this;
            var filter = self._getFilterQuery();
            var queries = $.extend({}, self._extractQueryString(url), dashlet.param);
            queries["query"] = JSON.stringify(self.options.filters);
            queries["isDashlet"] = (!isDashlet) ? 0 : 1;
            return queries;
        },

        _extractQueryString: function (url) {
            url = url.split("?")[1];
            var oResult = {};
            if (url == "" || url == undefined) return oResult;
            var aQueryString = (url.substr(0)).split("&");
            for (var i = 0; i < aQueryString.length; i++) {
                var aTemp = aQueryString[i].split("=");
                if (aTemp[1].length > 0) {
                    if (aTemp[0].toLowerCase() == "reportid") continue;
                    if (aTemp[0].toLowerCase() == "query") continue;
                    if (aTemp[0].toLowerCase() == "promptfilter") continue;
                    oResult[aTemp[0]] = unescape(aTemp[1]).replace(/\+/g, ' ');
                }
            }
            return oResult;
        },

        _getBaseURL: function () {
            return location.protocol + "//" + location.hostname + (location.port && ":" + location.port) + "/";
        },

        _getFilterQuery: function () {
            var self = this;
            var value1 = self.options.defaultFromDate.format('DD-MM-YYYY'); // moment().subtract('days', 29).format('DD-MM-YYYY');
            var value2 = self.options.defaultToDate.format('DD-MM-YYYY'); // moment().format('DD-MM-YYYY');
            var filter = new Array();
            var jObj = {
                "fieldName": "date",
                "operator": "Between",
                "value1": value1,
                "value2": value2,
                "type": "datetime",
                "displayName": "date"
            }
            filter.push(jObj);
            return filter;
        },

        _setDateRangePicker: function () {
            var self = this;
            $('div#dateRangeSelector').daterangepicker({
                buttonClasses: ['btn btn-default'],
                applyClass: 'btn-small btn-primary',
                cancelClass: 'btn-small',
                opens: 'left',
                locale: {
                    applyLabel: 'Submit',
                    cancelLabel: 'Clear',
                    fromLabel: 'From',
                    toLabel: 'To',
                    customRangeLabel: 'Custom',
                    firstDay: 1
                },
                ranges: {
                    'Today': [moment(), moment()],
                    'Yesterday': [moment().subtract('days', 1), moment().subtract('days', 1)],
                    'Last 7 Days': [moment().subtract('days', 6), moment()],
                    'Last 30 Days': [moment().subtract('days', 29), moment()],
                    'This Month': [moment().startOf('month'), moment().endOf('month')],
                    'Last Month': [moment().subtract('month', 1).startOf('month'), moment().subtract('month', 1).endOf('month')]
                },
                startDate: self.options.defaultFromDate, // moment("20130701", "YYYYMMDD"), //moment().subtract('days', 29),
                endDate: self.options.defaultToDate //moment("20130731", "YYYYMMDD") //moment()
            },
                function (start, end) {
                    self.element.find('div#dateRangeSelector span').html(start.format('MMMM D, YYYY') + ' - ' + end.format('MMMM D, YYYY'));
                });
            self.element.find('div#dateRangeSelector span').html(self.options.defaultFromDate.format('MMMM D, YYYY') + ' - ' + self.options.defaultToDate.format('MMMM D, YYYY'));
            self.element.find('div#dateRangeSelector').on('apply.daterangepicker', function (ev, picker) {
                self.options.defaultFromDate = picker.startDate;
                self.options.defaultToDate = picker.endDate;
                self._loadDashlets();
            });
        },

        _errorBox: function (options) {
            var self = this;
            $("#dialog-confir").html(options.message);
            if (options.errorType) {
                $("#dialog-confir").dialog({
                    resizable: false,
                    modal: true,
                    height: options.height || "100",
                    width: options.width || "auto",
                    close: function () { $(this).dialog('destroy'); },
                    draggable: false,
                    dialogClass: options.class
                });
            }
            else {
                $("#dialog-confir").dialog({
                    resizable: false,
                    modal: true,
                    height: options.height || "100",
                    width: options.width || "auto",
                    close: function () { $(this).dialog('destroy'); },
                    draggable: false,
                    dialogClass: options.class,
                    buttons: {
                        OK: function () {
                            $(this).dialog('destroy');
                        }
                    }
                });
            }
        },

        _ajaxcall: function (options) {
            var defaultOptions = {
                url: undefined,
                type: 'GET',
                dataType: 'json',
                data: undefined,
                async: true,
                success: undefined,
                error: function (p_request, p_status, p_error) {
                    if (window.console && window.console.log) console.log((p_error.message ? p_error.message : p_error));
                }
            };

            var ajaxOptions = $.extend(true, {}, defaultOptions, options);
            $.ajax(ajaxOptions);
        }
    });
})(jQuery);
