
(function ($) {
    $.widget('Assyst.aggFunctions', {
        options: {
            schema: undefined,
            query: undefined,
            filter: true,
            header: true,
            aggregation: true,
            catalog: undefined,
            url: '/BI/DataViewer/GetOptions',
            buttons: true,
            shared: false,
            visualize: undefined,
            onApplySearch: undefined,
            onClearSearch: undefined,
            functions: {//aggregate functions
                aggs: [{ value: "Terms", key: "groupby" },
                        { value: "Histogram", key: "interval" },
                        { value: "Date Histogram", key: "dateinterval" },
                        { value: "Range", key: "range" }
                        ],
                //aggregate operations
                metrics: [{ value: "MIN", key: "MIN" },
                        { value: "MAX", key: "MAX" },
                        { value: "SUM", key: "SUM" },
                        { value: "AVG", key: "AVG" },
                        { value: "COUNT", key: "COUNT"}]
            },
            sort: {//sort order
                order: [{ value: "None", key: "all" },
                                 { value: "ASC", key: "asc" },
                                 { value: "DESC", key: "desc"}],
                //date interval
                interval: [{ value: "Year", key: "year" },
                           { value: "Month", key: "month" },
                           { value: "Week", key: "week" },
                           { value: "Day", key: "day" },
                           { value: "Hour", key: "1h" },
                           { value: "Minute", key: "1m" },
                           { value: "Second", key: "1s"}],
                recordorder: [{ value: "All", key: "all" },
                        { value: "Top", key: "desc" },
                        { value: "Bottom", key: "asc"}]
            },
            operators: {
                //filter operators for string
                string: [{ value: "In", key: "In" },
                        { value: "Not In", key: "NotIn" },
                        { value: "Like", key: "Like" },
                        { value: "Not Like", key: "NotLike"}],
                //filter operators for numeric
                numeric: [
                        { value: "=", key: "=" },
                        { value: "!=", key: "!=" },
                        { value: ">", key: ">" },
                        { value: "<", key: "<" },
                        { value: ">=", key: ">=" },
                        { value: "<=", key: "<=" },
                        { value: "Between", key: "Between" },
                        { value: "Is Blank", key: "Is Blank"}],
                month: [{ value: "In", key: "In" },
                        { value: "Not In", key: "NotIn" },
                        { value: "Like", key: "Like" },
                        { value: "Not Like", key: "NotLike" },
                        { value: ">", key: ">" },
                        { value: ">=", key: ">=" },
                        { value: "<", key: "<" },
                        { value: "<=", key: "<=" },
                        { value: "Between", key: "Between" },
                        { value: "Is Blank", key: "Is Blank"}],
                date: [{ value: "=", key: "=" },
                        { value: "!=", key: "!=" },
                        { value: ">", key: ">" },
                        { value: "<", key: "<" },
                        { value: ">=", key: ">=" },
                        { value: "<=", key: "<=" },
                        { value: "Between", key: "Between" },
                        { value: "Is Blank", key: "Is Blank" }
                        ],
                asOFDate: [{ value: "=", key: "==" },
                        { key: 'Today', value: 'Today' },
                        { key: 'Yesterday', value: 'Yesterday' },
                        { key: 'This Week', value: 'This Week' },
                        { key: 'Prior Week', value: 'Prior Week' },
                        { key: 'Prior 2 Weeks', value: 'Prior 2 Weeks' },
                        { key: 'This Month', value: 'This Month' },
                        { key: 'Prior Month', value: 'Prior Month' },
                        { key: 'This Quarter', value: 'This Quarter' },
                        { key: 'Prior Quarter', value: 'Prior Quarter' },
                        { key: 'This Year', value: 'This Year' },
                        { key: 'Prior Year', value: 'Prior Year' },
                        { key: 'Days Ago', value: 'Days Ago'}],
                user: []
            }
        },
        //field template
        fields: [{
            id: "",
            title: "",
            type: ""
        }],
        esQuery: {
            // Get the collection sorted dashlet item
            get: function () {
                return { filter: this.filter.get(), aggregate: this.aggregate.get() };
            },
            // Set the new dashlet collection
            set: function (data) {
                this.filter.set(data.filter);
                this.aggregate.set(data.aggregate);
            },
            // Clear the dashlet collection
            clear: function () {
                this.filter.clear();
                this.aggregate.clear();
            },
            //template for the filter 
            filter: {
                items: [],
                template: {
                    id: "",
                    fieldName: "",
                    displayName: "",
                    operator: "",
                    value1: "",
                    value2: "",
                    displayValue1: "",
                    displayValue2: "",
                    type: "",
                    checked: false,
                    multiValue: false
                },

                get: function () { return this.items; },
                set: function (data) { this.items = $.extend([], data); },
                clear: function () { this.items = []; },
                select: function (id) { return _.findWhere(this.items, { id: id }); },
                add: function (options) {//adding an item to filter query
                    var self = this;
                    var newItem = $.extend(true, {}, this.template, options, { id: ("filt_" + Math.floor(Math.random() * 99999)) });
                    this.items.push(newItem);
                    return newItem;
                },
                update: function (options) {//updating an item to filter query
                    var item = this.select(options.id);
                    $.extend(true, item, options);
                    return item;
                },
                remove: function (id) {//removing an item to filter query with id
                    var index = -1;
                    _.each(this.items, function (val, idx) {
                        if (val.id == id) index = idx;
                    });
                    if (index > -1) this.items.splice(index, 1);
                    return index;
                }
            },
            aggregate: {
                items: [],
                template: {
                    id: "",
                    fieldName: "",
                    aliasName: "",
                    displayName: "",
                    type: "",
                    operator: "",
                    interval: 0,
                    dateinterval: "",
                    order: "All",
                    orderBy: "",
                    size: 0,
                    ranges: [],
                    metrics: false,
                    checked: false,
                    format: null,
                    decimalPoint: 2,
                    title: ""
                },

                get: function () { return this.items; },
                set: function (data) { this.items = $.extend([], data); },
                clear: function () { this.items = []; },
                select: function (id) { return _.findWhere(this.items, { id: id }); },
                add: function (options) {
                    var self = this;
                    var newItem = $.extend(true, {}, this.template, options, { id: ("aggr_" + Math.floor(Math.random() * 99999)) });
                    this.items.push(newItem);
                    return newItem;
                },
                update: function (options) {
                    var item = this.select(options.id);
                    $.extend(true, item, options);
                    return item;
                },
                remove: function (id) {
                    var index = -1;
                    $.each(this.items, function (idx, val) {
                        if (val.id == id) index = idx;
                    });
                    if (index > -1) this.items.splice(index, 1);
                    return index;
                }
            }
        },

        _init: function () {
            var self = this;
            self._setFields();
            self.render();
            self._addFilter();
            self._addAggregate();
            self.eventHandler();
            //Applying filter and aggregation if there any of them contains
            if (self.esQuery.aggregate.items.length > 0 || self.esQuery.filter.items.length > 0) {
                self.element.find('.applyButton,.headFilter').trigger('click');
            }
        },

        reDraw: function () {
            var self = this;
            self._setFields();
            if (self.options.query != undefined) {
                self.esQuery.set(self.options.query);
            }
            self.element.find('.selectedFunction').remove();
            self._addFilter();
            self._addAggregate();
            if (self.esQuery.aggregate.items.length > 0 || self.esQuery.filter.items.length > 0) {
                self.element.find('.applyButton,.headFilter').trigger('click');
            }
        },

        //setting fields with the corresponding schema
        _setFields: function () {
            var self = this;
            var fields = [];
            self.fields = $.map(self.options.schema, function (val, key) {
                return {
                    title: val.title || val.label,
                    type: val.dataType || val.type,
                    id: $.isNumeric(key) ? val.id : key,
                    relatedTo: val.relatedTo == undefined ? [] : val.relatedTo,
                    format: val.format,
                    decimalPoint: val.decimalPoint,
                    isAxis: val.isAxis,
                    isFilter: val.filter == undefined ? true : val.filter,
                    isAggregate: val.aggregate == undefined ? true : val.aggregate,
                    isMetrics: val.metrics == undefined ? true : val.metrics,
                    isHidden: val.isHidden
                };
            });
            //self._sortResults("title", true, self.fields);
            if (self.options.query != undefined) {
                self.esQuery.set(self.options.query);
            }
        },

        //Get particular fields schema
        _getFields: function (id) {
            var self = this;
            return _.findWhere(self.fields, { id: id });
        },

        _getItems: function (id) {
            var self = this;
            return _.findWhere(self.esQuery.get('aggregate'), { id: id });
        },

        render: function () {
            var self = this;
            if (self.options.header) self.element.append('<div class="headColor" title="Panel slider"><div class="analyzeHeader"><span class="headImg"></span><span class="analyze">Analyze</span></div><div class="VisualizeHeader"><span class="visualHeadImg"></span><span class="visualize">Visualize</span></div></div>');
            //template for the sidepanel
            var template = '<div class="calcDiv">{{#filter}}<div class="Filter acc"><div class="headFilter"><span class="filterImg" ></span><span class="filter-text">Filter</span></div><div class="filter-container acc_Container">' +
                            '<div id="agg_Filter">' +
                                        '<div class="divFunction"></div>' +
                                        '<div class="filterBlock"></div>' +
                             '</div>' +
                         '</div></div> {{/filter}}' +
                          '{{#aggregation}}<div class="Metrics acc"><div class="headFilter"><span class="metricsImg"></span><span class="metrics-text">Metrics</span></div>' +
                                '<div class="metrics-container acc_Container">' +
                                    '<div id="agg_Metrics">' +
                                        '<div class="divFunction">' +
                                            '<div class="sumAction">' +
                                                '<span class="aggrHeader">SUM :</span>' +
                                            '</div>' +
                                            '<div class="avgAction">' +
                                                '<span class="aggrHeader">AVG :</span>' +
                                            '</div>' +
                                            '<div class="minAction">' +
                                                '<span class="aggrHeader">MIN :</span>' +
                                            '</div>' +
                                            '<div class="maxAction">' +
                                                '<span class="aggrHeader">MAX :</span>' +
                                            '</div>' +
                                            '<div class="countAction">' +
                                                '<span class="aggrHeader">COUNT :</span>' +
                                            '</div>' +
                                        '</div>' +
                                        '<div class="divMetrics"></div>' +
                                   '</div>' +
                              '</div></div>' +
                          '<div class="Aggregate agg-background-clr acc"><div class="headFilter"><span class="aggsImg"></span><span class="aggregate-text">Aggregate</span></div><div class="aggregate-container acc_Container">' +
                             '<div id="agg_Aggregate"> <span class="aggrLabel">Aggregate By :</span> ' +
                                    '<div class="divFunction"></div>' +
                                    '<div class="divAggs"></div>' +
                               '</div>' +
                          '</div></div>{{/aggregation}}</div>' +
                          '{{#buttons}}<div class="footerSet"><div class="clearButton" title=" Clear"clicked="false">Clear</div><div class="applyButton" title="Apply">Apply</div></div>{{/buttons}}';
            var out = Mustache.render(template, { filter: self.options.filter, aggregation: self.options.aggregation, buttons: self.options.buttons });
            self.element.append(out);
            if (self.esQuery.filter.get().length > 1 || self.esQuery.aggregate.get().length > 1) {//showing sidebar if there is any filter or aggregation
                self.element.parents('#divSideBySideView').addClass('open-state').removeClass('closed-state');
                self.element.parents('.dataContent').find('.PanBI-main-data-container').addClass('closed').removeClass('open');
            }
        },

        //formatting operators
        _operators: function (dataType) {
            var self = this;
            var operators;
            switch (dataType) {
                case "string":
                    operators = self.options.operators.string;
                    break;
                case "numeric":
                case "number":
                case "geo":
                    operators = self.options.operators.numeric;
                    break;
                case "date":
                case "date-time":
                    operators = self.options.operators.date;
                    break;
                case "custom":
                    operators = self.options.operators.asOFDate;
                    break;
                case "user":
                    operators = self.options.operators.user;
                    break;
                case "month":
                    operators = self.options.operators.month;
                    break;
                case "integer":
                    operators = self.options.operators.integer;
                    break;
            }
            return operators;
        },

        //Template for filter
        //Contains display name and fields
        _filterBlock: function () {
            return '<div class="boxFilter">' +
                        '<div class="fieldDiv"><select class="drpField"><option class="disableClass" disabled selected>- Fields -</option>{{#fields}}<option type="{{type}}" value="{{id}}">{{title}}</option>{{/fields}}</select></div>' +
                        '<div class="filterContent"></div>' +
                        '<div class="btnAddFilter" title="Ok">Ok</div>' +
                        '<div class="btnClearFilter" title="Cancel">Cancel</div>' +
                          '<div class="errorMsg"></div>' +
                   '</div>';
        },

        //Template of filter content.
        //It shows operands depending on the field's schema
        _filterContent: function () {
            return '<div class="operator"><select class="drpOp">{{#operators}}<option value="{{key}}">{{value}}</option>{{/operators}}</select></div>' +
                        '<div class="txtValueDiv1"><input type="text" value="{{value1}}" class="txtValue1" placeHolder="" /></div>' +
                        '{{#value2}}<div class="txtValueDiv2"><input type="text" value="{{value2}}" class="txtValue2" placeHolder=""/></div>{{/value2}}';
        },

        //Template for metrics block
        // It shows functions like sum,max etc..
        _metricsBlock: function () {
            return '<div class="boxFilter">' +
                   '<div class="matFunDiv"><select class="drpFun"><option class="disableClass" disabled selected>- Metrics -</option>' +
                                                '{{#functions}}<option value="{{key}}">{{value}}</option>{{/functions}}' +
                                           '</select></div>' +
                   '<div class="metricsContent"></div>' +
                   '<div class="btnAddMetrics" title="Ok">Ok</div>' +
                   '<div class="btnClearMetrics" title="Cancel">Cancel</div>' +
                     '<div class="errorMsg"></div>' +
                   '</div>';
        },

        //Template for aggregate block
        // It shows aggregation like term,histogram etc..
        _aggsBlock: function () {
            return '<div class="boxFilter">' +
                   '<div class="aggFunDiv"><select class="drpFun"><option class="disableClass" disabled selected>- Aggregation -</option>' +
                                                '{{#functions}}<option value="{{key}}">{{value}}</option>{{/functions}}' +
                                           '</select></div>' +
                   '<div class="aggContent"></div>' +
                   '<div class="btnAddAgg" title="Ok">Ok</div>' +
                   '<div class="btnClearAgg" title="Cancel">Cancel</div>' +
                     '<div class="errorMsg"></div>' +
                   '</div>';
        },

        //Fields Template for metrics ang aggregate
        // For metrics it should contains numeric feilds and for aggregate all fields should come
        _fieldsTemplate: function () {
            return '<div class="select-field"><span class="selectAll _lngTrans_Translatable" title="Select All" defaulttitle="Select All"><input type="button" class="btnSelectAll"></span><span class="selectNone _lngTrans_Translatable" title="Unselect all" defaulttitle="Select None"><input type="button" class="selectNone"></span><span class="reverse _lngTrans_Translatable" title="Reverse" defaulttitle="Reverse">' +
            '<input type="checkbox" class="chkReverse"></span><input type="text" id="srchCheckbox" placeholder="Search.."/></div><div class="matFieldsDiv">{{#.}}<div class="matInput">' +
            '<input type="checkbox" class="drpFields chkInActive" value="{{id}}" data-type="{{type}}" data-value="{{format}}" data-content="{{title}}" /><span>{{title}}</span></div>{{/.}}</div><div class="aggFunctionDiv"></div>';
        },

        /*_displayFieldTemplate: function () {
        return '{{#displayName}}<div class="displayNamesDiv"><input type="text" value="{{displayName}}" placeHolder="Display Name" class="txtdisplay"/></div>{{/displayName}}';
        },*/

        //Template for histogram
        // Contains intervals
        _histogramTemplate: function () {
            return '<div class="intervalDiv"><input type="text" class="txtInterval" value="{{interval}}" placeHolder="Interval"/></div>';
        },

        //Template for datehistogram
        // Contains intervals like year,month etc..
        _dateHistogramTemplate: function () {
            return '<div class="intervalDiv"><select class="drpInterval">{{#.}}<option value="{{key}}">{{value}}</option>{{/.}}</select></div>';
        },

        //Template for sorting
        _orderTemplate: function () {
            return '<div class="orderDiv"><select class="drpOrder">{{#.}}<option value="{{key}}">{{value}}</option>{{/.}}</select></div>';
        },

        //Template for size
        //top 10,bottom 5 etc..
        _sizeTemplate: function () {
            return '<div class="sizeDiv"><input type="text" class="txtSize" value="{{size}}" placeHolder="Size"/></div>';
        },

        //Template for orderby with a particular field
        _orderByTemplate: function () {
            return '<div class="orderByDiv"><select class="drpOrderBy"><option class="disableClass" disabled selected>- OrderBy -</option>{{#.}}<option value="{{key}}">Metrics:- {{value}}</option>{{/.}}</select></div>';
        },

        //Template for range
        _rangeTemplate: function () {
            return '<div class="rangeDiv" id={{id}}><span class="addRange">+</span><input type="text" class="txtFromRange" placeHolder="From" value="{{from}}"/><input type="text" class="txtToRange" placeHolder="To" value="{{to}}"/></div>';
        },

        //Template for making selected metrics field as block 
        _selectedMetricsFunction: function () {
            return '{{#savedFilter}}<div class="selectedFunction" data-id="{{id}}" data-value="{{operator}}_{{id}}">{{operator}}(<span>{{title}})<span class="closeFun">X</span></span></div>{{/savedFilter}}';
        },

        //Template for making selected aggregate field as block
        _selectedAggrFunction: function () {
            return '{{#savedFilter}}<div class="selectedFunction" data-id="{{id}}" data-value="{{operator}}_{{id}}"><span>{{title}}<span class="closeFun">X</span></span></div>{{/savedFilter}}';
        },

        //Template for making selected filter field as block
        _selectedFilterFunction: function () {
            return '{{#savedFilter}}<div class="selectedFunction {{#isDiasble}}disableClass{{/isDiasble}}" data-id="{{id}}" data-displayField1 ="{{displayValue1}}" data-displayField2 ="{{displayValue2}}" data-field = "{{fieldName}}" data-name="{{displayName}}" data-operator="{{operator}}" data-value1="{{value1}}" data-value2="{{value2}}" data-type="{{type}}"><span>{{displayName}} {{operator}} {{displayValue1}} {{#value2}}and{{/value2}} {{displayValue2}}<span class="closeFun">X</span></span></div>{{/savedFilter}}';
        },
        //added the template for seperate metric headers
        _selectedSumMetricFunction: function () {
            return '{{#savedFilter}}' +
                        '<div class="selectedFunction" data-id="{{id}}" data-value="{{value}}" data-operator="{{operator}}" data-type="{{type}}" data-title="{{title}}"><span>{{title}}<span class="closeFun">X</span></span></div></div>' +
                    '{{/savedFilter}}';
        },

        //making block for saved filter
        _addFilter: function () {
            var self = this;
            var filterFields = $.grep(self.fields, function (val, index) {
                return val.isFilter != false;
            });

            self.element.find('.filterBlock').empty().append(Mustache.render(self._filterBlock(), { fields: filterFields }));
            // Loop filter items and prepolating the filter block
            _.each(self.esQuery.filter.get(), function (item, idx) {
                if (self.options.catalog) {
                    if (self.options.catalog.disableFilter) item["isDisable"] = true;
                    else item["isDiasble"] = false;
                }
                else item["isDiasble"] = false;

                item["displayValue1"] = item.value1.replace(/\|/g, ""); //Added by sreejith To display text 
                item["displayValue2"] = item.value2.replace(/\|/g, "");

                self.element.find('#agg_Filter').find('.divFunction').append(Mustache.render(self._selectedFilterFunction(), { savedFilter: item }));
                self._disableSelectedOptions('filter', $(self.element).find('.filterBlock .drpField'));
            });
        },

        //making block for saved aggregation
        _addAggregate: function () {
            var self = this;
            // Loop aggregate items and prepolating the aggregate block
            _.each(self.esQuery.aggregate.get(), function (item, idx) {
                var selectedFields = { title: item.title, value: item.fieldName, type: item.type, operator: item.operator, id: item.operator + '_' + item.fieldName };
                if (!item.metrics)
                    self.element.find('#agg_Aggregate').find('.divFunction').append(Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields }));
                else {
                    var enabledClass = self.getAction(item.operator);
                    self.element.find('#agg_Metrics .divFunction .' + enabledClass).show().append(Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields }));
                }
            });

            var out = Mustache.render(self._metricsBlock(), { functions: self.options.functions.metrics });
            self.element.find('#agg_Metrics .divMetrics').empty().append(out);
            self.element.find('#agg_Aggregate .divAggs').empty().append(Mustache.render(self._aggsBlock(), { functions: self.options.functions.aggs }));
        },

        returnData: function () {
            var self = this;
            self.esQuery.aggregate.clear();
            self.esQuery.filter.clear();
            if (self.element.find('.acc').length > 0) {
                var multiValue = false;
                _.each(self.element.find('#agg_Filter .selectedFunction'), function (val, i) {
                    var fieldSchema = self._getFields($(val).attr('data-field'));
                    if (fieldSchema) {
                        //if operator in or notin we can add two fields with comma
                        if (($(val).attr('data-operator') == "In" || $(val).attr('data-operator') == "NotIn")) {
                            multiValue = true;
                        }
                        var options = {
                            type: $(val).attr('data-type'),
                            fieldName: fieldSchema.id,
                            operator: $(val).attr('data-operator'),
                            aliasName: fieldSchema.id,
                            displayName: fieldSchema.title,
                            title: fieldSchema.title,
                            value1: $(val).attr('data-value1'),
                            value2: $(val).attr('data-value2'),
                            checked: true,
                            isDisable: $(val).attr('disabledFilter') == "true" ? true : false,
                            multiValue: multiValue
                        };
                        //adding item to the json
                        self.esQuery.filter.add(options);
                    }
                });

                _.each(self.element.find('#agg_Aggregate .selectedFunction'), function (val, i) {
                    var fieldSchema = self._getFields($(val).attr('data-value'));
                    var operator = $(val).attr('data-operator');
                    var options = {
                        id: operator + '_' + fieldSchema.id,
                        type: fieldSchema.type,
                        fieldName: fieldSchema.id,
                        operator: operator,
                        aliasName: fieldSchema.id,
                        displayName: fieldSchema.title,
                        title: fieldSchema.title,
                        format: fieldSchema.format,
                        interval: 0,
                        dateinterval: "",
                        order: "All",
                        orderBy: "",
                        size: 0,
                        checked: true,
                        metrics: false
                    };
                    self.esQuery.aggregate.add(options);
                });

                _.each(self.element.find('#agg_Metrics .selectedFunction'), function (val, i) {
                    var fieldSchema = self._getFields($(val).attr('data-value'));
                    var operator = $(val).attr('data-operator');
                    var options = {
                        id: operator + '_' + fieldSchema.id,
                        type: "numeric",
                        fieldName: fieldSchema.id,
                        operator: operator,
                        aliasName: fieldSchema.id + '_' + operator,
                        displayName: fieldSchema.title + ' (' + operator.toLowerCase() + ')',
                        title: fieldSchema.title,
                        format: fieldSchema.format,
                        decimalPoint: fieldSchema.decimalPoint,
                        metrics: true
                    };
                    self.esQuery.aggregate.add(options);
                });

                if (self.esQuery.aggregate.get().length > 0) {
                    var item = $.map(self.esQuery.aggregate.get(), function (val, i) {
                        if (!val.metrics) {
                            return {
                                id: val.aliasName,
                                title: val.displayName,
                                type: val.type,
                                filter: val.isFilter,
                                format: val.format, // added a format(to fix a problem with date)
                                aggregate: true,
                                isAxis: val.isAxis,
                                metrics: false,
                                isHidden: val.isHidden
                            };
                        }
                    });

                    var customFields;
                    if (typeof self._addCustomFields == 'function') {
                        customFields = $.merge(item, self._addCustomFields(fields));
                    }
                    else {
                        customFields = item;
                    }

                    fields = $.map(self.esQuery.aggregate.get(), function (field, index) {
                        if (field.metrics) {
                            return {
                                id: field.fieldName + "_" + field.operator,
                                title: field.displayName,
                                type: field.type,
                                format: field.format,
                                decimalPoint: field.decimalPoint,
                                filter: field.isFilter,
                                isAxis: field.isAxis,
                                aggregate: false,
                                metrics: true,
                                isHidden: field.isHidden
                            };
                        }
                    });
                    fields = $.merge(customFields, fields);
                }
                else
                    fields = self.fields;
                var data = $.extend({}, { fields: fields }, self.esQuery.get());
                return data;
            }
            else {
                var data = $.extend({}, { fields: self.fields }, self.esQuery.get());
                return data;
            }
        },

        eventHandler: function () {
            var self = this;

            //click of accordion Filter
            $(self.element).on('click', '.headFilter', function () {
                $(this).parents('.acc').find('.acc_Container').toggleClass('filter-container-slidedown');
            });

            $(self.element).on('click', '.VisualizeHeader', function () {
                window.location.href = '/BI/MISViewer/Index?misID=' + self.options.catalog.catalogId + '&fromCatalogViewer=' + self.options.catalog.fromCatalogID;
            });

            //click of addFilter button
            $(self.element).on('click', '.btnAddFilter', function () {
                var displayValue1, displayValue2;
                var type = self.element.find('#agg_Filter' + ' .drpField option:selected').attr('type'), drpOp = self.element.find('#agg_Filter' + ' .drpOp option:selected').val(), txtValue1 = "", txtValue2 = "";
                if ((type == "numeric" || type == "number") && (drpOp == "Between")) {
                    txtValue1 = parseFloat(self.element.find('.boxFilter .txtValueDiv1 .txtValue1').val()) || "";
                    txtValue2 = parseFloat(self.element.find('.boxFilter .txtValueDiv2 .txtValue2').val()) || "";
                    displayValue1 = self.element.find('.boxFilter .txtValueDiv1 .txtValue1').val() || "";
                    displayValue2 = self.element.find('.boxFilter .txtValueDiv2 .txtValue2').val() || "";
                }
                else if ((type == "date" || type == "date-time") && drpOp != "Month To Date" && drpOp != "Year To Date" && drpOp != "Quarter To Date" && drpOp != "Today" && drpOp != "Yesterday" && drpOp != "This Week" && drpOp != "Prior Week" && drpOp != "Prior 2 Weeks" && drpOp != "This Month" && drpOp != "Prior Month" && drpOp != "This Quarter" && drpOp != "Prior Quarter" && drpOp != "This Year" && drpOp != "Prior Year" && drpOp != "Days Ago" && drpOp != "Is Blank") {
                    txtValue1 = new Date(self.element.find('.boxFilter .txtValueDiv1 .txtValue1').val() || "");
                    txtValue2 = new Date(self.element.find('.boxFilter .txtValueDiv2 .txtValue2').val() || "");
                }
                else {
                    txtValue1 = self.element.find('.boxFilter .txtValueDiv1 .txtValue1').attr('dt-value') || self.element.find('.boxFilter .txtValueDiv1 .txtValue1').val() || "";
                    txtValue2 = self.element.find('.boxFilter .txtValueDiv2 .txtValue2').attr('dt-value') || self.element.find('.boxFilter .txtValueDiv1 .txtValue2').val() || "";
                    displayValue1 = self.element.find('.boxFilter .txtValueDiv1 .txtValue1').val() || "";
                    displayValue2 = self.element.find('.boxFilter .txtValueDiv1 .txtValue2').val() || "";
                }
                if ((type == "date" || type == "numeric" || type == "number") && (txtValue1 > txtValue2) && (drpOp == "Between")) {
                    self.element.find('.filterBlock .boxFilter').css('border', '1px solid #EB662E');
                    self.element.find('.filterBlock').find('.errorMsg').text("From Value should be less than To value").show();
                }
                else {
                    if ((type == "date" || type == "date-time") && drpOp != "Month To Date" && drpOp != "Year To Date" && drpOp != "Quarter To Date" && drpOp != "Today" && drpOp != "Yesterday" && drpOp != "This Week" && drpOp != "Prior Week" && drpOp != "Prior 2 Weeks" && drpOp != "This Month" && drpOp != "Prior Month" && drpOp != "This Quarter" && drpOp != "Prior Quarter" && drpOp != "This Year" && drpOp != "Prior Year" && drpOp != "Days Ago" && drpOp != "Is Blank") {
                        txtValue1 = (txtValue1.getMonth() + 1) + '/' + txtValue1.getDate() + '/' + txtValue1.getFullYear();
                        txtValue2 = txtValue2 == "Invalid Date" ? "" : (txtValue2.getMonth() + 1) + '/' + txtValue2.getDate() + '/' + txtValue2.getFullYear();
                        displayValue1 = self.element.find('.boxFilter .txtValueDiv1 .txtValue1').val() || "";
                        displayValue2 = self.element.find('.boxFilter .txtValueDiv2 .txtValue2').val() || "";
                    }
                    var cond = self._validateField("filter"); //validating the json
                    if (cond.cond) {
                        var drpField = self.element.find('#agg_Filter' + ' .drpField').val(); //taking field

                        var schfield = self._getFields(drpField); //schema of the field
                        var multiValue = false;

                        //if operator in or notin we can add two fields with comma
                        if ((drpOp == "In" || drpOp == "NotIn")) {
                            multiValue = true;
                        }

                        if (schfield) {
                            var options = {
                                type: type,
                                fieldName: schfield.id,
                                operator: drpOp,
                                aliasName: schfield.id,
                                displayName: schfield.title,
                                title: schfield.title,
                                value1: txtValue1,
                                value2: txtValue2,
                                displayValue1: displayValue1,
                                displayValue2: displayValue2,
                                checked: true,
                                multiValue: multiValue
                            };
                            //adding item to the json
                            //var addedItem = self.esQuery.filter.add(options);
                            //rendering added item to the view
                            self.element.find('#agg_Filter').find('.divFunction').append(Mustache.render(self._selectedFilterFunction(), { savedFilter: options }));
                        }
                        var fieldSet = $.grep(self.fields, function (val, i) {
                            return val.isFilter == true;
                        });
                        self.element.find('.filterBlock').empty().append(Mustache.render(self._filterBlock(), { fields: fieldSet }));
                    }
                    else {
                        self.element.find('#agg_Filter .boxFilter').css('border', '1px solid #EB662E'); //making red border on box
                        self.element.find('#agg_Filter .boxFilter').find('.errorMsg').text(cond.error).show(); //showing errors
                    }
                    self._disableSelectedOptions('filter', $('.drpField')); //making selected field as disabled
                }
            });

            $(self.element).on('click', '.btnClearFilter', function () {
                var fieldSet = $.grep(self.fields, function (val, i) {
                    return val.isFilter == true;
                });
                self.element.find('.filterBlock').empty().append(Mustache.render(self._filterBlock(), { fields: fieldSet }));
                self._disableSelectedOptions('filter', $('.drpField'));
            });

            //Enable filters to be edited instead of removing and adding each time for all fields
            $(self.element).on('dblclick', '#agg_Filter .divFunction .selectedFunction', function () {
                var fieldName = $(this).attr('data-name');
                var operatorFld = $(this).attr('data-operator');
                var txtValueOne = $(this).attr('data-value1');
                var displayval1 = $(this).attr('data-displayField1');
                var txtValueTwo = $(this).attr('data-value2');
                var displayval2 = $(this).attr('data-displayField2');
                $(self.element).find('#agg_Filter .boxFilter').find('.btnAddFilter,.btnClearFilter').show();
                $(self.element).find('#agg_Filter .boxFilter').find('.filterBlock .filterContent').empty();
                var out = Mustache.render(self._filterContent());
                $(self.element).find('#agg_Filter .boxFilter').find('.filterContent').empty().append(out);
                var fld = $(self.element).find('#agg_Filter .boxFilter').find('.fieldDiv .drpField option');
                $.each(fld, function (index, val) {
                    if ($(val).text() == fieldName) {
                        $('.drpField').children('option').attr('disabled', false).removeClass('disableClass');
                        $(val).attr("selected", true);
                    }
                });
                function operatorFieldCheck() {
                    var op = $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .operator .drpOp option');
                    $.each(op, function (index, elem) {
                        if ($(elem).val() == operatorFld) {
                            $(elem).attr("selected", true);
                        }
                    });
                }
                var field = $(self.element).find('#agg_Filter .boxFilter').find('.fieldDiv .drpField').val();
                var type = $(self.element).find('#agg_Filter .boxFilter').find('.fieldDiv .drpField').find('option:selected').attr('type');
                var dataType = self._operators(type);
                var schfield = self._getFields(field);
                var out = Mustache.render(self._filterContent(), { Field: schfield, operators: dataType });
                $(self.element).find('#agg_Filter .boxFilter').find('.filterContent').empty().append(out);
                var predefinedOP = ['Is Blank', 'Logged In User', 'Month To Date', 'Year To Date', 'Quarter To Date', 'Today', 'Yesterday', 'This Week', 'Prior Week', 'Prior 2 Weeks', 'This Month', 'Prior Month', 'This Quarter', 'Prior Quarter', 'This Year', 'Prior Year'];
                var op = $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .operator .drpOp option');
                if ((operatorFld != "Between") && (type == "numeric")) {
                    operatorFieldCheck();
                    txtValue1 = self.element.find('.boxFilter .txtValueDiv1 .txtValue1').attr('dt-value') || self.element.find('.boxFilter .txtValueDiv1 .txtValue1').val() || "";
                    txtValue2 = self.element.find('.boxFilter .txtValueDiv2 .txtValue2').attr('dt-value') || self.element.find('.boxFilter .txtValueDiv1 .txtValue2').val() || "";
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 input').val(displayval1);
                }
                else if ((operatorFld == "Between") && (type == "numeric")) {
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent').append('<div class="txtValueDiv2"><input type="text" value="" class="txtValue2" placeHolder=""/></div>');
                    operatorFieldCheck();
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 input').val(displayval1);
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv2 input').val(displayval2);
                }
                if ((operatorFld != "Between") && (type != "numeric")) {
                    operatorFieldCheck();
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 input').attr('dt-value', txtValueOne);
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 input').val(displayval1);
                }
                else if ((type != "numeric")) {
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent').append('<div class="txtValueDiv2"><input type="text" value="" class="txtValue2" placeHolder=""/></div>');
                    operatorFieldCheck();
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 input').attr('dt-value', txtValueOne);
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 input').val(displayval1);
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv2 input').attr('dt-value', txtValueTwo)
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv2 input').val(displayval2);
                }
                if (_.contains(predefinedOP, $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .operator .drpOp').val())) {
                    operatorFieldCheck();
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 .txtValue1').remove();
                }
                if (type == "date" || type == "date-time" || type == "custom") {
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv2 .txtValue2').datepicker({
                        dateFormat: 'mm/dd/yy',
                        changeMonth: true,
                        changeYear: true,
                        onSelect: function (dateText) {
                        }
                    });
                    $(self.element).find('#agg_Filter .boxFilter').find('.filterContent .txtValueDiv1 .txtValue1').datepicker({
                        dateFormat: 'mm/dd/yy',
                        changeMonth: true,
                        changeYear: true,
                        onSelect: function (dateText) {
                        }
                    });
                }
                if ((type == "string" || type == "user" || type == "month") && (self.element.find('.drpOp').val() == "In" || self.element.find('.drpOp').val() == "NotIn" || self.element.find('.drpOp').val() == ">" || self.element.find('.drpOp').val() == ">=" || self.element.find('.drpOp').val() == "<" || self.element.find('.drpOp').val() == "<" || self.element.find('.drpOp').val() == "<=" || self.element.find('.drpOp').val() == "Between")) {
                    var relatedFields = [];
                    if (schfield.relatedTo.length > 0) {
                        $.each(schfield.relatedTo, function (i, val) {
                            $.each(self.esQuery.filter.get(), function (j, value) {
                                if (value.fieldName == val)
                                    relatedFields.push(value);
                            });
                        });
                    }
                    $.ajax({
                        dataType: 'json',
                        async: false,
                        url: self.options.url,
                        type: 'POST',
                        data: { field: field, relatedTo: JSON.stringify(relatedFields), catalogId: (self.options.catalog ? self.options.catalog.catalogId : undefined) },
                        success: function (data) {
                            self.element.find('.txtValue1')
                            // don't navigate away from the field on tab when selecting an item
                    .bind("keydown", function (event) {
                        if (event.keyCode === $.ui.keyCode.TAB &&
                    $(this).autocomplete("instance").menu.active) {
                            event.preventDefault();
                        }
                    })
                    .autocomplete({
                        minLength: 0,
                        source: function (request, response) {
                            // delegate back to autocomplete, but extract the last term
                            response($.ui.autocomplete.filter(
                    data, extractLast(request.term)));
                        },
                        focus: function () {
                            // prevent value inserted on focus
                            return false;
                        },
                        select: function (event, ui) {
                            var terms = $(this).attr('dt-value') ? $(this).attr('dt-value') + ',' + ui.item.value.replace(',', '|,') : ui.item.value.replace(',', '|,');
                            this.value = terms.replace(/\|,/g, ',');
                            $(this).attr('dt-value', terms);
                            //                            var terms = split(this.value);
                            //                            // remove the current input
                            //                            terms.pop();
                            //                            // add the selected item
                            //                            terms.push(ui.item.value);
                            //                            // add placeholder to get the comma-and-space at the end
                            //                            //terms.push("");
                            //                            this.value = terms; //.join(", ");
                            return false;
                        }
                    });
                            self.element.find('.txtValue2')
                            // don't navigate away from the field on tab when selecting an item
                              .bind("keydown", function (event) {
                                  if (event.keyCode === $.ui.keyCode.TAB &&
                                    $(this).autocomplete("instance").menu.active) {
                                      event.preventDefault();
                                  }
                              })
                              .autocomplete({
                                  minLength: 0,
                                  source: function (request, response) {
                                      // delegate back to autocomplete, but extract the last term
                                      response($.ui.autocomplete.filter(
                                    data, extractLast(request.term)));
                                  },
                                  focus: function () {
                                      // prevent value inserted on focus
                                      return false;
                                  },
                                  select: function (event, ui) {
                                      var terms = $(this).attr('dt-value') ? $(this).attr('dt-value') + ',' + ui.item.value.replace(',', '|,') : ui.item.value.replace(',', '|,');
                                      this.value = terms.replace(/\|,/g, ',');
                                      $(this).attr('dt-value', terms);
                                      //                                      var terms = split(this.value);
                                      //                                      // remove the current input
                                      //                                      terms.pop();
                                      //                                      // add the selected item
                                      //                                      terms.push(ui.item.value);
                                      //                                      // add placeholder to get the comma-and-space at the end
                                      //                                      //terms.push("");
                                      //                                      this.value = terms; //.join(", ");
                                      return false;
                                  }
                              });
                        }
                    });
                }
                self.esQuery.filter.remove($(this).attr('data-id'));
                $(this).remove();
                self._disableSelectedOptions('filter', $('.drpField'));
            });
            // end
            $(self.element).on('change', '.fieldDiv .drpField', function () {
                var field = $(this).val();
                $(this).parents('.boxFilter').find('.btnAddFilter,.btnClearFilter').show();
                var title = $(this).find('option:selected').text();
                var type = $(this).find('option:selected').attr('type');
                $(this).css('border-color', '#E1E1E1');
                self.element.find('.errorMsg').text('').hide();
                $(this).parents('.boxFilter').find('.filterContent').empty();
                var dataType = self._operators(type);
                var schfield = self._getFields(field);
                var out = Mustache.render(self._filterContent(), { Field: schfield, operators: dataType });
                $(this).parents('.boxFilter').find('.filterContent').empty().append(out);
                if ((type == "string" || type == "user" || type == "month") && (self.element.find('.drpOp').val() == "In" || self.element.find('.drpOp').val() == "NotIn")) {
                    var relatedFields = [];
                    if (schfield.relatedTo.length > 0) {
                        $.each(schfield.relatedTo, function (i, val) {
                            $.each(self.esQuery.filter.get(), function (j, value) {
                                if (value.fieldName == val)
                                    relatedFields.push(value);
                            });
                        });
                    }
                    $.ajax({
                        dataType: 'json',
                        async: false,
                        url: self.options.url,
                        type: 'POST',
                        data: { field: field, relatedTo: JSON.stringify(relatedFields), catalogId: (self.options.catalog ? self.options.catalog.catalogId : undefined) },
                        success: function (data) {
                            self.element.find('.txtValue1')
                            // don't navigate away from the field on tab when selecting an item
                              .bind("keydown", function (event) {
                                  if (event.keyCode === $.ui.keyCode.TAB &&
                                    $(this).autocomplete("instance").menu.active) {
                                      event.preventDefault();
                                  }
                              })
                              .autocomplete({
                                  minLength: 0,
                                  source: function (request, response) {
                                      // delegate back to autocomplete, but extract the last term
                                      response($.ui.autocomplete.filter(
                                    data, extractLast(request.term)));
                                  },
                                  focus: function () {
                                      // prevent value inserted on focus
                                      return false;
                                  },
                                  select: function (event, ui) {/*Added by sreejith for comma separated issue*/
                                      var terms = $(this).attr('dt-value') ? $(this).attr('dt-value') + ',' + ui.item.value.replace(',', '|,') : ui.item.value.replace(',', '|,');
                                      this.value = terms.replace(/\|,/g, ',');
                                      $(this).attr('dt-value', terms);
                                      //                                      var terms = split($(this).attr('dt-value') ? $(this).attr('dt-value') + ',' : '');
                                      //                                      // remove the current input
                                      //                                      terms.pop();
                                      //                                      // add the selected item
                                      //                                      terms.push(ui.item.value.replace(',', '|,'));
                                      //                                      // add placeholder to get the comma-and-space at the end
                                      //                                      //terms.push("");
                                      //                                      this.value = terms; //.join(", ");
                                      //                                      $(this).attr('dt-value', terms);
                                      //                                      this.value = this.value.replace('|,', ',');
                                      return false;
                                  }
                              });
                        }
                    });
                }

                if (type == "date" || type == "date-time" || type == "custom") {
                    $(this).parents('.boxFilter').find('.txtValue1').datepicker({
                        dateFormat: 'mm/dd/yy',
                        changeMonth: true,
                        changeYear: true,
                        onSelect: function (dateText) {
                            var options = {
                                id: schfield.id,
                                value1: dateText
                            };
                            self.esQuery.filter.update(options);
                        }
                    });
                }
            });

            $(self.element).on('change', '.operator .drpOp', function () {
                $(this).parents('.boxFilter').find('.txtValue1,.txtValue2').val('');
                var type = $(this).parents('.boxFilter').find('.drpField option:selected').attr('type');
                var operatorVal = $(this).val();

                $(this).parents('.boxFilter').find('.txtValueDiv1').keypress(function (event) {
                    if (event.keyCode == 9 && operatorVal == "Between") {
                        $(this).parents('.boxFilter').find('.txtValue2').focus();
                    }
                    if (operatorVal == "Days Ago") {
                        if (event.which != 8 && event.which != 0 && (event.which < 48 || event.which > 57)) {
                            return false;
                        }
                    }
                });

                //blocked the text box while selecting predefined operators
                var predefinedOP = ['Is Blank', 'Logged In User', 'Month To Date', 'Year To Date', 'Quarter To Date', 'Today', 'Yesterday', 'This Week', 'Prior Week', 'Prior 2 Weeks', 'This Month', 'Prior Month', 'This Quarter', 'Prior Quarter', 'This Year', 'Prior Year'];
                if (_.contains(predefinedOP, $(this).val())) {
                    $(this).parents('.boxFilter').find('.txtValueDiv1 .txtValue1').remove();
                }
                else {
                    $(this).parents('.boxFilter').find('.txtValueDiv1 .txtValue1').datepicker("disable").remove();
                    $(this).parents('.boxFilter').find('.txtValueDiv1').append('<input type="text" value="" class="txtValue1" placeHolder="" />');

                    //if ($(this).parents('.boxFilter').find('.filterContent .txtValueDiv1').length == 0) {
                    //$(this).parents('.boxFilter').find('.filterContent').append('<div class="txtValueDiv1"><input type="text" value="" class="txtValue1" placeHolder="" /></div>');
                    if ((type == "date" || type == "date-time" || type == "custom") && operatorVal != "Days Ago" && operatorVal != "Between") {
                        if (!$.data($('.txtValue1').get(0), 'datepicker')) {
                            $(this).parents('.boxFilter').find('.txtValue1').datepicker({
                                dateFormat: 'mm/dd/yy',
                                changeMonth: true,
                                changeYear: true,
                                onSelect: function (dateText) {
                                }
                            });
                        }
                    }
                    //}

                }
                //end

                if ($(this).val() == "Between") {
                    $(this).parents('.boxFilter').find('.filterContent').append('<div class="txtValueDiv2"><input type="text" value="" class="txtValue2" placeHolder=""/></div>');
                }
                else {
                    $(this).parents('.boxFilter').find('.txtValueDiv2').remove();
                }

                if ((type == "string" || type == "user" || type == "month") && ($(this).val() == "In" || $(this).val() == "NotIn" || $(this).val() == ">" || $(this).val() == ">=" || $(this).val() == "<" || $(this).val() == "<" || $(this).val() == "<=" || $(this).val() == "Between")) {
                    $.ajax({
                        dataType: 'json',
                        async: false,
                        url: self.options.url,
                        type: 'POST',
                        data: { field: self.element.find('.drpField').val(), relatedTo: JSON.stringify([]), catalogId: (self.options.catalog ? self.options.catalog.catalogId : undefined) },
                        success: function (data) {
                            self.element.find('.txtValue1')
                            // don't navigate away from the field on tab when selecting an item
                              .bind("keydown", function (event) {
                                  if (event.keyCode === $.ui.keyCode.TAB &&
                                    $(this).autocomplete("instance").menu.active) {
                                      event.preventDefault();
                                  }
                              })
                              .autocomplete({
                                  minLength: 0,
                                  source: function (request, response) {
                                      // delegate back to autocomplete, but extract the last term
                                      response($.ui.autocomplete.filter(
                                    data, extractLast(request.term)));
                                  },
                                  focus: function () {
                                      // prevent value inserted on focus
                                      return false;
                                  },
                                  select: function (event, ui) {
                                      var terms = $(this).attr('dt-value') ? $(this).attr('dt-value') + ',' + ui.item.value.replace(',', '|,') : ui.item.value.replace(',', '|,');
                                      this.value = terms.replace('|,', ',');
                                      $(this).attr('dt-value', terms);
                                      //                                      var terms = split(this.value);
                                      //                                      // remove the current input
                                      //                                      terms.pop();
                                      //                                      // add the selected item
                                      //                                      terms.push(ui.item.value);
                                      //                                      // add placeholder to get the comma-and-space at the end
                                      //                                      //terms.push("");
                                      //                                      this.value = terms; //.join(", ");
                                      return false;
                                  }
                              });

                            self.element.find('.txtValue2')
                            // don't navigate away from the field on tab when selecting an item
                              .bind("keydown", function (event) {
                                  if (event.keyCode === $.ui.keyCode.TAB &&
                                    $(this).autocomplete("instance").menu.active) {
                                      event.preventDefault();
                                  }
                              })
                              .autocomplete({
                                  minLength: 0,
                                  source: function (request, response) {
                                      // delegate back to autocomplete, but extract the last term
                                      response($.ui.autocomplete.filter(
                                    data, extractLast(request.term)));
                                  },
                                  focus: function () {
                                      // prevent value inserted on focus
                                      return false;
                                  },
                                  select: function (event, ui) {
                                      var terms = $(this).attr('dt-value') ? $(this).attr('dt-value') + ',' + ui.item.value.replace(',', '|,') : ui.item.value.replace(',', '|,');
                                      this.value = terms.replace('|,', ',');
                                      $(this).attr('dt-value', terms);
                                      //                                      var terms = split(this.value);
                                      //                                      // remove the current input
                                      //                                      terms.pop();
                                      //                                      // add the selected item
                                      //                                      terms.push(ui.item.value);
                                      //                                      // add placeholder to get the comma-and-space at the end
                                      //                                      //terms.push("");
                                      //                                      this.value = terms; //.join(", ");
                                      return false;
                                  }
                              });
                        }
                    });
                }

                //var dataType = self._operators($(this).parents('.boxFilter').find('.drpField option:selected').attr('type'));
                if (type == "date" || type == "date-time" || type == "custom") {
                    $(this).parents('.boxFilter').find('.txtValue2').datepicker({
                        dateFormat: 'mm/dd/yy',
                        changeMonth: true,
                        changeYear: true,
                        onSelect: function (dateText) {
                        }
                    });

                    $(this).parents('.boxFilter').find('.txtValue1').datepicker({
                        dateFormat: 'mm/dd/yy',
                        changeMonth: true,
                        changeYear: true,
                        onSelect: function (dateText) {
                        }
                    });
                }

                if (operatorVal == "Days Ago") {
                    $(this).parents('.boxFilter').find('.txtValueDiv1 .txtValue1').remove();
                    $(this).parents('.boxFilter').find('.txtValueDiv1').append('<input type="text" value="" class="txtValue1" placeHolder="" />');
                }
            });

            //close button click
            $(self.element).on('blur', '.displayNamesDiv .txtdisplay', function () {
                var id = self.element.find(this).parents('.boxFilter').attr('id');
                var options = {
                    id: id,
                    displayName: $(this).val()
                };
                self.esQuery.aggregate.update(options);
                self.element.find('#' + id).find('.displayText').text($(this).val());
            });

            $(self.element).on('blur', '.sizeDiv .txtSize', function () {
                var id = self.element.find(this).parents('.boxFilter').attr('id');
                var options = {
                    id: id,
                    size: $(this).val() != "" ? parseInt($(this).val()) : 0
                };
                self.esQuery.aggregate.update(options);
            });

            $(self.element).on('blur', '.txtToRange', function (e) {
                $(this).css('border', '');
                if (!$(e.target).hasClass('hasDatepicker')) {
                    var id = self.element.find(this).parents('.boxFilter').attr('id');
                    var item = self.esQuery.aggregate.select(id);
                    var rangeId = $(this).parent('.rangeDiv').attr('id');
                    var from = parseInt($('#' + rangeId).find('.txtFromRange').val());
                    var to = parseInt($(this).val());
                    var item = self.esQuery.aggregate.select(id);
                    if (from != "" && to != "") {
                        if (item.ranges.length > 0) {
                            $.each(item.ranges, function (i, val) {
                                if (val.id == rangeId) {
                                    val.to = to;
                                }
                            });
                        }
                        else {
                            item.ranges.push({ id: rangeId, "from": from, "to": to });
                        }
                    }
                    else {
                        $('#' + id).find('.errorMsg').text("Values are Empty").show();
                        $(this).css('border', '1px solid #EB662E');
                        $(this).siblings('.txtFromRange').css('border', '1px solid #EB662E');
                    }
                }
            });

            $(self.element).on('blur', '.txtFromRange', function (e) {
                $(this).css('border', '');
                if (!$(e.target).hasClass('hasDatepicker')) {
                    var id = self.element.find(this).parents('.boxFilter').attr('id');
                    var item = self.esQuery.aggregate.select(id);
                    var rangeId = $(this).parent('.rangeDiv').attr('id');
                    var to = parseInt($('#' + rangeId).find('.txtToRange').val());
                    var from = parseInt($(this).val());
                    var item = self.esQuery.aggregate.select(id);
                    if (from != "" && to != "") {
                        if (item.ranges.length > 0) {
                            $.each(item.ranges, function (i, val) {
                                if (val.id == rangeId) {
                                    val.from = from;
                                }
                            });
                        }
                        else {
                            item.ranges.push({ id: rangeId, "from": from, "to": to });
                        }
                    }
                    else {
                        $('#' + id).find('.errorMsg').text("Values are Empty").show();
                        $(this).css('border', '1px solid #EB662E');
                        $(this).siblings('.txtFromRange').css('border', '1px solid #EB662E');
                    }
                }
            });

            $(self.element).on('click', '.applyButton', function () {
                var fields = [];
                var cond = self._validateField("filter");
                if (self.element.find('.clearButton').attr('clicked') == "false") {
                    $('.derivedImg').removeClass('disableClass');
                    if (typeof self.options.onApplySearch == 'function') self.options.onApplySearch(self.returnData());
                }
                else {
                    self.element.find('.clearButton').attr('clicked', 'false');
                }
            });

            $(self.element).on('click', '.clearButton', function () {
                /*Bug fixed by removing Matrix and Aggregate selected items while clicking on clear button - Added by Sreejith*/
                self.element.find('#agg_Metrics .divFunction .sumAction,#agg_Metrics .divFunction .avgAction,#agg_Metrics .divFunction .countAction,#agg_Metrics .divFunction .minAction,#agg_Metrics .divFunction .maxAction').hide();
                self.element.find('#agg_Aggregate .divFunction .aggrLabel ').hide();

                if (self.element.find('.selectedFunction').length > 0) {
                    self.element.find('.selectedFunction').remove();
                    self.element.find('.drpFields').attr('checked', false);
                    self.element.find('.UnselectAll').addClass('selectAll').removeClass('UnselectAll');
                }
                // Remove seperate metric headers  
                if (self.element.find('#agg_Metrics .divFunction').children('span').length > 0) {
                    self.element.find('#agg_Metrics .divFunction').children('span').remove();
                }

                //clearing the disabled options
                $('.drpField').children('option').attr('disabled', false).removeClass('disableClass');

                self.esQuery.filter.items = [];
                self.esQuery.aggregate.items = [];
                $(this).attr('clicked', 'true');
                self.element.find('.applyButton').trigger('click');
                if (typeof self.options.onClearSearch == 'function') self.options.onClearSearch();
            });

            $(self.element).on('keypress', '.txtValue1,.txtValue2', function (e) {
                //if (self.element.find('.drpField').find('option:selected').attr('type') == "numeric") {
                if ($(this).parents('.boxFilter').find('.drpField').find('option:selected').attr('type') == "numeric") {
                    var regex = new RegExp("^[0-9]+$");
                    if ($(this).parents('.boxFilter').find('.drpOp').val() == "In" || $(this).parents('.boxFilter').find('.drpOp').val() == "NotIn")
                        regex = new RegExp("^[0-9,]+$");
                    var Evt = e || window.event;
                    var key = Evt.keyCode || Evt.which;
                    // Don't validate the input if below arrow, delete and backspace keys were pressed 
                    if (key == 37 || key == 38 || key == 39 || key == 40 || key == 8 || key == 46) { // Left / Up / Right / Down Arrow, Backspace, Delete keys
                        return true;
                    }
                    var str = String.fromCharCode(!e.charCode ? e.which : e.charCode);
                    if (regex.test(str) || str == "-") {
                        return true;
                    }

                    e.preventDefault();
                    return false;
                }
            });

            $(self.element).on('keypress', '.txtSize,.txtInterval,.txtFromRange,.txtToRange', function (e) {
                var regex = new RegExp("^[0-9]+$");
                var Evt = e || window.event;
                var key = Evt.keyCode || Evt.which;
                // Don't validate the input if below arrow, delete and backspace keys were pressed 
                if (key == 37 || key == 38 || key == 39 || key == 40 || key == 8 || key == 46) { // Left / Up / Right / Down Arrow, Backspace, Delete keys
                    return true;
                }
                var str = String.fromCharCode(!e.charCode ? e.which : e.charCode);
                if (regex.test(str)) {
                    return true;
                }

                e.preventDefault();
                return false;
            });

            $(self.element).on("keyup", '.metricsContent .select-field #srchCheckbox', function (e) {
                var input = $(this).val();
                $.each($(".boxFilter .metricsContent .drpFields"), function (index, element) {
                    var content = $(element).attr("data-content");
                    var regex = new RegExp($.trim(input), "gim");
                    if ((content).match(regex) !== null) {
                        $(element).parent().show();
                    } else {
                        $(element).parent().hide();
                    }
                });
            });

            $(self.element).on("keyup", '.aggContent .select-field #srchCheckbox', function (e) {
                var input = $(this).val();
                $(".boxFilter .aggContent .drpFields").each(function (index, element) {
                    var content = $(element).attr("data-content");
                    var regex = new RegExp($.trim(input), "gim");
                    if ((content).match(regex) !== null) {
                        $(element).parent().show();
                    } else {
                        $(element).parent().hide();
                    }
                });
            });

            $(self.element).on('change', '.matFunDiv .drpFun', function () {
                if ($(this).val() != "COUNT") {
                    var items = $.grep(self.fields, function (val, i) {
                        return val.isMetrics == true && (val.type == "number" || val.type == "numeric");
                    });
                    $(this).parents('.boxFilter').find('.metricsContent').empty().append(Mustache.render(self._fieldsTemplate(), items));
                }
                else {
                    var items = $.grep(self.fields, function (val, i) {
                        return val.isMetrics == true;
                    });
                    $(this).parents('.boxFilter').find('.metricsContent').empty().append(Mustache.render(self._fieldsTemplate(), items));
                }
                var enabledClass = self.getAction($(this).val());
                self.enableSelectedMetrics(enabledClass);
                self.removeMetricItems(enabledClass);
            });

            $(self.element).on('click', '.boxFilter .metricsContent .matFieldsDiv .drpFields', function () {
                var operator = self.element.find('#agg_Metrics .matFunDiv .drpFun').val(),
                    selectedFields = { title: $(this).attr('data-content'), value: $(this).val(), type: $(this).attr('data-type'), operator: operator, id: operator + '_' + $(this).val() };
                var enabledClass = self.getAction(operator);
                if ($(this).attr('checked')) {
                    var out = Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields });
                    self.element.find('#agg_Metrics .divFunction .' + enabledClass).show().append(out);
                }
                else {
                    self.element.find('#agg_Metrics .divFunction .' + enabledClass).find('.selectedFunction[data-id="' + operator + '_' + selectedFields.value + '"]').remove();
                    self.element.find('#agg_Metrics .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                }
                self.removeMetricItems(enabledClass);
            });

            $(self.element).on('click', '.metricsContent .select-field .selectAll', function () {
                $(this).addClass('UnselectAll').removeClass('selectAll').attr('title', 'Unselect All');
                var operator = self.element.find('#agg_Metrics .matFunDiv .drpFun').val(), selectedFields;
                var enabledClass = self.getAction(operator);
                _.each($('.metricsContent .matFieldsDiv .drpFields'), function (val, i) {
                    selectedFields = { title: $(val).attr('data-content'), value: $(val).val(), type: $(val).attr('data-type'), operator: operator, id: operator + '_' + $(val).val() };
                    if (!$(val).attr('checked')) {
                        $(val).attr('checked', true);
                        var out = Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields });
                        self.element.find('#agg_Metrics .divFunction .' + enabledClass).show().append(out);
                    }
                });
            });

            $(self.element).on('click', '.metricsContent .select-field .UnselectAll', function () {
                var operator = self.element.find('#agg_Metrics .matFunDiv .drpFun').val(), selectedFields;
                var enabledClass = self.getAction(operator);
                _.each($('.metricsContent .matFieldsDiv .drpFields'), function (val, i) {
                    $(val).attr('checked', false);
                    self.element.find('#agg_Metrics .divFunction .' + enabledClass).find('.selectedFunction[data-id="' + operator + '_' + $(val).val() + '"]').remove();
                    self.element.find('#agg_Metrics .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                });
            });

            $(self.element).on('click', '.metricsContent .select-field .reverse', function () {
                var operator = self.element.find('#agg_Metrics .matFunDiv .drpFun').val(), selectedFields;
                var enabledClass = self.getAction(operator);
                _.each($('.metricsContent .matFieldsDiv .drpFields'), function (val, i) {
                    if ($(val).attr('checked')) {
                        $(val).attr('checked', false);
                        self.element.find('#agg_Metrics .divFunction .' + enabledClass).find('.selectedFunction[data-id="' + operator + '_' + $(val).val() + '"]').remove();
                        self.element.find('#agg_Metrics .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                    }
                    else {
                        selectedFields = { title: $(val).attr('data-content'), value: $(val).val(), type: $(val).attr('data-type'), operator: operator, id: operator + '_' + $(val).val() };
                        $(val).attr('checked', true);
                        var out = Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields });
                        self.element.find('#agg_Metrics .divFunction .' + enabledClass).show().append(out);
                    }
                    self.removeMetricItems(enabledClass);
                });
            });

            $(self.element).on('change', '.aggFunDiv .drpFun', function () {
                var items = $.grep(self.fields, function (val, i) {
                    return val.isAggregate == true;
                });
                $(this).parents('.boxFilter').find('.aggContent').append(Mustache.render(self._fieldsTemplate(), items));
                _.each(self.element.find('#agg_Aggregate .selectedFunction'), function (val, i) {
                    self.element.find('#agg_Aggregate .drpFields[value="' + $(val).attr('data-value') + '"]').attr('checked', true);
                });
                self.enableSelectedAggregate();
                if (self.element.find('#agg_Aggregate .drpFields:checked').length == self.element.find('#agg_Aggregate .drpFields').length) self.element.find('#agg_Aggregate .selectAll').addClass('UnselectAll').removeClass('selectAll');
            });

            $(self.element).on('click', '.boxFilter .aggContent .matFieldsDiv .drpFields', function () {
                var operator = self.element.find('#agg_Aggregate .aggFunDiv .drpFun').val(),
                    selectedFields = { title: $(this).attr('data-content'), value: $(this).val(), type: $(this).attr('data-type'), operator: operator, id: operator + '_' + $(this).val() };
                if ($(this).attr('checked')) {
                    var out = Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields });
                    self.element.find('#agg_Aggregate .divFunction').append(out);
                }
                else {
                    self.element.find('#agg_Aggregate .divFunction').find('.selectedFunction[data-id="' + operator + '_' + selectedFields.value + '"]').remove();
                    self.element.find('#agg_Aggregate .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                }
                if (self.element.find('#agg_Aggregate .drpFields:checked').length == self.element.find('#agg_Aggregate .drpFields').length) self.element.find('#agg_Aggregate .selectAll').addClass('UnselectAll').removeClass('selectAll');
            });

            $(self.element).on('click', '.aggContent .select-field .selectAll', function () {
                $(this).addClass('UnselectAll').removeClass('selectAll').attr('title', 'Unselect All');
                var operator = self.element.find('#agg_Aggregate .aggFunDiv .drpFun').val(), selectedFields;
                _.each($('.aggContent .matFieldsDiv .drpFields'), function (val, i) {
                    selectedFields = { title: $(val).attr('data-content'), value: $(val).val(), type: $(val).attr('data-type'), operator: operator, id: operator + '_' + $(val).val() };
                    if (!$(val).attr('checked')) {
                        $(val).attr('checked', true);
                        var out = Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields });
                        self.element.find('#agg_Aggregate .divFunction').append(out);
                    }
                });
            });

            $(self.element).on('click', '.aggContent .select-field .UnselectAll', function () {
                var operator = self.element.find('#agg_Aggregate .aggFunDiv .drpFun').val(), selectedFields;
                _.each($('.aggContent .matFieldsDiv .drpFields'), function (val, i) {
                    $(val).attr('checked', false);
                    self.element.find('#agg_Aggregate .divFunction').find('.selectedFunction[data-id="' + operator + '_' + $(val).val() + '"]').remove();
                    self.element.find('#agg_Aggregate .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                });
            });

            $(self.element).on('click', '.aggContent .select-field .reverse', function () {
                var operator = self.element.find('#agg_Aggregate .aggFunDiv .drpFun').val(), selectedFields;
                _.each($('.aggContent .matFieldsDiv .drpFields'), function (val, i) {
                    if ($(val).attr('checked')) {
                        $(val).attr('checked', false);
                        self.element.find('#agg_Aggregate .divFunction').find('.selectedFunction[data-id="' + operator + '_' + $(val).val() + '"]').remove();
                        self.element.find('#agg_Aggregate .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                    }
                    else {
                        selectedFields = { title: $(val).attr('data-content'), value: $(val).val(), type: $(val).attr('data-type'), operator: operator, id: operator + '_' + $(val).val() };
                        $(val).attr('checked', true);
                        var out = Mustache.render(self._selectedSumMetricFunction(), { savedFilter: selectedFields });
                        self.element.find('#agg_Aggregate .divFunction').show().append(out);
                    }
                    if (self.element.find('#agg_Aggregate .drpFields:checked').length == self.element.find('#agg_Aggregate .drpFields').length) self.element.find('#agg_Aggregate .selectAll').addClass('UnselectAll').removeClass('selectAll');
                });
            });

            //close button click
            $(self.element).on('click', '#agg_Metrics .selectedFunction .closeFun', function () {
                var value = $(this).parents('.selectedFunction').attr('data-value');
                $(this).parents('.selectedFunction').remove();
                self.element.find('#agg_Metrics .drpFields[value="' + value + '"]').attr('checked', false);
                $(self.element).find('.metricsContent .select-field .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                var enabledClass = self.getAction($(this).parents('.selectedFunction').attr('data-operator'));
                self.removeMetricItems(enabledClass);
            });

            $(self.element).on('click', '#agg_Aggregate .selectedFunction .closeFun', function () {
                var value = $(this).parents('.selectedFunction').attr('data-value');
                $(this).parents('.selectedFunction').remove();
                self.element.find('#agg_Aggregate .drpFields[value="' + value + '"]').attr('checked', false);
                $(self.element).find('.aggContent .select-field .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
            });

            $(self.element).on('click', '#agg_Filter .selectedFunction .closeFun', function () {
                self.esQuery.filter.remove($(this).parents('.selectedFunction').attr('data-id'));
                $(this).parents('.selectedFunction').remove();
                self._disableSelectedOptions('filter', $('.drpField'));
            });

            $(self.element).on('click', '.aggContent .select-field .UnselectAll', function () {
                $(this).addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                $(".boxFilter .aggContent input[type=checkbox]").each(function () {
                    $(this).attr("checked", false);
                    _.each(self.esQuery.aggregate.get(), function (val, i) {
                        if (val.metrics == false) {
                            self.esQuery.aggregate.remove(val.id);
                            self.element.find(' #agg_Aggregate .selectedFunction[data-value="' + val.fieldName + '"]').remove();
                        }
                    });
                });
            });

            $(self.element).on('click', '.aggContent .select-field .chkReverse', function () {
                $('.boxFilter .aggContent input[type=checkbox]').each(function () {
                    if ($(this).attr("checked")) {
                        $(this).attr("checked", false);
                        $(self.element).find('.aggContent .select-field .UnselectAll').addClass('selectAll').removeClass('UnselectAll').attr('title', 'Select All');
                        _.each(self.esQuery.aggregate.get(), function (val, i) {
                            if (val.metrics == false) {
                                self.esQuery.aggregate.remove(val.id);
                                self.element.find('#agg_Aggregate .selectedFunction[data-value="' + val.fieldName + '"]').remove();
                            }
                        });
                        self.element.find('.aggContent .select-field .UnselectAll').addClass('selectAll').removeClass('UnselectAll');
                    }
                    else {
                        if ($(this).attr("checked", true)) {
                            $(self.element).find('.aggContent .select-field .selectAll').addClass('UnselectAll').removeClass('selectAll').attr('title', 'Select All');
                            var cond = self._validateField("aggregate");
                            if (cond.cond) {
                                self.element.find('#agg_Aggregate .errorMsg').text("");
                                var operator = self.element.find('#agg_Aggregate .aggFunDiv .drpFun').val(),
                                    selectedFields = $.map(self.element.find('#agg_Aggregate .drpFields'), function (val, i) {
                                        if ($(val).attr('checked')) return { field: $(val).val(), type: $(val).attr('data-type') };
                                    }),
                                    esQueryFields = $.grep(self.esQuery.aggregate.get(), function (val, i) {
                                        return val.metrics == false;
                                    }),
                                    selectedFields = _.reject(selectedFields, function (val) {
                                        return _.findWhere(esQueryFields, { fieldName: val.field, operator: operator }) ? (_.findWhere(esQueryFields, { fieldName: val.field, operator: operator }))['fieldName'] : undefined;
                                    });
                                _.each(selectedFields, function (val, i) {
                                    var fieldSchema = self._getFields(val.field),
                                       options = {
                                           type: fieldSchema.type,
                                           fieldName: fieldSchema.id,
                                           operator: operator,
                                           aliasName: fieldSchema.id,
                                           displayName: fieldSchema.title + ((operator.toLowerCase() != "groupby") ? '(' + operator.toLowerCase() + ')' : ''),
                                           title: fieldSchema.title,
                                           interval: 0,
                                           dateinterval: "",
                                           order: "All",
                                           orderBy: "",
                                           size: 0,
                                           checked: true,
                                           metrics: false
                                       };
                                    self.element.find('#agg_Aggregate').find('.divFunction').append(Mustache.render(self._selectedAggrFunction(), { savedFilter: self.esQuery.aggregate.add(options) }));
                                });
                            }
                        }
                    }
                });
            });
        },

        // on adding a new dropdown, disable the options already selected in other dropdowns..
        _disableSelectedOptions: function (type, div, field) {
            var self = this;
            //removing all disabled field
            self.element.find(div).children('option').attr('disabled', false).removeClass('disableClass');
            $.each(self.element.find('#agg_Filter').find('.selectedFunction'), function (i, val) {
                self.element.find(div).children('option[value="' + $(val).attr('data-field') + '"]').attr('disabled', true).addClass('disableClass');
            });
        },

        getAction: function (operator) {
            if (operator == "SUM")
                return "sumAction";
            else if (operator == "AVG")
                return "avgAction";
            else if (operator == "COUNT")
                return "countAction";
            else if (operator == "MIN")
                return "minAction";
            else if (operator == "MAX")
                return "maxAction";
        },

        removeMetricItems: function (removeClass) {
            var self = this;
            if (self.element.find('.' + removeClass + ' .selectedFunction').length == 0) self.element.find('.' + removeClass).hide();
            if (self.element.find('.' + removeClass).parents('.acc_Container').find('.drpFields:checked').length == self.element.find('.' + removeClass).parents('.acc_Container').find('.drpFields').length) self.element.find('.' + removeClass).parents('.acc_Container').find('.selectAll').addClass('UnselectAll').removeClass('selectAll');
        },

        enableSelectedMetrics: function (enabledClass) {
            var self = this;
            _.each(self.element.find('#agg_Metrics .' + enabledClass + ' .selectedFunction'), function (val, i) {
                self.element.find('#agg_Metrics .drpFields[value="' + $(val).attr('data-value') + '"]').attr('checked', true);
            });
        },

        enableSelectedAggregate: function () {
            var self = this;
            _.each(self.element.find('#agg_Aggregate .selectedFunction'), function (val, i) {
                self.element.find('#agg_Aggregate .drpFields[value="' + $(val).attr('data-value') + '"]').attr('checked', true);
            });
        },

        //For sorting the objects.
        _sortResults: function (prop, asc, data) {
            return data.sort(function (a, b) {
                if (asc) return (a[prop] > b[prop]) ? 1 : ((a[prop] < b[prop]) ? -1 : 0);
                else return (b[prop] > a[prop]) ? 1 : ((b[prop] < a[prop]) ? -1 : 0);
            });
        },

        //For sorting the objects.
        _selectedOrder: function (list, origOrder) {
            var i, checked = document.createDocumentFragment(),
                    unchecked = document.createDocumentFragment();
            for (i = 0; i < origOrder.length; i++) {
                if (origOrder[i].getElementsByTagName("input")[0].checked) {
                    checked.appendChild(origOrder[i]);
                } else {
                    unchecked.appendChild(origOrder[i]);
                }
            }
            list.append(checked).append(unchecked);
        },
        //Validating the aggregation anf filter queries
        _validateField: function (part) {
            var self = this;
            // var temp = [];
            //var tempAggs = [];
            //var operator = [];
            var cond;
            switch (part) {
                case "filter":
                    if ($('.txtValue1').val() == "" || $('.txtValue2').val() == "") {
                        cond = {
                            cond: false,
                            error: 'Please specify Filter condition.'
                        }
                    }
                    else if ($('.txtValue1').val() != "" && self.element.find('.boxFilter .txtValueDiv1 .hasDatepicker').length > 0) {
                        if (Date.parse(self.element.find('.boxFilter .txtValueDiv1 .hasDatepicker').val())) {
                            cond = {
                                cond: true
                            }
                        }
                        else {
                            cond = {
                                cond: false,
                                error: 'Please enter a valid date.'
                            }
                        }
                    }
                    else if (self.element.find('#agg_Filter' + ' .drpField option:selected').attr('type') == "integer" && (!$.isNumeric($('.txtValue1').val()) || (parseInt($('.txtValue1').val()) > 12))) {
                        cond = {
                            cond: false,
                            error: 'Please enter numeric value less than 12.'
                        }
                    }
                    else {
                        cond = {
                            cond: true
                        }
                    }
                    break;
                default:
                    cond = {
                        cond: true
                    }
                    break;
            }
            return cond;
        }
    });
})(jQuery);
