/*+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

JQuery  widget for Dashboard creation
Created By      : Nithin V for Assyst International Pvt. Ltd.
Reviewed By     : Rony and Prasanth
Created Date    : 01-January-2017
Version         : 1.0.1
Project         : PanBI
USAGE:  

Option:
        
Public Functions:
    
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+*/
(function ($) {
    $.widget("custom.Dashboard", $.Assyst.Dashboard, {
        // creating the templates
        _create: function () {
            var self = this;
            try {
                self.render();
                self._personalize();
                self.eventManager();
            }
            catch (ex) {
                console.log(ex);
            }
        },

        renderDashbaord: function () {
            var self = this;
            var data = {
                toolBar: self.options.toolBar,
                dashletViews: self.dashletViews,
                guestUser: self.options.guestUser,
                dashLayout: self.dashboard.get()
            };
            $.extend(true, data, {
                columnLayout: self.options.columnLayout,
                themeLayout: self.options.themeLayout
            });
            var out = Mustache.render(self._dashboardTemplate(), data);
            self.element.html(out);
        },

        //Template for dashboard and dropdow filling
        _dashboardTemplate: function () {
            var template = '{{^guestUser}}<div class="dashboardIcons">' +
                '{{#dashLayout}}<div id="dashboardShare" class="{{#shared}}dashboardShareInActive{{/shared}} {{^shared}}dashboardShareActive{{/shared}}" title="Share">' +
                '</div>{{/dashLayout}}' +
                '{{#toolBar}}<div class="iconsDiv"><div class="dashIcons"><div id="ddlLayoutType" class="notDisabled"><div class="arrow-up"></div>' +
                '<span class="iconText">Change Layout</span> <span class="spriteIcon changeLayout">' +
                '</span><span class="iconArrow"></span>' +
                '<div class="layoutOption childMenu">' +
                '{{#columnLayout}}<div id="{{columnClass}}" class="{{columnClass}} toolMenu" data-value="{{value}}">' +
                '<span class="spriteIcon"></span><span class="iconText">{{text}}</span>' +
                '</div>{{/columnLayout}}' +
                '</div>' +
                '</div>' +
                '<span class="spriteIcon pipe notDisabled"></span>' +
                '<div id="changeTheme" class="changeTheme notDisabled">' +
                '<div class="arrow-up">' +
                '</div>' +
                '<span class="iconText">Change Theme</span> <span class="spriteIcon changeTheme">' +
                '</span><span class="iconArrow"></span>' +
                '<div class="themes childMenu">' +
                '{{#themeLayout}}<div id="{{columnClass}}" class="{{columnClass}} toolMenu" data-value="{{value}}">' +
                '<span class="spriteIcon"></span><span class="iconText"></span>' +
                '</div>{{/themeLayout}}' +
                '</div>' +
                '</div>' +
                '<span class="spriteIcon pipe notDisabled"></span>' +
                '<div id="aCancelBtn" class="cancelButton notDisabled">' +
                '<span class="iconText">Reset</span> <span class="spriteIcon reset"></span>' +
                '</div>' +
                '<span class="spriteIcon pipe notDisabled"></span>' +
                '{{#dashLayout}}<div id="aSavebtn" class="saveButton {{#shared}}disableClass{{/shared}}">' +
                '<span class="iconText">Save</span> <span class="spriteIcon save"></span>' +
                '</div>{{/dashLayout}}' +
                '<span class="spriteIcon pipe notDisabled"></span>' +
                '<div id="refresh" class="refresh notDisabled">' +
                '<span class="iconText">Refresh</span> <span class="spriteIcon refresh"></span>' +
                '</div>' +
                '<span class="spriteIcon pipe notDisabled"></span>' +
                '</div>' +
                '<div id="expand_icon" class="expand_iconPlus" title="Expand">' +
                '</div>' +
                '</div>{{/toolBar}}' +
                '<div id="dashletMenu" title="Dashboard View"></div>' +
                '</div>{{/guestUser}}' +
                '<div id="dashboardContainer">{{#dashLayout}}<div id="wrappercontainer" style="background:{{backgroundColor}};">{{/dashLayout}}' +
                '<div id="hdnDialogDiv" style="display:none">' +
                '<div id="dialog-confir" style="width:450px" title=""> </div>' +
                '</div> ' +
                '<div class="dashletMenuList" style="display: none;">' +
                '<div class="dashboardCollection">' +
                '<div class="contentdashletMenuList"></div>' +
                '<div class="dashletMenuListcolumnDivAdd">' +
                '<div class="dashletMenuListImage"></div>Add Dashboard' +
                '<div class="saveBox" title="Add Dashboard">' +
                '<div class="saveBoxTri"></div>' +
                '<div class="txtTitleBox"><input type="text" placeholder="Name" id="txtDash"/></div>' +
                '<div class="saveColorBox">' +
                '</div>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '<div class="headView"><a class="previous_link link" href="#"></a><span class="pageCountGroup"></span><a class="next_link link" href="#"></a></div>' +
                '</div>' +
                '{{#dashLayout}}<div id="layoutContainer" style="background:{{backgroundColor}}"></div>{{/dashLayout}}' +
                '</div></div>';
            return template;
        },

        _widgetTemplate: function () {
            return '{{#dashlet}}{{#clipHeadline}}' +
                        '{{#widget}}' +
                            '<div class="frontFace">' +
                                '{{^guestUser}}{{^hoverOnDashelt}}<span class="closeDashletWidget" title="Remove"></span>{{/hoverOnDashelt}}{{/guestUser}}' +
                                '<div class="widgetText">' +
                                    '<div style="color:{{head1Color}}" class="headlineText1"></div>' +
                                    '<div style="color:{{head2Color}}" class="headlineText2"></div>' +
                                '</div>' +
                                '<div class="widgetChartContent" data-widget="guage" data-color="{{color}}" style="color:{{color}}; fill:{{color}};"></div>' +
                            '</div>' +
                            '{{#hoverOnDashelt}}' +
                                '<div class="backFace">' +
                                    '<div class="header_div" data-bgcolor="{{bgColor}}" style="background-color:{{bgColor}}">' +
                                        '<span title ="{{title}}" class="titleDashlet">{{title}}</span>' +
                                        '<span class="graphTypeDashlet" title="Change Type">' +
                                            '<span class="spnType">' +
                                                '<span></span>' +
                                            '</span>' +
                                        '</span>' +
                                    '<div class="btndshGrid1"></div>' +
                                    '{{^guestUser}}<div class="selectedDashlet"><div class="addContentDiv"><span id="addContent" class="addContent spriteIcon toolMenu" title="Add Dashlet"></span><span class="dashletText"></span></div><div class="addRowDiv"><span class="rowSpan spriteIcon toolMenu" title="Row Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="rowOption">' +
                                    '<div class="insertBef"><span id="insertBefore" class="insertBefore spriteIcon toolMenu condMenu" title="Insert Before"></span><span class="dashletText">Insert Before</span></div>' +
                                    '<div class="insertAft"><span id="insertAfter" class="insertAfter spriteIcon toolMenu condMenu" title="Insert After"></span><span class="dashletText">Insert After</span></div>' +
                                    '<div class="insertRw"><span id="deleteRow" class="deleteRow spriteIcon toolMenu condMenu" title="Delete Row"></span><span class="dashletText">DeleteRow</span></div>' +
                                    '</div></div><div class="addCellDiv"><span class="cellSpan spriteIcon toolMenu" title="Cell Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="cellOption">' +
                                    '<div class="mergeLef"><span id="mergeLeft" class="mergeLeft spriteIcon toolMenu condMenu" title="Merge Left"></span><span class="dashletText">Merge Left</span></div>' +
                                    '<div class="mergeRig"><span id="mergeRight" class="mergeRight spriteIcon toolMenu condMenu" title="Merge Right"></span><span class="dashletText">Merge Right</span></div>' +
                                    '<div class="mergeTp"><span id="mergeTop" class="mergeTop spriteIcon toolMenu condMenu" title="Merge Top"></span><span class="dashletText">Merge Top</span></div>' +
                                    '<div class="mergeBo"><span id="mergeBottom" class="mergeBottom spriteIcon toolMenu condMenu" title="Merge Bottom"></span><span class="dashletText">Merge Bottom</span></div>' +
                                    '<div class="splitRw"><span id="splitRow" class="splitRow spriteIcon toolMenu condMenu" title="Split Row"></span><span class="dashletText">Split Row</span></div>' +
                                    '<div class="splitCn"><span id="splitColumn" class="splitColumn spriteIcon toolMenu condMenu" title="Split Column"></span><span class="dashletText">Split Column</span></div>' +
                                    '</div></div>' +
                                    '</div>{{/guestUser}}' +
                                    '<div class="defaultDashletIcons">{{^guestUser}}<span class="closeDashlet" title="Remove"></span>{{/guestUser}}<span class="fullsizeSameWindow" title="Open in same window"></span>{{^guestUser}}<span class="swapDashlet" title="Move"></span><span class="fullsizeDashlet" title="Open in new window"></span>{{/guestUser}}<span class="refreshDashlet" title="Refresh"></span>{{^guestUser}}<span class="dashletFilters" title="Show Filters"></span>{{/guestUser}}</div></div>' +
                                    '<div class="content_div"></div>' +
                                    '<div class="contentDrid_div"></div>' +
                                    '</div>' +
                '{{/hoverOnDashelt}}' +
                '{{/widget}}' +
                '{{/clipHeadline}}' +

                '{{^clipHeadline}}' +
                    '<div class="frontFace">' +
                        '<div class="header_div" data-bgcolor="{{bgColor}}" style="background-color:{{bgColor}}">' +
                            '<span title ="{{title}}" class="titleDashlet">{{title}}</span><span class="graphTypeDashlet" title="Change Type"><span class="spnType"></span><span class="spnArrow"></span></span><div class="btndshGrid1"></div>' +
                            '{{^guestUser}}<div class="selectedDashlet"><div class="addContentDiv"><span id="addContent" class="addContent spriteIcon toolMenu" title="Add Dashlet"></span><span class="dashletText"></span></div><div class="addRowDiv"><span class="rowSpan spriteIcon toolMenu" title="Row Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="rowOption">' +
                            '<div class="insertBef"><span id="insertBefore" class="insertBefore spriteIcon toolMenu condMenu" title="Insert Before"></span><span class="dashletText">Insert Before</span></div>' +
                            '<div class="insertAft"><span id="insertAfter" class="insertAfter spriteIcon toolMenu condMenu" title="Insert After"></span><span class="dashletText">Insert After</span></div>' +
                            '<div class="insertRw"><span id="deleteRow" class="deleteRow spriteIcon toolMenu condMenu" title="Delete Row"></span><span class="dashletText">DeleteRow</span></div>' +
                            '</div></div><div class="addCellDiv"><span class="cellSpan spriteIcon toolMenu" title="Cell Action"></span><span class="iconArrow"></span><span class="dashletText"></span><div class="cellOption">' +
                            '<div class="mergeLef"><span id="mergeLeft" class="mergeLeft spriteIcon toolMenu condMenu" title="Merge Left"></span><span class="dashletText">Merge Left</span></div>' +
                            '<div class="mergeRig"><span id="mergeRight" class="mergeRight spriteIcon toolMenu condMenu" title="Merge Right"></span><span class="dashletText">Merge Right</span></div>' +
                            '<div class="mergeTp"><span id="mergeTop" class="mergeTop spriteIcon toolMenu condMenu" title="Merge Top"></span><span class="dashletText">Merge Top</span></div>' +
                            '<div class="mergeBo"><span id="mergeBottom" class="mergeBottom spriteIcon toolMenu condMenu" title="Merge Bottom"></span><span class="dashletText">Merge Bottom</span></div>' +
                            '<div class="splitRw"><span id="splitRow" class="splitRow spriteIcon toolMenu condMenu" title="Split Row"></span><span class="dashletText">Split Row</span></div>' +
                            '<div class="splitCn"><span id="splitColumn" class="splitColumn spriteIcon toolMenu condMenu" title="Split Column"></span><span class="dashletText">Split Column</span></div>' +
                            '</div></div></div>{{/guestUser}}' +
                            '<div class="defaultDashletIcons">{{^guestUser}}<span class="closeDashlet" title="Remove"></span>{{/guestUser}}<span class="fullsizeSameWindow" title="Open in same window"></span>{{^guestUser}}<span class="swapDashlet" title="Move"></span><span class="fullsizeDashlet" title="Open in new window"></span>{{/guestUser}}<span class="refreshDashlet" title="Refresh"></span>{{^guestUser}}<span class="dashletFilters" title="Show Filters"></span>{{/guestUser}}</div>' +
                        '</div>' +
                        '<div class="content_div"></div>' +
                        '<div class="contentDrid_div"></div>' +
                    '</div>' +
                '{{/clipHeadline}}{{/dashlet}}';
        },

        drawWidget: function (element, dashlet) {
            var self = this;
            if (dashlet.clipHeadline) {
                var widgetType = '<div class="selectType">' +
                        '<div class="widgetTypes">' +
                        '<div class="typeText widgetCharts text_class" data-value="text" title="Text"></div>' +
                        '<div class="typeRadial widgetCharts radial_class" data-value="radial" title="Radial"></div>' +
                        '<div class="typeGuage widgetCharts guage_class" data-value="guage" title="Guage"></div>' +
                        '<div class="typeProgress widgetCharts progressBar_class" data-value="progressBar" title="Progress Bar"></div>' +
                        '</div>' +
                        '</div>' +
                        '<div class="grphTypeMobile clickMobileType"></div>';                
                if (self.options.guestUser == false) {
                    $(widgetType).insertBefore('#' + dashlet.id);
                }
                $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').css('margin-left', $('#' + dashlet.id).position().left + $('#' + dashlet.id).width() - self.element.find('.selectType').width());
                if (screen.width > 991) $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').css('margin-top', dashlet.top - 13);
                else $('#' + dashlet.id).parents('.dashletContainer').find('.selectType').css('margin-top', '2px');
            }
            var out = Mustache.render(self._widgetTemplate(), { dashlet: dashlet, guestUser: self.options.guestUser });
            element.empty().html(out);
        },

        // Adding content
        _addContent: function (div) {
            var self = this;
            var id = $(div).attr("id");
            if (self.options.guestUser == false) {
                var catalog = self.dashboard.dashlets.select(id);
                if (catalog.widget == null) catalog.widget = undefined;
                var dashlet = $.extend(true, {
                    title: undefined,
                    catalogId: 0,
                    dashletId: 0,
                    clipHeadline: false,
                    widget: {
                        headline1: "",
                        head1Color: "",
                        headline2: "",
                        head2Color: "",
                        enableWidget: false,
                        percentage: 0,
                        percentageColor: "",
                        hoverOnDashelt: false,
                        chartType: ""
                    }
                }, catalog);

                var data = {
                    toolBar: self.options.toolBar,
                    title: dashlet.title,
                    dashletViews: self.dashletViews,
                    dashLayout: self.dashboard.get(),
                    clipHeadline: dashlet.clipHeadline,
                    name: dashlet.param.name,
                    widget: dashlet.widget
                };

                var out = Mustache.render(self._addDashletTemplate(), data);
                div.append(out);
                //Grouping the dashlet based on type
                var itemsName = _.groupBy(data.dashletList, function (obj) {
                    return obj.Type;
                });

                if (self.dashboard.templateType == 2 || self.dashboard.templateType == 1 || catalog.colspan > 1) {
                    self.element.find('.addDashletBody,.clipHeadBody').width('340px');
                    self.element.find('.buttonSet').width('381px');
                }
                else self.element.find("div.dialog-confirm").height($(div).height() + 4);

                $("select#ddlcontentName option").each(function () {
                    if ($(this).attr("value") == $(this).parents(".addDashletBody").find("#ddlcontentName").val()) {
                        $(this).parents(".addDashletBody").find("#txtcontenttitle").val($(this).text());
                    }
                });
            }
        },

        viewOnSameWindow: function (id) {
            var self = this;
            var dashlet = self.dashboard.dashlets.select(id);
            var dataset = dashlet["dataset"];
            var misSchema = dashlet["misSchema"];
            self.element.find('#myModal').remove();
            var template = '<div id="myModal" class="'+id+'">' +
                                    '<div class="modal-content">' +
                                        '<div class="title">{{title}}</div>' +
                                        '<span class="close">&times;</span>' +
                                        '<div class="maxView mis-container"></div>' +
                                    '</div>' +
                                '</div>';
            self.element.append(Mustache.render(template, misSchema));
            var l_subviewer = self.element.find(".maxView");
            self.element.find('#myModal').show();
            l_subviewer.height(self.element.find('.modal-content').height() - 43);
            _appFun._create_ViewExplorer(dataset, l_subviewer, misSchema, dashlet.type);
        },       

        _resizable: function () {
            var self = this;
            var width;
            if (self.options.guestUser == false) {
                self.element.find("div.col").resizable({
                    handles: 's',
                    start: function (event, ui) {
                        minWidth: $(ui.element).width;
                    },
                    resize: function (event, ui) {
                    },
                    stop: function (event, ui) {
                        var div = $(ui.element);
                        var id = $(ui.element[0]).attr('id');
                        var flag = true;

                        var itemRow = self.dashboard.dashlets.select(id).rowNo;
                        var itemHeight = self.dashboard.dashlets.select(id).height;
                        var diffHeight = itemHeight - div.height();

                        var items = $.grep(self.dashboard.dashlets.get(), function (val, i) {
                            return val.rowNo == itemRow;
                        });

                        var leastValue = $.grep(items, function (val, i) {
                            return (val.height - diffHeight) < self.options.minHeight;
                        });

                        if (leastValue.length > 0) {
                            flag = false;
                        }

                        if (flag) {
                            var data = {
                                id: $(div).attr("id"),
                                layout: self.dashboard.get().templateType,
                                height: $(ui.element).height(),
                                width: $(ui.element).width(),
                                handles: $(ui.element).data('ui-resizable').axis // $(this).data('resizable').axis
                            };

                            self.dashboard.dashlets.resize(data);
                            $(ui.element).resizable("option", "disabled", false);
                            self._drawDashlets();
                        }
                        else {
                            $(ui.element).resizable("option", "disabled", false);
                            self._drawDashlets();
                        }
                    }
                });
            }
        },

        //function for getting height of dashboard
        getHeight: function () {
            var self = this;
            var dashlets = self.dashboard.dashlets.get();
            var flag;
            var item = [];
            var height = 0;
            var maxRow = _.max(dashlets, function (data) {
                return data.rowNo;
            }).rowNo;
            var lowestHeight = 0;
            for (var i = 0; i <= maxRow; i++) {
                lowestHeight += _.findWhere(dashlets, { rowNo: i }).height;
            }
            //rowHeight + 10 padding for each + 60 outer padding
            return lowestHeight + (maxRow * 55);
        },

	_getQueryString: function (url, isDashlet, dashlet) {
            var self = this;
            var filter = self._getFilterQuery();
            var queries = $.extend({}, self._extractQueryString(url), dashlet.param);
            if (url.indexOf('GetData') != -1) {
                var filteredData = self.filterData(dashlet);
                if (filteredData.filter.length != 0 || filteredData.aggregate.length != 0)
                    queries["query"] = JSON.stringify(filteredData);
                else {
                    queries["query"] = JSON.stringify(undefined);
                }
            }
            else {
                queries["query"] = JSON.stringify(undefined);
            };
            queries["isDashlet"] = (!isDashlet) ? 0 : 1;
            return queries;
        },

        filterData: function (dashlet) {
            var self = this;
            var filters = [], fieldName, operator, type;
            //self.options.filter = [{ "filterkey": "Thematic-and-Cross-Cutting", "value": "SE4All Knowledge Hub"}];
            //self.options.filter = [{ "filterkey": "year", "value": 2015, "value2": 2017}];
            //self.options.filter = [{ "filterkey": "Expected-Outcome-Indicator", "value": "Preparation of new operation informed"}];
            var displayName;
            //catalog query is used to show the filters that are selected in the analyze section
            var catalogQuery = [];
            var catalogId = dashlet.dashletId;
            if (catalogId == '0') {
                catalogId = dashlet.selectedCatalog.CatalogId;
            }
            var catalogId;
            self._ajaxcall({
                url: self.options.apiURL + '/GetCatalogQuery',
                type: 'GET',
                async: false,
                data: { catalogId: catalogId },
                success: function (data) {
                    if (data != "" && data.Data.query != "") {
                        catalogQuery = JSON.parse(data.Data.query);
                    }
                    else catalogQuery = {
                        aggregate: [],
                        filter: [],
                        fields: []
                    };
                    catalogId = data.Data.CatalogId;
                }
            });
            if (self.options.filter && self.options.filter.length > 0) {
                function arrUnique(arr) {
                    var cleaned = [];
                    self.options.filter.forEach(function (itm) {
                        var unique = true;
                        cleaned.forEach(function (itm2) {
                            if (_.isEqual(itm, itm2)) unique = false;
                        });
                        if (unique) cleaned.push(itm);
                    });
                    return cleaned;
                }

                self.options.filter = arrUnique(self.options.filter);

                var groupedData = _.groupBy(self.options.filter, function (d) { return d.filterkey });
                _.each(groupedData, function (value, idx) {
                    var values = "", value2 = "";
                    _.each(value, function (val, i) {
                        if (val.filterkey == "Thematic-and-Cross-Cutting") {
                            fieldName = "EP.esmapProgram_" + catalogId;
                            displayName = "Thematic-and-Cross-Cutting";
                            operator = "In";
                            type = "string";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Priorities") {
                            fieldName = "EP.FA.focalArea_" + catalogId;
                            displayName = "Focal Area";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Region") {
                            fieldName = "FundCountryRegionName_" + catalogId;
                            displayName = "Region";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value.toUpperCase() + " ,";
                            }
                        }
                        if (val.filterkey == "Country") {
                            fieldName = "FundCountryName_" + catalogId;
                            displayName = "Country";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Product-Line") {
                            fieldName = "ProductLineCode_" + catalogId;
                            displayName = "Product Line";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Sector") {
                            fieldName = "Sector_" + catalogId + ".sector";
                            displayName = "Sector";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Output") {
                            fieldName = "outputs_" + catalogId + ".outputName";
                            displayName = "Sector";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Outcome-Type") {
                            fieldName = "outcome_" + catalogId + ".outcomeName";
                            displayName = "Sector";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Outcome-Indicator") {
                            fieldName = "outcome_" + catalogId + ".outcomeIndicators.outcomeIndicator";
                            displayName = "Sector";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
			if (val.filterkey == "Gender-Tag") {
                            fieldName = "socialGenderRating_" + catalogId;
                            displayName = "social Gender Rating";
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "Status") {
                            fieldName = "FundStatus_" + catalogId;
                            displayName = "Status";
                            if (val.value == "Active") {
                                val.value = "ACTV ,ACTN ,PEND";
                            }
                            else if (val.value == "Closed") {
                                val.value = "LCLS";
                            }
                            type = "string";
                            operator = "In";
                            if (val.value != "all") {
                                values += val.value + " ,";
                            }
                        }
                        if (val.filterkey == "year") {
                            fieldName = "activationFY_" + catalogId;
                            displayName = "Activation FY";
                            type = "numeric";
                            operator = "between";
                            values = val.value;
                            value2 = val.value2;
                        }
                    });
                    if (values != "") {
                        if (displayName != "Activation FY") values = values.replace(/ ,\s*$/, "");
                        filters.push({
                            "id": "filt_666",
                            "fieldName": fieldName,
                            "displayName": displayName,
                            "operator": operator,
                            "value1": values,
                            "value2": value2,
                            "displayValue1": "",
                            "displayValue2": "",
                            "type": type,
                            "checked": true,
                            "nested": true,
                            "multiValue": true,
                            "aliasName": fieldName,
                            "title": displayName,
                            "isDisable": false
                        });
                    }
                    $.merge(catalogQuery.filter, filters);
                });
            }
            return catalogQuery;
        },

	 getMapData: function () {
            var self = this, records, record = [];
            var catalogId = self.dashboard.dashlets.get()[0].catalogId;
            var filterData = {
                "query": '',
                "misID": self.dashboard.dashlets.get()[0].catalogId
            };
            var paramData = new Object();
            paramData.mId = self.options.menuId;
            paramData.userid = self.options.userid;
            paramData["getData"] = JSON.stringify(filterData);
            self._ajaxcall({
                url: self.options.apiURL + '/POST',
                type: 'POST',
                async: false,
                data: paramData,
                success: function (data) {
                    if (typeof data.Data == 'string') {
                        records = JSON.parse(JSON.parse(data.Data).Records);
                        $.each(records, function (i, val) {
                            var obj = {}, arr = [], focalarr = [], productarr = [], statusarr = [], focalareasarr = [], fvalue, country = [], region = [], sector = [], outcomeIndicators = [], outcometype = [], output = [], gendertag = [];
                            var ep;
                            if (val.EP) {
                                if (val.EP.length != 0) ep = val.EP[0]['esmapProgram_' + catalogId];
                                arr.push(val.EP[0]['esmapProgram_' + catalogId]);
                                var focal = {}
                                var focalvar;
                                if (val.EP[0].FA.length != 0) focalvar = val.EP[0].FA[0]['focalArea_' + catalogId];
                                focalareasarr.push(focalvar);
                                focal[val.EP[0]['esmapProgram_' + catalogId]] = focalareasarr;
                                focalarr.push(focal);
                            }

                            productarr.push(val['ProductLineCode_' + catalogId]);
                            if (val['FundStatus_' + catalogId] == 'ACTN' || val['FundStatus_' + catalogId] == 'ACTV' || val['FundStatus_' + catalogId] == 'PEND') {
                                fvalue = 'Active';
                            } else {
                                fvalue = 'Closed';
                            }
                            statusarr.push(fvalue)
                            var sec = '';
                            var countrys = val['FundCountryName_' + catalogId]
                            country.push(self._stringCamel(countrys));
                            var regions = val['FundCountryRegionName_' + catalogId]
                            region.push(self._stringCamel(regions));
                            if (val['Sector_' + catalogId]) {
                                if (val['Sector_' + catalogId].length != 0) sec = val['Sector_' + catalogId][0].sector;
                                sector.push(sec);
                            }
                            var outnames = '';
                            if (val['outcome_' + catalogId]) {
                                if (val['outcome_' + catalogId].length != 0) outnames = val['outcome_' + catalogId][0].outcomeName
                                outcometype.push(outnames);
                            }
                            var outcomeInd = {};
                            var out = '';
                            if (val['outcome_' + catalogId]) {
                                if (val['outcome_' + catalogId].length != 0) out = val['outcome_' + catalogId][0].outcomeIndicators[0].outcomeIndicator;
                                outcomeIndicators.push(out);
                            }
                            if (outcomeIndicators.length>0) {
                                outcomeInd[outnames] = outcomeIndicators;
                            } else {
                                outcomeInd = '';
                            }
                            var ind = [];
                            ind.push(outcomeInd);
                            var outputs = '';
                            if (val['outputs_' + catalogId]) {
                                if (val['outputs_' + catalogId].length != 0) outputs = val['outputs_' + catalogId][0].outputName
                                output.push(outputs);
                            }
                            gendertag.push(val['socialGenderRating_' + catalogId]);
                            obj.Year = val['activationFY_' + catalogId]
                            obj.Country = country
                            obj.Region = region
                            obj.Lat = val['Latitude']
                            obj.Lon = val['Longitude']
                            obj['Thematic and Cross Cutting'] = arr;
                            obj['Priorities'] = focalarr;
                            obj['Product Line'] = productarr;
                            obj['Status'] = statusarr;
                            obj['Sector'] = sector
                            obj['Allocation USD'] = val['TransferSPinUSD_' + catalogId];
                            obj['Disbursment USD'] = val['DisbursementsUSD_' + catalogId];
                            obj['Output'] = output;
                            obj['Outcome Type'] = outcometype;
                            obj['Outcome Indicator'] = ind;
                            obj['Gender Tag'] = gendertag
                            obj['GrantAmount USD'] = val['GrantAmountUSD_' + catalogId];
				obj['No:of Activities']=1;
                            record.push(obj);
                        });
                    }
                }
            });
            return record;
        },

        _stringCamel: function (inputString) {
            var result = "";
            if (inputString == '') {
                return result;
            }
            var firstChar = inputString.charAt(0);
            var firstCharToUpperCase = firstChar.toUpperCase();
            result = result + firstCharToUpperCase;
            for (var i = 1; i < inputString.length; i++) {
                var currentChar = inputString.charAt(i);
                var previousChar = inputString.charAt(i - 1);
                if (previousChar == ' ') {
                    var currentCharToUpperCase = currentChar.toUpperCase();
                    result = result + currentCharToUpperCase;
                } else {
                    var currentCharToLowerCase = currentChar.toLowerCase();
                    result = result + currentCharToLowerCase;
                }
            }
            return result;
        },

	_ajaxcall: function (options) {
            var defaultOptions = {
                url: undefined,
                type: 'GET',
                dataType: 'json',
                data: undefined,
                crossDomain: true,
                headers: {
                    'authorization': 'basic ' + btoa('guest:033cc66ca4310b56b7ef829077c4ac83')
                },
                async: true,
                success: undefined,
                error: function (p_request, p_status, p_error) {
                    if (window.console && window.console.log) console.log((p_error.message ? p_error.message : p_error));
                }
            };

            var ajaxOptions = $.extend(true, {}, defaultOptions, options);
            $.ajax(ajaxOptions);
        },

        eventManager: function () {
            var self = this;
            $(document).on('click', '#myModal .close', function () {
		self._refresh($('#'+$(this).parents('#myModal').attr('class')));
                $('#myModal').remove();
            });
        }
    });
})(jQuery);
