﻿/*+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

JQuery  widget for slick grid data crude operations
Created By      : Rony for Assyst International Pvt. Ltd.
Reviewed By     : 
Created Date    : 19-Aug-2015
Version         : 1.0.1
Project         : PanBI
USAGE:  

Option:
        
Public Functions:
    
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+*/
(function ($) {

    //Create widget for slick grid data viewer object
    $.widget('Assyst.CatalogViewer', {
        //Default values for options
        options: {
            schema: undefined,
            dataURL: undefined,
            actions: {
                listAction: undefined,
                deleteAction: undefined,
                updateAction: undefined
            },
            query: undefined,
            enableJsonp: false,
            grid: {
                enable: true,
                height: undefined,
                hiddenColumns: [],
                options: {
                    enableCellNavigation: false,
                    enableColumnReorder: false,
                    multiColumnSort: true,
                    enableAddRow: false,
                    forceFitColumns: true,
                    leaveSpaceForNewRows: false,
                    explicitInitialization: false,
                    editable: false,
                    asyncEditorLoading: false,
                    rowHeight: 25
                    //syncColumnCellResize: true,
                },
                nested: {
                    enable: true,
                    id: 'id',
                    parent: 'parent'
                },
                filter: {
                    searchField: undefined,
                    thresholdField: undefined
                }
            },

            paging: {
                enable: true,
                panel: 'bottom',
                showItemCount: true,
                pageSize: 20,
                pageSizes: [5, 10, 20, 50, 100, 250, 500, 1000]
            },
            callBack: undefined,
            onRecordLoad: undefined,
            buttons: []
        },
        rendered: false,
        grid: undefined,
        searchText: undefined,
        dataView: undefined,
        sidePanelContainer: $('<div class="sidePanelContainer"/>'),
        fields: undefined, //[{id: xfield, name: xfield, field: xfield}]
        records: [],
        filter: {
            percentCompleteThreshold: 0,
            searchString: ""
        },
        pagedList: {
            pageNumber: 1,
            pageSize: 10,
            pageCount: 1,
            itemCount: 0,
            isFirstPage: false,
            isLastPage: false,
            hasNextPage: false,
            hasPreviousPage: false,
            set: function (recordcount) {
                var pageCount = Math.floor(recordcount / this.pageSize);
                if (recordcount % this.pageSize != 0) {
                    ++pageCount;
                }
                if (pageCount == 0) pageCount = 1;
                if (this.pageNumber > pageCount) this.pageNumber = pageCount;
                this.itemCount = recordcount;
                this.pageCount = pageCount;
                this.isFirstPage = this.pageNumber == 1;
                this.isLastPage = this.pageNumber == this.pageCount;
                this.hasPreviousPage = this.pageNumber > 1;
                this.hasNextPage = this.pageNumber < this.pageCount;
            }
        },

        _init: function () {
            try {
                var self = this;
                var $element = $(self.element);
                var $block = $('<div class="jtable-main-container ui-corner-all"></div>');
                var $pagingBlock = $('<div class="pagingSet ui-corner-bottom"><div class="button-container"></div><div class="paging-container"></div></div>');
                var $gridBlock = $('<div class="grid-container"></div>').css("height", self.options.grid.height - 20);

                if (self.options.paging.panel == 'top') {
                    $block.append($pagingBlock);
                    $block.append($gridBlock);
                }
                else {
                    $block.append($gridBlock);
                    $block.append($pagingBlock);
                }
                $element.empty().append($block);
                this.rendered = !this.options.grid.options.explicitInitialization;
                this._createButtons();
                this.render("load");
            }
            catch (e) {
                console.log(e);
            }
        },

        _create: function () {
            try {
                this._personalize();
                this._initOptions();
            }
            catch (e) {
                console.log(e);
            }
        },

        _initOptions: function () {
            var self = this;
            var pageSize = self._tryParseInt(self.options.paging.pageSize, 10)
            var formatter = function (row, cell, value, columnDef, dataContext) {
                var decimalPoint = columnDef.decimalPoint;
                var format = columnDef.format;
                var iconClass = '';
                var iconTitle = '';
                switch (columnDef.type) {
                    case 'btn':
                        value = columnDef.prefix;
                        if (dataContext.ParentCatalogId != 0) {
                            value = value.replace('panbi-catalog-visulize-icon slick-grid-icon-hide', '');
                        }
                        // show delete button if the user is created user
                        if (dataContext.CreatedById != _app.currentUserId) {
                            value = value.replace('panbi-catalog-delete-icon slick-grid-icon-hide', '');
                            value = value.replace('panbi-catalog-edit-icon slick-grid-icon-hide', ''); 
                        }
                        break;
                    case 'geo':
                        break;
                    case 'numeric':
                    case 'number':
                        if (format === 'percentage') {
                            value = value + '%';
                        }
                        if (!Number.isNaN(parseFloat(value))) value = parseFloat(parseFloat(value).toFixed(decimalPoint)); // numberWithCommas(parseFloat(value).toFixed(decimalPoint));
                        else value = 0;
                        break;
                    case 'date':
                    case 'datetime':
                    case 'date-time':
                    case 'timestamp':
                        var out = moment(value).format("MM/DD/YYYY HH:mm:ss");
                        value = out;
                        break;
                    case 'string':
                        switch (format) {
                            case 'markdown':
                                if (typeof Showdown !== 'undefined') {
                                    var showdown = new Showdown.converter();
                                    var out = showdown.makeHtml(value);
                                    value = out;
                                }
                                break;
                            case 'plain':
                                break;
                            default:
                                // as this is the default and default type is string may get things
                                // here that are not actually strings
                                if (value && typeof value === 'string') {
                                    value = value.replace(/(https?:\/\/[^ ]+)/g, '<a href="$1">$1</a>');
                                }
                                if (cell == 0) {
                                    switch (dataContext.CatalogTypeName) {
                                        case 'Dashlet':
                                            iconClass = 'icon-dashlet';
                                            if (dataContext.Schema) {
                                                switch (JSON.parse(dataContext.Schema).layoutSchema.type) {
                                                    case 'grid':
                                                        iconClass = 'icon-grid';
                                                        iconTitle = 'Grid';
                                                        break;
                                                    case 'pivot':
                                                        iconClass = 'icon-pivot';
                                                        iconTitle = 'Pivot';
                                                        break;
                                                    case 'graph':
                                                        iconClass = 'icon-chart';
                                                        iconTitle = 'Chart';
                                                        break;
                                                }
                                            }
                                            else {
                                                iconClass = 'icon-chart';
                                                iconTitle = 'Chart';
                                            }
                                            break;
                                        case 'Snapshot':
                                            iconClass = 'icon-snapshot';
                                            iconTitle = 'Snapshot';
                                            break;
                                        case 'Filter':
                                            iconClass = 'icon-filter';
                                            if (JSON.parse(dataContext.Schema).layoutSchema != undefined) {
                                                switch (JSON.parse(dataContext.Schema).layoutSchema.type) {
                                                    case 'grid':
                                                        iconClass = 'icon-grid';
                                                        iconTitle = 'Grid';
                                                        break;
                                                    case 'pivot':
                                                        iconClass = 'icon-pivot';
                                                        iconTitle = 'Pivot';
                                                        break;
                                                    case 'graph':
                                                        iconClass = 'icon-chart';
                                                        iconTitle = 'Chart';
                                                        break;
                                                }
                                            }
                                            break;
                                        default:
                                            iconClass = 'panbi-catalog-empty-icon';
                                            iconTitle = 'Dataset';
                                    }
                                }
                                break;
                        }
                        break;
                }

                if (columnDef.root) {
                    value = value.toString().replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
                    var spacer = "<span style='float:left;display:inline-block;height:1px;width:" + (15 * dataContext._indent) + "px'></span>";
                    if (dataContext._hasChild) {
                        if (dataContext._collapsed) {
                            value = spacer + " <div class='toggle expand'>&nbsp;&nbsp;</div><div class=" + iconClass + " title=" + iconTitle + " ></div><span title='" + value + "'>" + value + "</span>";
                        }
                        else {
                            value = spacer + " <div class='toggle collapse'></div><div class=" + iconClass + " title=" + iconTitle + " ></div><span title='" + value + "'>" + value + "</span>";
                        }
                    }
                    else {
                        value = spacer + " <div class='toggle tggempty'></div><div class=" + iconClass + " title=" + iconTitle + " ></div><span title='" + value + "'>" + value + "</span>";
                    }
                }
                else {
                    value = "<span title='" + value + "'>" + value + "</span>";
                }
                return value;
            };

            self.pagedList.pageSize = $.inArray(pageSize, self.options.paging.pageSizes) > -1 ? pageSize : self.options.paging.pageSizes[0];
            self.fields = getColumns(self.options.schema);

            function getColumns(fields) {
                var columnList = [];
                var isArray = $.isArray(fields);
                _.each(fields, function (value, key) {
                    var field = isArray ? value.id : key;
                    if ($.inArray(field, self.options.grid.hiddenColumns) > -1) return;
                    var column = {
                        id: field,
                        root: (self.options.grid.nested.enable && columnList.length == 0),
                        name: value.title,
                        field: field,
                        type: value.dataType,
                        prefix: value.prefix,
                        decimalPoint: value.decimalPoint || 0,
                        toolTip: value.description || value.title,
                        sortable: true,
                        minWidth: 16,
                        width: value.width,
                        formatter: formatter,
                        cssClass: getClass(value.dataType),
                        headerCssClass: getClass(value.dataType)
                    };
                    columnList.push(column);
                });

                // Modified by Assyst (Rony at 07-Feb-2014)    
                // For text align based on data type
                /******************************************/
                function getClass(type) {
                    var className = '';
                    switch (type) {
                        case 'number':
                        case 'numeric':
                        case 'integer':
                            className = 'align-right'
                            break;
                        case 'date':
                        case 'datetime':
                        case 'date-time':
                        case 'timestamp':
                        case 'geo':
                            className = 'align-left'
                            break;
                        default:
                            className = 'align-left'
                            break;
                    }
                    return className;
                }
                /***************End*********************/
                return columnList;
            };
        },

        render: function (event) {
            var self = this;
            var advWidget = $("#divAdvancedSearch").data("AdvanceSearch");
            var AdvancedSearchFilterCriteria = advWidget._getJsonQuery('apply');
            if (AdvancedSearchFilterCriteria == undefined) {
                $('#filterMsg').hide();
            }

            var sorting = null;
            if ($('.sortColumn').attr('id') != undefined) {
                sorting = $('.sortColumn').attr('id') + " DESC";
            }

            var postdata = {
                jsonAdvancedSearchFilterCriteria: (AdvancedSearchFilterCriteria || null),
                jtStartIndex: ((self.pagedList.pageNumber - 1) * self.pagedList.pageSize),
                jtPageSize: self.pagedList.pageSize,
                jtSorting: sorting
            }
            var callingMethod = self.options.enableJsonp ? self._jsonpcall : self._ajaxcall;
            callingMethod(
                self.options.dataURL,
                postdata,
                true, //asynchronous
                function (data) { //success
                    processData(data.Data);
                },
                function (p_request, p_status, p_error) {
                    if (window.console && window.console.log) console.log((p_error.message ? p_error.message : p_error));
                });
                                
                function processData(data) {
                    if (typeof data.Records == 'string') { data.Records = JSON.parse(data.Records); }
                    data.TotalRecordCount = self._tryParseInt(data.TotalRecordCount, 0);
                    self.pagedList.set(data.TotalRecordCount);

                    if (self.options.paging.enable) self._createPageNavigator();
                    if (self.options.grid.enable) self._createGrid(data.Records);
                    if (typeof self.options.onRecordLoad == "function") self.options.onRecordLoad(event, data);
                };
        },

        search: function (text) {
            var self = this;
            self.searchText = text;
            self.dataView.beginUpdate();
            self.dataView.setFilterArgs({ records: self.records, searchText: self.searchText });
            self.dataView.endUpdate();
            self.grid.render();
        },

        show: function () {
            // If the div is hidden, SlickGrid will calculate wrongly some
            // sizes so we must render it explicitly when the view is visible
            if (!this.rendered) {
                if (!this.grid) {
                    this.render();
                }
                this.grid.init();
                this.rendered = true;
            }
        },

        redrow: function () {
            // If the div is hidden, SlickGrid will calculate wrongly some
            // sizes so we must render it explicitly when the view is visible
            if (!this.grid) {
                return;
            }
            this.render();
        },

        _personalize: function () {
            var self = this;
            var $element = $(self.element);

            $element.on('click', 'button.page-navigator', function (event) {
                self.pagedList.pageNumber = self._tryParseInt($(this).attr("pageindex"), 1);
                self.options.grid.options.explicitInitialization = false;
                self.render("paging");
            });

            $element.on('change', 'select.jtable-pagination-dropdown', function (event) {
                self.pagedList.pageNumber = self._tryParseInt($(this).val(), 1);
                self.options.grid.options.explicitInitialization = false;
                self.render("paging");
            });

            $element.on('change', 'select.jtable-page-size-dropdown', function (event) {
                self.pagedList.pageSize = self._tryParseInt($(this).val(), 5);
                if (((self.pagedList.pageNumber - 1) * self.pagedList.pageSize) > self.pagedList.itemCount) self.pagedList.pageNumber = 1;
                self.options.grid.options.explicitInitialization = false;
                self.render("paging");
            });

            $element.on('click', 'span.cust-button', function (event) {
                var buttonId = $(this).attr("id");
                var elements = $.grep(self.options.buttons, function (element, index) {
                    return element.id == buttonId;
                });

                if (elements.length == 0) return false;
                var button = elements[0];
                if (typeof button.click == "function") button.click(event);
            });
        },

        _createButtons: function (data) {
            var self = this;
            var $container = $(self.element).find("div.button-container");
            $container.empty();
            var template = '{{#buttons}}<span class="jtable-add-record jtable-include-split-btn cust-button {{cssClass}}" title="{{title}}" id="{{id}}">' +
            '<a href="#" class="ui-corner-all _lngTrans_Translatable add-new-record">{{text}}</a></span>{{/buttons}}';

            var tmplData = { buttons: self.options.buttons };
            var buttonsHtml = Mustache.render(template, tmplData);
            $container.html(buttonsHtml);
        },

        _deleteRecordFromServer: function ($row, success, error, url, self, rowIndex) {
            var self = this;
            postData = $row;
            self._performAjaxCall(
                (url || self.options.actions.deleteAction),
                postData,
                true, function (data) { //success
                    //Check for errors
                    if (data.Result != 'OK') {
                        if (error) {
                            error(data.Message);
                        }

                        return;
                    }

                    if (success) {
                        success(data);
                        self.render();
                        //grid.deleteItem(rowIndex);
                    }
                }, function () {
                    if (error) {
                        error(self.options.messages.serverCommunicationError);
                    }
                }, self, rowIndex);
        },

        /* COMMON METHODS *******************************************************/

        /* Performs an AJAX call to specified URL.
        *************************************************************************/
        _performAjaxCall: function (url, postData, async, success, error, self, rowIndex) {
            $.ajax({
                url: url,
                type: 'POST',
                dataType: 'json',
                data: postData,
                async: async,
                success: function (data) {
                    var d = self.grid.getData().getItem(rowIndex);
                    if (d != null && d != 'undefined') {
                        self.dataView.deleteItem(d.CatalogId);
                        self.grid.invalidate();
                        self.grid.updateRowCount();
                        self.render();
                    }
                    success(data);
                },
                error: function () {
                    error();
                }
            });
        },

        _createGrid: function (data) {
            var self = this;
            var $container = $(self.element).find("div.grid-container").empty();
            function myFilter(item, args) {
                if (args.searchText && $.trim(args.searchText).length > 0) {
                    var filterText = args.searchText;
                    //matching search text with catelognames.toLowerCase() is to make search non case sensitive
                    var hasFilter = String(item.Name.toLowerCase()).indexOf(filterText.toLowerCase()) >= 0 || String(item.CatalogTypeName).indexOf(filterText) >= 0 || String(item.UserName).indexOf(filterText) >= 0 || String(item.UpdatedDate).indexOf(filterText) >= 0 || String(item.CategoryName).indexOf(filterText) >= 0 || String(item.Tags).indexOf(filterText) >= 0 || String(item.Description).indexOf(filterText) >= 0; ;
                    if (!hasFilter) return false;
                }
                if (item._parent != 0) {
                    var parent = _.findWhere(args.records, { _id: item._parent });
                    while (parent) {
                        if (parent._collapsed) { return false; }
                        parent = _.findWhere(args.records, { _id: parent._parent });
                    }
                }
                return true;
            }
            self.records = self.options.grid.nested.enable ? normalize(data) : data;

            // initialize the model
            self.dataView = new Slick.Data.DataView({ inlineFilters: true });
            self.dataView.beginUpdate();
            self.dataView.setItems(self.records, self.options.grid.nested.id);
            self.dataView.setFilterArgs({ records: self.records, searchText: self.searchText });
            self.dataView.setFilter(myFilter);
            _.each(self.dataView.getItems(), function (val, i) {
                val._collapsed = false;
            });
            self.dataView.endUpdate();
            // initialize the grid
            self.grid = new Slick.Grid($container, self.dataView, self.fields, self.options.grid.options);

            if (data.length == 0 && $("#content_2").hasClass('jTableHasData') != true && (defaultLoad == "0" || defaultLoad == '')) {
                $('#content_2').html("<div class=\"messageDivCatalog\"><div class='warningMessage'>Welcome to PanBI.  Please upload your data using “Connect Data” or view our tutorial videos for a step by step guide on using PanBI.</div><span id=\"videoIconNew\" class=\"ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only\" >Watch Video</span></div>");
                $(".spnGrid").trigger("click");
                $(".menuConnectData").trigger("click");
            }
            else {
                $('#content_2').addClass('jTableHasData');
            }

            self.grid.setSelectionModel(new Slick.RowSelectionModel({ selectActiveRow: true }));
            self.grid.onClick.subscribe(function (e) {
                var cell = self.grid.getCellFromEvent(e);
                //console.log(cell.row); //Here is the row id, I want to change this row background color
                self.grid.setSelectedRows([cell.row]);
                //e.stopPropagation();
            });

            self.grid.onSelectedRowsChanged.subscribe(function (e, args) {
                //alert(e);

            });
            self.grid.onClick.subscribe(function (e, args) {
                if ($(e.target).hasClass("toggle")) {
                    var item = self.dataView.getItem(args.row);
                    if (item) {
                        if (!item._collapsed) {
                            item._collapsed = true;
                        } else {
                            item._collapsed = false;
                        }

                        self.dataView.updateItem(item._id, item);
                    }
                    e.stopImmediatePropagation();
                    $(".slick-row").hover(function () {
                        $(".slick-row").unbind("hover");
                        $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
                        $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
                        $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
                    });
                    $(".slick-row").mouseout(function () {
                        $(".slick-row").unbind("mouseout");
                        $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
                        $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
                        $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
                    });
                }
            });


            // wire up model events to drive the grid
            self.dataView.onRowCountChanged.subscribe(function (e, args) {
                self.grid.updateRowCount();
                self.grid.render();
            });

            self.dataView.onRowsChanged.subscribe(function (e, args) {
                self.grid.invalidateRows(args.rows);
                self.grid.render();
            });

            self.grid.onCellChange.subscribe(function (e, args) {
                self.dataView.updateItem(args.item.id, args.item);
            });

            self.grid.onSort.subscribe(function (e, args) {
                var cols = args.sortCols;
                args.grid.getData().sort(function (dataRow1, dataRow2) {
                    for (var i = 0, l = cols.length; i < l; i++) {
                        var field = cols[i].sortCol.field;
                        var sign = cols[i].sortAsc ? 1 : -1;
                        var value1 = dataRow1[field], value2 = dataRow2[field];
                        var result = (value1 == value2 ? 0 : (value1 > value2 ? 1 : -1)) * sign;
                        if (result != 0) {
                            return result;
                        }
                    }
                    return 0;
                });
                self.grid.invalidate();
                self.grid.render();
            });


            self.grid.onAddNewRow.subscribe(function (e, args) {
                var item = {
                    /*"id": "new_" + (Math.round(Math.random() * 10000)),
                    "indent": 0,
                    "title": "New task",
                    "duration": "1 day",
                    "percentComplete": 0,
                    "start": "01/01/2009",
                    "finish": "01/01/2009",
                    "effortDriven": false*/
                };
                $.extend(item, args.item);
                self.dataView.addItem(item);
            });
            function normalize(p_data, p_indent) {
                var v_records = [];
                p_indent = p_indent || 0;

                _.each(p_data, function (value, idx) {

                    var metta = {
                        _indent: p_indent,
                        _hasChild: (value.Children && value.Children.length > 0),
                        _id: value[self.options.grid.nested.id],
                        _parent: value[self.options.grid.nested.parent],
                        _collapsed: true,
                        Children: undefined
                    };

                    v_records.push($.extend(true, {}, value, metta));
                    if (metta._hasChild) {
                        var children = normalize(value.Children, p_indent + 1)
                        $.merge(v_records, children);
                    }
                });
                return v_records;
            }

        },

        _createPageNavigator: function () {
            var self = this;
            var $container = $(self.element).find("div.paging-container");
            var template = '<span class="jtable-page-list">' +
            '{{#pageInfo}}' +
                '<span class="jtable-page-info">' +
                    '<span class="_lngTrans_Translatable">Showing</span>' +
                    '<span>&nbsp;{{from}}&nbsp;</span>' +
                    '<span class="_lngTrans_Translatable">to</span>' +
                    '<span>&nbsp;{{to}}&nbsp;</span>' +
                    '<span class="_lngTrans_Translatable">of</span>' +
                    '<span>&nbsp;{{itemCount}}&nbsp;</span>' +
                    '<span class="_lngTrans_Translatable">records</span>' +
                '</span>' +
            '{{/pageInfo}}' +

            '{{#hasPreviousPage}}' +
                '<span>' +
                    '<button class="jtable-page-number-first page-navigator" name="first" pageindex="1" >|&lt;</button>' +
                    '<button class="jtable-page-number-previous page-navigator"  name="previous"  pageindex="{{prevPageIndex}}">&lt;</button>' +
               ' </span>' +
            '{{/hasPreviousPage}}' +

            '<span></span>' +

            '<span class="jtable-page-text _lngTrans_Translatable" style="float:left;">Page :</span>' +
            '<select class="jtable-pagination-dropdown">' +
                '{{#pages}}' +
                    '<option value="{{value}}" class="_lngTrans_Translatable" {{#selected}}selected{{/selected}}>{{value}}</option>' +
                '{{/pages}}' +
            '</select>' +

            '<span class="jtable-page-text _lngTrans_Translatable" style="float:left;">Page Size :</span>' +
            '<select class="jtable-page-size-dropdown">' +
                '{{#pageSize}}' +
                    '<option value="{{value}}" class="_lngTrans_Translatable" {{#selected}}selected{{/selected}}>{{value}}</option>' +
                '{{/pageSize}}' +
            '</select>' +

            '{{#hasNextPage}}' +
                '<span>' +
                    '<button class="jtable-page-number-next page-navigator" pageindex="{{nextPageIndex}}">&gt;</button>' +
                    '<button class="jtable-page-number-last page-navigator" pageindex="{{pageCount}}">&gt;|</button>' +
                '</span>' +
            '{{/hasNextPage}}' +
                '<span></span>' +
            '</span>';

            var pages = [];
            var pageSize = [];
            var pagedList = self.pagedList;

            _.each(self.options.paging.pageSizes, function (size, idx) {
                pageSize.push({ value: size, selected: (size == pagedList.pageSize) });
            });
            var start = 1;
            var max = pagedList.pageCount;
            if (pagedList.pageCount > 100) {
                if ((pagedList.pageNumber + 100) >= pagedList.pageCount) {
                    start = pagedList.pageCount - 100;
                    max = pagedList.pageCount
                }
                else if (pagedList.pageNumber > 50) {
                    start = pagedList.pageNumber - 50;
                    max = start + 100;
                }
                else max = 100;
            }


            for (idx = start; idx <= max; idx++) {
                pages.push({ value: idx, selected: (idx == pagedList.pageNumber) });
            }

            var pageConfig = {
                pageInfo: (self.options.paging.showItemCount && pagedList.itemCount > 0),
                from: (pagedList.isFirstPage ? 1 : ((pagedList.pageNumber - 1) * pagedList.pageSize) + 1),
                to: (pagedList.isLastPage ? pagedList.itemCount : (pagedList.pageNumber * pagedList.pageSize)),
                prevPageIndex: (pagedList.pageNumber - 1),
                nextPageIndex: (pagedList.pageNumber + 1),
                pages: pages,
                pageSize: pageSize
            };
            var tmplData = $.extend(true, {}, pagedList, pageConfig);
            var pagingHtml = Mustache.render(template, tmplData);
            $container.empty().html(pagingHtml);
        },

        /* Parse to int value.
        *************************************************************************/
        _tryParseInt: function (value, defaultValue) {
            var retValue = defaultValue;
            var value = $.trim(value);
            if (value.length > 0 && !isNaN(value)) {
                retValue = parseInt(value);
            }
            return retValue;
        },

        /* Performs an AJAX call to specified URL.
        *************************************************************************/
        _ajaxcall: function (url, postData, async, success, error) {
            $.ajax({
                url: url,
                type: 'POST',
                dataType: 'json',
                data: postData,
                async: async,
                success: function (data) {
                    if (data && typeof data == "string") data = JSON.parse(data);
                    success(data);
                },
                error: function () {
                    error();
                }
            });
        },

        /* Performs an JSONP call to specified URL.
        *************************************************************************/
        _jsonpcall: function (url, postData, async, success, error) {
            $.jsonp({
                url: url,
                callbackParameter: "callback",
                data: postData,
                cache: false,
                success: function (data) {
                    if (data && typeof data == "string") data = JSON.parse(data);
                    success(data);
                },
                error: function (xOptions, textStatus) {
                    error();
                }
            });
        },

        createAVButton: function () {
            var self = this;
            self.sidePanelContainer.empty();
            var jtableSideViewAnalyticsVisulizerTab = $('<div class="jtableSideViewAnalyticsVisulizerTab">' +
                            '<div id="jtableSideViewOppTab">' +
                            '<div>' +
                            '<div class="filter-CommentTab_Analytics"><span class="analyzeAImg"></span><span class="analytic-visulizer">Analyze</span></div>' +
                            '<div class="filter-CommentTab_Visulizer"><span class="analyzeVImg"></span><span class="analytic-visulizer">Visualize</span></div>' +
                            '<span class="filter-CommentTab_Edit"><span class="analyzeEImg"></span><div class="analytic-visulizer">Manage</div></span>' +
                            '</div></div>');
            self.sidePanelContainer.append(jtableSideViewAnalyticsVisulizerTab);
            $('#divSideBySideView').append(self.sidePanelContainer);
            $("#divSideBySideView").removeClass('closed-state').addClass('open-state');
            $('.PanBI-main-data-container').removeClass('open').addClass('closed');
        },

        createEdit: function () {
            var self = this;
            $('#divSideBySideView').append(self.sidePanelContainer);
            $("#divSideBySideView").removeClass('closed-state').addClass('open-state');
            $('.PanBI-main-data-container').removeClass('open').addClass('closed');
        },

        createAppend: function () {
            var self = this;
            $('#divSideBySideView').append(self.sidePanelContainer);
            $("#divSideBySideView").removeClass('closed-state').addClass('open-state');
            $('.PanBI-main-data-container').removeClass('open').addClass('closed');
        },

        createCSTemplate: function (selectedData) {
            var self = this;
            $('.collaborateContainer').remove();
            var collaborateContainer = $('<div class="collaborateContainer"></div>');

            var collaborateTab = $('<div class="collaborate">Collaborate</div>').
                click(function (e) {
                    if ($(this).hasClass('toggler')) {
                        $(this).parents('.collaborateContainer').find('.tabContainer').hide();
                    }
                    else {
                        $(this).parents('.collaborateContainer').find('.tabContainer').show();
                        $(this).parents('.collaborateContainer').find('.commentTab').trigger('click');
                    }
                    $(this).toggleClass('toggler');
                    e.preventDefault();
                });

            var tabContainer = $('<div class="tabContainer commentShareDiv"></div>');

            var commentTab = $('<div class="commentTab">Comment</div>').click(function () {
                $(this).parents('.collaborateContainer').find('.active').removeClass('active');
                $(this).addClass('active');
                $('.commentBodyContent').show().collaborate({
                    catalogId: selectedData[0].CatalogId
                });
                $('.shareBodyContent').hide();
            });

            var shareTab = $('<div class="shareTab">Share</div>').click(function () {
                $(this).parents('.collaborateContainer').find('.active').removeClass('active');
                $(this).addClass('active');
                $('.shareBodyContent').show().shareCollaborate({
                    catalogId: selectedData[0].CatalogId
                });
                $('.commentBodyContent').hide();
            });

            collaborateContainer.empty().append(collaborateTab);
            tabContainer.append(commentTab);
            tabContainer.append(shareTab);
            tabContainer.append($('<div class="commentBodyContent"></div><div class="shareBodyContent"></div>'));
            collaborateContainer.append(tabContainer);
            self.sidePanelContainer.append(collaborateContainer);
        }
    });
})(jQuery);


var shareFlag = false, shareCountFlag = 0;

$(".slick-row").unbind("click");
$(".slick-row").off("click");
$(document).on("click", "#content_2 .slick-row", function (e) {
    if ($('.visuzlize-header').length == 0 && $('.analyzeHeader').length == 0) {
        var self = $("#content_2").data("CatalogViewer");
        if (self.grid) self.grid.resizeCanvas();
        var selectedData = [];
        e.stopPropagation();
        var $row = this;
        //hiding advanced search while clicking row 
        $('button[title="Save this criteria"]').css('pointer-events', 'none');
        $('.filtericon-div').parent('.filterIcon').next('#filterMsg').length > 0 ? $('.filtericon-div').parent('.filterIcon').next('#filterMsg').hide() : "";
        if ($('.filter-data-form').css('display') == "block") {
            $('.filtericon-div').removeClass('filtericon-div-click-up');
            $('.filter-data-form').hide('slow');
            $('.filter-button-panel').hide('slow');
            $('.filter-form-container').removeClass('bg');
            $('#divSimpleSearch').css("margin-top", "-20px");
            $(".filter-form-container").removeClass("contentDown");
            $(".jtable-main-container").removeClass("active");
            $(".jtable-main-container").css('height', 'auto');
        }

        if ($($row).hasClass('slick-grid-selected')) {
            $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
            $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
            $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
            $(this).hover(function () {
                $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
                $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
                $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            });
            $(this).mouseout(function () {
                $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
                $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
                $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
            });
            $($row).removeClass('slick-grid-selected');
            $("#divSideBySideView").removeClass('open-state').addClass('closed-state');
            $('.PanBI-main-data-container').removeClass('closed').addClass('open');
        }
        else {
            $(".slick-row").find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
            $(".slick-row").find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
            $(".slick-row").find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');

            $(this).unbind("hover");
            $(this).unbind("mouseout");
            $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            $(".appendDataForm").remove();
            $('.slick-row').removeClass('slick-grid-selected');
            $($row).addClass('slick-grid-selected');
            var selectedIndexes;
            selectedIndexes = self.grid.getSelectedRows();
            jQuery.each(selectedIndexes, function (index, value) {
                selectedData.push(self.grid.getDataItem(value));
            });
            self.createAVButton(); //creating analyze and visualize buttons
            if ($('.headColor').hasClass('noClick')) {
                $('.headColor').toggleClass('noClick', 'slow');
                $('.filter-master-control-container').toggleClass('noClickSearch', 'slow');
            }
            self.createCSTemplate(selectedData); //creating comment and share template

            //disble share if not shareable
            if (!selectedData[0].Shareable) {
                $('.shareTab').addClass('disableMenu');
            }

            if (selectedData[0].CatalogTypeName == "Dashlet") {
                $('.filter-CommentTab_Analytics').hide();
                $(".slick-grid-selected").dblclick(function () {
                    window.location = "/BI/MISViewer/Index?misID=" + selectedData[0].CatalogId + "&fromCatalogViewer=" + selectedData[0].ParentCatalogId;
                });
            }
            else {
                $('.filter-CommentTab_Analytics').show();
            }

            if (selectedData[0].CatalogTypeName == "Dataset") {
                $('.filter-CommentTab_Edit').show();
            }
            else {
                $('.filter-CommentTab_Edit').hide();
            }

            $('.filter-CommentTab_Analytics').click(function () {
                window.location = "/BI/DataViewer/Index?CatalogId=" + selectedData[0].CatalogId;
            });
            $('.filter-CommentTab_Visulizer').click(function () {
                location.href = "/BI/MISViewer/Index?misID=" + selectedData[0].CatalogId + "&fromCatalogViewer=" + selectedData[0].ParentCatalogId;
            });
            $('.filter-CommentTab_Edit').click(function () {
                window.location = "/BI/DataEditor/Index?CatalogId=" + selectedData[0].CatalogId;
            });

            if (selectedData[0].Comments == null || selectedData[0].Comments == '[]') { }
            else {
                $('.collaborateContainer').find('.collaborate').trigger('click');
                $('.collaborateContainer').find('.commentTab').trigger('click');
            }
        }
    }
    setTimeout(function () {
        self.grid.resizeCanvas();
    }, 510);
});

$(".panbi-catalog-visulize-icon").unbind("click");

$(document).on("click", ".panbi-catalog-visulize-icon", function (e) {
    var self = $("#content_2").data("CatalogViewer");
    $('#getDataPartialView').show();
    //Code for Append functionality  
    e.stopPropagation();
    e.preventDefault();
    var $rows = this;
    $('.slick-row').removeClass('slick-grid-selected');
    $($rows).parents('.slick-row').addClass('slick-grid-selected');
    $('.slick-row').find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
    $('.slick-row').find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
    $('.slick-row').find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');

    $('.slick-grid-selected').find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $('.slick-grid-selected').find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $('.slick-grid-selected').find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    var selectedData = [],
                        selectedIndexes;
    selectedIndexes = self.grid.getSelectedRows();
    jQuery.each(selectedIndexes, function (index, value) {
        selectedData.push(self.grid.getDataItem(value));
    });
    self.createAppend();
    $(".appendDataForm").remove();
    var _appendData = $('<div class="appendDataForm" style="display:block;margin-left: 28px;margin-top: 20px;"></div>');
    $('<div>Append Data</div>').appendTo(_appendData);
    var _appendFormDiv = $('<div style="margin-top:10px;"></div>');
    $('<iframe src="about:blank" frameborder="0" scrolling="no" style="height: 10px; display: none;margin-top:10px;" id="ifrmjTableFileAppend" name="ifrmjTableFileUpload"></iframe>').appendTo(_appendData);
    var _formApp = $('<form id="formGetAppendData" action="/BI/DataImport/Create" method="POST" enctype="multipart/form-data" target="ifrmjTableFileUpload" class="connectData"></form>');
    $('<input type="hidden" class="ui-corner-all bi-previewer-input" id="appendRecords" name="Records" value="">').appendTo(_formApp);
    $('<input type="hidden" class="ui-corner-all bi-previewer-input" id="schema" name="schema" value=\'' + selectedData[0].Schema + '\'>').appendTo(_formApp);
    $('<input type="hidden" class="ui-corner-all bi-previewer-input" id="Name" name="Name" value="">').appendTo(_formApp);
    $('<input type="hidden" class="ui-corner-all bi-previewer-input" id="CatalogID" name="CatalogID" value="' + selectedData[0].CatalogId + '">').appendTo(_formApp);
    $('<input type="hidden" class="ui-corner-all bi-previewer-input" id="Description" name="Description" value="' + selectedData[0].Description + '">').appendTo(_formApp);
    $('<input class="ui-corner-all bi-previewer-input" type="file" value="Upload File" id="appendFileImport" name="appendFileImport" onchange="loadFile(event,\'formGetAppendData\')" />').appendTo(_formApp);
    $('<div class="jtable-input-field-container file-extension-err-msg" style="display: none;">' +
            '<p style="color:red">File extension should be .xlx, xlsx or csv</p>' +
       '</div>' +
       '<div class="jtable-input-field-container connect-data-input file-empty-err-msg" style="display: none;">' +
            '<p style="color:red">File should not be empty</p>' +
       '</div>').appendTo(_formApp);
    $('<button type="submit" style="display: none;" id="btnSaveAppendData" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only btnExcelValidator" title="Save" role="button" aria-disabled="false">' +
                                    '<span class="ui-button-text">Save</span>' +
                                '</button>').appendTo(_formApp);
    _formApp.appendTo(_appendFormDiv);
    _appendFormDiv.appendTo(_appendData);
    $('#divSideBySideView').find('.sidePanelContainer').empty().append(_appendData);
    //_app.SidePanel.show(self.grid);
    $('#jtableSideViewAnalyticsVisulizerTab').hide();
    //$('.collaborate').hide();
    $('#jtableSideViewCommentShareTab').hide();
    $('#jtableSideViewEditTab').hide();

    $('.jtable').find('.jtable-command-button').css('visibility', 'hidden');
    $('.jtable').find('.jtable-row-selected').removeClass('jtable-row-selected');

    $(this).parent().parent().addClass('jtable-row-selected');
    $('.appendDataForm').show();
    setTimeout(function () {
        self.grid.resizeCanvas();
    }, 510);
});

var allData = [];
$(document).on("keyup", ".filter-simple-search-input", function (e) {
    var self = $("#content_2").data("CatalogViewer");
    var filterText = $(".filter-simple-search-input").val();
    self.search(filterText);
});
$(document).on("click", ".panbi-catalog-delete-icon", function (e) {
    var self = $("#content_2").data("CatalogViewer");
    e.stopPropagation();
    var $rows = this;
    $('.slick-row').removeClass('slick-grid-selected');
    $($rows).parents('.slick-row').addClass('slick-grid-selected');
    $('.slick-row').find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
    $('.slick-row').find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
    $('.slick-row').find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');

    $('.slick-grid-selected').find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $('.slick-grid-selected').find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $('.slick-grid-selected').find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    var $panel = _app.SidePanel;
    var selectedData = [],
                        selectedIndexes;
    selectedIndexes = self.grid.getSelectedRows();
    jQuery.each(selectedIndexes, function (index, value) {
        selectedData.push(self.grid.getDataItem(value));
    });
    var selectedindex = selectedData[0];

    $("#dialog-confir").html(g_LangTranslator.Translate('Are you sure you want to delete the selected record from Catalog?'));
    $("#dialog-confir").data('object', self).dialog({
        resizable: false,
        modal: true,
        height: "180",
        width: "auto",
        draggable: false,
        close: function () { $(this).dialog('destroy'); },
        dialogClass: "message warning-dialog custom-style no-titlebar",
        buttons: {
            Delete: function () {
                self._deleteRecordFromServer(
                    selectedData[0], function (selectedindex) {
                        //self._removeRowsFromTableWithAnimation(self._$deletingRow);
                    }, function (message) {
                        $("#dialog-confir").html(message);
                        $("#dialog-confir").data('object', self).dialog({
                            resizable: false,
                            modal: true,
                            height: "170",
                            width: "auto",
                            draggable: false,
                            close: function () { $(this).dialog('destroy'); },
                            dialogClass: "message error-dialog custom-style no-titlebar",
                            buttons: {
                                close: function () {
                                    $(this).dialog('destroy');
                                }

                            }
                        });
                    }, self.options.actions.deleteAction, self, selectedIndexes[0]);
                $(this).dialog('destroy');
            },
            Cancel: function () {
                $(this).dialog('destroy');
            }
        }
    });
});

$(document).on("hover", ".slick-row", function (e) {
    $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
});

$(document).on("mouseout", ".slick-row", function (e) {
    if (!$(this).hasClass("slick-grid-selected")) {
        var $overRow = this;
        $(this).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
        $(this).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
        $(this).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');

        $(this).find(".slick-cell,.panbi-catalog-edit-icon,.panbi-catalog-delete-icon,.panbi-catalog-visulize-icon").hover(function () {
            $($overRow).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            $($overRow).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            $($overRow).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
        });
        $(this).find(".slick-cell,.panbi-catalog-edit-icon,.panbi-catalog-delete-icon,.panbi-catalog-visulize-icon").mouseout(function () {
            $($overRow).find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            $($overRow).find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
            $($overRow).find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
        });
    }
});
$(".panbi-catalog-edit-icon").unbind("click");
$(document).on("click", ".panbi-catalog-edit-icon", function (e) {
    var self = $("#content_2").data("CatalogViewer");
    //Code for Append functionality  
    e.stopPropagation();
    e.preventDefault();
    var $rows = this;
    $('.slick-row').removeClass('slick-grid-selected');
    $($rows).parents('.slick-row').addClass('slick-grid-selected');
    $("#divSideBySideView").removeClass('closed-state').addClass('open-state');
    $('.PanBI-main-data-container').removeClass('open').addClass('closed');
    $('.editContainer').remove();

    $('.slick-row').find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
    $('.slick-row').find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');
    $('.slick-row').find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-show').addClass('slick-grid-icon-hide');

    $('.slick-grid-selected').find('.panbi-catalog-edit-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $('.slick-grid-selected').find('.panbi-catalog-delete-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');
    $('.slick-grid-selected').find('.panbi-catalog-visulize-icon').removeClass('slick-grid-icon-hide').addClass('slick-grid-icon-show');

    var selectedData = [], selectedIndexes;
    selectedIndexes = self.grid.getSelectedRows();
    jQuery.each(selectedIndexes, function (index, value) {
        selectedData.push(self.grid.getDataItem(value));
    });
    $('#jtableSideViewCommentShareTab').hide();
    $('.appendDataForm').hide();

    if (selectedData[0].CatalogTypeId == _app.catalogType.External) {
        _app.notify({
            title: 'External Catalog',
            type: 'notice',
            text: 'You cannot rename the External catalogs.',
            delay: 3000
        });
    }
    else {
        self.createEdit();
        catalogEdit.showSaveAs({
            Name: { value: selectedData[0].Name },
            Tags: { value: (selectedData[0].Tags != null) ? selectedData[0].Tags : '' },
            CategoryId: { value: selectedData[0].CategoryId },
            Description: { value: (selectedData[0].Description != null) ? selectedData[0].Description : '' },
            CatalogId: { value: selectedData[0].CatalogId },
            CreateNew: { value: 0 }
        });
    }
    setTimeout(function () {
        self.grid.resizeCanvas();
    }, 510);
});
$(document).on("click", ".submitbtn", function (e) {
    _saveDVForm();
    var self = $("#content_2").data("CatalogViewer");
    $("#divSideBySideView").removeClass('open-state').addClass('closed-state');
    $('.PanBI-main-data-container').removeClass('closed').addClass('open');
    setTimeout(function () {
        self.grid.resizeCanvas();
    }, 510);
});
$(document).on("click", ".cancelbtn", function (e) {
    var self = $("#content_2").data("CatalogViewer");
    $("#divSideBySideView").removeClass('open-state').addClass('closed-state');
    $('.PanBI-main-data-container').removeClass('closed').addClass('open');
    setTimeout(function () {
        self.grid.resizeCanvas();
    }, 510);
});
