﻿(function ($) {
    //Create widget for slick grid data viewer object
    var groupItemMetadataProvider = new Slick.Data.GroupItemMetadataProvider();
    var headerButtonsPlugin = new Slick.Plugins.HeaderButtons();
    $.widget('Assyst.slickGridFormula', {
        //Default values for options
        options: {
            data: undefined,
            columns: undefined,
            gridOptions: undefined,
            group: undefined,
            formulaGrid: true,
            grandTotal: true,
            contextMenu: true,
            callback: undefined
        },

        _create: function () {
            var self = this;
            self.createGrid();
            //Condition to avoid Add formula option from dashboard
            if (self.options.formulaGrid)
                self.createContextMenu();
        },

        createGrid: function () {
            var self = this;
            var totalData;
            var data = _appFun.getAlaSQL(self.options.columns, self.options.data.getItems());
            for (var i = 0; i < self.options.columns.length; ++i) {
                if (self.options.columns[i].formula) {
                    var temp = self.options.columns[i];
                    var position = self.options.columns.getIndexBy("id", temp.formula.positionId); //positon of the selected field
                    self.options.columns.splice(position + 1, 0, temp);
                    self.options.columns.splice(i + 1, 1);
                }
            }
            if (self.options.grandTotal) {
                totalData = new TotalsDataView(data, self.options.columns);
            }
            else {
                _.each(data, function (val, i) {
                    val["idx"] = i;
                })

                self.options.data.setItems(data, 'idx');
                totalData = self.options.data;
            }

            //setting height for grid while aggregating it
            if ($('.data-view-container').length > 0 && !self.options.grandTotal)
                self.element.height($('.data-view-container').height());

            self.grid = new Slick.Grid(self.element, totalData, self.options.columns, self.options.gridOptions);

            if (!self.options.grandTotal) {
                var pager = new Slick.Controls.Pager(totalData, self.grid, $("#pager"));
            }
            headerButtonsPlugin.onCommand.subscribe(function (e, args) {
                var column = args.column;
                var button = args.button;
                var command = args.command;
                var position, positionId;

                var expBuilderFormat = $.map(self.options.columns, function (value, i) {
                    if (value.isHidden == 'N' && value.type == "numeric" || value.type == "number" || value.type == "date-time" || value.type == "date") {
                        if (value.id != column.id) return { DisplayText: value.name.replace(/ /g, '').replace("(sum)", "").replace("(max)", "").replace("(min)", "").replace("(avg)", "").replace("(count)", ""), Value: value.id, format: value.format, formula: value.formula };
                        else {
                            position = i;
                            positionId = value.id;
                        }
                    }
                });
                $(e.target).append('<div class="preview1"></div>');
                //Condition to avoid edit formula option from dashboard
                if (self.options.formulaGrid) {
                    $('.preview1').ExpressionBuilder({
                        Variables: expBuilderFormat,
                        createName: {
                            show: true,
                            label: column.name,
                            percentage: column.formula.percentage
                        },
                        FormulaFn: column.formula.label,
                        FormulaFieldEquation: column.formula.label,
                        dialog: { title: column.name }
                    }).click();
                }
                $("#ebOperators #dateSelect").val(column.formula.dateOp.operation); //In edit mode Displays Date selector
                $("#ebOperators #dateOperations  #" + column.formula.dateOp.operation).val(column.formula.dateOp.key);
                $("#ebOperators #dateOperations  #" + column.formula.dateOp.operation).show();
                $('#ebDialogue_div').on('ebComplete', function (event, equationData) {
                    if (equationData.label == "") {
                        _app.notify({
                            title: 'Error',
                            type: 'error',
                            text: 'Please enter a valid equation',
                            delay: 2000
                        });
                        return false;
                    }
                    else {
                        var deletedItem;
                        _.each(self.options.columns, function (val, i) {
                            if (val.id == column.id) {
                                deletedItem = val;
                                self.options.columns.splice(i, 1);
                            }
                        });
                        $.extend(true, equationData, { position: deletedItem.formula.position, positionId: deletedItem.formula.positionId });
                        if (self.options.callback) self.options.callback(self.createNewSchema(equationData, column.id), "edit", _appFun.getAlaSQL(self.options.columns, self.options.data.getItems()));
                        _app.notify({
                            title: 'Success',
                            type: 'Success',
                            text: 'Successfully Updated',
                            delay: 2000
                        });
                        return true;
                    }
                });
            });
            self.grid.registerPlugin(headerButtonsPlugin);
            self.grid.registerPlugin(groupItemMetadataProvider);
            self.grid.setSelectionModel(new Slick.CellSelectionModel());
        },
        render: function () {
            var self = this;
            for (var i = 0; i < self.options.columns.length; ++i) {
                if (self.options.columns[i].formula) {
                    var temp = self.options.columns[i];
                    self.options.columns.splice(self.options.columns[i].formula.position, 0, temp);
                    self.options.columns.splice(i + 1, 1);
                }
            }

            var items = $.grep(self.options.columns, function (value, i) {
                return value.isHidden == false;
            });

            var data = _appFun.getAlaSQL(self.options.columns, self.options.data.getItems());

            if (items.length == 0) {
                _.each(self.options.columns, function (value, i) {
                    value.isHidden = false;
                });
                data = new TotalsDataView(data, self.options.columns);
                self.grid.setColumns(self.options.columns);
                self.createContextMenu();
            }
            else {
                data = new TotalsDataView(data, items);
                self.grid.setColumns(items);
            }
            self.grid.setData(data);
            self.grid.render();
            self.grid.resizeCanvas();
            var totalsPlugin = new TotalsPlugin($.getScrollbarWidth());
            self.grid.registerPlugin(totalsPlugin);
        },

        createContextMenu: function () {
            var self = this;
            var items = {};
            items["name"] = "Show/Hide Fields";
            items["icon"] = "";
            _.each(self.options.columns, function (val, i) {
                var prow = {};
                prow[val.id] = {
                    name: val.name,
                    icon: "dropdownIconsel",
                    callback: function (key, options) {
                        if (options.$selected.hasClass('cm-icon-dropdownIconsel')) {
                            options.$selected.removeClass('cm-icon-dropdownIconsel').addClass('cm-icon-dropdownIconUnsel');
                            var selected = _.findWhere(self.options.columns, { id: key });
                            selected.isHidden = true;
                        }
                        else {
                            options.$selected.removeClass('cm-icon-dropdownIconUnsel').addClass('cm-icon-dropdownIconsel');
                            var selected = _.findWhere(self.options.columns, { id: key });
                            selected.isHidden = false;
                        }

                        self.render();
                    }
                };
                items["items"] = $.extend(true, items["items"], prow);
            });
            $.contextMenu('destroy');
            $.contextMenu({
                selector: '.recline-slickgrid .slick-header-column',
                className: 'contextmenu-customwidth',
                callback: function (key, options) {
                },
                items: {
                    "addFields": {
                        name: "Add Field",
                        icon: "",
                        callback: function (key, opt) {
                            var position = $(this).attr('title');
                            var positionId = $(this).attr('title');
                            var items = $.map(self.options.columns, function (value, i) {
                                position = value.name == position ? i + 1 : position;
                                positionId = value.name == positionId ? value.id : positionId;
                                if (value.isHidden == "N" && value.type == "numeric" || value.type == "number" || value.type == "date-time" || value.type == "date") {
                                    return { DisplayText: value.name.replace(/ /g, '').replace("(sum)", "").replace("(max)", "").replace("(min)", "").replace("(avg)", "").replace("(count)", ""), Value: value.id, format: value.format, formula: value.formula };
                                }
                            });

                            $(opt.$selected).append('<div class="preview"></div>');
                            $('.preview').ExpressionBuilder({
                                Variables: items,
                                createName: {
                                    show: true,
                                    label: ""
                                },
                                dialog: { title: $('.txtFieldName').val() }
                            });

                            $('.preview').click();
                            $('#ebDialogue_div').on('ebComplete', function (event, equationData) {
                                if (equationData.name == "") {
                                    _app.notify({
                                        title: 'Error',
                                        type: 'error',
                                        text: "Please enter the name",
                                        delay: 3000
                                    });
                                    event.preventdefault();
                                }
                                else if (equationData.label == "") {
                                    _app.notify({
                                        title: 'Error',
                                        type: 'error',
                                        text: 'Please enter a valid equation',
                                        delay: 2000
                                    });
                                    event.preventdefault();
                                    return false;
                                }
                                else {
                                    $('.spnformulaGroup').attr('dt-value', JSON.stringify(equationData));
                                    $.extend(true, equationData, { position: position, positionId: positionId });
                                    var newSchema = self.createNewSchema(equationData);
                                    if (self.options.callback) {
                                        self.options.callback(newSchema, "create", _appFun.getAlaSQL(self.options.columns, self.options.data.getItems()));
                                    }
                                    _app.notify({
                                        title: 'Success',
                                        type: 'Success',
                                        text: 'Successfully Updated',
                                        delay: 2000
                                    });
                                    return true;
                                }

                            });
                        }
                    },
                    "showHideFields": items,
                    "Delete": {
                        name: "Delete",
                        icon: "",
                        disabled: getMenuStatus,
                        callback: function (key, opt) {
                            var name = $(this).find('.slick-column-name').text(); // the name of the field which we selected to delete
                            var item = _.findWhere(self.options.columns, { name: name }); //selecting the particular item which is going to delete from the grid
                            var position = self.options.columns.getIndexBy("name", name); //positon of the selected field
                            //validations on deleting related fields in calculation.
                            var hits = [];
                            var reservedWords = ['', '+', '-', '(', ')', '*', '/', ':', '?', 'if', ',', '<', '>', '<=', '>=', '==', '=', 'DATEDIFF', 'DATE360', 'DATEADD', 'DATESUB', 'days', 'months', 'years', 'US', 'EURO'];
                            _.each(self.options.columns, function (text, i) {
                                if (text.formula != null) {
                                    var words = text.formula.label.split(' ');
                                    for (var i = 0; i < words.length; i++) {
                                        if ($.inArray(words[i], reservedWords) < 0 && $.inArray(words[i], hits) < 0)
                                            hits.push(words[i]);
                                    }
                                }
                            });
                            if ($.inArray(name.replace(/ /g, ''), hits) < 0) {
                                self.options.columns.splice(position, 1); //removing the selected item from schema of fields
                                if (self.options.callback) self.options.callback(item, "delete", _appFun.getAlaSQL(self.options.columns, self.options.data.getItems()));
                            }
                            else {
                                _app.notify({
                                    title: 'Error',
                                    type: 'error',
                                    text: 'Cannot delete. Child fields exist.',
                                    delay: 2000
                                });
                            }
                        }
                    }
                }
            });

            function getMenuStatus(key, options, x) {
                var div = options.$trigger;
                if (div.find('.slick-header-button').length == 0) {
                    return true;
                }
                else return false;
            }
        },

        createNewSchema: function (equationData, edit) {
            var self = this;

            var fieldType;
            var format = self.findFormat(equationData);
            var id;
            var fieldname = edit ? edit : equationData.name;            //added a field to compare old id for deleting old field from fieldlist while updating a field 
            if (edit) {
                id = edit.replace(/ /g, '');
                id = equationData.percentage ? id.replace(/%$/, "") + '%' : id;
                equationData.format = format;
            }
            else {
                id = equationData.name.replace(/ /g, '');
                id = equationData.percentage ? id.replace(/%$/, "") + '%' : id;
            }

            var newSchema = {
                id: id,
                name: equationData.percentage ? equationData.name.replace(/%$/, "") + '%' : equationData.name,
                field: id,
                type: "numeric",
                decimalPoint: 2,
                toolTip: equationData.name,
                fieldname: fieldname,
                sortable: false,
                minWidth: 80,
                format: format,
                formula: equationData,
                formatter: slickFormatter,
                hasTotal: equationData.percentage ? false : true,
                header: {
                    buttons: [{
                        cssClass: "icon-highlight-off",
                        command: "toggle-highlight",
                        tooltip: "Derived column"
                    }]
                },
                isHidden: false,
                cssClass: "align-right",
                headerCssClass: "align-right"
            };
            return newSchema;
        },

        findFormat: function (equationData) {

            var self = this;
            if (equationData.percentage)
                return { 'category': 'Number', 'datatype': 'percent', 'locale': 'en-US', 'format': { 'style': 'percent', 'maximumFractionDigits': '2'} };
            else if (equationData.format)
                return equationData.format;
            else
                return { 'category': 'Number', 'datatype': 'Decimal', 'locale': 'en-IN', 'format': { 'minimumFractionDigits': '2', 'maximumFractionDigits': '2'} };
        },

        returnGrid: function () {
            var self = this;
            return self.grid;
        },

        returnSchema: function () {
            var self = this;
            return self.options.columns;
        }
    });
})(jQuery);