/*+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   
JQuery  widget for mis report viewer creation
Created By      : Nithin V for Assyst International Pvt. Ltd.
Created Date    : 03-March-2014
Version         : 1.0.0
Project         : PanAgro

+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+*/
var Viewer = {
    "All": 0,
    "Grid": 1,
    "Graph": 2,
    "Map": 3,
    "Timeseries": 4,
    "Pivot": 5
};
var visual = {
    Data: "Data",
    Dashlet: "Dashlet",
    Dashboard: "Dashboard",
    DashletOnView: "DashletOnView"
};
//global variable added for map resizing.
var requestPage = undefined;
"use strict";
(function ($) {
    $.widget('assyst.reclineInit', {

        options: {
            title: undefined,
            GIS: true,
            viewer: Viewer.All,
            defaultViewer: Viewer.All,
            catalog: undefined,
            minLegend: 3,
            requestPage: undefined,
            source: {
                records: undefined,
                fields: undefined,
                filters: undefined,
                axisFields: undefined,
                geoFields: undefined,
                timeSeries: undefined,
                totalRecords: undefined
            },
            views: {
                grid: {
                    show: false,
                    label: 'Grid',
                    state: {
                        gridOptions: {
                            editable: false,
                            enabledAddRow: true,
                            enableCellNavigation: true
                        },
                        hiddenColumns: undefined,
                        columnsWidth: undefined
                    }
                },
                graph: {
                    show: false,
                    label: 'Chart',
                    state: {
                        series: [],
                        graphTypes: [],
                        graphType: "multiBar",
                        group: undefined,
                        series: [],
                        showData: false,
                        enableLegend: false
                    }
                },
                pivot: {
                    show: true,
                    label: 'Pivot',
                    state: {
                        Pivot: {
                            rows: [],
                            cols: [],
                            vals: [],
                            preFilters: null,
                            sort: 'asc'
                        }
                    }
                },
                map: {
                    show: false,
                    label: 'Map',
                    state: {
                        heatField: undefined,
                        type: "Point"
                    }
                },
                timeseries: {
                    show: false,
                    label: 'Timeseries',
                    state: {
                        series: [],
                        graphTypes: [],
                        graphType: "line",
                        group: undefined,
                        compareField: undefined,
                        multipleCompare: "true",
                        series: [],
                        enableLegend: false
                    }
                },
                state: {
                    timeState: {
                        enable: false,
                        datePicker: true,
                        start: undefined, //moment("01-Jan-2014")
                        end: undefined, //moment(newDate())
                        interval: parseInt($('.timesreisGroup .timeInterval').find('select').val()),
                        field: undefined
                    },
                    queryState: {
                        size: 1000,
                        from: 0,
                        sort: undefined
                    },
                    pagingState: {
                        enable: true,
                        showItemCount: false,
                        pageSize: 10000,
                        pageSizes: [5, 10, 20, 50, 100, 250, 500, 1000, 5000, 10000]
                    }
                }
            },
            export: {
                title: "MIS", //Give required title dynamically here
                criteria: undefined, //Structure [{ "fieldName": "StartDate", "operator": "==", "value1": "01-08-2013", "value2": null, "type": "dateTime", "filterType": "mandatory", "displayName": "StartDate", "enabletimeformat": "false", "lookupName": null }, { "fieldName": "EndtDate", "operator": "==", "value1": "31-08-2013", "value2": null, "type": "dateTime", "filterType": "mandatory", "displayName": "EndDate", "enabletimeformat": "false", "lookupName": null }, { "fieldName": "Estate", "operator": "in", "value1": "COTTABETTA", "value2": null, "type": "string", "filterType": "mandatory", "displayName": "Estate", "enabletimeformat": "false", "lookupName": null }, { "fieldName": "Division", "operator": "0", "value1": "", "value2": null, "type": "string", "filterType": "default", "displayName": "Division", "enabletimeformat": "false", "lookupName": null }, { "fieldName": "Gang", "operator": "0", "value1": "", "value2": null, "type": "string", "filterType": "default", "displayName": "Gang", "enabletimeformat": "false", "lookupName": null }]
                type: "PDF", //Default export type(optional)
                pageSize: "A4", //Default page size(optional)
                promptDialog: true, // If set to false, will be exported in default type and page size
                url: undefined // Url for document down load
            },
            dashlet: {
                name: "MIS",
                description: "Description",
                tag: "Tag",
                category: "Category"
            },
            buttons: {
                save: true,
                export: true,
                saveAsDashlet: true,
                navigation: true,
                pagination: true,
                search: true,
                gotoAnalytics: true
            }
        },
        _reclineView: undefined,
        _create: function () {
            this._create_Structure();
            if (g_LangTranslator) {
                g_LangTranslator.ApplyTranslation(this.element.id);
            }
        },

        _create_Structure: function () {
            var self = this;
            window.dataExplorer = null;
            window.explorerDiv = this.element;

            var state = recline.View.parseQueryString(decodeURIComponent(window.location.search));
            if (state) {
                _.each(state, function (value, key) {
                    try {
                        value = JSON.parse(value);
                    } catch (e) { }
                    state[key] = value;
                });
            } else {
                state.url = 'demo';
            }

            var dataset = null;
            requestPage = self.options.requestPage;
            if (state.dataset || state.url) {
                var datasetInfo = _.extend({
                    url: state.url,
                    backend: state.backend
                },
                    state.dataset
                );
                dataset = new recline.Model.Dataset(datasetInfo);
            } else {
                if (self.options.source.fields != undefined) {
                    // Code for initialize the time state selector
                    if (self.options.views.timeseries && self.options.views.timeseries.show && self.options.views.timeseries.state.group && _.findWhere(self.options.source.fields, {
                        id: self.options.views.timeseries.state.group
                    })) {
                        self.options.views.state.timeState.enable = true;
                        var field = self.options.views.timeseries.state.group;
                        if (!self.options.views.state.timeState.field) self.options.views.state.timeState.field = field;
                        if (!self.options.views.state.queryState.sort) self.options.views.state.queryState.sort = [{
                            field: field,
                            order: "asc"
                        }];
                        var groupDates = $.map(self.options.source.records, function (value) {
                            return moment(value[field]);
                        });
                        if (groupDates && groupDates.length > 0) {
                            if (!self.options.views.state.timeState.start) self.options.views.state.timeState.start = Math.min.apply(this, groupDates);
                            if (!self.options.views.state.timeState.end) self.options.views.state.timeState.end = Math.max.apply(this, groupDates);
                        }
                    }
                    self.options.views.state.queryState.size = self.options.source.records.length == 0 ? 0 : self.options.source.records.length;
                    var withComputedFields=[],computedFields = JSON.parse(self.options.catalog.schema).computedFields;
                    withComputedFields = self.options.source.fields;
                    _.each(computedFields,function(val,i){      
                                                //pushes computed fields if its not already exist in array
                       var existField=_.findWhere(withComputedFields, {
                                id: val.id
                            });
                        if(existField==null || existField==undefined)       
                        {
                            withComputedFields.push(val);
                        }
                    });
                    var records = _appFun.getAlaSQL(self.options.source.fields,self.options.source.records);
                    dataset = new recline.Model.Dataset({
                        records: records,
                        fields: self.options.source.fields,
                        filters: self.options.source.filters,
                        axisFields: self.options.source.axisFields,
                        geoFields: self.options.source.geoFields,
                        timeSeries: self.options.source.timeSeries,
                        timeState: self.options.views.state.timeState,
                        catalog: self.options.catalog,
                        pagingState: self.options.views.state.pagingState,
                        queryInit: self.options.views.state.queryState,
                        totalRecords: self.options.source.totalRecords
                    });
                } else {
                    dataset = new recline.Model.Dataset({
                        records: self.options.source.records
                    });
                }
            }
            switch (self.options.defaultViewer) {
                case Viewer.Grid:
                    state["currentView"] = "grid";
                    break;
                case Viewer.Graph:
                    state["currentView"] = "graph";
                    break;
                case Viewer.Map:
                    state["currentView"] = "map";
                    break;
                case Viewer.Pivot:
                    state["currentView"] = "pivot";
                    break;
                case Viewer.Timeseries:
                    state["currentView"] = "timeseries";
                    break;
                default:
                    state["currentView"] = "all";
                    break;
            }
            var savedFilters;
            switch (self.options.viewer) {
                case Viewer.Grid:
                    savedFilters = self._create_GridExplorer(dataset);
                    break;
                case Viewer.Graph:
                    savedFilters = self._create_GraphExplorer(dataset);
                    break;
                case Viewer.Pivot:
                    savedFilters = self._create_PivotExplorer(dataset);
                    break;
                case Viewer.Map:
                    savedFilters = self._create_MapExplorer(dataset);
                    break;
                case Viewer.Timeseries:
                    savedFilters = self._create_TimeseriesExplorer(dataset);
                    break;
                default:
                    savedFilters = self._create_ViewExplorer(dataset, state);
                    break;
            }

            if($("div.dashboardDiv").length>0)
                $("div.dashboardDiv").Dashboard('savedFilters',savedFilters);
        },

        _create_GridExplorer: function (dataset) {
            var self = this;
            var container = self.element;
            var grid = new recline.View.SlickGrid({
                model: dataset,
                state: self.options.views.graph.state,
                el: container
            });
            grid.visible = true;
            grid.render();
            return grid;
        },

        _create_GraphExplorer: function (dataset) {
            var self = this;
            var container = self.element;
            var graph = new recline.View.Graph({
                model: dataset,
                state: $.extend(self.options.views.graph.state, {
                    enableLegend: false
                }),
                el: container
            });
            graph.render();
            graph.redraw();
            return graph;
        },

        //dashboard pivot call
        _create_PivotExplorer: function (dataset) {
            var self = this;
            var container = self.element;
            var pivot = new recline.View.Pivot({
                model: dataset,
                state: self.options.views.pivot.state,
                el: container
            });
            pivot.render(); //dashboard call of pivot
            $(".pivotedDiv").height($(container).height());
            //For Setting height of pivot for Dashboard Page
             $("#dashboardContainer .pivotedDiv").height($(container).height() - 2);
            var toolbar = false;
            var reduceHight = 0;
            var canMoveFields = false;
            initializePivot(container,pivot, dataset, toolbar, reduceHight, canMoveFields, misSchema.views.view['pivot']['lazyload']);
            return pivot;
        },

        _create_MapExplorer: function (dataset) {
            var self = this;
            var container = self.element;
            self.options.views.map.state["autoZoom"] = true;
            var map = new recline.View.Map({
                model: dataset,
                state: self.options.views.map.state,
                el: container
            });
            map.render();
            map.redraw();
            return map;
        },

        _create_TimeseriesExplorer: function (dataset) {
            var self = this;
            var container = self.element;
            var timeseries = new recline.View.Timeseries({
                model: dataset,
                state: $.extend(self.options.views.timeseries.state, {
                    enableLegend: false
                }),
                el: container
            });
            timeseries.render();
            timeseries.redraw();
            return timeseries;
        },

        _create_ViewExplorer: function (dataset, state) {
            var self = this;
            $el = $('<div />');
            $el.appendTo(window.explorerDiv);
            var reload = false;
            if (window.dataExplorer) {
                window.dataExplorer.remove();
                reload = true;
            }
            var views = [];
            if (self.options.views.graph.show) {
                var graph = {
                    id: 'graph',
                    label: self.options.views.graph.label,
                    view: new recline.View.Graph({
                        model: dataset,
                        state: $.extend(self.options.views.graph.state, {
                            enableLegend: true,
                            showData: true,
                            minLegend: self.options.minLegend
                        })
                    })
                };
                views.push(graph);
            }

            if (self.options.views.grid.show) {
                var grid = {
                    id: 'grid',
                    label: self.options.views.grid.label,
                    view: new recline.View.SlickGrid({
                        model: dataset,
                        state: self.options.views.grid.state
                    })
                };
                views.push(grid);
            }

            if (self.options.views.map.show && self.options.GIS) {
                var map = {
                    id: 'map',
                    label: self.options.views.map.label,
                    view: new recline.View.Map({
                        model: dataset,
                        state: self.options.views.map.state
                    })
                };
                views.push(map);
            }
            if (self.options.views.timeseries.show) {
                var timeseries = {
                    id: 'timeseries',
                    label: self.options.views.timeseries.label,
                    view: new recline.View.Timeseries({
                        model: dataset,
                        state: $.extend(self.options.views.timeseries.state, {
                            enableLegend: true,
                            minLegend: self.options.minLegend
                        })
                    })
                };
                views.push(timeseries);
            }
            if (self.options.views.pivot.show) {
                var pivot = {
                    id: 'pivot',
                    label: self.options.views.pivot.label,
                    view: new recline.View.Pivot({
                        model: dataset,
                        state: self.options.views.pivot.state
                    })
                };
                views.push(pivot);
            }
            self._reclineView = new recline.View.MultiView({
                title: self.options.title,
                model: dataset,
                el: $el,
                state: state,
                views: views,
                buttons: self.options.buttons,
                dashlet: self.options.dashlet,
                export: self.options.export,
                onDateRangeChange: self.options.onDateRangeChange,
                onPagingChange: self.options.onPagingChange,
                onSaveAsDashlet: self.options.onSaveAsDashlet,
                onRemoveDashlet: self.options.onRemoveDashlet,
                onGotoAnalytics: self.options.onGotoAnalytics,
                onSaveConfig: self.options.onSaveConfig
            });
            window.dataExplorer = self._reclineView;
            var pivot = _.findWhere(self._reclineView.pageViews, {
                id: "pivot"
            });
            $(".pivotedDiv").height($(window).height() - 174);
            var toolbar = true;
            var reduceHight = 25;
            var canMoveFields = true;
            //if lazyload false, the data for the pivot will not taken from the server
            var lazyload = JSON.parse(dataset.get('catalog').schema).layoutSchema.view["pivot"]?JSON.parse(dataset.get('catalog').schema).layoutSchema.view["pivot"]["lazyload"]:false;
            initializePivot($el,pivot.view, dataset, toolbar, reduceHight, canMoveFields,lazyload);
            if ($("#editor-auto-zoom")) $("#editor-auto-zoom", self.element).trigger("click");
            if ($(".leaflet-control-layers-base input:radio").length > 0) $(".leaflet-control-layers-base input:radio")[0].checked = true;
            $(".menu-right div").removeClass("btn-group");
        },        

        GetActiveViewConfig: function () {
            var self = this;
            if (self._reclineView) return self._reclineView.getActiveViewConfig();
            return false;
        },

        GetReclineConfig: function () {
            var self = this;
            if (self._reclineView) return self._reclineView.getReclineConfig();
            return false;
        },

        SaveReclineConfig: function () {
            var self = this;
            if (self._reclineView) self._reclineView.onSaveconfigClick();
        },

        RestoreData: function (data, pagingState) {
            var self = this;
            if (self._reclineView) self._reclineView.model.restore(data, pagingState);
        }
    });
})($);