/* =============================================================
* bootstrap-typeahead.js v2.3.2
* http://twitter.github.com/bootstrap/javascript.html#typeahead
* =============================================================
* Copyright 2012 Twitter, Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
* ============================================================ */

/*
* Modifications by Paul Warelis, Alexey Gordeyev
*/
!function (e) {
    "use strict";
    var t = function (t, n) {
        var r = this;

        r.$element = e(t);
        r.options = e.extend({}, e.fn.titleeditor.defaults, n);
        r.$menu = e(r.options.menu).insertAfter(r.$element);
        r.eventSupported = r.options.eventSupported || r.eventSupported;
        r.grepper = r.options.grepper || r.grepper;
        r.highlighter = r.options.highlighter || r.highlighter;
        r.lookup = r.options.lookup || r.lookup;
        r.matcher = r.options.matcher || r.matcher;
        r.render = r.options.render || r.render;
        r.onSelect = r.options.onSelect || null;
        r.onRemove = r.options.onRemove || null;
        r.onChange = r.options.onChange || null;
        r.onCreate = r.options.onCreate || null;
        r.sorter = r.options.sorter || r.sorter;
        r.source = r.options.source || r.source;
        r.display = r.options.display || r.display;
        r.renderDefault(r.source); //.show()


        if (r.options.ajax) {
            var i = r.options.ajax;
            if (typeof i === "string") {
                r.ajax = e.extend({}, e.fn.titleeditor.defaults.ajax, {
                    url: i
                })
            } else {
                if (typeof i.displayField === "string") {
                    r.display = r.options.display = i.displayField
                }
                if (typeof i.valueField === "string") {
                    r.val = r.options.val = i.valueField
                }
                r.ajax = e.extend({}, e.fn.titleeditor.defaults.ajax, i)
            } if (!r.ajax.url) {
                r.ajax = null
            }
            r.query = ""
        } else {
            r.source = r.options.source;
            r.ajax = null
        }
        r.shown = false;
        r.listen()
    };
    t.prototype = {
        constructor: t,
        eventSupported: function (e) {
            var t = e in this.$element;
            if (!t) {
                this.$element.setAttribute(e, "return;");
                t = typeof this.$element[e] === "function"
            }
            return t
        },
        remove: function () {
            var e = this.$menu.find(".active");
            var t = e.attr("data-value");
            var n = this.$menu.find(".active .itemNames").text();
            var index = -1;
            $.each(this.options.source, function (idx, val) {
                if (val.name == n) index = idx;
            });
            if (index > -1 && confirm(this.options.deleteMsg)) {
                if (this.options.onRemove) {
                    this.options.onRemove({ value: t, text: n })
                }
                this.options.source.splice(index, 1);
                e.remove();
            }
            return this.$menu.show()
        },
        select: function () {
            var e = this.$menu.find(".active");
            var n = this.$menu.find(".active .itemNames").text();
            var t = e.attr("data-value");
            var m = $("li.active .itemNames:contains('  (Create New') ").length;
            if (m != 0) {
                if (this.options.onCreate) {
                    this.options.onCreate({
                        text: n
                    })
                }
            }
            else {
                if (this.options.onSelect) {
                    this.options.onSelect({
                        value: t,
                        text: n
                    })
                }
            }
            if (this.options.onChange) {
                this.options.onChange({
                    value: t,
                    text: n
                })
            }
            this.$element.val(this.updater(n)).change();
            return this.hide()

        },
        updater: function (e) {
            var m = $("li.active .itemNames:contains(' (Create New')").length;
            if (m != 0) {
                e = e.substring(0, e.length - 12);
            }
            return $.trim(e);
        },
        show: function () {
            var t = e.extend({}, this.$element.position(), {
                height: this.$element[0].offsetHeight
            });
            if (t.height != 0) {
                this.$menu.css({
                    top: t.top + t.height,
                    left: t.left
                });
            }
            else { // added by Nithin
                this.$menu.css({
                    top: t.top + 46,
                    left: t.left + 70
                });
            }
            this.$menu.show();
            this.shown = true;
            return this
        },
        hide: function () {
            this.$menu.hide();
            this.shown = false;
            return this
        },
        ajaxLookup: function () {
            function n() {
                this.ajaxToggleLoadClass(true);
                if (this.ajax.xhr) this.ajax.xhr.abort();
                var n = this.ajax.preDispatch ? this.ajax.preDispatch(t) : {
                    query: t
                };
                this.ajax.xhr = e.ajax({
                    url: this.ajax.url,
                    data: n,
                    success: e.proxy(this.ajaxSource, this),
                    type: this.ajax.method || "get",
                    dataType: "json"
                });
                this.ajax.timerId = null;
            }
            var t = e.trim(this.$element.val());
            if (t == this.query) {
                return this;
            }
            this.query = t;
            if (this.ajax.timerId) {
                clearTimeout(this.ajax.timerId);
                this.ajax.timerId = null;
            }
            if (!t || t.length < this.ajax.triggerLength) {
                if (this.ajax.xhr) {
                    this.ajax.xhr.abort();
                    this.ajax.xhr = null;
                    this.ajaxToggleLoadClass(false);
                }
                return this.shown ? this.hide() : this;
            }
            this.ajax.timerId = setTimeout(e.proxy(n, this), this.ajax.timeout);
            return this;
        },
        ajaxSource: function (e) {
            this.ajaxToggleLoadClass(false);
            var t = this,
                n;
            if (!t.ajax.xhr) return;
            if (t.ajax.preProcess) {
                e = t.ajax.preProcess(e)
            }
            t.ajax.data = e;
            n = t.grepper(t.ajax.data) || [];
            if (!n.length) {
                return t.shown ? t.hide() : t
            }
            t.ajax.xhr = null;
            return t.render(n.slice(0, t.options.items)).show()
        },
        ajaxToggleLoadClass: function (e) {
            if (!this.ajax.loadingClass) return;
            this.$element.toggleClass(this.ajax.loadingClass, e)
        },
        lookup: function (e) {
            var t = this,
                n;
            if (t.ajax) {
                t.ajaxer()
            } else {
                t.query = t.$element.val();
                if (!t.query) {
                    return t.renderDefault(t.source).show();
                    //return t.shown ? t.show() : t
                }
                n = t.grepper(t.source);
                if (!n || !n.length) {
                    return t.render(n.slice(0, t.options.items)).show()
                }
                return t.render(n.slice(0, t.options.items)).show()
            }
        },
        matcher: function (e) {

            return ~e.toLowerCase().indexOf(this.query.toLowerCase())
        },
        sorter: function (e) {
            if (!this.options.ajax) {
                var t = [],
                    n = [],
                    r = [],
                    i;
                while (i = e.shift()) {
                    if (!i.toLowerCase().indexOf(this.query.toLowerCase())) t.push(i);
                    else if (~i.indexOf(this.query)) n.push(i);
                    else r.push(i)
                }
                return t.concat(n, r)
            } else {
                return e
            }
        },
        highlighter: function (e) {
            var t = this.query.replace(/[\-\[\]{}()*+?.,\\\^$|#\s]/g, "\\$&");
            return e.replace(new RegExp("(" + t + ")", "ig"), function (e, t) {
                return "<strong>" + t + "</strong>"
            })
        },
        renderDefault: function (t) {
            var n = this,
                r, i = typeof n.options.display === "string";
            t = e(t).map(function (t, s) {
                r = i ? s[n.options.display] : n.options.display(s);
                t = e(n.options.item).attr("data-value", s[n.options.val]);
                t.find(".itemNames").html(r);
                return t[0]
            });
            this.$menu.html(t);
            return this
        },
        render: function (t) {
            var n = this,
                r, i = typeof n.options.display === "string";
            t = e(t).map(function (t, s) {
                r = i ? s[n.options.display] : n.options.display(s);
                t = e(n.options.item).attr("data-value", s[n.options.val]);
                t.find(".itemNames").html(n.highlighter(r));
                return t[0]
            });

            var input = $(n.$element).attr("value");
            t.first().addClass("active");
            this.$menu.html(t);

            if (t.length > 0) {
                var inputval = input.toLowerCase();
                var hasValue = false;
                $(".dropdown-menu li .itemNames").each(function () {
                    if ($(this).text().toLowerCase() == inputval) hasValue = true;
                });

                if (!hasValue) {
                    this.$menu.append('<li><span "id="createTitle" class="itemNames">' + input + ' (Create New)</span></li>');
                }
            }
            else {
                this.$menu.append('<li><span "id="createTitle" class="itemNames">' + input + ' (Create New)</span></li>');
            }
            return this;
        },
        grepper: function (t) {
            var n = this,
                r, i, s = typeof n.options.display === "string";
            if (s && t && t.length && !t[0].hasOwnProperty(n.options.display)) {
                return null
            }
            r = e.grep(t, function (e) {
                i = s ? e[n.options.display] : n.options.display(e);

                return n.matcher(i)

            });

            return this.sorter(r)
        },
        next: function (t) {
            var n = this.$menu.find(".active").removeClass("active"),
                r = n.next();
            if (!r.length) {
                r = e(this.$menu.find("li")[0])
            }
            r.addClass("active")
        },
        prev: function (e) {
            var t = this.$menu.find(".active").removeClass("active"),
                n = t.prev();
            if (!n.length) {
                n = this.$menu.find("li").last()
            }
            n.addClass("active")
        },
        listen: function () {
            this.$element.on("focus", e.proxy(this.focus, this)).on("blur", e.proxy(this.blur, this)).on("keypress", e.proxy(this.keypress, this)).on("keyup", e.proxy(this.keyup, this));
            if (this.eventSupported("keydown")) {
                this.$element.on("keydown", e.proxy(this.keydown, this))
            }
            $(".dropdown-menu").on("click", e.proxy(this.click, this)).on("mouseenter", "li", e.proxy(this.mouseenter, this)).on("mouseleave", "li", e.proxy(this.mouseleave, this))
        },
        move: function (e) {
            if (!this.shown) return;
            switch (e.keyCode) {
                case 9:
                case 13:
                case 27:
                    e.preventDefault();
                    break;
                case 38:
                    e.preventDefault();
                    this.prev();
                    break;
                case 40:
                    e.preventDefault();
                    this.next();
                    break
            }
            e.stopPropagation()
        },
        keydown: function (t) {
            this.suppressKeyPressRepeat = ~e.inArray(t.keyCode, [40, 38, 9, 13, 27]);
            this.move(t)
        },
        keypress: function (e) {
            if (this.suppressKeyPressRepeat) return;
            this.move(e)
        },
        keyup: function (e) {
            switch (e.keyCode) {
                case 40:
                case 38:
                case 16:
                case 17:
                case 18:
                    break;
                case 9:
                case 13:
                    if (!this.shown) return;
                    this.select();
                    break;
                case 27:
                    if (!this.shown) return;
                    this.hide();
                    break;
                default:
                    if (this.ajax) this.ajaxLookup();
                    else this.lookup()
            }
            e.stopPropagation();
            e.preventDefault()
        },
        focus: function (e) {
            this.focused = true
        },
        blur: function (e) {
            this.focused = false;
            this.select();
            if (!this.mousedover && this.shown) this.hide()
        },
        click: function (e) {
            var elem = e.toElement.className;
            e.stopPropagation();
            e.preventDefault();
            if (elem == 'close') {
                this.remove();
            }
            else {
                this.select();
            }
            this.$element.focus()
        },
        mouseenter: function (t) {
            this.mousedover = true;
            this.$menu.find(".active").removeClass("active");
            e(t.currentTarget).addClass("active")
        },
        mouseleave: function (e) {
            this.mousedover = false;
            if (!this.focused && this.shown) this.hide()
        }
    };
    e.fn.titleeditor = function (n) {
        return this.each(function () {
            var r = e(this),
                i = r.data("titleeditor"),
                s = typeof n == "object" && n;
            if (!i) r.data("titleeditor", i = new t(this, s));
            if (typeof n == "string") i[n]()
        })
    };   
    e.fn.titleeditor.defaults = {
        source: [],
        items: 8,
        menu: '<ul class="titleeditor dropdown-menu"></ul>',
        item: '<li><span class="itemNames"></span><span class="close">&times</span></li>',
        display: "name",
        val: "id",
        deleteMsg: "Are you sure you want to delete?",
        onSelect: function () { },
        onRemove: function () { },
        onChange: function () { },
        onCreate: function () { },
        ajax: {
            url: null,
            timeout: 300,
            method: "get",
            triggerLength: 1,
            loadingClass: null,
            preDispatch: null,
            preProcess: null
        }
    };
    e.fn.titleeditor.Constructor = t;
    e(function () {
        e("body").on("focus.titleeditor.data-api", '[data-provide="titleeditor"]', function (t) {
            var n = e(this);
            if (n.data("titleeditor")) return;
            t.preventDefault();

            n.titleeditor(n.data())
        })
    })
} (window.jQuery)