/*+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+*/

this.recline = this.recline || {};
this.recline.View = this.recline.View || {};
(function ($, my) {
    "use strict";

    my.FilterEditor = Backbone.View.extend({
        className: 'recline-filter-editor well',
        template: ' <div class="filterDiv"></div>\
          ',
        initialize: function () {
            _.bindAll(this, 'render');
            var self = this;
            self.listenTo(self.model.fields, 'all', self.render);
            self.listenTo(self.model.queryState, 'change change:filters:new-blank', self.render);
            if($('.divTabViewer').length==0){
                self.templateCreation();
                self.render();
            }
        },
        
        templateCreation: function () {
            var self = this;
            var out = Mustache.render(self.template,"");
            self.$el.html(out);
            var esQuery = {};
            esQuery["filter"] = self.model.queryState.get('filters');
            if(self.model.queryState.get('groupings').selectedAggs){
                var mergedItems = (self.model.queryState.get('groupings').selectedAggs).concat(self.model.queryState.get('groupings').selectedGroups);
                esQuery["aggregate"] = mergedItems;
            }

            self.$el.find('.filterDiv').aggFunctions({
                schema: self.model.fields.toJSON(),
                onApplySearch: MyCustomSearch,
                onClearSearch:MyCustomClear,
                catalog: { fromCatalogID: 0, catalogId: self.model.get('catalog').CatalogId },
                query:esQuery,
                header:false,
                functions: { 
                    aggs: [{ value: "Terms", key: "groupby"}],
                    metrics: [
                        { value: "MIN", key: "MIN" },
                        { value: "MAX", key: "MAX" },
                        { value: "SUM", key: "SUM" },
                        { value: "AVG", key: "AVG" }
                    ] 
                },
                operators:{
                    //filter operators for string
                    string: [{ value: "In", key: "In" },
                            { value: "Not In", key: "NotIn" },
                            { value: "Like", key: "Like" },
                            { value: "Not Like", key: "NotLike" }],
                    //filter operators for numeric
                    numeric: [{ value: "In", key: "In" },
                            { value: "Not In", key: "NotIn" },
                            { value: "=", key: "=" },
                            { value: "!=", key: "!=" },
                            { value: ">", key: ">" },
                            { value: "<", key: "<" },
                            { value: ">=", key: ">=" },
                            { value: "<=", key: "<=" },
                            { value: "Between", key: "Between" }],
                    date: [{ value: "In", key: "In" },
                            { value: "Not In", key: "NotIn" },
                            { value: "=", key: "=" },
                            { value: "!=", key: "!=" },
                            { value: ">", key: ">" },
                            { value: "<", key: "<" },
                            { value: ">=", key: ">=" },
                            { value: "<=", key: "<=" },
                            { value: "Between", key: "Between" }],
                    user: [{ value: "In", key: "In" },
                            { value: "Not In", key: "NotIn" },
                            { value: "Like", key: "Like" },
                            { value: "Not Like", key: "NotLike" },
                            { value: "Logged In User", key: "Logged In User" }]

                }
            });
            function MyCustomSearch(query) {
                var metrics = $.grep(query.aggregate,function(val,i){
                    return val.metrics==true;
                });
                var aggs = $.grep(query.aggregate,function(val,i){
                    return val.metrics==false;
                });
                self.model.queryState.set({filters:query.filter, groupings:{selectedAggs:metrics,selectedGroups:aggs}});
                self.model.queryState.trigger('change');
            }

            function MyCustomClear() {
                self.model.queryState.set({filters:[], groupings:{}});
                self.model.queryState.trigger('change');
            }
            
        },

        render: function () {
            var self = this;
            var filters = self.model.queryState.get('filters');         
        }
    });
})(jQuery, recline.View);
