﻿/*+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   
JQuery Immediately-Invoked Function for recline NVD3 Graph
Created By      : Rony T S for Assyst International Pvt. Ltd.
Created Date    : 10-Oct-2014
Version         : 1.0.2
Project         : PanAgro

+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+*/
var pgridwidget, cid;
this.recline = this.recline || {};
this.recline.View = this.recline.View || {};

var config = null;
function pivotConfig()  // added by kather  -- To get config file from orb.js
{
    return config;
}

(function ($, my) {
    "use strict";
    my.Pivot = Backbone.View.extend({
        template: ' \
            <div class="pivotedDiv" id ="orbpivot"> \
              <div id="pvtDiv" class="pvtDiv {{viewId}}" ></div> \
            </div> \
        ',

        initialize: function (options) {
            var self = this;
            this.el = $(this.el);
            _.bindAll(this, 'render');
            var stateData = _.extend({
                Pivot: {
                    rows: [],
                    cols: [],
                    vals: [],
                    preFilters: null,
                    totals:{},
                    sort: 'asc'
                }
            }, options.state);
            this.state = new recline.Model.ObjectState(stateData);
            this.state.set({ Pivot: self.model.queryState.get('Pivot') || self.state.get('Pivot') });
            this.editor = new my.PivotControls({
                model: this.model,
                state: this.state.toJSON()
            });
            this.elSidebar = this.editor.$el;
        },

        render: function () {
            var self = this;
            var tmplData = this.model.toTemplateJSON();
            tmplData["viewId"] = this.cid;
            cid = this.cid;
            var htmls = Mustache.render(this.template, tmplData);
            this.$el.html(htmls);
            return this;
        }
    });
    
    my.PivotControls = Backbone.View.extend({
        className: "editor pivotEditor",
        template:' \
            <div> \
                <div class="pivotEditorSide"></div>\
            </div> \
        ',
        events: {
        },
        initialize: function (options) {
            var self = this;
            _.bindAll(this, 'render');
            this.listenTo(this.model.axisFields, 'reset add', this.render);
            this.state = new recline.Model.ObjectState(options.state);
            this.render();
        },
        render: function () {
            var self = this;
            var tmplData = this.model.toTemplateJSON();
            var htmls = Mustache.render(this.template, tmplData);
            var query = {
                    filter :self.model.queryState.get('Pivot') == undefined? [] : self.model.queryState.get('Pivot').esQueryFilter||[],
                    aggregate : []
                }
                query.filter = $.grep(query.filter, function (item,index) {
                            if(item.fieldName.indexOf('_SUM')!= -1) {
                                item.fieldName=item.fieldName.replace('_SUM','');
                                item.aliasName=item.aliasName.replace('_SUM','');
                            }
                            return item;
                        });

            this.$el.html(htmls);
            this.$el.find('.pivotEditorSide').aggFunctions({
                schema: self.model.fields.toJSON(),
                query:query,
                header:false,
                buttons:false,
                aggregation : false,
                catalog: { fromCatalogID: 0, catalogId: self.model.get('catalog').CatalogId }
            });            
        }
    });
})(jQuery, recline.View);
